using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration.Install;
using System.Xml;
using System.IO;
using System.Reflection;
using System.Windows.Forms;
using System.Security.AccessControl;
using System.Security.Principal;
using System.DirectoryServices;
using System.Net;
using System.ServiceProcess;
namespace TimecheckCollectRawData
{
    [RunInstaller(true)]
    public partial class ProjectInstaller : Installer
    {
        public ProjectInstaller()
        {
            InitializeComponent();
        }
        string virtualDirectory = string.Empty, serverName = string.Empty, dbName = string.Empty, userId = string.Empty;
        string password = string.Empty;
        protected string WebConfigFilename
        {
            get
            {
                return Path.Combine(
                    this.Context.Parameters["INSTALLDIR"], "TimeCheckCollectDataService.exe.config");
            }
        }
        protected string InstallationPath
        {
            get
            {
                return Path.Combine(
                    this.Context.Parameters["INSTALLDIR"], "");
            }
        }
        public override void Install(System.Collections.IDictionary stateSaver)
        {
            base.Install(stateSaver);
            string startPath = "";
            startPath = this.Context.Parameters["sourceDir"].ToString();
            startPath = startPath.Replace(@"\TimecheckCollectRawDataSetup", "");
            startPath = Path.Combine(startPath, "web.config");
            XmlDocument doc = new XmlDocument();
            doc.Load(startPath);
            XmlNodeList oList = doc.SelectNodes("configuration/connectionStrings/add");
            string conStr = string.Empty;
            for (int i = 0; i < oList.Count; i++)
            {
                XmlAttribute oKey = oList[i].Attributes["name"];
                XmlAttribute oValue = oList[i].Attributes["connectionString"];
                if (oKey.Value == "DBConnection")
                {
                    conStr = oValue.Value;
                }
            }
            // Overwrites the connection string in web.config.
            OverwriteConnectionString(conStr);
        }
        /// <summary>
        /// Overwrites the connection string.
        /// </summary>
        /// <param name="serverName">Name of the server.</param>
        /// <param name="virDir">The vir dir.</param>
        /// <param name="dbName">Name of the db.</param>
        /// <param name="userId">The user id.</param>
        /// <param name="pw">The pw.</param>
        void OverwriteConnectionString(string strConStr)
        {
            XmlDocument doc = new XmlDocument();
            doc.Load(this.WebConfigFilename);
            XmlNodeList oList = doc.SelectNodes("configuration/appSettings/add");
            for (int i = 0; i < oList.Count; i++)
            {
                XmlAttribute oKey = oList[i].Attributes["key"];
                XmlAttribute oValue = oList[i].Attributes["value"];
                if (oKey.Value == "ConnectionString")
                {
                    oValue.Value = strConStr;
                }
            }
            doc.Save(this.WebConfigFilename);
        }
        /// <summary>
        /// When overridden in a derived class, completes the install transaction.
        /// </summary>
        /// <param name="savedState">An <see cref="T:System.Collections.IDictionary"></see> that contains the state of the computer after all the installers in the collection have run.</param>
        /// <exception cref="T:System.ArgumentException">The savedState parameter is null.-or- The saved-state <see cref="T:System.Collections.IDictionary"></see> might have been corrupted. </exception>
        /// <exception cref="T:System.Configuration.Install.InstallException">An exception occurred during the <see cref="M:System.Configuration.Install.Installer.Commit(System.Collections.IDictionary)"></see> phase of the installation. This exception is ignored and the installation continues. However, the application might not function correctly after the installation is complete. </exception>
        public override void Commit(System.Collections.IDictionary savedState)
        {
            base.Commit(savedState);
            StreamWriter sw = null;
            string strStratPath = string.Empty;
            string strRawFilePath = string.Empty;
            string strRawFileContent = string.Empty;
            strStratPath = this.Context.Parameters["sourceDir"].ToString();
            strRawFileContent = this.WebConfigFilename;
            strRawFilePath = strStratPath + @"RawFilePath.txt";
            sw = File.CreateText(strRawFilePath);
            sw.WriteLine(strRawFileContent);
            sw.Flush();
            sw.Close();
            DirectorySecurity dirSec = Directory.GetAccessControl(this.InstallationPath);
            string osname = GetOSName();
            if (osname == "Windows XP")
            {
                NTAccount AccountName = new NTAccount("ASPNET");
                FileSystemAccessRule fsar = new FileSystemAccessRule(AccountName, FileSystemRights.FullControl, InheritanceFlags.ContainerInherit | InheritanceFlags.ObjectInherit, PropagationFlags.NoPropagateInherit, AccessControlType.Allow);
                dirSec.AddAccessRule(fsar);
            }
            else if (osname == "Windows Server 2003")
            {
                NTAccount AccountName = new NTAccount("NETWORK SERVICE");
                FileSystemAccessRule fsar = new FileSystemAccessRule(AccountName, FileSystemRights.FullControl, InheritanceFlags.ContainerInherit | InheritanceFlags.ObjectInherit, PropagationFlags.NoPropagateInherit, AccessControlType.Allow);
                dirSec.AddAccessRule(fsar);
            }
            else if (osname == "Windows Vista")
            {
                NTAccount AccountName = new NTAccount("NETWORK SERVICE");
                FileSystemAccessRule fsar = new FileSystemAccessRule(AccountName, FileSystemRights.FullControl, InheritanceFlags.ContainerInherit | InheritanceFlags.ObjectInherit, PropagationFlags.NoPropagateInherit, AccessControlType.Allow);
                dirSec.AddAccessRule(fsar);
            }
            Directory.SetAccessControl(this.InstallationPath, dirSec);
            string src = this.Context.Parameters["sourceDir"].ToString();
            src = src.Replace(@"\TimecheckCollectRawDataSetup\", "");
            int sIndex = src.LastIndexOf(@"\");
            src = src.Substring(sIndex + 1);
            IPAddress[] localIPs = Dns.GetHostAddresses(Dns.GetHostName());
            DirectoryEntry path = new DirectoryEntry("IIS://LocalHost/W3SVC/1");
            path.RefreshCache();
            PropertyValueCollection pvcServerBindings = path.Properties["serverbindings"];
            string bindings = pvcServerBindings.Value.ToString().Replace(":", "");
            System.Diagnostics.Process.Start("iexplore.exe", "http://" + localIPs[localIPs.Length - 1] + ":" + bindings + "/" + src + "/" + "Index.aspx");
        }
        public static string GetOSName()
        {
            OperatingSystem osInfo = Environment.OSVersion;
            string osName = "UNKNOWN";
            switch (osInfo.Platform)
            {
                case PlatformID.Win32Windows:
                    {
                        switch (osInfo.Version.Minor)
                        {
                            case 0:
                                {
                                    osName = "Windows 95";
                                    break;
                                }
                            case 10:
                                {
                                    if (osInfo.Version.Revision.ToString() == "2222A")
                                    {
                                        osName = "Windows 98 Second Edition";
                                    }
                                    else
                                    {
                                        osName = "Windows 98";
                                    }
                                    break;
                                }
                            case 90:
                                {
                                    osName = "Windows Me";
                                    break;
                                }
                        }
                        break;
                    }
                case PlatformID.Win32NT:
                    {
                        switch (osInfo.Version.Major)
                        {
                            case 3:
                                {
                                    osName = "Windows NT 3.51";
                                    break;
                                }
                            case 4:
                                {
                                    osName = "Windows NT 4.0";
                                    break;
                                }
                            case 5:
                                {
                                    if (osInfo.Version.Minor == 0)
                                    {
                                        osName = "Windows 2000";
                                    }
                                    else if (osInfo.Version.Minor == 1)
                                    {
                                        osName = "Windows XP";
                                    }
                                    else if (osInfo.Version.Minor == 2)
                                    {
                                        osName = "Windows Server 2003";
                                    }
                                    break;
                                }
                            case 6:
                                {
                                    osName = "Windows Vista";
                                    break;
                                }
                        }
                        break;
                    }
            }
            return osName;
        }        
    }
}