﻿using System.ServiceModel;
using System;


[System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "3.0.0.0")]
[System.ServiceModel.ServiceContractAttribute(Namespace = "http://Report_Generator",
    ConfigurationName = "Report_Genertion_Service.IReportGenerationService")]
public interface IReportGenerationService
{
    [System.ServiceModel.OperationContractAttribute
        (Action = "http://Report_Generator/IReportGenerationService/GetReportData",
        ReplyAction = "http://Report_Generator/IReportGenerationService/GetReportDataResponse")]
    byte[] GetReportData(int reportOption, long organizationID, long fleetID, int boxID,
        DateTime startDate, DateTime endDate, long userID, string reportParameters, string sortBy,
        string sortDirection, bool showSummary, bool showDetails, string extension, string showHideOptions,
        string fleetName, string vehicleDisplayName, string resourceFileName, string reportReference);
}

[System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "3.0.0.0")]
public interface IReportGenerationServiceChannel : IReportGenerationService,
    System.ServiceModel.IClientChannel
{
}

[System.Diagnostics.DebuggerStepThroughAttribute()]
[System.CodeDom.Compiler.GeneratedCodeAttribute("System.ServiceModel", "3.0.0.0")]
public partial class ReportGenerationServiceClient : System.ServiceModel.ClientBase
    <IReportGenerationService>, IReportGenerationService
{

    public ReportGenerationServiceClient()
    {
    }

    public ReportGenerationServiceClient(string endpointConfigurationName) :
        base(endpointConfigurationName)
    {
    }

    public ReportGenerationServiceClient(string endpointConfigurationName, string remoteAddress) :
        base(endpointConfigurationName, remoteAddress)
    {
    }

    public ReportGenerationServiceClient(string endpointConfigurationName, EndpointAddress remoteAddress) :
        base(endpointConfigurationName, remoteAddress)
    {
    }

    public ReportGenerationServiceClient(System.ServiceModel.Channels.Binding binding, System.ServiceModel.EndpointAddress remoteAddress) :
        base(binding, remoteAddress)
    {
    }

    /// <summary>
    /// Gets the report data.
    /// </summary>
    /// <param name="reportOption">The report option.</param>
    /// <param name="organizationID">The organization ID.</param>
    /// <param name="fleetID">The fleet ID.</param>
    /// <param name="boxID">The box ID.</param>
    /// <param name="startDate">The start date.</param>
    /// <param name="endDate">The end date.</param>
    /// <param name="userID">The user ID.</param>
    /// <param name="reportParameters">The report parameters.</param>
    /// <param name="sortBy">The sort by.</param>
    /// <param name="sortDirection">The sort direction.</param>
    /// <param name="showSummary">if set to <c>true</c> [show summary].</param>
    /// <param name="showDetails">if set to <c>true</c> [show details].</param>
    /// <param name="extension">The extension.</param>
    /// <param name="showHideOptions">The show hide options.</param>
    /// <param name="fleetName">Name of the fleet.</param>
    /// <param name="vehicleDisplayName">Display name of the vehicle.</param>
    /// <param name="resourceFileName">Name of the resource file.</param>
    /// <param name="reportReference">The report reference.</param>
    /// <returns></returns>
    public byte[] GetReportData(int reportOption, long organizationID, long fleetID, int boxID,
        DateTime startDate, DateTime endDate, long userID, string reportParameters, string sortBy,
        string sortDirection, bool showSummary, bool showDetails, string extension, string showHideOptions,
        string fleetName, string vehicleDisplayName, string resourceFileName, string reportReference)
    {
        return base.Channel.GetReportData(reportOption, organizationID, fleetID, boxID,
         startDate, endDate, userID, reportParameters, sortBy, sortDirection, showSummary,
         showDetails, extension, showHideOptions, fleetName, vehicleDisplayName, resourceFileName,reportReference);
    }
}
