using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Text;
using System.Timers;
using System.Net.Mail;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.ReportSource;
using CrystalDecisions.Shared;
using System.Configuration;
using System.Net;
using TimecheckReportSchedularService;
using System.IO;
using System.Globalization;
using System.Collections;

namespace TimecheckReportSchedular
{
    public partial class EmailSchedular : ServiceBase
    {
        public System.Timers.Timer timer;
        Int64 gintTimerInterval = 0;
        GetReports objGetReports = new GetReports();
        string strMonth, strYear, strDay, strFromDate;
        string ReportName1 = string.Empty;
        string ScheduleName = string.Empty;
        string CreatedBy = string.Empty;
        string Duration = string.Empty;
        string ExePath = string.Empty;
        static CultureInfo CI; string strAppID = string.Empty;
        DataTable dsDateFormat = new DataTable();
        public EmailSchedular()
        {
            InitializeComponent();
            if (ConfigurationSettings.AppSettings["TimerInterval"].ToString() != string.Empty)
            {
                gintTimerInterval = Convert.ToInt64(ConfigurationSettings.AppSettings["TimerInterval"].ToString());
            }
            else
            {
                gintTimerInterval = 120000;
            }
            // Initialize timer and set the elapsed event
            timer = new System.Timers.Timer(gintTimerInterval);
            timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
            if (!System.Diagnostics.EventLog.SourceExists("TC2.7.0ReportSchedularLogSource"))
                System.Diagnostics.EventLog.CreateEventSource("TC2.7.0ReportSchedularLogSource", "TC2.7.0ReportSchedularLog");
            eventLog1.Source = "TC2.7.0ReportSchedularLogSource";
            // the event log source by which 
            //the application is registered on the computer
            eventLog1.Log = "TC2.7.0ReportSchedularLog";
        }
        protected override void OnStart(string[] args)
        {
            try
            {
                timer.Start();
            }
            catch (Exception ex)
            {
                eventLog1.WriteEntry(ex.Message);
                WriteErrorToEventLog("OnStart : ", "OnStart ---> " + ex.Message);
                throw ex;
            }
        }
        protected override void OnStop()
        {
            timer.Stop();
        }
        private void timer_Elapsed(object source, ElapsedEventArgs e)
        {
            timer.Stop();
            try
            {
                CI = new CultureInfo("en-us");
                CI.DateTimeFormat.ShortDatePattern = "MM/dd/yyyy";
                CI.DateTimeFormat.LongDatePattern = "MM/dd/yyyy";
                CI.DateTimeFormat.ShortTimePattern = "hh:mm tt";
                CI.DateTimeFormat.LongTimePattern = "hh:mm tt";
                CI.DateTimeFormat.FullDateTimePattern = "MM/dd/yyyy";
                System.Threading.Thread.CurrentThread.CurrentCulture = CI;
                DataTable dtLic = new DataTable();
                dtLic = objGetReports.ExecuteQuery("Proc_OL_SelectLicenseExpiryDate", "TA_Tbl_LIC_Details");
                if (dtLic.Rows.Count > 0)
                {
                    string ExpDate = string.Empty;
                    ExpDate = dtLic.Rows[0][0].ToString();
                    ExpDate = Cryptographys.Cryptography.Decrypt_BioStar(ExpDate, "");
                    ExpDate = ExpDate + " 23:59:00";
                    //if (Convert.ToDateTime(ExpDate, CI) > Convert.ToDateTime(Convert.ToString(DateTime.Now, CI)))
                    //{
                    //    ProcessData();
                    //}
                    //else
                    //{
                    //    //WriteErrorToEventLog("license expired", "license expired: Please Update the License. Once License update the data automatically processed.");contact system administrator
                    //    WriteErrorToEventLog("License expired", "License expired: Contact System Administrator.");
                    //}
                    ProcessData();
                }
                else
                {
                    ProcessData();
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("timer_Elapsed : ", "timer_Elapsed -->" + ex.Message);
                throw ex;
            }
            finally
            {
                timer.Start();
            }
        }
        private void ProcessData()
        {
            try
            {
                //As per manager sir requisition we implemented reminder concept for leave,permission and discrepancy module.
                //Actually we implemented this concept in v2.4 but we updated the same in latest version for source maintainance.
                int payrollConfig = 0;
                payrollConfig = objGetReports.CheckPageExistsInLicense(185);
                if (payrollConfig == 1)
                {
                    GetLeaveReminder();
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            DataSet dsDateTimeFormat = new DataSet();
            dsDateTimeFormat = objGetReports.Select_DateandTimeFormat();
            ExePath = System.Windows.Forms.Application.ExecutablePath.ToString();
            ExePath = ExePath.Replace("TimecheckReportSchedular.exe", "Reports\\");
            try
            {
                GetEmailSchedule("Daily", dsDateTimeFormat.Tables[0].Rows[0]["DateFormat"].ToString(), dsDateTimeFormat.Tables[0].Rows[0]["TimeFormat"].ToString());
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("Function :", "GetEmailSchedule - Daily --->" + ex.Message);
                //eventLog1.WriteEntry("Function : GetEmailSchedule - Daily " + ex.Message);
                throw ex;
            }
            try
            {
                GetEmailSchedule("Weekly", dsDateTimeFormat.Tables[0].Rows[0]["DateFormat"].ToString(), dsDateTimeFormat.Tables[0].Rows[0]["TimeFormat"].ToString());
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("Function :", "GetEmailSchedule - Weekly --->" + ex.Message);
                //eventLog1.WriteEntry("Function : GetEmailSchedule - Weekly " + ex.Message);
                throw ex;
            }
            try
            {
                GetEmailSchedule("Monthly", dsDateTimeFormat.Tables[0].Rows[0]["DateFormat"].ToString(), dsDateTimeFormat.Tables[0].Rows[0]["TimeFormat"].ToString());
            }
            catch (Exception ex)
            {
                //eventLog1.WriteEntry("Function : GetEmailSchedule - Monthly " + ex.Message);
                WriteErrorToEventLog("Function :", "GetEmailSchedule - Monthly --->" + ex.Message);
                throw ex;
            }
        }
        public void GetLeaveReminder()
        {
            DataSet dsEmployee = new DataSet();
            DataSet dsleave = new DataSet();
            GetReports objgr = new GetReports();
            try
            {
                dsEmployee = objGetReports.GetDataSet("Proc_TA_EmployeeDetailsForRemainder", null);
                Hashtable htreportingTo = new Hashtable();
                string dEmployeeid = string.Empty;
                foreach (DataRow dr in dsEmployee.Tables[0].Rows)
                {
                    htreportingTo.Clear();
                    htreportingTo.Add("@EmployeeId", dr["Employee_Id"]);
                    htreportingTo.Add("@Type", "L");
                    dsleave = objgr.GetDataSet("Proc_Ta_GetFutureLeaveRecordsEmployees_ForEmailTriggering", htreportingTo);
                    if (dsleave.Tables.Count > 0)
                    {
                        if (dsleave.Tables[0].Rows.Count > 0)
                        {
                            PrepareBodyContent(dsleave);
                        }
                    }

                    //Getting Future day Permission details
                    htreportingTo.Clear();
                    dsleave.Tables.Clear();
                    htreportingTo.Add("@EmployeeId", dr["Employee_Id"]);
                    htreportingTo.Add("@Type", "P");
                    dsleave = objgr.GetDataSet("Proc_Ta_GetFutureLeaveRecordsEmployees_ForEmailTriggering", htreportingTo);
                    if (dsleave.Tables.Count > 0)
                    {
                        if (dsleave.Tables[0].Rows.Count > 0)
                        {
                            PrepareBodyContentPermission(dsleave);
                        }
                    }

                    htreportingTo.Clear();
                    dsleave.Tables.Clear();
                    htreportingTo.Add("@EmployeeId", dr["Employee_Id"]);
                    htreportingTo.Add("@Type", "D");
                    dsleave = objgr.GetDataSet("Proc_Ta_GetFutureLeaveRecordsEmployees_ForEmailTriggering", htreportingTo);
                    if (dsleave.Tables.Count > 0)
                    {
                        if (dsleave.Tables[0].Rows.Count > 0)
                        {
                            if (Convert.ToString(dsleave.Tables[0].Rows[0]["EmailId"]) != "" && Convert.ToString(dsleave.Tables[0].Rows[0]["EmailId"]) != null)
                            {
                                string body = string.Empty;

                                if (Convert.ToString(dsleave.Tables[0].Rows[0]["body"]) == "1")
                                {
                                    body = "<font face='arial' size='2'><b>Dear " + Convert.ToString(dsleave.Tables[0].Rows[0]["employeeName"]) + ",</b><br><br>You have not kept your shift In punch properly <b><font color='red'> Yesterday (" + Convert.ToString(dsleave.Tables[0].Rows[0]["date"]) + ")</font></b>.Please do take the next steps to correct it & avoid such manual errors going forward.</b></font><br>";
                                }
                                if (Convert.ToString(dsleave.Tables[0].Rows[0]["body"]) == "2")
                                {
                                    body = "<font face='arial' size='2'><b>Dear " + Convert.ToString(dsleave.Tables[0].Rows[0]["employeeName"]) + ",</b><br><br>You have not kept your shift Out punch properly <b><font color='red'> Yesterday (" + Convert.ToString(dsleave.Tables[0].Rows[0]["date"]) + ")</font></b>.Please do take the next steps to correct it & avoid such manual errors going forward.</b></font><br>";
                                }
                                if (Convert.ToString(dsleave.Tables[0].Rows[0]["body"]) == "3")
                                {
                                    body = "<font face='arial' size='2'><b>Dear " + Convert.ToString(dsleave.Tables[0].Rows[0]["employeeName"]) + ",</b><br><br>You have not kept your shift In & Shift Out punch properly <b><font color='red'> Yesterday (" + Convert.ToString(dsleave.Tables[0].Rows[0]["date"]) + ")</font></b>.Please do take the next steps to correct it & avoid such manual errors going forward.</b></font><br>";
                                }
                                TriggerMail
                                (
                                    body,
                                    "TimeCheck - Discrepancy Reminder",
                                    //"manikandan.rr@angleritech.com",
                                    Convert.ToString(dsleave.Tables[0].Rows[0]["EmailId"]),
                                    "",
                                    null
                                );
                                Hashtable htEmail = new Hashtable();
                                htEmail.Clear();
                                htEmail.Add("@Appid", 0);
                                htEmail.Add("@Type", "D");
                                htEmail.Add("@Employeeid", Convert.ToInt16(dr["Employee_Id"]));
                                htEmail.Add("@ccMailID", "");
                                GetReports.ExecuteCommand("Proc_TA_InsertAndUpdateRemainder", htEmail);
                            }
                        }
                    }

                    //Getting Previous day Permission details
                    htreportingTo.Clear();
                    dsleave.Tables.Clear();
                    htreportingTo.Add("@EmployeeId", dr["Employee_Id"]);
                    htreportingTo.Add("@Type", "PP");
                    dsleave = objgr.GetDataSet("Proc_Ta_GetFutureLeaveRecordsEmployees_ForEmailTriggering", htreportingTo);
                    if (dsleave.Tables.Count > 0)
                    {
                        if (dsleave.Tables[0].Rows.Count > 0)
                        {
                            PrepareBodyContentPermission(dsleave);
                        }
                    }

                    //Getting Previous day Leave details
                    htreportingTo.Clear();
                    dsleave.Tables.Clear();
                    htreportingTo.Add("@EmployeeId", dr["Employee_Id"]);
                    htreportingTo.Add("@Type", "LP");
                    dsleave = objgr.GetDataSet("Proc_Ta_GetFutureLeaveRecordsEmployees_ForEmailTriggering", htreportingTo);
                    if (dsleave.Tables.Count > 0)
                    {
                        if (dsleave.Tables[0].Rows.Count > 0)
                        {
                            PrepareBodyContent(dsleave);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("GetLeaveRemainder", ex.Message.ToString());
            }
        }
        public void PrepareBodyContentPermission(DataSet ds)
        {
            string bodyContentFirst = "";
            try
            {
                int slno = 1;
                for (int j = 0; j < ds.Tables[0].Rows.Count; j++)
                {
                    GetReports objgr = new GetReports();
                    bodyContentFirst = "";
                    strAppID = "";
                    try
                    {
                        DataTable dt = new DataTable();
                        dt = ds.Tables[0];
                        string EmployeeID = Convert.ToString(ds.Tables[0].Rows[j]["Employee_Id"]);
                        dt.DefaultView.RowFilter = "Employee_Id=" + EmployeeID;
                        bodyContentFirst += "<br><br>" + PermissionHeaderScript("");
                        if (dt.DefaultView.Count > 1)
                        {
                            int k = 0;

                            foreach (DataRowView drv in dt.DefaultView)
                            {
                                strAppID = (strAppID == "") ? Convert.ToString(dt.Rows[j]["Permission_Id"]) : strAppID + "," + Convert.ToString(dt.Rows[j]["Permission_Id"]);
                                bodyContentFirst += "<tr>";
                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += slno;
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["Permission_Date"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["Permission_FromTime"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["Permission_ToTime"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["Permission_Status"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "</tr>";
                                slno += 1;
                                k += 1;
                            }
                            j = j + 1;
                            slno = 1;
                        }
                        else
                        {
                            strAppID = Convert.ToString(dt.Rows[j]["Permission_Id"]);

                            bodyContentFirst += "<tr>";
                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += slno;
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["Permission_Date"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["Permission_FromTime"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["Permission_ToTime"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["Permission_Status"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "</tr>";
                        }
                        bodyContentFirst += "</table>";
                        if (Convert.ToString(ds.Tables[0].Rows[j]["EmailId"]) != "" && Convert.ToString(ds.Tables[0].Rows[j]["EmailId"]) != null)
                        {
                            string ccMailID = "";
                            if (Convert.ToString(ds.Tables[0].Rows[j]["reportingToEmail"]) != null && Convert.ToString(ds.Tables[0].Rows[j]["reportingToEmail"]) != "")
                            {
                                ccMailID = Convert.ToString(ds.Tables[0].Rows[j]["reportingToEmail"]);
                            }
                            TriggerMail
                                (
                                "<font face='arial' size='2'><b>Dear " + Convert.ToString(ds.Tables[0].Rows[j]["employeeName"]) + ",</b><br><br>The following permission are not got approved, kindly get it approved before availing the Permission.</b></font>" + bodyContentFirst,
                                "TimeCheck - Permission Approval Reminder",
                                //"manikandan.rr@angleritech.com",
                                Convert.ToString(ds.Tables[0].Rows[j]["EmailId"]),
                                ccMailID,
                                null
                                );


                            Hashtable htEmail = new Hashtable();
                            htEmail.Clear();
                            htEmail.Add("@Appid", strAppID);
                            htEmail.Add("@Type", "P");
                            htEmail.Add("@Employeeid", Convert.ToInt16(EmployeeID));
                            htEmail.Add("@ccMailID", "");
                            GetReports.ExecuteCommand("Proc_TA_InsertAndUpdateRemainder", htEmail);
                        }
                    }
                    catch (Exception ex)
                    {
                        throw ex;
                    }
                }
            }
            catch (Exception errorInSendingMail)
            {
                throw errorInSendingMail;
            }
        }
        public string PermissionHeaderScript(string frm)
        {
            string headerscript = string.Empty;
            headerscript = "<table border='1' cellpadding='0' cellspacing='0' style='border-collapse: collapse' bordercolor='#111111' width='700'>";
            headerscript += "<tr bgcolor='#003466'>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Sl.No</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Permission Date</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>From Time</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>To Time</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Status</font></td>";
            headerscript += "</tr>";
            return headerscript;
        }
        public void PrepareBodyContent(DataSet ds)
        {
            string bodyContentFirst = "", bodyContentSecond = "", bodyContentFinal = "", bodyFirstline = ""; ;
            try
            {
                int slno = 1;
                for (int j = 0; j < ds.Tables[0].Rows.Count; j++)
                {
                    GetReports objgr = new GetReports();
                    bodyContentFirst = "";
                    bodyContentSecond = "";
                    strAppID = "";
                    try
                    {
                        DataTable dt = new DataTable();
                        dt = ds.Tables[0];
                        string EmployeeID = Convert.ToString(ds.Tables[0].Rows[j]["Employee_Id"]);
                        dt.DefaultView.RowFilter = "Employee_Id=" + EmployeeID;
                        bodyContentFirst += "<br><br>" + HeaderScript("");
                        if (dt.DefaultView.Count > 1)
                        {
                            int k = 0;

                            foreach (DataRowView drv in dt.DefaultView)
                            {
                                strAppID = (strAppID == "") ? Convert.ToString(dt.Rows[j]["LeaveApplication_Id"]) : strAppID + "," + Convert.ToString(dt.Rows[j]["LeaveApplication_Id"]);
                                bodyContentFirst += "<tr>";
                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += slno;
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["LeaveType"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["Leave_FromDate"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["Leave_ToDate"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["Leave_SessionFrom"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["Leave_SessionTo"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center'><font face='Arial' size='2'>";
                                bodyContentFirst += Convert.ToString(dt.Rows[k]["Status"]);
                                bodyContentFirst += "</font></td>";

                                bodyContentFirst += "</tr>";
                                slno += 1;
                                k += 1;
                            }
                            j = j + 1;
                            slno = 1;
                        }
                        else
                        {
                            strAppID = Convert.ToString(dt.Rows[j]["LeaveApplication_Id"]);

                            bodyContentFirst += "<tr>";
                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += slno;
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["LeaveType"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["Leave_FromDate"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["Leave_ToDate"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["Leave_SessionFrom"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["Leave_SessionTo"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "<td height='19' bgcolor='AliceBlue' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                            bodyContentFirst += Convert.ToString(dt.Rows[j]["Status"]);
                            bodyContentFirst += "</font></td>";

                            bodyContentFirst += "</tr>";
                        }
                        bodyContentFirst += "</table>";
                        bodyContentFinal = bodyContentFirst + bodyContentSecond;
                        if (Convert.ToString(ds.Tables[0].Rows[j]["EmailId"]) != "" && Convert.ToString(ds.Tables[0].Rows[j]["EmailId"]) != null)
                        {
                            string ccMailID = "";
                            if (Convert.ToString(ds.Tables[0].Rows[j]["reportingToEmail"]) != null && Convert.ToString(ds.Tables[0].Rows[j]["reportingToEmail"]) != "")
                            {
                                ccMailID = Convert.ToString(ds.Tables[0].Rows[j]["reportingToEmail"]);
                            }
                            TriggerMail
                                (
                                "<font face='arial' size='2'><b>Dear " + Convert.ToString(ds.Tables[0].Rows[j]["employeeName"]) + ",</b><br><br>The following Leaves are not got approved, Kindly get your leave Approved. If it is not getting approved then your Leave will be treated as LOP.  If not clear get it discussed.</b></font>" + bodyContentFinal,
                                "TimeCheck - Leave Approval Reminder",
                                //"manikandan.rr@angleritech.com",
                                Convert.ToString(ds.Tables[0].Rows[j]["EmailId"]),
                                ccMailID,
                                null
                                );

                            Hashtable htEmail = new Hashtable();
                            htEmail.Clear();
                            htEmail.Add("@Appid", strAppID);
                            htEmail.Add("@Type", "L");
                            htEmail.Add("@Employeeid", Convert.ToInt16(EmployeeID));
                            htEmail.Add("@ccMailID", ccMailID);
                            GetReports.ExecuteCommand("Proc_TA_InsertAndUpdateRemainder", htEmail);
                        }
                    }
                    catch (Exception ex)
                    {
                        throw ex;
                    }
                }
            }
            catch (Exception errorInSendingMail)
            {
                throw errorInSendingMail;
            }
        }
        public string HeaderScript(string frm)
        {
            string headerscript = string.Empty;
            headerscript = "<table border='1' cellpadding='0' cellspacing='0' style='border-collapse: collapse' bordercolor='#111111' width='700'>";
            headerscript += "<tr bgcolor='#003466'>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Sl.No</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Leave Type </font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>From</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>To</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>From Session</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>To Session</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Status</font></td>";
            headerscript += "</tr>";
            return headerscript;
        }

        public string prepareTableHeader(string frm)
        {
            string headerscript = string.Empty;
            headerscript = "<table border='1' cellpadding='0' cellspacing='0' style='border-collapse: collapse' bordercolor='#111111' width='750'>";
            headerscript += "<tr bgcolor='#003466'>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Sl.No</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Employee Name & ID </font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Department</font></td>";
            headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Date</font></td>";
            switch (frm)
            {
                case "LateEntry":
                    headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Shift Start Time</font></td>";
                    headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>In Time</font></td>";
                    headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Late by Hours</font></td>";
                    break;
                case "Early Exit":
                    headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Shift Start Time</font></td>";
                    headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>In Time</font></td>";
                    headerscript += "<td width='120px' height='25' align='center' style='border-right-color: #FFFFFF'><font face='Arial' size='2' color='#FFFFFF'>Late by Hours</font></td>";
                    break;
                default:
                    break;
            }
            headerscript += "</tr>";
            return headerscript;
        }
        public string prepareTableRecords(DataTable dt, string frm)
        {
            string tblrow = string.Empty;
            int i = 0;
            string bgcolor = "";
            foreach (DataRow dr in dt.Rows)
            {
                i = i + 1;
                tblrow += "<tr bgcolor='#003466'>";
                if (frm == "LateEntry")
                {
                    bgcolor = (i % 2 == 0) ? "AliceBlue" : "AliceBlue";
                    tblrow += "<td height='19' bgcolor='" + bgcolor + "' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                    tblrow += i;
                    tblrow += "</td>";
                    tblrow += "<td height='19' bgcolor='" + bgcolor + "' width='120px' align='left' style='border-color:#666666'><font face='Arial' size='2'>";
                    tblrow += Convert.ToString(dr["Employee Name"]) + " (" + Convert.ToString(dr["CardNo"]) + ")";
                    tblrow += "</td>";
                    tblrow += "<td height='19' bgcolor='" + bgcolor + "' width='120px' align='left' style='border-color:#666666'><font face='Arial' size='2'>";
                    tblrow += Convert.ToString(dr["Level Name"]);
                    tblrow += "</td>";
                    tblrow += "<td height='19' bgcolor='" + bgcolor + "' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                    tblrow += Convert.ToString(dr["Date"]);
                    tblrow += "</td>";
                    tblrow += "<td height='19' bgcolor='" + bgcolor + "' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                    tblrow += Convert.ToString(dr["Shift_StartTime"]);
                    tblrow += "</td>";
                    tblrow += "<td height='19' bgcolor='" + bgcolor + "' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                    tblrow += Convert.ToString(dr["InTime"]);
                    tblrow += "</td>";
                    tblrow += "<td height='19' bgcolor='" + bgcolor + "' width='120px' align='center' style='border-color:#666666'><font face='Arial' size='2'>";
                    tblrow += Convert.ToString(dr["LateBy"]);
                    tblrow += "</td>";
                }
                else
                {

                }
                tblrow += "</tr>";
            }
            tblrow += "</table>";
            return tblrow;
        }
        public void GetEmailSchedule(string ScheduleBasis, string DateFormat, string TimeFormat)
        {
            try
            {
                GetReports objGetReports = new GetReports();
                DataSet dsEmailSchedule = new DataSet();
                dsEmailSchedule = objGetReports.GetEmailSchedule(ScheduleBasis);
                DataSet dsDate = new DataSet();
                string pdfLocation = string.Empty;
                if (dsEmailSchedule.Tables[0].Rows.Count > 0)
                {
                    string FromDate = string.Empty;
                    string ToDate = string.Empty;
                    string FromDate_InReport = string.Empty;
                    string ToDate_InReport = string.Empty;
                    DataSet dsActiveLanguage = new DataSet();
                    dsActiveLanguage = objGetReports.GetActiveLanguage();
                    foreach (DataRow drRow in dsEmailSchedule.Tables[0].Rows)
                    {
                        DataSet dsScheduleDetails = new DataSet();
                        dsScheduleDetails = objGetReports.GetEmailIdsForSendingEmail(Convert.ToInt32(drRow["ScheduleId"]));
                        if (dsScheduleDetails != null && dsScheduleDetails.Tables.Count > 0 && dsScheduleDetails.Tables[0].Rows.Count > 0)
                        {
                            if (ScheduleBasis == "Daily")
                            {
                                dsDate = objGetReports.GetDates(ScheduleBasis, 0, 0);
                                if (dsDate.Tables[0].Rows.Count > 0)
                                {
                                    FromDate = dsDate.Tables[0].Rows[0][0].ToString();
                                    ToDate = dsDate.Tables[0].Rows[0][1].ToString();
                                }
                                else
                                {
                                    //ToDo:
                                    FromDate = Convert.ToDateTime(Convert.ToString(DateTime.Now, CI)).ToString();
                                    ToDate = Convert.ToDateTime(Convert.ToString(DateTime.Now, CI)).ToString();
                                }
                            }
                            else if (ScheduleBasis == "Weekly")
                            {
                                string strDayFrom = dsScheduleDetails.Tables[0].Rows[0]["DayFrom"].ToString();
                                string strDayTo = dsScheduleDetails.Tables[0].Rows[0]["DayTo"].ToString();
                                DataSet dsPrev_WeekDates = new DataSet();
                                dsPrev_WeekDates = objGetReports.GetSampleWeekDays(2, SelectDropDownItem(Convert.ToString(strDayFrom)), SelectDropDownItem(Convert.ToString(strDayTo)), 0, 0);
                                if (dsPrev_WeekDates.Tables.Count > 0)
                                {
                                    if (dsPrev_WeekDates.Tables[0].Rows.Count > 0)
                                    {
                                        FromDate = dsPrev_WeekDates.Tables[0].Rows[0][1].ToString();
                                        ToDate = dsPrev_WeekDates.Tables[0].Rows[0][2].ToString();
                                    }
                                }
                            }
                            else if (ScheduleBasis == "Monthly")
                            {
                                int Month = DateTime.Now.Date.Month;
                                int DateFrom = Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["DateFrom"]);
                                int DateTo = Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["DateTo"]);
                                int Year = DateTime.Now.Year;
                                dsDate = objGetReports.GetSampleWeekDays(3, "", "", DateFrom, DateTo);
                                if (dsDate.Tables[0].Rows.Count > 0)
                                {
                                    FromDate = dsDate.Tables[0].Rows[0][1].ToString();
                                    ToDate = dsDate.Tables[0].Rows[0][2].ToString();
                                }
                            }
                            if (dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString() == "Report_FirstInPunchDifference" || dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString() == "System_MultiLingual")
                            {
                                FromDate = (Convert.ToDateTime(FromDate).AddDays(-1)).ToShortDateString();
                                ToDate = (Convert.ToDateTime(ToDate).AddDays(-1)).ToShortDateString();
                            }
                            dsDateFormat = objGetReports.GetDatesWithFormat(FromDate, ToDate);
                            if (dsDateFormat.Rows.Count > 0)
                            {
                                FromDate_InReport = Convert.ToString(dsDateFormat.Rows[0][0]);
                                ToDate_InReport = Convert.ToString(dsDateFormat.Rows[0][1]);
                                FromDate_InReport = FromDate_InReport.Replace('/', '-');
                                ToDate_InReport = ToDate_InReport.Replace('/', '-');
                            }
                            else
                            {
                                FromDate_InReport = FromDate;
                                ToDate_InReport = ToDate;
                            }
                            if (ScheduleBasis == "Daily")
                            {
                                Duration = FromDate_InReport;
                                ScheduleName = dsScheduleDetails.Tables[0].Rows[0]["ScheduleName"].ToString();
                                ReportName1 = dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString();
                                CreatedBy = dsScheduleDetails.Tables[0].Rows[0]["Employee_FirstName"].ToString() + " " + dsScheduleDetails.Tables[0].Rows[0]["Employee_LastName"].ToString();
                            }
                            else if (ScheduleBasis == "Weekly")
                            {
                                Duration = FromDate_InReport + " - " + ToDate_InReport;
                                ScheduleName = dsScheduleDetails.Tables[0].Rows[0]["ScheduleName"].ToString();
                                ReportName1 = dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString();
                                CreatedBy = dsScheduleDetails.Tables[0].Rows[0]["Employee_FirstName"].ToString() + " " + dsScheduleDetails.Tables[0].Rows[0]["Employee_LastName"].ToString();
                            }
                            else if (ScheduleBasis == "Monthly")
                            {
                                Duration = FromDate_InReport + " - " + ToDate_InReport;
                                ScheduleName = dsScheduleDetails.Tables[0].Rows[0]["ScheduleName"].ToString();
                                ReportName1 = dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString();
                                CreatedBy = dsScheduleDetails.Tables[0].Rows[0]["Employee_FirstName"].ToString() + " " + dsScheduleDetails.Tables[0].Rows[0]["Employee_LastName"].ToString();
                            }
                            if (Convert.ToString(ConfigurationSettings.AppSettings["PDFGenerateLocation"]) != string.Empty)
                            {
                                pdfLocation = Convert.ToString(ConfigurationSettings.AppSettings["PDFGenerateLocation"]);
                            }
                            if (dsActiveLanguage.Tables.Count > 0)
                            {
                                if (dsActiveLanguage.Tables[0].Rows.Count > 0)
                                {
                                    LoadReport(dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["Filters"].ToString(), FromDate, ToDate, dsScheduleDetails.Tables[0].Rows[0]["ToEmailList"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["CCEmailList"].ToString(), Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["ScheduleId"]), DateFormat, TimeFormat, dsScheduleDetails.Tables[0].Rows[0]["Subject"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["EmailContent"].ToString(), FromDate_InReport, ToDate_InReport, dsActiveLanguage.Tables[0].Rows[0]["Language_Name"].ToString(), Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["CompanyId"]), dsScheduleDetails.Tables[0].Rows[0]["ReportType"].ToString(), Convert.ToInt16(dsScheduleDetails.Tables[0].Rows[0]["EmailSendType"]), Convert.ToInt16(dsScheduleDetails.Tables[0].Rows[0]["Authentication"]), dsScheduleDetails.Tables[0].Rows[0]["FileType"].ToString(), pdfLocation);
                                }
                            }
                            else
                            {
                                LoadReport(dsScheduleDetails.Tables[0].Rows[0]["displayName"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["Filters"].ToString(), FromDate, ToDate, dsScheduleDetails.Tables[0].Rows[0]["ToEmailList"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["CCEmailList"].ToString(), Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["ScheduleId"]), DateFormat, TimeFormat, dsScheduleDetails.Tables[0].Rows[0]["Subject"].ToString(), dsScheduleDetails.Tables[0].Rows[0]["EmailContent"].ToString(), FromDate_InReport, ToDate_InReport, "", Convert.ToInt32(dsScheduleDetails.Tables[0].Rows[0]["CompanyId"]), dsScheduleDetails.Tables[0].Rows[0]["ReportType"].ToString(), Convert.ToInt16(dsScheduleDetails.Tables[0].Rows[0]["EmailSendType"]), Convert.ToInt16(dsScheduleDetails.Tables[0].Rows[0]["Authentication"]), dsScheduleDetails.Tables[0].Rows[0]["FileType"].ToString(), pdfLocation);
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("Function :", "GetEmailSchedule --->" + ex.Message);
                throw ex;
            }
        }
        //public void TriggerMail(string bodyContent, string subject, string ToEmail, string CCEmail, Attachment attachment)
        //{
        //    GetReports objGetReports = new GetReports();
        //    DataSet dsMailConfiguration = new DataSet();
        //    dsMailConfiguration = objGetReports.GetMailConfiguration();
        //    string FromEmailId = string.Empty;
        //    string SMTPHost = string.Empty;
        //    string SMTPPort = string.Empty;
        //    if (dsMailConfiguration.Tables[0].Rows.Count > 0)
        //    {
        //        FromEmailId = dsMailConfiguration.Tables[0].Rows[0]["FromEmailId"].ToString();
        //        SMTPHost = dsMailConfiguration.Tables[0].Rows[0]["SMTPClientHost"].ToString();
        //        SMTPPort = dsMailConfiguration.Tables[0].Rows[0]["SMTPPort"].ToString();
        //    }
        //    else
        //    {
        //    }
        //    SmtpClient client = new SmtpClient();
        //    client.Host = SMTPHost;
        //    client.Port = Convert.ToInt32(SMTPPort);
        //    try
        //    {
        //        /*
        //         * Code Added By Thilakraj.C
        //         * Date : 20-Feb-2013
        //         * For : create LINK for Authentication or UnAuthentication User
        //         *                                          
        //         */
        //        //Start
        //        if (bodyContent.Contains("{Report Name}"))
        //        {
        //            bodyContent = bodyContent.Replace("{Report Name}", ReportName1);
        //        }
        //        if (bodyContent.Contains("{Schedule Name}"))
        //        {
        //            bodyContent = bodyContent.Replace("{Schedule Name}", ScheduleName);
        //        }
        //        if (bodyContent.Contains("{Duration}"))
        //        {
        //            bodyContent = bodyContent.Replace("{Duration}", Duration);
        //        }
        //        if (bodyContent.Contains("{Created By}"))
        //        {
        //            bodyContent = bodyContent.Replace("{Created By}", CreatedBy);
        //        }
        //        if (subject.Contains("{Report Name}"))
        //        {
        //            subject = subject.Replace("{Report Name}", ReportName1);
        //        }
        //        if (subject.Contains("{Schedule Name}"))
        //        {
        //            subject = subject.Replace("{Schedule Name}", ScheduleName);
        //        }
        //        if (subject.Contains("{Duration}"))
        //        {
        //            subject = subject.Replace("{Duration}", Duration);
        //        }
        //        if (subject.Contains("{Created By}"))
        //        {
        //            subject = subject.Replace("{Created By}", CreatedBy);
        //        }
        //        //End
        //        MailMessage message = new MailMessage();
        //        message.Body = bodyContent;
        //        message.IsBodyHtml = true;
        //        message.Subject = subject;
        //        message.From = new MailAddress(FromEmailId);
        //        char[] split = { ';' };
        //        string[] strToEmailIds = ToEmail.Split(split);
        //        foreach (string strToMail in strToEmailIds)
        //        {
        //            if (strToMail != string.Empty)
        //            {
        //                message.To.Add(strToMail);
        //            }
        //        }
        //        string[] strCCEmailIds = CCEmail.Split(split);
        //        foreach (string strCCMail in strCCEmailIds)
        //        {
        //            if (strCCMail != string.Empty)
        //            {
        //                message.CC.Add(strCCMail);
        //            }
        //        }
        //        if (attachment != null)
        //        {
        //            message.Attachments.Add(attachment);
        //        }
        //        // Send the e-mail message via the specified SMTP server
        //        client.Send(message);
        //        //message.Dispose();
        //        //message = null;
        //    }
        //    catch (Exception errorInSendingMail)
        //    {
        //        WriteErrorToEventLog("Function :", "TriggerMail --->" + errorInSendingMail.Message);
        //        throw errorInSendingMail;
        //    }
        //}

        public void SendMail(MailMessage mailMessage, string strSMTPPort, string strHost, string strSSLEnable, string strMailAuthentication, string strMailAuthenticateUser, string strMailAuthenticatePassword)
        {
            try
            {
                SmtpClient loSMTPServer = new SmtpClient(strSMTPPort, Convert.ToInt32(strSMTPPort));
                loSMTPServer.Host = strHost;
                if (strMailAuthentication == "1")
                {
                    strMailAuthenticatePassword = Cryptographys.Cryptography.Decrypt(strMailAuthenticatePassword, "TimecheckPhaseI");
                }
                loSMTPServer.Port = Convert.ToInt32(strSMTPPort);
                if (strSSLEnable == "1")
                {
                    loSMTPServer.EnableSsl = true;
                }
                else
                {
                    loSMTPServer.EnableSsl = false;
                }
                if (strMailAuthentication == "0")
                {
                    loSMTPServer.UseDefaultCredentials = true;
                }
                else
                {
                    loSMTPServer.UseDefaultCredentials = false;
                }
                mailMessage.IsBodyHtml = true;
                if (strMailAuthentication == "1")
                {
                    System.Net.ServicePointManager.ServerCertificateValidationCallback = delegate (object s,
                 System.Security.Cryptography.X509Certificates.X509Certificate certificate,
                 System.Security.Cryptography.X509Certificates.X509Chain chain,
                 System.Net.Security.SslPolicyErrors sslPolicyErrors)
                    {
                        return true;
                    };
                    loSMTPServer.Credentials = new System.Net.NetworkCredential(strMailAuthenticateUser, strMailAuthenticatePassword);
                    loSMTPServer.Send(mailMessage);
                }
                else
                {
                    loSMTPServer.DeliveryMethod = SmtpDeliveryMethod.Network;
                    loSMTPServer.Send(mailMessage);
                }
            }
            catch (Exception Ex)
            {

                throw;
            }

        }
        public void TriggerMail(string bodyContent, string subject, string ToEmail, string CCEmail, Attachment attachment)
        {
            GetReports objGetReports = new GetReports();
            DataSet dsMailConfiguration = new DataSet();
            dsMailConfiguration = objGetReports.GetMailConfiguration();

            string FromEmailId = string.Empty;
            string SMTPHost = string.Empty;
            string SMTPPort = string.Empty;
            string strSSLEnable = string.Empty;
            string strMailAuthentication = string.Empty;
            string strMailAuthenticateUser = string.Empty;
            string strMailAuthenticatePassword = string.Empty;
            if (dsMailConfiguration.Tables.Count > 0)
            {
                if (dsMailConfiguration.Tables[0].Rows.Count > 0)
                {
                    FromEmailId = dsMailConfiguration.Tables[0].Rows[0]["FromEmailId"].ToString();
                    SMTPHost = dsMailConfiguration.Tables[0].Rows[0]["SMTPClientHost"].ToString();
                    SMTPPort = dsMailConfiguration.Tables[0].Rows[0]["SMTPPort"].ToString();
                    if (Convert.ToString(dsMailConfiguration.Tables[0].Rows[0]["SSLEnable"]) == "True")
                    {
                        strSSLEnable = "1";
                    }
                    else
                    {
                        strSSLEnable = "0";
                    }
                    if (Convert.ToString(dsMailConfiguration.Tables[0].Rows[0]["MailAuthentication"]) == "True")
                    {
                        strMailAuthentication = "1";
                    }
                    else
                    {
                        strMailAuthentication = "0";
                    }
                    strMailAuthenticateUser = dsMailConfiguration.Tables[0].Rows[0]["MailAuthenticateUser"].ToString();
                    strMailAuthenticatePassword = dsMailConfiguration.Tables[0].Rows[0]["MailAuthenticatePassword"].ToString();

                    //FromEmailId = "iecfax@iecc.md";iecfax@iecc.md
                    //SMTPHost = "smtp.office365.com";smtp.office365.com
                    //SMTPPort = "587";
                    //strSSLEnable = "1";
                    //strMailAuthentication = "1";
                    //strMailAuthenticateUser = "iecfax@iecc.md";iecfax@iecc.md
                    //strMailAuthenticatePassword = "AEfY8u45zckNPGjeO8Hkeg==";AEfY8u45zckNPGjeO8Hkeg==

                    try
                    {

                        if (bodyContent.Contains("{Report Name}"))
                        {
                            bodyContent = bodyContent.Replace("{Report Name}", ReportName1);
                        }
                        if (bodyContent.Contains("{Schedule Name}"))
                        {
                            bodyContent = bodyContent.Replace("{Schedule Name}", ScheduleName);
                        }
                        if (bodyContent.Contains("{Duration}"))
                        {
                            bodyContent = bodyContent.Replace("{Duration}", Duration);
                        }
                        if (bodyContent.Contains("{Created By}"))
                        {
                            bodyContent = bodyContent.Replace("{Created By}", CreatedBy);
                        }
                        if (subject.Contains("{Report Name}"))
                        {
                            subject = subject.Replace("{Report Name}", ReportName1);
                        }
                        if (subject.Contains("{Schedule Name}"))
                        {
                            subject = subject.Replace("{Schedule Name}", ScheduleName);
                        }
                        if (subject.Contains("{Duration}"))
                        {
                            subject = subject.Replace("{Duration}", Duration);
                        }
                        if (subject.Contains("{Created By}"))
                        {
                            subject = subject.Replace("{Created By}", CreatedBy);
                        }
                        //End
                        MailMessage message = new MailMessage();
                        message.Body = bodyContent;
                        message.IsBodyHtml = true;
                        message.Subject = subject;
                        message.From = new MailAddress(FromEmailId);
                        char[] split = { ';' };
                        string[] strToEmailIds = ToEmail.Split(split);
                        foreach (string strToMail in strToEmailIds)
                        {
                            if (strToMail != string.Empty)
                            {
                                message.To.Add(strToMail);
                            }
                        }
                        string[] strCCEmailIds = CCEmail.Split(split);
                        foreach (string strCCMail in strCCEmailIds)
                        {
                            if (strCCMail != string.Empty)
                            {
                                message.CC.Add(strCCMail);
                            }
                        }
                        if (attachment != null)
                        {
                            message.Attachments.Add(attachment);
                        }
                        // Send the e-mail message via the specified SMTP server
                        SendMail(message, SMTPPort, SMTPHost, strSSLEnable, strMailAuthentication, strMailAuthenticateUser, strMailAuthenticatePassword);
                        //message.Dispose();
                        //message = null;
                    }
                    catch (Exception errorInSendingMail)
                    {
                        throw errorInSendingMail;
                    }
                }
            }
        }
        /*
            * Code Added By Thilakraj.C
            * Date : 20-Feb-2013
            * For : create LINK for Authentication or UnAuthentication User
            *                                          
        */
        //Start
        public string LinkCreation(string Mailbody, int Authentication, int ScheduleId, string FromDate, string Todate, string Language, string DateFormat, string TimeFormat)
        {
            string UpdatedMailbody = string.Empty;
            string strVirualDirectory = string.Empty;
            try
            {
                UpdatedMailbody = Mailbody;
                UpdatedMailbody = UpdatedMailbody + "{Link}";
                strVirualDirectory = ConfigurationSettings.AppSettings["VirualDirectory"].ToString();
                if (Authentication == 1)
                {
                    //Login Required
                    if (UpdatedMailbody.Contains("{Link}"))
                    {
                        string Link = string.Empty;
                        string LinkHref = string.Empty;
                        Link = @"<br/><br/><b><a runat=""server"" href=""{LinkHref}""><span>Click Here To Open the File</span></a></b> ";
                        if (Link.Contains("{LinkHref}"))
                        {
                            LinkHref = "http://" + strVirualDirectory.Trim() + "/Index.aspx?ScheduleId=" + Encryption.Encrypt(ScheduleId.ToString(), "") + "&FromDate=" + Encryption.Encrypt(FromDate.ToString(), "") + "&ToDate=" + Encryption.Encrypt(Todate.ToString(), "");
                            Link = Link.Replace("{LinkHref}", LinkHref);
                        }
                        UpdatedMailbody = UpdatedMailbody.Replace("{Link}", Link);
                    }
                }
                else
                {
                    //Show File
                    if (UpdatedMailbody.Contains("{Link}"))
                    {
                        string Link = string.Empty;
                        string LinkHref = string.Empty;
                        Link = @"<br/><br/><b><a runat=""server"" href=""{LinkHref}""><span>Click Here To Open the File</span></a></b> ";
                        if (Link.Contains("{LinkHref}"))
                        {
                            LinkHref = "http://" + strVirualDirectory.Trim() + "/Reports/TA_UI_Report_ReportViewer.aspx?ScheduleId=" + Encryption.Encrypt(ScheduleId.ToString(), "") + "&Language=" + Encryption.Encrypt(Language, "") + "&FromDate=" + Encryption.Encrypt(FromDate.ToString(), "") + "&ToDate=" + Encryption.Encrypt(Todate.ToString(), "") + "&DateFormat=" + Encryption.Encrypt(DateFormat.ToString(), "") + "&TimeFormat=" + Encryption.Encrypt(TimeFormat.ToString(), "");
                            Link = Link.Replace("{LinkHref}", LinkHref);
                        }
                        UpdatedMailbody = UpdatedMailbody.Replace("{Link}", Link);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("Function :", "LinkCreation --->" + ex.Message);
            }
            return UpdatedMailbody;
        }
        //End
        public void LoadReport(string ReportName, string Filters, string FromDate, string ToDate, string ToEmail, string CCEmail, int ScheduleId, string DateFormat, string TimeFormat, string Subject, string EmailContent, string FromDateInReport, string ToDateInReport, string LanguageName, int CompanyId, string ReportType, int EmailSendType, int Authentication, string FileFormat, string path)
        {
            try
            {
                GetReports objGetReports = new GetReports();
                ReportDocument rptDoc = new ReportDocument();
                HeaderInformation hdrTable = new HeaderInformation();
                DataSet dsHeader = new DataSet();
                dsHeader = objGetReports.getHeader(CompanyId);
                DataSet dsData = new DataSet();
                if (ReportName == "Report_FirstInPunchDifference" || ReportName == "System_MultiLingual")
                {
                    FromDate = (Convert.ToDateTime(FromDate).AddDays(-1)).ToShortDateString();
                    ToDate = (Convert.ToDateTime(ToDate).AddDays(-1)).ToShortDateString();
                }
                if (ReportName == "Report_Late_Entry")
                {
                    if (ReportType == "LateEntry")
                    {
                        ReportName = "Report_Late_Entry";
                        ReportName1 = "Report_Late_Entry";
                    }
                    else if (ReportType == "EarlyExit")
                    {
                        ReportName = "Report_Early_Exit";
                        ReportName1 = "Report_Early_Exit";
                    }
                    else if (ReportType == "EarlyEntry")
                    {
                        ReportName = "Report_EarlyEntry";
                        ReportName1 = "Report_EarlyEntry";
                    }
                    else if (ReportType == "LateExit")
                    {
                        ReportName = "Report_Late_Exit";
                        ReportName1 = "Report_Late_Exit";
                    }
                    else if (ReportType == "All")
                    {
                        ReportName = "Report_Exception";
                        ReportName1 = "Report_Exception";
                    }
                }
                Filters = Filters.Replace("Duration_From ", FromDate);
                Filters = Filters.Replace("Duration_To ", ToDate);
                switch (ReportName)
                {
                    case "Report_WeeklyWorkHours":
                        #region Report_Monthly_Attendance
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Cumulative Minimum Work Week Hours";
                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Cumulative Minimum Work Week Hours";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (ReportType == "0")
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "WeeklyWorkHours.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "WeeklyWorkHours.rpt");
                                                }
                                            }
                                            else
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "WeeklyWorkHoursSummary.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "WeeklyWorkHoursSummary.rpt");
                                                }
                                            }
                                            rptDoc.Database.Tables["dt_Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Weekly_Work_Hours"].SetDataSource(dsData.Tables[1]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.Database.Tables["WeekDayDetails"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            if (ReportType == "0")
                                            {
                                                rptDoc.SetParameterValue("DtFormat", DateFormat, "WeekDayDetails");
                                                rptDoc.SetParameterValue("TimeFormat", TimeFormat, "WeekDayDetails");
                                            }
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        // EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_WeeklyWorkHours--->" + ex.Message);
                        }
                        break;
                    #endregion
                    case "Report_RawData":
                        #region Report_RawData
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "RawData";
                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "RawData";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (ReportType == "0")
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "RptRawData.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "RptRawData.rpt");
                                                }
                                            }
                                            else
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "rptRawDataLatestPunch.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "rptRawDataLatestPunch.rpt");
                                                }
                                            }
                                            //MonthlyAttendanceDetailData2
                                            rptDoc.Database.Tables["dt_Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["RawData"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        // EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_RawData--->" + ex.Message);
                        }
                        break;
                    #endregion
                    case "Report_GeneralMonthly_Attendance":
                        #region Report_Monthly_Attendance
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "General Monthly Attendance";
                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "General Monthly Attendance";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "RptGeneralMonthlyAttendance.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "RptGeneralMonthlyAttendance.rpt");
                                            }
                                            //MonthlyAttendanceDetailData2
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        // EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_RawData--->" + ex.Message);
                        }
                        break;
                    #endregion
                    case "Report_Employee_Shift_Allocation":
                        #region Report_Employee_Shift_Allocation
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Header";
                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Shift Not Allocated Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);
                            if (ReportType == "0")
                            {
                                dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                                if (dsData != null)
                                {
                                    if (dsData.Tables.Count > 0)
                                    {
                                        if (dsData.Tables[0].Rows.Count > 0)
                                        {
                                            if (EmailSendType == 1)
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "RptShiftNotAllocatedReport_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "EmployeeShiftAllocationReport.rpt");
                                                }
                                                rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                                rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[1]);
                                                rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                                rptDoc.SetParameterValue("DtFormat", DateFormat);
                                                rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                                EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                            }
                                            else
                                            {
                                                /*
                                                 * Code Added By Thilakraj.C
                                                 * Date : 20-Feb-2013
                                                 * For : create LINK for Authentication or UnAuthentication User
                                                 *                                          
                                                 */
                                                //Start
                                                string UpdatedEmailContent = string.Empty;
                                                UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDate, ToDate, LanguageName, DateFormat, TimeFormat);
                                                TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                                //End
                                            }
                                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                        }
                                        else
                                        {
                                            //EmailContent = string.Empty;
                                            Subject = Subject + " - " + " No Records Found ";
                                            TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                        }
                                    }
                                }
                            }
                            else
                            {
                                dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                                if (dsData != null)
                                {
                                    if (dsData.Tables.Count > 0)
                                    {
                                        if (dsData.Tables[0].Rows.Count > 0)
                                        {
                                            if (EmailSendType == 1)
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "RptShiftNotAllocatedReport_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "RptShiftNotAllocatedReport.rpt");
                                                }
                                                rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                                rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                                rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                                rptDoc.SetParameterValue("DtFormat", DateFormat);
                                                rptDoc.SetParameterValue("TimeFormat", TimeFormat);

                                                EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                            }
                                            else
                                            {
                                                /*
                                                 * Code Added By Thilakraj.C
                                                 * Date : 20-Feb-2013
                                                 * For : create LINK for Authentication or UnAuthentication User
                                                 *                                          
                                                 */
                                                //Start
                                                string UpdatedEmailContent = string.Empty;
                                                UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDate, ToDate, LanguageName, DateFormat, TimeFormat);
                                                TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                                //End
                                            }
                                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);

                                        }
                                        else
                                        {
                                            //EmailContent = string.Empty;
                                            Subject = Subject + " - " + " No Records Found ";
                                            TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                        }
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function : ", " Load Report ---> Report_Employee_Shift_Allocation ---> " + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_ShiftNotAllocated":
                        #region Report_ShiftNotAllocated
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Header";
                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Shift Not Allocated Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "RptShiftNotAllocatedReport_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "RptShiftNotAllocatedReport.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            /*
                                             * Code Added By Thilakraj.C
                                             * Date : 20-Feb-2013
                                             * For : create LINK for Authentication or UnAuthentication User
                                             *                                          
                                             */
                                            //Start
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDate, ToDate, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);

                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function : ", "Load Report ---> Report_ShiftNotAllocated ---> " + ex.Message);

                        }
                        break;
                    #endregion
                    case "LeaveDetails":
                        #region "DailyReport"
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Absent";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Leave & Permission Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            DataSet dsDailyLeave = new DataSet();
                            DataSet dsDailyLeaveUnplanned = new DataSet();
                            DataSet dsDailyPermission = new DataSet();
                            DataSet dsDailyPermissionUnplanned = new DataSet();

                            dsDailyLeave = objGetReports.SelectReportData(Filters, "DailyReport-DailyLeave", ReportType);

                            dsDailyLeaveUnplanned = objGetReports.SelectReportData(Filters, "DailyReport-DailyLeaveUnplanned", ReportType);

                            dsDailyPermission = objGetReports.SelectReportData(Filters, "DailyReport-DailyPermission", ReportType);

                            dsDailyPermissionUnplanned = objGetReports.SelectReportData(Filters, "DailyReport-DailyPermissionUnplanned", ReportType);

                            if (dsDailyLeave != null && dsDailyLeaveUnplanned != null && dsDailyPermission != null && dsDailyPermissionUnplanned != null)
                            {
                                if (EmailSendType == 1)
                                {
                                    if (LanguageName == "Arabic")
                                    {
                                        rptDoc.Load(ExePath + "DailyReport.rpt");
                                    }
                                    else
                                    {
                                        rptDoc.Load(ExePath + "DailyReport.rpt");
                                    }
                                    rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                    rptDoc.Database.Tables["leave"].SetDataSource(dsDailyLeave.Tables[0]);
                                    rptDoc.Database.Tables["unplanned"].SetDataSource(dsDailyLeaveUnplanned.Tables[0]);
                                    rptDoc.Database.Tables["permission"].SetDataSource(dsDailyPermission.Tables[0]);
                                    rptDoc.Database.Tables["permissionunplanned"].SetDataSource(dsDailyPermissionUnplanned.Tables[0]);
                                    rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                    EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                }
                                else
                                {
                                    string UpdatedEmailContent = string.Empty;
                                    UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                    TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                    //End
                                }
                                objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                            }
                            else
                            {
                                Subject = Subject + " - " + " No Records Found ";
                                TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                            }
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);

                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report ---> LeaveDetails ---> " + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Absent":
                        #region Report_Absent
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Absent";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Absent Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "absent_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "absent.rpt");
                                            }

                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDate, ToDate, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);

                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);

                                    }
                                    else
                                    {
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Absent --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_OnDutyEntry":
                        #region Report_OnDutyEntry
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Header";
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "OnDuty Entry Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "OnDutyEntry_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "OnDutyEntry.rpt");
                                            }

                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDate, ToDate, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);

                                    }
                                    else
                                    {
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                        }
                        break;
                    #endregion
                    case "Report_EarltEntry":
                    case "Report_EarlyEntry":
                        #region Report_EarltEntry
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Early Entry";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Early Entry Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);
                            //dsData = objGetReports.SelectEarlyEntryReport("", "0", FromDate, ToDate, "", 0, 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "EarlyEntry_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "EarlyEntry.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_EarltEntry -->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Late_Entry":
                        #region Report_Late_Entry
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Late Entry";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Late Entry Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectLateInstanceReport("", "0", FromDate, ToDate, "", 0, 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            int payrollConfig = 0;
                                            string bodyContent = "";
                                            payrollConfig = objGetReports.CheckPageExistsInLicense(185);
                                            if (payrollConfig == 1)
                                            {
                                                bodyContent = prepareTableHeader("LateEntry");
                                                bodyContent += prepareTableRecords(dsData.Tables[0], "LateEntry");
                                                EmailContent = EmailContent + "<br>" + bodyContent;
                                            }
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "LateInstanceReport_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "LateInstanceReport.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Late_Entry --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Early_Exit":
                        #region Report_Early_Exit
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Absent";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Early Exit Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectEarlyOutReportNew(FromDate, ToDate, "", 0, "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "earlyExit_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "earlyExit.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Early_Exit --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Late_Exit":
                        #region Report_Late_Exit
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Late Exit";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Late Exit Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectLateExit(FromDate, ToDate, "", 0, "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "lateExit_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "lateExit.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString(), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Late_Exit --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Leave":
                        #region Report_Leave
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Leave";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Leave Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectLeave(FromDate, ToDate, "", 0, "", "", "All", "All", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (ReportType == "0")
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "leave_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "leave.rpt");
                                                }
                                            }
                                            else
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "RptLeaveSummary_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "RptLeaveSummary.rpt");
                                                }
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Leave --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_All_Swipes":
                        #region Report_All_Swipes
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "All Swipes";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "All Swipes Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectMovementsEntryReport("", "", FromDate, ToDate, "", 0, 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both", "12:00:00 AM", "11:59:59 PM");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            int AllSwipesReportType;
                                            AllSwipesReportType = objGetReports.ReturnAllSwiper();
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "MovementsEntry_AR.rpt");
                                            }
                                            else
                                            {
                                                if (AllSwipesReportType == 1)
                                                {
                                                    rptDoc.Load(ExePath + "RptMovementEntry_FirstAndLast.rpt");
                                                }
                                                else if (AllSwipesReportType == 2)
                                                {
                                                    rptDoc.Load(ExePath + "MatchedMovementsEntry.rpt");
                                                }
                                                else if (AllSwipesReportType == 3)
                                                {
                                                    rptDoc.Load(ExePath + "MovementsEntryWithOutMatched.rpt");
                                                }
                                                else if (AllSwipesReportType == 4)
                                                {
                                                    rptDoc.Load(ExePath + "OtherMovementsEntry.rpt");
                                                }
                                                else if (AllSwipesReportType != 1)
                                                {
                                                    rptDoc.Load(ExePath + "MovementsEntry.rpt");
                                                }
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_All_Swipes --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Detailed_Attendance":
                        #region Report_Detailed_Attendance
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Detailed Attendance";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Detailed Attendance Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectDetailAttend(FromDate, ToDate, "", "", "", UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            dsData.Tables[0].Columns.Remove("EmployeeCategory");
                            dsData.Tables[0].Columns.Remove("EmpCategory");
                            dsData.Tables[0].Columns.Remove("EmployeeType");
                            int iField = 1;
                            int iInc = 0;

                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            DataTable dtHeaderLabel = new DataTable();
                                            dtHeaderLabel.TableName = "HeaderLabels";

                                            DataTable dtNew = new DataTable();
                                            dtNew = dsData.Tables[0];

                                            //DataTable dtDetAttend = new DataTable();
                                            //dtDetAttend = dsData.Tables["Table"].Copy();

                                            DataTable dt = new DataTable();
                                            DataSet dsReportHeader = new DataSet();
                                            dsReportHeader = objGetReports.getHeader(CompanyId);

                                            if (dsData.Tables[0].Columns.Count > 11)
                                            {
                                                // total columns = 16

                                                if (dsData.Tables[0].Columns.Count < 21)
                                                {

                                                    int iDiff = (20 - dsData.Tables[0].Columns.Count);
                                                    for (int iDum = 0; iDum < iDiff; iDum++)
                                                    {

                                                        dsData.Tables[0].Columns.Add(new DataColumn("iField" + iInc, System.Type.GetType("System.String")));
                                                        iInc = iInc + 1;
                                                    }
                                                }

                                                DataRow dsRow = dtHeaderLabel.NewRow();
                                                int iIcont = 1;
                                                for (int iRow = 0; iRow < dsData.Tables[0].Columns.Count; iRow++)
                                                {
                                                    dtHeaderLabel.Columns.Add(new DataColumn("Header" + iIcont, System.Type.GetType("System.String")));
                                                    if (dsData.Tables[0].Columns[iRow].ColumnName != "Others")
                                                    {
                                                        dsRow[iRow] = dsData.Tables[0].Columns[iRow].ColumnName;
                                                    }
                                                    else if (dsData.Tables[0].Columns[iRow].ColumnName == "Others")
                                                    {
                                                        //dsRow[iRow] = rm.GetString("Employee_Others", ci);
                                                        dsRow[iRow] = dsData.Tables[0].Columns[iRow].ColumnName;
                                                    }
                                                    iIcont = iIcont + 1;

                                                }
                                                int iCheckFlag = 0;
                                                dtHeaderLabel.Rows.InsertAt(dsRow, 0);
                                                for (int iCol = 16; iCol < dsData.Tables[0].Columns.Count; iCol++)
                                                {
                                                    if (dsData.Tables[0].Columns[iCol].ColumnName != "Others")
                                                    {
                                                        dsData.Tables[0].Columns[iCol].ColumnName = "Field" + iField;
                                                        iField = iField + 1;
                                                    }
                                                    else
                                                    {
                                                        iCheckFlag = 1;
                                                    }
                                                }
                                                if (iCheckFlag == 0)
                                                {
                                                    //dsEmp.Tables[0].Columns[16].ColumnName = "Others";
                                                    //dsEmp.Tables[0].Columns[16].ColumnName = rm.GetString("Employee_Others", ci);
                                                }
                                            }

                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "detailedAttendance_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "detailedAttendance.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsReportHeader.Tables[0]);
                                            rptDoc.Database.Tables["HeaderLabels"].SetDataSource(dtHeaderLabel);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        // EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Detailed_Attendance --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Monthly_Attendance":
                        #region Report_Monthly_Attendance
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Monthly Attendance";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Monthly Attendance Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectMonthlyAttendanceReport("", FromDate, ToDate, "", "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both", 0);

                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (ReportType == "0")
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "RptMonthlyAttendance_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "RptMonthlyAttendance.rpt");
                                                }
                                            }
                                            else
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "RptMonthlyAttendance_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "RptMonthlyAttendanceDetail.rpt");
                                                }
                                                rptDoc.Database.Tables["Table1"].SetDataSource(dsData.Tables[1]);
                                            }
                                            //MonthlyAttendanceDetailData2
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        // EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Monthly_Attendance --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Punctuality":
                        #region Report_Punctuality
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Punctuality";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Punctuality Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectPunctuality(FromDate, ToDate, "", 0, "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "punctuality_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "punctuality.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Punctuality -->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Discrepancy":
                        #region Report_Discrepancy
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Discrepancy";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Discrepancy Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectDiscrepancy(FromDate, ToDate, "", 0, "", "", 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "discrepancy_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "discrepancy.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Discrepancy --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Permission":
                        #region Report_Permission
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Permission";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Permission Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectPermissionReport(FromDate, ToDate, "", "", "", 0, 0, UserGroupName, GradeLevel, "All", "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "rptPermission_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "rptPermission.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Permission --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_ManualTimeEntry":
                        #region Report_ManualTimeEntry
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Manual Time Entry";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Manual Time Entry Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            //dsData = objGetReports.SelectManualTimeEntryReport("", "", FromDate, ToDate, "", 0, 0, UserGroupName, GradeLevel, "All", "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "ManualTimeEntry_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "ManualTimeEntry.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);

                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        // EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_ManualTimeEntry --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "MustoRollReport":
                        #region MustoRollReport
                        try
                        {
                            int iWorkingDays = 0;

                            DataSet dsTot = new DataSet();
                            DataTable dt = new DataTable();
                            dt = objGetReports.GetDateMonth(FromDate, ToDate);
                            if (dt.Rows.Count > 0)
                            {
                                strMonth = Convert.ToString(dt.Rows[0]["Month"]);
                                strYear = Convert.ToString(dt.Rows[0]["Year"]);
                                strDay = Convert.ToString(dt.Rows[0]["TS"]);
                                strFromDate = Convert.ToString(dt.Rows[0]["Fromdate"]);
                            }
                            dsTot = objGetReports.SelectTotalWorkingDays(strMonth, strYear);
                            if (dsTot != null && dsTot.Tables.Count > 0 && dsTot.Tables[0].Rows.Count > 0 && dsTot.Tables[0].Rows[0]["TotalWokingDays"] != DBNull.Value)
                            {
                                iWorkingDays = Convert.ToInt32(dsTot.Tables[0].Rows[0]["TotalWokingDays"]);
                            }
                            //Filters = Filters.Replace("@fromDat", "@FromDate1");
                            //Filters = Filters.Replace("@ToDat", "@ToDate1");

                            DataTable dtRptHeader = new DataTable();
                            //start report//

                            //Create the datatable ,that holds the header information
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Header";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = iWorkingDays;
                            drHdr["ReportName"] = "Form 25 Report";

                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;

                            dtHdr1.Rows.Add(drHdr);

                            //Get the Report source from the Server and load this into the report table
                            DataSet dsForm25 = new DataSet();

                            string SelectedMonth = strMonth;
                            string SelectedYear = strYear;

                            DataTable NewDT = new DataTable();
                            string EmpID = "";

                            DataColumn DC1 = new DataColumn();
                            DC1.ColumnName = "Name";
                            NewDT.Columns.Add(DC1);
                            DataColumn DC2 = new DataColumn();
                            DC2.ColumnName = "FatherName";
                            NewDT.Columns.Add(DC2);
                            DataColumn DC3 = new DataColumn();
                            DC3.ColumnName = "Designation";
                            NewDT.Columns.Add(DC3);

                            DataColumn DC9 = new DataColumn();
                            DC9.ColumnName = "Employee_Code_Id";
                            NewDT.Columns.Add(DC9);

                            DataColumn DC4 = new DataColumn();
                            DC4.ColumnName = "Present";
                            NewDT.Columns.Add(DC4);
                            DataColumn DC5 = new DataColumn();
                            DC5.ColumnName = "Absent";
                            NewDT.Columns.Add(DC5);

                            DataColumn DC6 = new DataColumn();
                            DC6.ColumnName = "Leave";
                            NewDT.Columns.Add(DC6);

                            DataColumn dcHoliday = new DataColumn();
                            dcHoliday.ColumnName = "Holiday";
                            NewDT.Columns.Add(dcHoliday);

                            DataColumn dcOT = new DataColumn();
                            dcOT.ColumnName = "TotalOT";
                            NewDT.Columns.Add(dcOT);

                            for (int j = 1; j <= 31; j++)
                            {
                                DataColumn DC = new DataColumn();
                                DC.ColumnName = "Day" + j;
                                NewDT.Columns.Add(DC);
                            }
                            DataSet dsSummaryData = new DataSet();
                            DataSet dsDetailedData = new DataSet();

                            //TimeSpan ts = Convert.ToDateTime(ToDate).Subtract(Convert.ToDateTime(FromDate));
                            int Days = Convert.ToInt32(strDay);
                            if (Days > 31)
                            {
                                FromDate = strFromDate;
                            }
                            //dsSummaryData = objGetReports.SelectInOutEmployeeSummary(SelectedMonth, SelectedYear, "", "", "", "0", "0", UserGroupName, GradeLevel, "", 0, 0, "Both");

                            if (ReportType == "0")
                            {
                                dsSummaryData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                                if (dsSummaryData != null)
                                {
                                    if (dsSummaryData.Tables.Count > 0)
                                    {
                                        if (dsSummaryData.Tables[0].Rows.Count > 0)
                                        {
                                            if (EmailSendType == 1)
                                            {
                                                rptDoc.PrintOptions.PaperSize = CrystalDecisions.Shared.PaperSize.PaperCsheet;
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "EmployeInOutSummary_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "EmployeeInOutSummary.rpt");
                                                }
                                                rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                                rptDoc.Database.Tables["Table"].SetDataSource(dsSummaryData.Tables[0]);
                                                rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                                rptDoc.Database.Tables["Table1"].SetDataSource(dsSummaryData.Tables[1]);

                                                rptDoc.SetParameterValue("DtFormat", DateFormat);
                                                rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                                EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                            }
                                            else
                                            {
                                                string UpdatedEmailContent = string.Empty;
                                                UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                                TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                                //End
                                            }
                                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                        }
                                        else
                                        {
                                            //EmailContent = string.Empty;
                                            Subject = Subject + " - " + " No Records Found ";
                                            TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                        }
                                    }
                                }
                            }
                            else
                            {
                                //dsDetailedData = objGetReports.SelectInOutEmployeeNew(SelectedMonth, SelectedYear, "", "", "", "0", "0", UserGroupName, GradeLevel, "", 0, 0, "Both");
                                dsDetailedData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                                if (dsDetailedData != null)
                                {
                                    if (dsDetailedData.Tables.Count > 0)
                                    {
                                        if (dsDetailedData.Tables[0].Rows.Count > 0)
                                        {
                                            if (EmailSendType == 1)
                                            {
                                                rptDoc.PrintOptions.PaperSize = CrystalDecisions.Shared.PaperSize.DefaultPaperSize;
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "EmployeeInOut_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "EmployeeInOut.rpt");
                                                }

                                                rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                                rptDoc.Database.Tables["Table"].SetDataSource(dsDetailedData.Tables[0]);
                                                rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                                rptDoc.Database.Tables["Table1"].SetDataSource(dsDetailedData.Tables[1]);

                                                rptDoc.SetParameterValue("DtFormat", DateFormat);
                                                rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                                rptDoc.SetParameterValue("FromDate", FromDateInReport);
                                                rptDoc.SetParameterValue("ToDate", ToDateInReport);
                                                rptDoc.SetParameterValue("Display", "Both");
                                                EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                            }
                                            else
                                            {
                                                string UpdatedEmailContent = string.Empty;
                                                UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                                TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                                //End
                                            }
                                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                        }
                                        else
                                        {
                                            //EmailContent = string.Empty;
                                            Subject = Subject + " - " + " No Records Found ";
                                            TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                        }
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : MustoRollReport -->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_SummaryReport":
                        #region Report_SummaryReport
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Summary Entry";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Summary Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            DataSet dsSummaryData = new DataSet();
                            DataSet dsDetailedData = new DataSet();

                            //dsSummaryData = objGetReports.SelectSummaryReport(FromDate, UserGroupName, 0, 0);
                            dsSummaryData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsSummaryData != null)
                            {
                                if (dsSummaryData.Tables.Count > 0)
                                {
                                    if (dsSummaryData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "SummaryReport_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "SummaryReport.rpt");
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsSummaryData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.Database.Tables["Table1"].SetDataSource(dsSummaryData.Tables[1]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        // EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_SummaryReport --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Overtime":
                        #region Report_Overtime
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Over Time";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Over Time Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);

                            DataSet dsOverTime = new DataSet();
                            DataSet dsCompOff = new DataSet();

                            //dsOverTime = objGetReports.SelectOverTime(FromDate, ToDate, "", 0, "", "0", 0, 0, UserGroupName, GradeLevel, "All", "", 0, 0, "Both", "OverTime");
                            dsOverTime = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsOverTime != null)
                            {
                                if (dsOverTime.Tables.Count > 0)
                                {
                                    if (dsOverTime.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (ReportType == "CompOff")
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "Compensation_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "Compensation.rpt");
                                                }
                                            }
                                            else if (ReportType == "OverTime")
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "overTime_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "overTime.rpt");
                                                }
                                            }
                                            else
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "OTCompensation_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "OTCompensation.rpt");
                                                }
                                            }

                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsOverTime.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);

                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDate, ToDate, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }


                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", " Load Report : Report_Overtime --->" + ex.Message);
                        }
                        break;
                    #endregion
                    case "Report_LessHoursWorked":
                        #region Report_LessHoursWorked
                        try
                        {
                            //Create the datatable ,that holds the header information
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Header";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "LessHoursWorked";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;

                            dtHdr1.Rows.Add(drHdr);

                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (ReportType == "0")
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "RptLessHoursWorked_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "RptLessHoursWorked.rpt");
                                                }
                                            }
                                            else
                                            {
                                                if (LanguageName == "Arabic")
                                                {
                                                    rptDoc.Load(ExePath + "RptLessHoursWorkedSummary_AR.rpt");
                                                }
                                                else
                                                {
                                                    rptDoc.Load(ExePath + "RptLessHoursWorkedSummary.rpt");
                                                }
                                            }
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", "Load Report ---> Report_LessHoursWorked --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_FirstInPunchDifference":
                        #region Report_FirstInPunchDifference

                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Header";

                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "In Punch Deviation Hours Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);
                            //dtHdr = dtHdr1;
                            DataSet dsInPunchDifference = new DataSet();
                            dsInPunchDifference = objGetReports.SelectReportData(Filters, ReportName, ReportType);

                            if (dsInPunchDifference != null)
                            {
                                if (dsInPunchDifference.Tables.Count > 0)
                                {
                                    if (dsInPunchDifference.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            rptDoc.Load(ExePath + "RptInPunchDeviationHours.rpt");
                                            rptDoc.Database.Tables["Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Table"].SetDataSource(dsInPunchDifference.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);

                                    }
                                    else
                                    {
                                        //EmailContent = string.Empty;
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function : ", "Load Report ---> Report_FirstInPunchDifference --->" + ex.Message);

                        }
                        break;
                    #endregion
                    case "Report_Exception":
                        #region Report_Exception
                        try
                        {
                            DataTable dtHdr1 = new DataTable();
                            dtHdr1 = hdrTable.CreateHeader();
                            dtHdr1.TableName = "Late Entry";
                            //Add the Header information
                            DataRow drHdr = dtHdr1.NewRow();
                            drHdr["Link"] = 1;
                            drHdr["Hdr1"] = "";
                            drHdr["Hdr2"] = "";
                            drHdr["Address1"] = "";
                            drHdr["Address2"] = "";
                            drHdr["ReportName"] = "Late Entry Report";
                            drHdr["FromDate"] = FromDateInReport;
                            drHdr["ToDate"] = ToDateInReport;
                            dtHdr1.Rows.Add(drHdr);
                            //dsData = objGetReports.SelectLateInstanceReport("", "0", FromDate, ToDate, "", 0, 0, 0, UserGroupName, GradeLevel, "", 0, 0, "Both");
                            dsData = objGetReports.SelectReportData(Filters, ReportName, ReportType);
                            if (dsData != null)
                            {
                                if (dsData.Tables.Count > 0)
                                {
                                    if (dsData.Tables[0].Rows.Count > 0)
                                    {
                                        if (EmailSendType == 1)
                                        {
                                            if (LanguageName == "Arabic")
                                            {
                                                rptDoc.Load(ExePath + "rptExceptionReport_AR.rpt");
                                            }
                                            else
                                            {
                                                rptDoc.Load(ExePath + "rptExceptionReport.rpt");
                                            }
                                            rptDoc.Database.Tables["dt_Header"].SetDataSource(dtHdr1);
                                            rptDoc.Database.Tables["Exception"].SetDataSource(dsData.Tables[0]);
                                            rptDoc.Database.Tables["Table_1"].SetDataSource(dsHeader.Tables[0]);
                                            rptDoc.SetParameterValue("DtFormat", DateFormat);
                                            rptDoc.SetParameterValue("TimeFormat", TimeFormat);
                                            EmailSendWithAttachment(FileFormat, EmailContent, Subject, ToEmail, CCEmail, ReportName, rptDoc, ExePath);
                                        }
                                        else
                                        {
                                            string UpdatedEmailContent = string.Empty;
                                            UpdatedEmailContent = LinkCreation(EmailContent, Authentication, ScheduleId, FromDateInReport, ToDateInReport, LanguageName, DateFormat, TimeFormat);
                                            TriggerMail(UpdatedEmailContent, Subject, ToEmail, CCEmail, null);
                                            //End
                                        }
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                    else
                                    {
                                        Subject = Subject + " - " + " No Records Found ";
                                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, null);
                                        objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 1);
                                    }
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            objGetReports.InsertEmailScheduleStatus(ScheduleId, FromDate, ToDate, DateTime.Now.ToString("yyyy-MM-dd"), 0);
                            WriteErrorToEventLog("Function :", "Load Report ---> Report_Exception --->" + ex.Message);
                        }
                        break;
                        #endregion
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("Function : ", "LoadReport --->" + ex.Message);
            }
        }
        public void EmailSendWithAttachment(string FileFormat, string EmailContent, string Subject, string ToEmail, string CCEmail, string ReportName, ReportDocument rptDoc, string path)
        {
            try
            {
                Attachment attachment;
                if (EmailContent.Contains("{Link}"))
                {
                    EmailContent = EmailContent.Replace("{Link}", "");
                }
                switch (FileFormat)
                {
                    case "PDF":
                        rptDoc.ExportToDisk(ExportFormatType.PortableDocFormat, path + ReportName + ".pdf");
                        attachment = new Attachment(path + ReportName + ".pdf");
                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, attachment);
                        attachment.Dispose();
                        if (System.IO.File.Exists(path + ReportName + ".pdf"))
                        {
                            System.IO.File.Delete(path + ReportName + ".pdf");
                        }
                        break;
                    case "Excel":
                        rptDoc.ExportToDisk(ExportFormatType.PortableDocFormat, path + ReportName + ".xls");
                        attachment = new Attachment(path + ReportName + ".xls");
                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, attachment);
                        attachment.Dispose();
                        if (System.IO.File.Exists(path + ReportName + ".xls"))
                        {
                            System.IO.File.Delete(path + ReportName + ".xls");
                        }
                        break;
                    case "RichText":
                        rptDoc.ExportToDisk(ExportFormatType.PortableDocFormat, path + ReportName + ".rtf");
                        attachment = new Attachment(path + ReportName + ".rtf");
                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, attachment);
                        attachment.Dispose();
                        if (System.IO.File.Exists(path + ReportName + ".rtf"))
                        {
                            System.IO.File.Delete(path + ReportName + ".rtf");
                        }
                        break;
                    case "Word":
                        rptDoc.ExportToDisk(ExportFormatType.PortableDocFormat, path + ReportName + ".doc");
                        attachment = new Attachment(path + ReportName + ".doc");
                        TriggerMail(EmailContent, Subject, ToEmail, CCEmail, attachment);
                        attachment.Dispose();
                        if (System.IO.File.Exists(path + ReportName + ".doc"))
                        {
                            System.IO.File.Delete(path + ReportName + ".doc");
                        }
                        break;
                }
            }
            catch (Exception ex)
            {
                throw ex;
                WriteErrorToEventLog("Function : ", "EmailSendWithAttachment --->" + ex.Message);
            }
        }
        public void WriteErrorToEventLog(string applicationName, string msg)
        {
            StackFrame CallStack = new StackFrame(1, true);
            int lineNumber = CallStack.GetFileLineNumber();
            string msg2 = CallStack.GetFileName() + "\r\n";           // This get calling module's file name and adds to event log.
            msg2 += "Line: " + lineNumber.ToString() + "\r\n";        // This get calling module's line number of call to this function.
            msg2 += msg;
            if (!EventLog.SourceExists("TC2.7.0ReportSchedularLogSource"))
            {
                EventLog.CreateEventSource("TC2.7.0ReportSchedularLogSource", "TC2.7.0ReportSchedularLog");
            }
            EventLog.WriteEntry("TC2.7.0ReportSchedularLogSource", msg2, EventLogEntryType.Error, lineNumber);
        }
        private void eventLog1_EntryWritten(object sender, EntryWrittenEventArgs e)
        {
        }
        private string SelectDropDownItem(string WeekName)
        {
            string value = "1";
            switch (WeekName)
            {
                case "Sunday":
                    value = "1";
                    break;
                case "Monday":
                    value = "2";
                    break;
                case "Tuesday":
                    value = "3";
                    break;
                case "Wednesday":
                    value = "4";
                    break;
                case "Thursday":
                    value = "5";
                    break;
                case "Friday":
                    value = "6";
                    break;
                case "Saturday":
                    value = "7";
                    break;
            }
            return value;
        }
    }
}
