﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Net;

namespace SMSSchedulerConsole
{
    class Program
    {
        SMSTriggering objSms = new SMSTriggering();
        DataTable gdtShift;        

        static void Main(string[] args)
        {
            Program objProgram = new Program();
            DataSet dsDateTimeFormat = new DataSet();
            objProgram.GetSMSSchedule();
        }
        public void GetSMSSchedule()
        {
            try
            {
                DataSet dsGateway = new DataSet();
                //To get SMS gateway and Scheduler details
                dsGateway = objSms.GettingDataset("Proc_TA_SelectTemplateDetailsForSMSTriggering");
                string destinationKey = string.Empty;
                string MessageKey = string.Empty;
                string ServiceUrl = string.Empty;
                int isValid;
                // 1. Getting SMS Gateway and Template details for SMS Triggering. if any one is not active, its skip the data
                if (dsGateway.Tables.Count > 0)
                {
                    if (dsGateway.Tables[0].Rows.Count > 0 && dsGateway.Tables[1].Rows.Count > 0)
                    {
                        // 2. Processing the data based on Templates(Late Entry , Early Exit, Absent & continuous Absent)
                        foreach (DataRow drTemplate in dsGateway.Tables[1].Rows)
                        {
                            // 3. Getting Shift details for SMS Triggering
                            gdtShift = objSms.GettingDataTable("Proc_Ta_GettingShiftDetailsForSMS");
                            foreach (DataRow drShift in gdtShift.Rows)
                            {
                                isValid = 0;
                                Console.WriteLine("Template Name:" + Convert.ToString(drTemplate["TemplateName"]));
                                Console.WriteLine("ShiftID:" + Convert.ToString(drShift["Shift_Id"]));
                                SqlParameter templateName = new SqlParameter("@TemplateName", Convert.ToString(drTemplate["TemplateName"]));
                                SqlParameter shiftid = new SqlParameter("@ShiftID", Convert.ToString(drShift["Shift_Id"]));
                                SqlParameter[] pmeters = { templateName, shiftid };
                                // 4. Checking whether any employees are came to office by late on this shift using Shift id 
                                // and checking whether the current time is reached SMS Triggering Timings or not
                                isValid = objSms.SP_ExecuteWithReturn(pmeters, "Proc_TA_CheckingShiftTimingsReachedTriggeringTime");
                                if (isValid == 1)
                                {
                                    if (dsGateway.Tables[0].Rows[0]["ServiceUrl"] != null)
                                    {
                                        ServiceUrl = Convert.ToString(dsGateway.Tables[0].Rows[0]["ServiceUrl"]);
                                    }
                                    if (dsGateway.Tables[0].Rows[0]["DestinationKey"] != null)
                                    {
                                        destinationKey = Convert.ToString(dsGateway.Tables[0].Rows[0]["DestinationKey"]);
                                    }
                                    if (dsGateway.Tables[0].Rows[0]["MessageKey"] != null)
                                    {
                                        MessageKey = Convert.ToString(dsGateway.Tables[0].Rows[0]["MessageKey"]);
                                    }
                                    DataSet dsActiveTemplates = new DataSet();
                                    DataSet dsTriggeringDetails = new DataSet();
                                    SqlParameter tempName = new SqlParameter("@TemplateName", Convert.ToString(drTemplate["TemplateName"]));
                                    SqlParameter shft = new SqlParameter("@ShiftID", Convert.ToString(drShift["Shift_Id"]));
                                    SqlParameter[] pParams = { tempName, shft };
                                    //  5. Reached means, get the receivers and employee details for SMS Triggering
                                    dsTriggeringDetails = objSms.GettingDataset(pParams, "Proc_TA_SelectEmployeeDetailsForSmsTriggering");
                                    string strSMSTemplate = string.Empty;
                                    if (dsTriggeringDetails.Tables.Count > 0)
                                    {
                                        if (dsTriggeringDetails.Tables[0].Rows.Count > 0 && Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["Message"]) != "NO")
                                        {
                                            if (dsTriggeringDetails.Tables[1].Rows.Count > 0)
                                            {
                                                foreach (DataRow drreceivers in dsTriggeringDetails.Tables[1].Rows)
                                                {
                                                    if (drreceivers["Mobile_Number"] != DBNull.Value)
                                                    {
                                                        if (Convert.ToString(drreceivers["Mobile_Number"]) != string.Empty)
                                                        {
                                                            SendSMSNotifications(ServiceUrl, destinationKey, MessageKey, Convert.ToString(drreceivers["Receivers"]), Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["Message"]), Convert.ToString(drreceivers["Mobile_Number"]), Convert.ToInt32(drreceivers["TemplateID"]), Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["ExceptionReceivedEmployees"]), Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["TemplateName"]), Convert.ToInt16(drShift["Shift_Id"]), Convert.ToString(drreceivers["SwipeCardNo"]), Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["next"]), Convert.ToString(dsGateway.Tables[1].Rows[0]["Continue_AbsentDays"]));
                                                        }
                                                        else
                                                        {
                                                            if (Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["Message"]).Contains("{User Name}"))
                                                            {
                                                                strSMSTemplate = Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["Message"]).Replace("{User Name}", Convert.ToString(drreceivers["Receivers"]));
                                                            }
                                                            InsertLogDetails(Convert.ToInt32(drreceivers["TemplateID"]), Convert.ToString(drreceivers["SwipeCardNo"]), Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["ExceptionReceivedEmployees"]), false, strSMSTemplate, Convert.ToInt16(drShift["Shift_Id"]), "Mobile Number is not configured for the following recipient: " + Convert.ToString(drreceivers["SwipeCardNo"]), Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["next"]));
                                                            WriteErrorLog("Triggered Date and Time:" + DateTime.Now.ToString() +
                                                                Environment.NewLine + "Template Name:" + Convert.ToString(drTemplate["TemplateName"]) +
                                                                Environment.NewLine + "Shift ID:" + Convert.ToString(drShift["Shift_Id"]) +
                                                                Environment.NewLine + "Message : " + "Mobile Number is not configured for the following recipient: " + Convert.ToString(drreceivers["SwipeCardNo"]));
                                                            WriteErrorLog("*********************************************************************************************");
                                                        }
                                                    }
                                                    else
                                                    {
                                                        if (Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["Message"]).Contains("{User Name}"))
                                                        {
                                                            strSMSTemplate = Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["Message"]).Replace("{User Name}", Convert.ToString(drreceivers["Receivers"]));
                                                        }
                                                        InsertLogDetails(Convert.ToInt32(drreceivers["TemplateID"]), Convert.ToString(drreceivers["SwipeCardNo"]), Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["ExceptionReceivedEmployees"]), false, strSMSTemplate, Convert.ToInt16(drShift["Shift_Id"]), "Mobile Number is not configured for the following recipient: " + Convert.ToString(drreceivers["SwipeCardNo"]), Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["next"]));
                                                        WriteErrorLog("Triggered Date and Time:" + DateTime.Now.ToString() +
                                                                Environment.NewLine + "Template Name:" + Convert.ToString(drTemplate["TemplateName"]) +
                                                                Environment.NewLine + "Shift ID:" + Convert.ToString(drShift["Shift_Id"]) +
                                                                Environment.NewLine + "Message : " + "Mobile Number is not configured for the following recipient: " + Convert.ToString(drreceivers["SwipeCardNo"]));
                                                        WriteErrorLog("*********************************************************************************************");
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                int TemplateID = Convert.ToInt32(drTemplate["ID"]);
                                                if (Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["Message"]).Contains("{User Name}"))
                                                {
                                                    strSMSTemplate = Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["Message"]).Replace("{User Name}", "");
                                                }
                                                InsertLogDetails(TemplateID, "", Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["ExceptionReceivedEmployees"]), false, strSMSTemplate, Convert.ToInt16(drShift["Shift_Id"]), "Recipients are not available for configured Usergroup", Convert.ToString(dsTriggeringDetails.Tables[0].Rows[0]["next"]));
                                                WriteErrorLog("Triggered Date and Time:" + DateTime.Now.ToString() +
                                                                Environment.NewLine + "Template Name:" + Convert.ToString(drTemplate["TemplateName"]) +
                                                                Environment.NewLine + "Shift ID:" + Convert.ToString(drShift["Shift_Id"]) +
                                                                Environment.NewLine + "Message : " + "Recipients are not available for configured Usergroup");
                                                WriteErrorLog("*********************************************************************************************");
                                            }
                                        }
                                        else
                                        {
                                            int TemplateID = Convert.ToInt32(drTemplate["ID"]);
                                            InsertLogDetails(TemplateID, "", "", true, strSMSTemplate, Convert.ToInt16(drShift["Shift_Id"]), "No Record Found", "");
                                            WriteErrorLog("Triggered Date and Time:" + DateTime.Now.ToString() +
                                                            Environment.NewLine + "Template Name:" + Convert.ToString(drTemplate["TemplateName"]) +
                                                            Environment.NewLine + "Shift ID:" + Convert.ToString(drShift["Shift_Id"]) +
                                                            Environment.NewLine + "Message : " + "No Record Found");
                                            WriteErrorLog("*********************************************************************************************");
                                        }
                                    }
                                    else
                                    {
                                        int TemplateID = Convert.ToInt32(drTemplate["ID"]);
                                        InsertLogDetails(TemplateID, "", "", true, strSMSTemplate, Convert.ToInt16(drShift["Shift_Id"]), "No Record Found", "");
                                        WriteErrorLog("Triggered Date and Time:" + DateTime.Now.ToString() +
                                                        Environment.NewLine + "Template Name:" + Convert.ToString(drTemplate["TemplateName"]) +
                                                        Environment.NewLine + "Shift ID:" + Convert.ToString(drShift["Shift_Id"]) +
                                                        Environment.NewLine + "Message : " + "No Record Found");
                                        WriteErrorLog("*********************************************************************************************");
                                    }
                                    if (Convert.ToString(drTemplate["TemplateName"]) == "Continuous Absent")
                                    {
                                        break;
                                    }
                                }
                                else
                                {
                                    //Not reached Triggering Timing
                                }
                            }
                        }
                    }
                    else
                    {
                        if (dsGateway.Tables[0].Rows.Count == 0 && dsGateway.Tables[1].Rows.Count > 0)
                        {
                            WriteErrorLog("Triggered Date and Time:" + DateTime.Now.ToString() +
                                                        Environment.NewLine + "Message : " + "To check SMS gateway details are configured in SMS Gateway Configuratioin");
                            WriteErrorLog("*********************************************************************************************");
                        }
                        else if (dsGateway.Tables[1].Rows.Count == 0)
                        {
                            WriteErrorLog("Triggered Date and Time:" + DateTime.Now.ToString() +
                                                        Environment.NewLine + "Message : " + "Templates are not in active mode");
                            WriteErrorLog("*********************************************************************************************");
                        }
                    }
                }
            }
            catch (Exception ex)
            {

            }
        }
        public void SendSMSNotifications(string serviceUrl, string destinationKey, string messageKey, string receivers, string SMSTemplate, string MobNo, int templateId, string exceptionEmployees, string TemplateName, int ShiftID, string ReceiversID, string NextTriggeringTime, string ContinuousDays)
        {
            StreamWriter sw = null;
            try
            {
                if (serviceUrl.Contains("=" + destinationKey))
                {
                    serviceUrl = serviceUrl.Replace(destinationKey, MobNo);
                }
                if (SMSTemplate.Contains("{User Name}"))
                {
                    SMSTemplate = SMSTemplate.Replace("{User Name}", receivers);
                }
                if (SMSTemplate.Contains("{Count}"))
                {
                    SMSTemplate = SMSTemplate.Replace("{Count}", ContinuousDays);
                }
                if (SMSTemplate.Contains("{Date}"))
                {
                    SMSTemplate = SMSTemplate.Replace("{Date}", DateTime.Now.ToString("dd-MM-yyyy"));
                }
                if (serviceUrl.Contains("=" + messageKey))
                {
                    serviceUrl = serviceUrl.Replace("=" + messageKey, "=" + SMSTemplate);
                }
                DataTable dtwhiteLists = new DataTable();
                dtwhiteLists = GetWhiteListData();
                if (dtwhiteLists.Rows.Count > 0)
                {
                    if (Convert.ToString(dtwhiteLists.Rows[0]["whiteList"]) != "")
                    {
                        serviceUrl = serviceUrl + Convert.ToString(dtwhiteLists.Rows[0]["whiteList"]);
                    }
                }
                HttpWebRequest smsRequest = (HttpWebRequest)HttpWebRequest.Create(serviceUrl.ToString());
                smsRequest.Method = WebRequestMethods.Http.Get;
                HttpWebResponse smsResponse = (HttpWebResponse)smsRequest.GetResponse();
                StreamReader responseReader = new StreamReader(smsResponse.GetResponseStream());
                string message = responseReader.ReadToEnd();
                string status = smsResponse.StatusDescription;
                responseReader.Close();
                responseReader.Dispose();
                smsResponse.Close();
                smsRequest = null;
                smsResponse = null;
                InsertLogDetails(templateId, ReceiversID, exceptionEmployees, true, SMSTemplate, ShiftID, "Fine", NextTriggeringTime);
            }
            catch (Exception ex)
            {
                InsertLogDetails(templateId, ReceiversID, exceptionEmployees, true, SMSTemplate, ShiftID, ex.ToString(), NextTriggeringTime);
                WriteErrorLog("Triggered Date & Time: " + DateTime.Now.ToString() +
                    Environment.NewLine + "Template Name: " + TemplateName +
                    Environment.NewLine + "Shift ID" +
                    Environment.NewLine + "Error in SMS Triggering : " + ex.Message.ToString() +
                    Environment.NewLine + "Recipient: " + receivers +
                    Environment.NewLine + "Message Content: " + SMSTemplate);
                WriteErrorLog("*********************************************************************************************");
            }
        }
        public void InsertLogDetails(int TemplateId, string Receivers, string exceptionEmployees, bool status, string message, int ShiftID, string StatusMessage, string NextTriggeringTime)
        {
            try
            {
                SqlParameter tempId = new SqlParameter("@TemplateID", Convert.ToString(TemplateId));
                SqlParameter receiver = new SqlParameter("@Receivers", Convert.ToString(Receivers));
                SqlParameter ExceptionEmp = new SqlParameter("@ExceptionEmployees", Convert.ToString(exceptionEmployees));
                SqlParameter pmstatus = new SqlParameter("@Status", Convert.ToInt32(status));
                SqlParameter pmMessage = new SqlParameter("@Message", Convert.ToString(message));
                SqlParameter pmShiftID = new SqlParameter("@ShiftID", Convert.ToInt32(ShiftID));
                SqlParameter pmStatusMessage = new SqlParameter("@StatusMessage", Convert.ToString(StatusMessage));
                SqlParameter pmNextTriggeringTime = new SqlParameter("@NextTriggeringTime", Convert.ToString(NextTriggeringTime));
                SqlParameter[] pParams = { tempId, receiver, ExceptionEmp, pmstatus, pmMessage, pmShiftID, pmStatusMessage, pmNextTriggeringTime };
                objSms.SP_Execute(pParams, "Proc_TA_InsertSMSLogDetails");
            }
            catch (Exception)
            {
                throw;
            }
        }
        public static void WriteErrorLog(string message)
        {
            StreamWriter sw = null;
            if (!Directory.Exists(AppDomain.CurrentDomain.BaseDirectory + "\\SMSLog"))
            {
                Directory.CreateDirectory(AppDomain.CurrentDomain.BaseDirectory + "\\SMSLog");
            }
            sw = new StreamWriter(AppDomain.CurrentDomain.BaseDirectory + "\\SMSLog" + "\\SMSLogFile.txt", true);
            sw.WriteLine(message);
            sw.Flush();
            sw.Close();
        }
        public DataTable GetWhiteListData()
        {
            DataTable dt = new DataTable();
            try
            {
                dt = objSms.GettingDataTable("Proc_Ta_ReplacingSMSContent");
            }
            catch (Exception ex)
            {
                WriteErrorLog(ex.ToString());
            }
            return dt;
        }
    }
}
