using System;
using System.Data;
using System.Globalization;
using System.IO;
using System.Resources;
using System.Threading;
using System.Web.UI;
using NPOI.HSSF.UserModel;
using NPOI.SS.UserModel;
using NPOI.HSSF.Util;
using NPOI.SS.Util;
using System.Text;
using System.Web;
 using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.text.html;
using iTextSharp.text.html.simpleparser;
public partial class Masters_SMS_LogDetails : Base.BasePage
{
    #region "Variable Declaration"
    ResourceManager rm;
    CultureInfo ci;
    cls_Common objCommon = new cls_Common();
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    SMSNotification objsms = new SMSNotification();
    DataSet ds_Checkuser = new DataSet();
    DataSet ds_Templates = new DataSet();
    string gstrUserGroupName = string.Empty;
    int EmployeeID = 0;
    string source_Language;
    string strScript = string.Empty;
    string strFromdate, gstrDateFormat, strTodate;
    #endregion
    #region PageLoadEvent
    protected override void Page_Load(object sender, EventArgs e)
    {
        // session checking
        base.Page_Load(sender, e);
        source_Language = Convert.ToString(Session["Session_ActiveLanguage"]);
        rm = new ResourceManager(source_Language, System.Reflection.Assembly.Load("App_GlobalResources"));
        ci = Thread.CurrentThread.CurrentCulture;
        //Set UserRights
        if (!IsPostBack)
        {
            objCommon.menu("Configuration", "245");
        }
        UserRights();
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        // LoadStrings Function fills the Label from the Resource File
        LoadStrings(ci);
        EmployeeID = Convert.ToInt32(Convert.ToString(Session["EmpAutoID"]));
        hdnDateTime.Value = Convert.ToString(Session["IDateFormat"]);
        if (!IsPostBack)
        {
            txtFromdate.Text = (Convert.ToDateTime(objCommon.CurrentMonthStartDate())).ToString(Convert.ToString(Session["MDateFormat"]));
            txtTodate.Text = (Convert.ToDateTime(System.DateTime.Now.ToShortDateString())).ToString(Convert.ToString(Session["MDateFormat"]));
            BindTemplates();
        }
        BindGridview();
    }
    #endregion
    #region UserDefinedFunctions
    private void LoadStrings(CultureInfo ci)
    {
        lbl_Header.Text = rm.GetString("SMSLogDetails", ci);
        lblTemplate.Text = rm.GetString("SMSTemplateList_TemplateName", ci);
        lblReceivers.Text = rm.GetString("Receivers", ci);
        lblFromDate.Text = rm.GetString("OnDuty_InDate", ci);
        lblToDate.Text = rm.GetString("OnDuty_OutDate", ci);
        lblStatus.Text = rm.GetString("email_Status", ci);
        btn_Search.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Search", ci);
        btn_Clear.Text = "&nbsp;&nbsp;" + rm.GetString("btn_Clear", ci);
        lnkbtnPdf.Text = "&nbsp;&nbsp;" + rm.GetString("PDF", ci);
        lnkbtnCSV.Text = "&nbsp;&nbsp;" + rm.GetString("CSV", ci);
        lnkbtnExcel.Text = "&nbsp;&nbsp;" + rm.GetString("Excel", ci);
    }
    private void UserRights()
    {
        //Todo: Need to change ID value in below
        ds_Checkuser = objCheckUser.checkRights(245, Convert.ToInt32(Session["userGroup_Id"]), "ViewPrv");
        if (ds_Checkuser.Tables[0].Rows.Count > 0)
        {
        }
        else
        {
            Response.Redirect("MasterLandingPage.aspx");
        }
    }
    private void BindTemplates()
    {
        DataSet dsTemplates = new DataSet();
        dsTemplates = objsms.SelectTemplateDetails(0);
        if (dsTemplates.Tables.Count > 0)
        {
            if (dsTemplates.Tables[0].Rows.Count > 0)
            {
                ddlTemplate.DataSource = dsTemplates;
                ddlTemplate.DataTextField = "TemplateName";
                ddlTemplate.DataValueField = "TemplateId";
                ddlTemplate.DataBind();
            }
        }
    }
    private void BindGridview()
    {
        DataSet dsSMSLogDetails = new DataSet();
        if (Convert.ToString(Session["LogDetails"]) != "")
        {
            dsSMSLogDetails = (DataSet)Session["LogDetails"];
        }
        else
        {
            dsSMSLogDetails = objsms.SelectLogDetails(Convert.ToInt32(Session["parentLevelId"]),
                Convert.ToString(ddlTemplate.SelectedItem.Text), Convert.ToString(txtReceivers.Text),
                Convert.ToString(txtFromdate.Text), Convert.ToString(txtTodate.Text),
                Convert.ToInt16(ddlStatus.SelectedItem.Value), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]));
        }
        if (dsSMSLogDetails.Tables.Count > 0)
        {
            if (dsSMSLogDetails.Tables[0].Rows.Count > 0)
            {
                grdSmslog.DataSource = dsSMSLogDetails;
                grdSmslog.DataBind();
                Session["LogDetails"] = dsSMSLogDetails;
            }
        }
    }
    #region Export Excel
    protected void ExportExcel(DataSet dsEmp, string exportType)
    {
        try
        {
            DataTable dtLevelName = new DataTable();
            HSSFWorkbook workbook = new HSSFWorkbook();
            ISheet sheet = workbook.CreateSheet("SMS Log Details");
            int rowIndex = 0;
            NPOI.SS.UserModel.IRow row = sheet.CreateRow(rowIndex);
            HSSFFont hFont = (HSSFFont)workbook.CreateFont();
            hFont.Boldweight = (short)FontBoldWeight.Bold;
            hFont.Color = HSSFColor.Maroon.Index;
            hFont.FontHeightInPoints = 10;
            HSSFCellStyle hStyle = (HSSFCellStyle)workbook.CreateCellStyle();
            hStyle.SetFont(hFont);
            hStyle.FillForegroundColor = IndexedColors.White.Index;
            hStyle.FillPattern = FillPattern.SolidForeground;
            hStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
            hStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
            hStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
            hStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
            HSSFCellStyle MainHStyle = (HSSFCellStyle)workbook.CreateCellStyle();
            MainHStyle.SetFont(hFont);
            MainHStyle.Alignment = HorizontalAlignment.Center;
            HSSFCellStyle IStyle = (HSSFCellStyle)workbook.CreateCellStyle();
            IStyle.BorderTop = NPOI.SS.UserModel.BorderStyle.Thin;
            IStyle.BorderBottom = NPOI.SS.UserModel.BorderStyle.Thin;
            IStyle.BorderLeft = NPOI.SS.UserModel.BorderStyle.Thin;
            IStyle.BorderRight = NPOI.SS.UserModel.BorderStyle.Thin;
            row.CreateCell(0).SetCellValue("SMS Log Details");
            row.GetCell(0).CellStyle = MainHStyle;
            sheet.AddMergedRegion(new CellRangeAddress(rowIndex, rowIndex, 0, 5));
            rowIndex++;
            row = sheet.CreateRow(rowIndex);
            row = sheet.CreateRow(rowIndex);
            row.CreateCell(0).SetCellValue("Sl.No");
            row.CreateCell(1).SetCellValue("Template Name");
            row.CreateCell(2).SetCellValue("Message");
            row.CreateCell(3).SetCellValue("Triggered Time");
            row.CreateCell(4).SetCellValue("Receivers");
            row.CreateCell(5).SetCellValue("Status");
            for (int i = 0; i <= 5; i++)
            {
                row.GetCell(i).CellStyle = hStyle;
            }
            rowIndex++;
            string strPre = string.Empty;
            Int32 SlNo = 0;
            foreach (DataRow DR in dsEmp.Tables[0].Rows)
            {
                row = sheet.CreateRow(rowIndex);
                SlNo++;
                row.CreateCell(0).SetCellValue(SlNo);
                row.CreateCell(1).SetCellValue(Convert.ToString(DR["TemplateName"]));
                row.CreateCell(2).SetCellValue(Convert.ToString(DR["Message"]));
                row.CreateCell(3).SetCellValue(Convert.ToString(DR["TriggeredTimings"]));
                row.CreateCell(4).SetCellValue(Convert.ToString(DR["Receivers"]));
                row.CreateCell(5).SetCellValue(Convert.ToString(DR["Status"]));
                //Style Added the created Headers.
                for (int i = 0; i <= 5; i++)
                {
                    row.GetCell(i).CellStyle = IStyle;
                    sheet.AutoSizeColumn(i);
                }
                rowIndex++;
            }
            using (MemoryStream exportData = new MemoryStream())
            {
                workbook.Write(exportData);
                string saveAsFileName = string.Format("SMSLogDetails-{0:d}.xls", DateTime.Now).Replace("/", "-");
                Response.ContentType = "application/vnd.ms-excel";
                Response.AddHeader("Content-Disposition", string.Format("attachment;filename={0}", saveAsFileName));
                Response.Clear();
                Response.BinaryWrite(exportData.GetBuffer());
                Response.End();
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    #endregion
    #region Export PDF
    public void ExportToPDF(DataSet ds)
    {
        //Response.ContentType = "application/pdf";
        //Response.AddHeader("content-disposition", "attachment;filename=UserDetails.pdf");
        //Response.Cache.SetCacheability(HttpCacheability.NoCache);
        //StringWriter sw = new StringWriter();
        //HtmlTextWriter hw = new HtmlTextWriter(sw);
        //grdSmslog.DataBind();
        //grdSmslog.RenderControl(hw);
        //grdSmslog.Style.Add("text-decoration", "none");
        //grdSmslog.Style.Add("font-family", "Arial, Helvetica, sans-serif;");
        //grdSmslog.Style.Add("font-size", "8px");
        //StringReader sr = new StringReader(sw.ToString());
        //Document pdfDoc = new Document(PageSize.A2, 7f, 7f, 7f, 0f);
        //HTMLWorker htmlparser = new HTMLWorker(pdfDoc);
        //PdfWriter.GetInstance(pdfDoc, Response.OutputStream);
        //pdfDoc.Open();
        //htmlparser.Parse(sr);
        //pdfDoc.Close();
        //Response.Write(pdfDoc);
        //Response.End();
    }
    #endregion
    #region Export CSV
    public StringBuilder Export(DataSet ds)
    {
        StringBuilder columnnames = new StringBuilder();
        StringBuilder body = new StringBuilder();
        StringBuilder record = new StringBuilder();
        int RowCount = ds.Tables[0].Columns.Count;
        int increment = 0;
        foreach (DataColumn col in ds.Tables[0].Columns)
        {
            increment = increment + 1;
            if (increment != 1 && increment != 2)
            {
                columnnames.Append(" ");
                columnnames.Append(col.ColumnName);
                columnnames.Append(" ");
                if (increment != RowCount)
                {
                    columnnames.Append(",");
                }
            }
        }
        foreach (DataRow row in ds.Tables[0].Rows)
        {
            object[] arr = row.ItemArray;
            for (int i = 0; i <= arr.Length - 1; i++)
            {
                if (arr[i].ToString().IndexOf(",") > 0)
                {
                    record.Append(" ");
                    record.Append(arr[i].ToString());
                    record.Append(" ");
                    record.Append(" # ");
                }
                else
                {
                    if (i == 0 || i == 1)
                    {
                    }
                    else
                    {
                        record.Append(arr[i].ToString());
                        record.Append(" # ");
                    }
                }
            }
            body.Append(record.ToString().Substring(0, record.Length - 1) + System.Environment.NewLine);
            record.Remove(0, record.Length);
        }
        columnnames.Append(System.Environment.NewLine);
        return (columnnames.Append(body.ToString()));
    }
    #endregion
    #endregion
    #region ButtonEvents
    protected void btn_Search_Click(object sender, EventArgs e)
    {
        DataSet dsSMSLogDetails = new DataSet();
        try
        {
            if (Page.IsValid == true)
            {
                dsSMSLogDetails = objsms.SelectLogDetails(Convert.ToInt32(Session["parentLevelId"]), Convert.ToString(ddlTemplate.SelectedItem.Text), Convert.ToString(txtReceivers.Text), Convert.ToString(txtFromdate.Text), Convert.ToString(txtTodate.Text), Convert.ToInt16(ddlStatus.SelectedItem.Value), Convert.ToString(Session["UserGroupName"]), Convert.ToString(Session["GradeLevel"]));
                if (dsSMSLogDetails.Tables.Count > 0)
                {
                    if (dsSMSLogDetails.Tables[0].Rows.Count > 0)
                    {
                        grdSmslog.DataSource = dsSMSLogDetails;
                        grdSmslog.DataBind();
                        Session["LogDetails"] = dsSMSLogDetails;
                    }
                    else
                    {
                        grdSmslog.DataSource = "";
                        grdSmslog.DataBind();
                        Session["LogDetails"] = "";
                    }
                }
            }
        }
        catch (Exception)
        {
            throw;
        }
    }
    protected void lnkbtnExcel_Click(object sender, EventArgs e)
    {
        string strScript = string.Empty;
        if (Convert.ToString(Session["LogDetails"]) != "")
        {
            DataSet dsLogs = new DataSet();
            dsLogs = (DataSet)Session["LogDetails"];
            if (dsLogs.Tables.Count > 0)
            {
                if (dsLogs.Tables[0].Rows.Count > 0)
                    ExportExcel(dsLogs, "ms-excel");
            }
            else
            {
                strScript = "";
                strScript = strScript + "<script language='javascript'>";
                strScript = strScript + "alert('" + rm.GetString("Alert_Recordsarenotavailableforexport", ci) + "')";
                strScript = strScript + "</script>";
                Page.RegisterStartupScript("DelAlert1", strScript);
                return;
            }
        }
        else
        {
            strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("Alert_Recordsarenotavailableforexport", ci) + "')";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("DelAlert1", strScript);
            return;
        }
    }
    protected void lnkbtnCSV_Click(object sender, EventArgs e)
    {
        string strScript = string.Empty;
        if (Convert.ToString(Session["LogDetails"]) != "")
        {
            DataSet dsLogs = new DataSet();
            dsLogs = (DataSet)Session["LogDetails"];
            if (dsLogs.Tables.Count > 0)
            {
                if (dsLogs.Tables[0].Rows.Count > 0)
                {
                    StringBuilder strData = Export(dsLogs);
                    byte[] data = System.Text.ASCIIEncoding.ASCII.GetBytes(strData.ToString());
                    string attachment = "attachment; filename=SMSLogDetails.csv";
                    Response.Clear();
                    Response.AddHeader("Content-Type", "application/Excel");
                    Response.AddHeader("Content-Disposition", attachment);
                    Response.BinaryWrite(data);
                    Response.End();
                }
            }
            else
            {
                strScript = "";
                strScript = strScript + "<script language='javascript'>";
                strScript = strScript + "alert('" + rm.GetString("Alert_Recordsarenotavailableforexport", ci) + "')";
                strScript = strScript + "</script>";
                Page.RegisterStartupScript("DelAlert1", strScript);
                return;
            }
        }
        else
        {
            strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("Alert_Recordsarenotavailableforexport", ci) + "')";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("DelAlert1", strScript);
            return;
        }
    }
    protected void lnkbtnPdf_Click(object sender, EventArgs e)
    {
        string strScript = string.Empty;
        if (Convert.ToString(Session["LogDetails"]) != "")
        {
            DataSet dsLogs = new DataSet();
            dsLogs = (DataSet)Session["LogDetails"];
            if (dsLogs.Tables.Count > 0)
            {
                if (dsLogs.Tables[0].Rows.Count > 0)
                {
                    ExportToPDF(dsLogs);
                }
            }
            else
            {
                strScript = "";
                strScript = strScript + "<script language='javascript'>";
                strScript = strScript + "alert('" + rm.GetString("Alert_Recordsarenotavailableforexport", ci) + "')";
                strScript = strScript + "</script>";
                Page.RegisterStartupScript("DelAlert1", strScript);
                return;
            }
        }
        else
        {
            strScript = "";
            strScript = strScript + "<script language='javascript'>";
            strScript = strScript + "alert('" + rm.GetString("Alert_Recordsarenotavailableforexport", ci) + "')";
            strScript = strScript + "</script>";
            Page.RegisterStartupScript("DelAlert1", strScript);
            return;
        }
    }
    public override void VerifyRenderingInServerForm(Control control)
    {
        /* Confirms that an HtmlForm control is rendered for the specified ASP.NET
           server control at run time. */
    }
    #endregion
}
