using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Globalization;
using System.Threading;
using System.Reflection;
using System.Resources;
/*************************************************************************************************
* 	Project Name    	 	    :    TimeCheck                       Started  	: 10-01-2009
*	Module          	 	    :    OverTime Sanction                         		
*	Description		 	        :    OverTime Sanction Filter
*	Programmer	 	            :    Sasireka.M
*   Modified by 		 	    :    Sasireka.M
*	Modified Date and Reason    :    16.05.09 Updated Coding based on the Coding Standards                                                      
**************************************************************************************************/
public partial class Transactions_TA_UI_Transactions_OverTimeSanction : Base.BasePage
{
    #region Variables
    /// <summary>
    /// To get the common functions
    /// </summary>
    cls_Common objCommon = new cls_Common();
    /// <summary>
    /// To get the Employee related details
    /// </summary>
    EmployeeEventData objEmployee = new EmployeeEventData();
    /// <summary>
    /// To get the users rights
    /// </summary>
    Cls_CheckUser objCheckUser = new Cls_CheckUser();
    /// <summary>
    /// Instance of the ReportCommon function
    /// </summary>
    Rpt_Common rptcommon = new Rpt_Common();
    /// <summary>
    /// Instance of the Resource Manager
    /// </summary>
    ResourceManager objResourceManager;
    /// <summary>
    /// Instance of the CultureInfo
    /// </summary>
    CultureInfo objCultureInfo;
    /// <summary>
    /// String type Variable
    /// </summary>
    string strFromdate, gstrDateFormat, strTodate;
    /// <summary>
    /// Individual Type users count
    /// </summary>
    int intIndividualUser = 0;
    #endregion
    #region PageLoadEvent
    /// <summary>
    /// Handles the Load event of the Page control.
    /// </summary>
    /// <param name="sender">The source of the event.</param>
    /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        ////if Standar Edition set the visibility to false
        //if (Session["Edition"].ToString() == "1")
        //{
        //    Response.Redirect("TransactionLandingPage.aspx");
        //}
        string strSourceLanguage;
        //Getting resource file information
        strSourceLanguage = Convert.ToString(Session["Session_ActiveLanguage"]);
        objResourceManager = new ResourceManager(strSourceLanguage, System.Reflection.Assembly.Load("App_GlobalResources"));
        objCultureInfo = Thread.CurrentThread.CurrentCulture;
        site.SiteMapProvider = Convert.ToString(Session["SiteMapProvider"]);
        //Get the label information from resource file
        LoadStrings(objCultureInfo);
        if (!Page.IsPostBack)
        {
            base.CheckPages(0);
        }
        Hidden1.Value = Convert.ToString(Session["IDateFormat"]);
        if (!IsPostBack)
        {
            //calling the function to bind Employee Category and Type
            BindingEmployeeCategoryandType();
            //Calling function to load Leave Status
            //LoadLeaveStatus();
            // Alert Message 28-1-2011
            objCommon.menu("OverTime", "97");
        }
        //check the User Rights
        UserRights();
        string strSetAlert = "";
        strSetAlert = strSetAlert + "<script language='javascript'>";
        strSetAlert = strSetAlert + "MaxLengthh('" + objResourceManager.GetString("Alert_MaximumLengthis", objCultureInfo) + "');";
        // strSetAlert = strSetAlert + "SetAlertMessages('" + objResourceManager.GetString("Alert_PleaseselectFromDate", objCultureInfo) + "','" + objResourceManager.GetString("Alert_PleaseselectToDate", objCultureInfo) + "','" + objResourceManager.GetString("Msg_GrearterThanFrmDate", objCultureInfo) + "','" + objResourceManager.GetString("Alert_SelectStatus", objCultureInfo) + "');";
        strSetAlert = strSetAlert + "SetAlertMessages('" + objResourceManager.GetString("Alert_PleaseselectFromDate", objCultureInfo) + "','" + objResourceManager.GetString("Alert_PleaseselectToDate", objCultureInfo) + "','" + objResourceManager.GetString("Alert_SelectStatus", objCultureInfo) + "','" + objResourceManager.GetString("Msg_GrearterThanFrmDate", objCultureInfo) + "');";
        strSetAlert = strSetAlert + "SetAlertCheckDate('" + objResourceManager.GetString("Alert_Validdatemonthfourdigit", objCultureInfo) + "','" + objResourceManager.GetString("Alert_Invalidyearentry", objCultureInfo) + "','" + objResourceManager.GetString("Alert_Invalidmonthentry", objCultureInfo) + "','" + objResourceManager.GetString("Alert_Invaliddateentry", objCultureInfo) + "','" + objResourceManager.GetString("Alert_IncorrectdateformatDDMONYYYY", objCultureInfo) + "','" + objResourceManager.GetString("Alert_Entertime", objCultureInfo) + "','" + objResourceManager.GetString("Alert_Invalidvalueforhours", objCultureInfo) + "','" + objResourceManager.GetString("Alert_Invalidvalueforminites", objCultureInfo) + "','" + objResourceManager.GetString("Alert_Invalidtimeformat1", objCultureInfo) + "','" + objResourceManager.GetString("Alert_PleaseentervalidDateandTime", objCultureInfo) + "','" + objResourceManager.GetString("Alert_ValiddatemonthMMDDYYHHMM", objCultureInfo) + "','" + objResourceManager.GetString("Alert_ValiddatemonthMMDDYYHHMMTT", objCultureInfo) + "','" + objResourceManager.GetString("Alert_PleaseentervalidDateandTime", objCultureInfo) + "','" + objResourceManager.GetString("Alert_Invalidvalueforhours", objCultureInfo) + "','" + objResourceManager.GetString("Alert_Invalidvalueforminites", objCultureInfo) + "');";
        strSetAlert = strSetAlert + "</script>";
        Page.RegisterStartupScript("SetAlertMessages", strSetAlert);
        #region Code Commented By Bug No : 0019035
        //intIndividualUser = objCheckUser.CheckIndividualUser(Convert.ToString(Session["UserGroupName"]));
        //if (intIndividualUser >= 1)
        //{
        //    PhrOverTimeSanction.Controls.Clear();
        //    divEmployeeDetails.Visible = false;
        //} 
        #endregion
    }
    #endregion
    #region UserDefinedFunctions
    #region LoadStrings
    /// <summary>
    /// Loads the strings.
    /// </summary>
    /// <param name="ci">The ci.</param>
    private void LoadStrings(CultureInfo ci)
    {
        btnView.Text = "&nbsp;&nbsp;" + objResourceManager.GetString("btn_View", ci);
        lblEmployeeName.Text = objResourceManager.GetString("Field_EmployeeName", ci);
        lblEmployeeId.Text = objResourceManager.GetString("Field_EmployeeID", ci);
        lblEmpCategory.Text = objResourceManager.GetString("Master_Category", ci);
        lblEmpType.Text = objResourceManager.GetString("Master_Type", ci);
        //lblTimePeriod.Text = objResourceManager.GetString("Reports_TimePeriod", ci);
        lblFrom.Text = objResourceManager.GetString("Field_From", ci);
        lblTo.Text = objResourceManager.GetString("Field_To", ci);
        lblStatus.Text = objResourceManager.GetString("Field_Status", ci);
        lblOverTimeSanction.Text = objResourceManager.GetString("Transaction_OverTime_Sanction", ci);
        lblEmpSwipe.Text = objResourceManager.GetString("TerminalDataType_Card_No", ci);
        ddlOTStatus.Items[0].Text = objResourceManager.GetString("ExportData_All", ci);
        ddlOTStatus.Items[1].Text = objResourceManager.GetString("btn_Approved", ci);
        ddlOTStatus.Items[2].Text = objResourceManager.GetString("btn_Forwarded", ci);
        ddlOTStatus.Items[3].Text = objResourceManager.GetString("btn_Pending", ci);
        ddlOTStatus.Items[4].Text = objResourceManager.GetString("btn_Reject", ci);
        cvrFromDate.ErrorMessage = objResourceManager.GetString("Alert_SelectvalidFromDate", ci);
        cvrToDate.ErrorMessage = objResourceManager.GetString("Alert_SelectvalidToDate", ci);
        cvrComToDate.ErrorMessage = objResourceManager.GetString("Msg_SelectvaliddatecomparewithFromdate", ci);
        rfvFromDate.ErrorMessage = objResourceManager.GetString("Alert_PleaseselectFromDate", ci);
        rfvToDate.ErrorMessage = objResourceManager.GetString("Alert_PleaseselectToDate", ci);
        ddlEmpCatagory.Items[0].Text = objResourceManager.GetString("Select", ci);
        ddlEmpType.Items[0].Text = objResourceManager.GetString("Select", ci);
        lbl_IndicatesMandatoryFields.Text = objResourceManager.GetString("IndicatesMandatoryFields", ci);
        lblSanctionType.Text = objResourceManager.GetString("Caption_SanctionType", ci);
        rbtnOverTime.Text = objResourceManager.GetString("Menu_Reports_OverTime", ci);
        rbtnCompoff.Text = objResourceManager.GetString("Caption_CompOff", ci);
        rbtnOTCompOff.Text = objResourceManager.GetString("rbtn_OTCompOff", ci);
        lblFilter.Text = objResourceManager.GetString("lblFilter", ci);
        lbl_OT_Comp.Text = objResourceManager.GetString("Transaction_OverTime_Sanction", ci);
    }
    #endregion
    #region LeaveStatus
    /// <summary>
    /// Loads the leave status.
    /// </summary>
    public void LoadLeaveStatus()
    {
        ddlOTStatus.Items.Clear();
        ddlOTStatus.Items.Insert(0, "All");
        ddlOTStatus.Items.Insert(1, "Pending");
        ddlOTStatus.Items.Insert(2, "Approved");
        ddlOTStatus.Items.Insert(3, "Forwarded");
        ddlOTStatus.Items.Insert(4, "Rejected");
    }
    #endregion
    #region validateFromdate
    /// <summary>
    /// Validates from date.
    /// </summary>
    /// <param name="s">The s.</param>
    /// <param name="e">The <see cref="System.Web.UI.WebControls.ServerValidateEventArgs"/> instance containing the event data.</param>
    public void ValidateFromDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            gstrDateFormat = Session["MDateFormat"].ToString();
            //Convert current datetime to default datetime format
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date);
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan DateTimeDiff = dtFromDate.Subtract(dtCurrentDate);
            int intDay = DateTimeDiff.Days;
            if (intDay <= 0)
                e.IsValid = true;
            else
                e.IsValid = false;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    #endregion
    #region ValidateToDate
    /// <summary>
    /// Validate the ToDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void ValidateToDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            gstrDateFormat = Session["MDateFormat"].ToString();
            strTodate = txtToDate.Text;
            //Convert current datetime to default datetime format
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            DateTime dtCurrentDate = Convert.ToDateTime(DateTime.Today.Date);
            DateTime dtFromDate = DateTime.Parse(strTodate);
            TimeSpan DateTimeDiff = dtFromDate.Subtract(dtCurrentDate);
            int intDay = DateTimeDiff.Days;
            if (intDay <= 0)
                e.IsValid = true;
            else
                e.IsValid = false;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    #endregion
    #region CompareDate
    /// <summary>
    /// Compare ToDate with FromDate
    /// </summary>
    /// <param name="s"></param>
    /// <param name="e"></param>
    public void CompareDate(object s, ServerValidateEventArgs e)
    {
        try
        {
            strFromdate = txtFromDate.Text;
            strTodate = txtToDate.Text;
            gstrDateFormat = Session["MDateFormat"].ToString();
            //Convert current datetime to default datetime format
            strTodate = objCommon.DateConvertion(gstrDateFormat, strTodate);
            strFromdate = objCommon.DateConvertion(gstrDateFormat, strFromdate);
            DateTime dtToDate = DateTime.Parse(strTodate);
            DateTime dtFromDate = DateTime.Parse(strFromdate);
            TimeSpan DateTimeDiff = dtToDate.Subtract(dtFromDate);
            int intDay = DateTimeDiff.Days;
            if (intDay >= 0)
                e.IsValid = true;
            else
                e.IsValid = false;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    #endregion
    #region "EmployeeCategoryandType
    /// <summary>
    /// Bindings the type of the employee category and Type.
    /// </summary>
    private void BindingEmployeeCategoryandType()
    {
        // employee category binding
        DataSet dsCategory = new DataSet();
        try
        {
            //Get the Employee Category details
            dsCategory = objEmployee.SelectCategoryDetailsEmployee("");
            if (dsCategory != null)
            {
                if (dsCategory.Tables[0].Rows.Count > 0)
                {
                    ddlEmpCatagory.DataSource = dsCategory;
                    ddlEmpCatagory.DataTextField = "CategoryName";
                    ddlEmpCatagory.DataValueField = "CategoryId";
                    ddlEmpCatagory.DataBind();
                }
                dsCategory.Dispose();
                foreach (ListItem item in ddlEmpCatagory.Items)
                {
                    item.Attributes.Add("title", item.Text);
                }
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
        // employee type binding
        DataSet dsType = new DataSet();
        try
        {
            //Get the Employee Type Details
            dsType = objEmployee.SelectTypeDetailsEmployee("");
            if (dsType != null)
            {
                if (dsType.Tables[0].Rows.Count > 0)
                {
                    ddlEmpType.DataSource = dsType;
                    ddlEmpType.DataTextField = "TypeName";
                    ddlEmpType.DataValueField = "TypeId";
                    ddlEmpType.DataBind();
                }
                dsType.Dispose();
                foreach (ListItem item in ddlEmpType.Items)
                {
                    item.Attributes.Add("title", item.Text);
                }
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    #endregion
    /// <summary>
    /// To check rights for the logged in user
    /// </summary>
    private void UserRights()
    {
        DataSet ds_Checkuser = objCheckUser.checkRights(97, Convert.ToInt32(Session["userGroup_Id"]), "viewPrv");
        if (ds_Checkuser.Tables[0].Rows.Count == 0)
        {
            Response.Redirect("TransactionLandingPage.aspx");
        }
        else
        {
            //   
        }
    }
    #endregion
}
