/*
#define WORD	ushort
#define DWORD	uint
#define BYTE	byte
#define Long	int
*/
using System;
using System.Runtime.InteropServices; // DllImport
using System.Reflection;
    /// <summary>
    /// </summary>
    public class DongleAuthentication
    {
        // declare function codes
        const ushort UNIKEY_FIND = 1;		// Find UniKey                                              
        const ushort UNIKEY_FIND_NEXT = 2;  	// Find next UniKey                                         
        const ushort UNIKEY_LOGON = 3;	// Open UniKey                                              
        const ushort UNIKEY_LOGOFF = 4;		// Close UniKey                                             
        const ushort UNIKEY_READ_MEMORY = 5;		// Read UniKey                                              
        const ushort UNIKEY_WRITE_MEMORY = 6;		// Write UniKey                                             
        const ushort UNIKEY_RANDOM = 7;		// Generate Random Number                                   
        const ushort UNIKEY_SEED = 8;		// Generate Seed Code                                       
        const ushort UNIKEY_WRITE_SOFTID = 9;		// Write Software ID                                        
        const ushort UNIKEY_READ_SOFTID = 10;	// Read Software ID                                         
        const ushort UNIKEY_SET_MODULE = 11;	// Set license module                                       
        const ushort UNIKEY_CHECK_MODULE = 12;	// Check license module                                     
        const ushort UNIKEY_WRITE_ARITHMETIC = 13;	// Write Arithmetic                                         
        const ushort UNIKEY_CALCULATE1 = 14;	// Calculate 1                                              
        const ushort UNIKEY_CALCULATE2 = 15;	// Calculate 2                                              
        const ushort UNIKEY_CALCULATE3 = 16;	// Calculate 3                                              
        const ushort UNIKEY_MODULE_DECRASE = 17;	// Decrease license module Unit                             
        const ushort UNIKEY_SET_NEW_PASSWORD = 18;	// Set New Password via a New Seed                          
        const ushort UNIKEY_GENERATE_KEY = 19;	// Generate a New Key in specific Key Store                 
        const ushort UNIKEY_ENCRYPT = 20;	// Encrypt the Buffer with a Specific Key                   
        const ushort UNIKEY_DECRYPT = 21;	// Decrypt the Buffer with a Specific Key	                
        const ushort UNIKEY_MD5 = 22;	// Make an MD5 Digest for a Certain Content	                
        const ushort UNIKEY_READ_UPDATETAG = 23;	// Read UpdateTag from a Specific Key                       
        const ushort UNIKEY_WRITE_UPDATETAG = 24;	// Write UpdateTag to a Specific Key 
        // error codes
        const ushort SUCCESS = 0; //Success
        const ushort ERROR_NO_UNIKEY = 3; //No UniKey dongle
        const ushort ERROR_FOUND_INVALID_PASSWORD = 4; //Found UniKey dongle, but Basic passwords are incorrect
        const ushort ERROR_INVALID_PASSWORD_OR_ID = 5; //Wrong password or UniKey HID
        const ushort ERROR_SET_SOFTID = 6; //Set UniKey ID wrong
        const ushort ERROR_INVALID_ADDR_OR_SIZE = 7; //Read/Write address or length is wrong
        const ushort ERROR_UNKNOWN_COMMAND = 8; //No such command
        const ushort ERROR_NOTBELEVEL3 = 9; //Internal Error
        const ushort ERROR_READ = 10; //Read Error
        const ushort ERROR_WRITE = 11; //Write Error
        const ushort ERROR_RANDOM = 12; //Random number Error
        const ushort ERROR_SEED = 13; //Seed code Error
        const ushort ERROR_CALCULATE = 14; //Calculate Error
        const ushort ERROR_NO_OPEN = 15; //No open dongle before operating dongle
        const ushort ERROR_OPEN_OVERFLOW = 16; //Too many open dongles (>16)
        const ushort ERROR_NOMORE = 17; //No more dongle
        const ushort ERROR_NEED_FIND = 18; //No Find before FindNext
        const ushort ERROR_MODULE_DECRASE = 19; //MODULE_DECRASE Error
        const ushort ERROR_AR_BAD_COMMAND = 20; //Arithmetic instruction Error
        const ushort ERROR_AR_UNKNOWN_OPCODE = 21; //Arithmetic operator Error
        const ushort ERROR_AR_WRON_GBEGIN = 22; //Const number can't use on first arithmetic instruction
        const ushort ERROR_AR_WRONG_END = 23; //Const number can't use on last arithmetic instruction
        const ushort ERROR_AR_VALUE_OVERFLOW = 24; //Const number > 63
        const ushort ERROR_TOO_MUCH_THREAD = 25; //Too many (>100) threads in the single process open the dongle
        const ushort ERROR_INVALID_KEY = 26; //The key in the key storage is wrong
        const ushort ERROR_VERIFY_ADV_PASSWORD = 27; //Advanced passwords (password3 and passowrd4) not verified
        const ushort ERROR_INVALID_KEY_STORE = 28; //Wrong key storage number
        const ushort EEROR_GENERATE_NEW_PASSWORD = 29; //Generate new password Error
        const ushort ERROR_READ_UPDATETAG = 30; //Read UpdateTag Error
        const ushort ERROR_WRITE_UPDATETAG = 31; //Write UpdateTag Error
        const ushort ERROR_RECEIVE_NULL = 0x100; //Receive null
        const ushort ERROR_UNKNOWN_SYSTEM = 0x102; //Unknown operating system
        const ushort ERROR_UNKNOWN_ERROR = 0xffff; //Unknown Error		
        // declare function 
        [DllImport("UniKey")]
        public static extern ushort UniKey(ushort function, ref ushort handle, ref uint lp1, ref uint lp2, ref ushort p1, ref ushort p2, ref ushort p3, ref ushort p4, Byte[] buffer);
        public string ReadDongle(ushort from, ushort to)
        {        
            ushort p1, p2, p3, p4, handle;
            uint lp1, lp2;
            Byte[] buffer = new Byte[256];
            ushort retcode;
            ushort[] rc = new ushort[4];
            p1 = p2 = p3 = p4 = 1234;		// init para
            handle = 1;
            lp1 = lp2 = 0;            
            string readString = string.Empty;
            // find dongle
            retcode = UniKey(UNIKEY_FIND, ref handle, ref lp1, ref lp2, ref p1, ref p2, ref p3, ref p4, buffer);
            if (retcode != 0)
            {
                return "1";
            }        
            // open dongle
            retcode = UniKey(UNIKEY_LOGON, ref handle, ref lp1, ref lp2, ref p1, ref p2, ref p3, ref p4, buffer);
            if (retcode != 0)
            {                
                return "2";
            }           
            p1 = from;
            p2 = to;
            buffer = new Byte[100];
            // read dongle memory
            retcode = UniKey(UNIKEY_READ_MEMORY, ref handle, ref lp1, ref lp2, ref p1, ref p2, ref p3, ref p4, buffer);
            if (retcode != 0)
            {                
                return "3";
            }
            readString = System.Text.Encoding.ASCII.GetString(buffer);
            return readString;            
       } 
	}
