using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for HolidayEventData
/// </summary>
public class HolidayEventData
{
    Database dbCon = DatabaseFactory.CreateDatabase("DBConnection");
    int count, Result;
    //String Htype = "";
    
    public void InsertHoliday(string Holiday_Type, string Holiday_FromDate, string Holiday_ToDate, string Holiday_Description, string YearSettings_Id, string Emp_Id, string LevelId)
    {
        try
        {
            DbCommand cmd_InsertHoliday = dbCon.GetStoredProcCommand("Proc_TA_InsertHoliday", new object[] { 'I', 0, Holiday_Type, Holiday_FromDate, Holiday_ToDate, Holiday_Description, YearSettings_Id, Emp_Id, LevelId });
            cmd_InsertHoliday.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_InsertHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet SelectHolidayDetails(string UserGroupName, int YearsettingsId)
    {
        DataSet ds_HolidayDetails = new DataSet();
        try
        {
            DbCommand cmd_SelectHoliday = dbCon.GetStoredProcCommand("Proc_TA_SelectHoliday", new object[] { 'A', 0, UserGroupName, 0, YearsettingsId, 0, 0 });
            cmd_SelectHoliday.CommandTimeout = 0;
            ds_HolidayDetails = dbCon.ExecuteDataSet(cmd_SelectHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_HolidayDetails;
    }
    public DataSet SelectHolidayDetailsById(int Holiday_Id, string UserGroupName, int yearsettingsId)
    {
        DataSet ds_HolidayDetails = new DataSet();
        try
        {
            DbCommand cmd_SelectHoliday = dbCon.GetStoredProcCommand("Proc_TA_SelectHoliday", new object[] { 'P', Holiday_Id, UserGroupName, 0, yearsettingsId, 0, 0 });
            cmd_SelectHoliday.CommandTimeout = 0;
            ds_HolidayDetails = dbCon.ExecuteDataSet(cmd_SelectHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_HolidayDetails;
    }
    public void UpdateHolidayDetails(int Holiday_Id, string Holiday_Type, string Holiday_FromDate, string Holiday_ToDate, string Holiday_Description, string YearSettings_Id, string Emp_Id, string LevelId)
    {
        try
        {
            DbCommand cmd_UpdateHoliday = dbCon.GetStoredProcCommand("Proc_TA_InsertHoliday", new object[] { 'U', Holiday_Id, Holiday_Type, Holiday_FromDate, Holiday_ToDate, Holiday_Description, YearSettings_Id, Emp_Id, LevelId });
            cmd_UpdateHoliday.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_UpdateHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void DeleteHolidayDetails(string Holiday_Id, string strType, int @auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteHoliday = dbCon.GetStoredProcCommand("Proc_TA_DeleteHoliday", new object[] { Holiday_Id, strType, auditEmpId });
            cmd_DeleteHoliday.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_DeleteHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public int checkHoliday(string HolidayType, string HolidayFromdate, string HolidayTodate, string HolidayDescription, int LevelId)
    {
        DataSet ds_CheckHoliday = new DataSet();
        try
        {
            DbCommand cmd_CheckHoliday = dbCon.GetStoredProcCommand("Proc_TA_CheckHolidays", new object[] { HolidayType, HolidayFromdate, HolidayTodate, HolidayDescription, LevelId });
            cmd_CheckHoliday.CommandTimeout = 0;
            count = (int)dbCon.ExecuteScalar(cmd_CheckHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int checkHolidayTempWeekDay(string HolidayFromdate, string HolidayTodate)
    {
        DataSet ds_CheckHoliday = new DataSet();
        try
        {
            DbCommand cmd_CheckHoliday = dbCon.GetStoredProcCommand("Proc_TA_CheckHolidaysTempWeekDay", new object[] { HolidayFromdate, HolidayTodate });
            cmd_CheckHoliday.CommandTimeout = 0;
            count = (int)dbCon.ExecuteScalar(cmd_CheckHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public DataSet GetHolidayDetailsByHolidayID(int HolidayID)
    {
        DataSet ds_CheckHoliday = new DataSet();
        try
        {
            ds_CheckHoliday = dbCon.ExecuteDataSet("Proc_TA_GetHolidayDetailsByHolidayID", new object[] { HolidayID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_CheckHoliday;
    }
    public int checkHolidayUp(int Holidayid, string HolidayType, string HolidayFromdate, string HolidayTodate, string HolidayDescription, int LevelId)
    {
        try
        {
            DbCommand cmd_CheckHoliday = dbCon.GetStoredProcCommand("Proc_TA_CheckHolidaysUpdate", new object[] { Holidayid, HolidayType, HolidayFromdate, HolidayTodate, HolidayDescription, LevelId });
            cmd_CheckHoliday.CommandTimeout = 0;
            count = (int)dbCon.ExecuteScalar(cmd_CheckHoliday);            
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int checkHolidayRestore(int Holidayid, string HolidayType, string HolidayFromdate, string HolidayTodate, string HolidayDescription)
    {
        try
        {
            DbCommand cmd_CheckHoliday = dbCon.GetStoredProcCommand("Proc_TA_CheckHolidaysRestore", new object[] { Holidayid, HolidayType, DateTime.Parse(HolidayFromdate).ToShortDateString(), DateTime.Parse(HolidayTodate).ToShortDateString(), HolidayDescription });
            cmd_CheckHoliday.CommandTimeout = 0;
            count = (int)dbCon.ExecuteScalar(cmd_CheckHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int HoildayCount(string HTYPE)
    {
        try
        {
            DbCommand cmd_CheckHoliday = dbCon.GetStoredProcCommand("Proc_TA_CheckGlobalHoliday", new object[] { HTYPE });
            cmd_CheckHoliday.CommandTimeout = 0;
            Result = (int)dbCon.ExecuteScalar(cmd_CheckHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Result;
    }
    public int HoildayCountUpdate(int HID, string HTYPE)
    {
        try
        {
            DbCommand cmd_CheckHoliday = dbCon.GetStoredProcCommand("Proc_TA_CheckGlobalHolidayUpdate", new object[] { HID, HTYPE });
            cmd_CheckHoliday.CommandTimeout = 0;
            Result = (int)dbCon.ExecuteScalar(cmd_CheckHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Result;
    }
    public DataSet MaxHoliday()
    {
        DataSet ds_MaxHoliday = new DataSet();
        try
        {
            ds_MaxHoliday = dbCon.ExecuteDataSet("Proc_TA_CheckMaxHoliday");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_MaxHoliday;
    }
    public DataTable CheckDateForHoliday(string strDate, string EmployeeCodeId)
    {
        DataSet ds_Holiday = new DataSet();
        try
        {
            ds_Holiday = dbCon.ExecuteDataSet("Proc_TA_CheckDateForHoliday", new object[] { strDate, EmployeeCodeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Holiday.Tables[0];
    }
    //Get Restricted Holiday count From Leave Application
    public int GetRestrictedHolidayCount(int Holiday_Id)
    {
        DataSet ds_RestrictedHolidayCount = new DataSet();
        try
        {
            DbCommand cmd_GetHoliday = dbCon.GetStoredProcCommand("Proc_TA_GetRestrictedHolidayCount", new object[] { Holiday_Id });
            cmd_GetHoliday.CommandTimeout = 0;
            count = (int)dbCon.ExecuteScalar(cmd_GetHoliday);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public HolidayEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = dbCon.DbProviderFactory;
        dbCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public void UpdateProcessedDataFlag(string FromDate, string ToDate)
    {
        try
        {
            DbCommand cmd_UpdateProcessedDataFlag = dbCon.GetStoredProcCommand("Proc_Ta_Reprocess_HolidayData", new object[] { FromDate, ToDate });
            cmd_UpdateProcessedDataFlag.CommandTimeout = 0;
            dbCon.ExecuteNonQuery(cmd_UpdateProcessedDataFlag);
        }
        catch (Exception ex)
        {
            throw ex;
        }        
    }
    public DataSet CheckHolidays_GlobalDate(string fromDate, string toDate, string mode, int holidayId)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = dbCon.ExecuteDataSet("Proc_TA_CheckHolidays_GlobalDate", new object[] { fromDate, toDate, mode, holidayId });
        }
        catch
        {
            return ds;
        }
        return ds;
    }
}
