using System;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
public class LeaveEventData
{
    //creating DB connection
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    //creating dataset
    DataSet ds_LeaveDetails = new DataSet();
    int count;
    //Added by MAnjula.P on 29-Jan-2013
    string strCount = string.Empty;
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    //select leave type for grid
    public DataSet SelectLeaveTypeDetails(string UserGroupName)
    {
        try
        {
            ds_LeaveDetails = DBCon.ExecuteDataSet("Proc_TA_GetLeaveTypeDetails", new object[] { UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeaveDetails;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    //select leave type for grid
    //Included Empautoid by Amsaveni on 01/10/2013 to load data in autocomplete based on grade level
    public DataSet SelectAutoCompleteExtender(string Id, string CardNo, string Empautoid, string ParentLevelId)
    {
        try
        {
            ds_LeaveDetails = DBCon.ExecuteDataSet("Proc_TA_AutoCompleteExtender", new object[] { Id, CardNo, Empautoid, ParentLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeaveDetails;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    //select leave type for grid
    //Included Empautoid by Amsaveni on 01/10/2013 to load data in autocomplete based on grade level
    public DataSet SelectAutoCompleteExtenderForReports(string Id, string CardNo, string Empautoid, string ParentLevelId)
    {
        try
        {
            ds_LeaveDetails = DBCon.ExecuteDataSet("Proc_TA_AutoCompleteExtenderForReports", new object[] { Id, CardNo, Empautoid, ParentLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeaveDetails;
    }
    public DataSet SelectLeavePolicyDetails(string UserGroupName, string EmployeeCategory, string EmployeeType, string gender, string Religion)
    {
        try
        {
            ds_LeaveDetails = DBCon.ExecuteDataSet("Proc_TA_GetLeavePolicyDetails", new object[] { UserGroupName, EmployeeCategory, EmployeeType, gender, Religion });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeaveDetails;
    }
    //select Leave type for View/modify page
    public DataSet SelectLeaveTypeDetailsById(int id, string UserGroupName)
    {
        try
        {
            ds_LeaveDetails = DBCon.ExecuteDataSet("Proc_TA_GetLeaveTypeDetailsById", new object[] { id, UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeaveDetails;
    }
    //insert leave type
    public void InsertLeaveTypeDetails(string LeaveType, string LeaveDescription, string Emp_Id, int EmployeeCategory, int Employeetype, string Gender, int Religion, int CountFactor)
    {
        try
        {
            DbCommand cmd_InsertLeaveType = DBCon.GetStoredProcCommand("Proc_TA_Insert_LeaveTypeDetails", new object[] { LeaveType, LeaveDescription, Emp_Id, CountFactor, EmployeeCategory, Employeetype, Gender, Religion });
            cmd_InsertLeaveType.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_InsertLeaveType);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update leave type
    public void UpdateLeaveTypeDetails(string LeaveType, string LeaveDescription, int Id, int employeeId, int CountFactor, int EmpCatagory, int empType, string Gender, int Religion)
    {
        try
        {
            DbCommand cmd_UpdateLeave = DBCon.GetStoredProcCommand("Proc_TA_Update_LeaveTypeDetails", new object[] { LeaveType, LeaveDescription, Id, employeeId, CountFactor, EmpCatagory, empType, Gender, Religion });
            cmd_UpdateLeave.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_UpdateLeave);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // In Activating thje Leave Type
    public void Delete_LeaveTypes(String LeaveTypeId, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteType = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreLeaveType", new object[] { "TemporaryDelete", LeaveTypeId, auditEmpId });
            cmd_DeleteType.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteType);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Leave Type Permanent Deletion
    public void PermanentDeleteLeaveTypes(String LeaveTypeId, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteType = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreLeaveType", new object[] { "PermanentDelete", LeaveTypeId, auditEmpId });
            cmd_DeleteType.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteType);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public int CheckPermanentDeleteLeaveTypes(String LeaveTypeId)
    {
        DataSet ds_CheckLeave = new DataSet();
        try
        {
            ds_CheckLeave = DBCon.ExecuteDataSet("Proc_TA_CheckLeaveTypeForPermanentDelete", new object[] { LeaveTypeId });
            count = Convert.ToInt32(ds_CheckLeave.Tables[0].Rows[0]["Ltype"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    // Restoring Leave Types
    public void RestoreLeaveTypes(String LeaveTypeId, int auditEmpId)
    {
        try
        {
            DbCommand cmd_RestoreLeaveTypes = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreLeaveType", new object[] { "Restore", LeaveTypeId, auditEmpId });
            cmd_RestoreLeaveTypes.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_RestoreLeaveTypes);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Check for already existing while update
    public int CheckLeaveType_Update(string LeaveType, int Id)
    {
        DataSet ds_CheckLeaveType = new DataSet();
        try
        {
            ds_CheckLeaveType = DBCon.ExecuteDataSet("Proc_TA_CheckLeave_Update", new object[] { LeaveType, Id });
            count = Convert.ToInt32(ds_CheckLeaveType.Tables[0].Rows[0]["Ltype"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    /// <summary>
    /// Check for already existing count factor leave types by MAnjula.P on 29-Jan-2014
    /// </summary>
    /// <param name="LeaveTypeId"></param>
    /// <returns></returns>
    public string CheckCountFacorLeaveTypes(int LeaveTypeId)
    {
        DataSet ds_CheckLeaveType = new DataSet();
        try
        {
            ds_CheckLeaveType = DBCon.ExecuteDataSet("Proc_TA_CheckCountFacorLeaveTypes", new object[] { LeaveTypeId });
            strCount = Convert.ToString(ds_CheckLeaveType.Tables[0].Rows[0]["count"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return strCount;
    }
    //check for already existing while insert
    public int CheckLeaveType_Insert(string LeaveType)
    {
        DataSet ds_CheckLeave = new DataSet();
        try
        {
            ds_CheckLeave = DBCon.ExecuteDataSet("Proc_TA_CheckLeave_Insert", new object[] { LeaveType });
            count = Convert.ToInt32(ds_CheckLeave.Tables[0].Rows[0]["Ltype"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //check for mapping in Leave policy while deleting
    public int CheckLeaveType(int LeaveType)
    {
        DataSet ds_LeaveType = new DataSet();
        try
        {
            ds_LeaveType = DBCon.ExecuteDataSet("Proc_TA_CheckLeaveType", new object[] { LeaveType });
            count = Convert.ToInt32(ds_LeaveType.Tables[0].Rows[0]["LType"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    // Check whether the Record already Exists while Restoring
    public int CheckRestoreLeaveType(int LeaveTypeId)
    {
        DataSet ds_LeaveType = new DataSet();
        try
        {
            ds_LeaveType = DBCon.ExecuteDataSet("Proc_TA_CheckRestoreLeaveType", new object[] { LeaveTypeId });
            count = Convert.ToInt32(ds_LeaveType.Tables[0].Rows[0]["LType"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //check for mapping in Leave Application while deleting
    public int CheckLeaveType_LeaveApp(int LeaveType)
    {
        DataSet ds_LeaveType = new DataSet();
        try
        {
            ds_LeaveType = DBCon.ExecuteDataSet("Proc_TA_CheckLeaveType_LeaveApp", new object[] { LeaveType });
            count = Convert.ToInt32(ds_LeaveType.Tables[0].Rows[0]["LType"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectAllLeavePolicy(string strUserGroupName)
    {
        DataSet ds_LeavePolicy = new DataSet();
        try
        {
            ds_LeavePolicy = DBCon.ExecuteDataSet("Proc_TA_SelectLeavePolicy", new object[] { 'A', 0, strUserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeavePolicy;
    }
    //select All Leave Policy
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectAllLeavePolicyforEmployeeFilters(string LeavePolicy)
    {
        DataSet ds_LeavePolicy = new DataSet();
        try
        {
            ds_LeavePolicy = DBCon.ExecuteDataSet("Proc_TA_SelectLeavePolicyforEmployeeFilters", new object[] { LeavePolicy });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeavePolicy;
    }
    //select Leave Policy by ID
    public DataSet SelectLeavePolicyByID(int LeavePolicyID, string UserGroupName)
    {
        DataSet ds_LeavePolicy = new DataSet();
        try
        {
            ds_LeavePolicy = DBCon.ExecuteDataSet("Proc_TA_SelectLeavePolicy", new object[] { 'P', LeavePolicyID, UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeavePolicy;
    }
    public DataSet ViewLeavePolicyDetails(string UserGroupName, string EmployeeCategory, string EmployeeType, string Gender, string Religion)
    {
        DataSet ds_LeavePolicy = new DataSet();
        try
        {
            ds_LeavePolicy = DBCon.ExecuteDataSet("Proc_TA_ViewLeavePolicyDetails", new object[] { 'P', UserGroupName, EmployeeCategory, EmployeeType, Gender, Religion });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeavePolicy;
    }
    //Check Leave Policy Name
    public int LeavePolicyName(string PolicyName)
    {
        DataSet ds_LeavePolicy = new DataSet();
        int count;
        try
        {
            ds_LeavePolicy = DBCon.ExecuteDataSet("Proc_TA_CheckLeavepolicyName", new object[] { PolicyName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        count = Convert.ToInt32(ds_LeavePolicy.Tables[0].Rows[0][0]);
        return count;
    }
    //Check policy name update
    public int CheckPolicyName(int PolicyId, string Policyname)
    {
        DataSet ds_LeavePolicy = new DataSet();
        int count;
        try
        {
            ds_LeavePolicy = DBCon.ExecuteDataSet("Proc_TA_PolicyName", new object[] { PolicyId, Policyname });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        count = Convert.ToInt32(ds_LeavePolicy.Tables[0].Rows[0][0]);
        return count;
    }
    // Insert Leave policy
    public void InsertLeavePolicy(string PolicyName, string Permission_MaxHrs_Month, int Permission_MaxInstances_Month, string Permission_MaxHrs_Instance, int Employee_Id, int PermissionBeforeLeave, int PermissionAfterLeave, int OtHourWise, int OtDayWise, string OtMinHrs, int EmployeeCategory, int EmployeeType, string Gender, int Religion, string strHalfDayCompOff, int iValidDays, string Permission_MinHrs_Instance)
    {
        try
        {
            DbCommand cmd_InsertLeavePolicy = DBCon.GetStoredProcCommand("Proc_TA_InsertLeavePolicy", new object[] { 'I', 0, PolicyName, Permission_MaxHrs_Month, Permission_MaxInstances_Month, Permission_MaxHrs_Instance, Employee_Id, PermissionBeforeLeave, PermissionAfterLeave, OtHourWise, OtDayWise, OtMinHrs, EmployeeCategory, EmployeeType, Gender, Religion, strHalfDayCompOff, iValidDays, Permission_MinHrs_Instance });
            cmd_InsertLeavePolicy.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_InsertLeavePolicy);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Update Leave policy
    public void UpdateLeavePolicy(int LeavePolicyID, string PolicyName, string Permission_MaxHrs_Month, int Permission_MaxInstances_Month, string Permission_MaxHrs_Instance, int Employee_Id, int PermissionBeforeLeave, int PermissionAfterLeave, int OtHourWise, int OtDayWise, string OtMinHrs, int EmployeeCategory, int EmployeeType, string Gender, int Religion, string strHalfDayCompOff, int iValidDays, string Permission_MinHrs_Instance)
    {
        try
        {
            DbCommand cmd_UpdateLeavePolicy = DBCon.GetStoredProcCommand("Proc_TA_InsertLeavePolicy", new object[] { 'U', LeavePolicyID, PolicyName, Permission_MaxHrs_Month, Permission_MaxInstances_Month, Permission_MaxHrs_Instance, Employee_Id, PermissionBeforeLeave, PermissionAfterLeave, OtHourWise, OtDayWise, OtMinHrs, EmployeeCategory, EmployeeType, Gender, Religion, strHalfDayCompOff, iValidDays, Permission_MinHrs_Instance });
            cmd_UpdateLeavePolicy.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_UpdateLeavePolicy);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // In Activating the Leave Policies
    public void Delete_LeavePolicies(string LeavePolicyIDs, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteLeavepolicy = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreLeavePolicy", new object[] { "TemporaryDelete", LeavePolicyIDs, auditEmpId });
            cmd_DeleteLeavepolicy.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteLeavepolicy);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Permanently Deleting Leave Policies
    public void PermanentDeleteLeavePolicies(string LeavePolicyIDs, int auditEmpId)
    {
        try
        {
            DbCommand cmd_PermanentDeleteLeavepolicy = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreLeavePolicy", new object[] { "PermanentDelete", LeavePolicyIDs, auditEmpId });
            cmd_PermanentDeleteLeavepolicy.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_PermanentDeleteLeavepolicy);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Restoring Leave Policies
    public void RestoreLeavePolicies(string LeavePolicyIDs, int auditEmpId)
    {
        try
        {
            DbCommand cmd_RestoreLeavepolicy = DBCon.GetStoredProcCommand("Proc_TA_DeleteRestoreLeavePolicy", new object[] { "Restore", LeavePolicyIDs, auditEmpId });
            cmd_RestoreLeavepolicy.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_RestoreLeavepolicy);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Select Leave Policy Details by Leave Policy ID
    public DataSet SelectLeavePolicyDetails(int LeavePolicyID)
    {
        DataSet ds_LeavePolicyDetails = new DataSet();
        try
        {
            ds_LeavePolicyDetails = DBCon.ExecuteDataSet("Proc_TA_SelectLeavePolicyDetails", new object[] { LeavePolicyID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeavePolicyDetails;
    }

    public void InsertLeavePolicyDetails(int Policy_Id, int LeaveType_Id, float MaxDays_applicable, float MaxDays_Month, float MaxDays_avail, float MinDays_avail, int Spells, float MaxDays_Acc, bool LossOfPay, float Max_LOP_Days, bool Count_BeforeWeeklyOff, bool Count_AfterWeeklyOff, bool Count_Intervening, bool Borrow_FromNextYear, bool Carry_ToNextYear, bool Encashment, float Calc_Factor, float fltMinWorkDays, bool WeekDays, bool WeekOff, bool Leave, bool Holidays, float ApplicableAfterDays, int Employee_Id)
    {
        try
        {
            DbCommand cmd_InsertLeavePolicyDetails = DBCon.GetStoredProcCommand("Proc_TA_InsertLeavePolicyDetails", new object[] { Policy_Id, LeaveType_Id, MaxDays_applicable, MaxDays_Month, MaxDays_avail, MinDays_avail, Spells, MaxDays_Acc, LossOfPay, Max_LOP_Days, Count_BeforeWeeklyOff, Count_AfterWeeklyOff, Count_Intervening, Borrow_FromNextYear, Carry_ToNextYear, Encashment, Calc_Factor, fltMinWorkDays, WeekDays, WeekOff, Leave, Holidays, ApplicableAfterDays, Employee_Id });
            cmd_InsertLeavePolicyDetails.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_InsertLeavePolicyDetails);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Delete Leave Policy details
    public void PermanentDeleteLeavePolicyDetails(int LeavePolicyID)
    {
        try
        {
            DbCommand cmd_DeleteLeavepolicyDetails = DBCon.GetStoredProcCommand("Proc_TA_DeleteLeavePolicyDetails", new object[] { LeavePolicyID });
            cmd_DeleteLeavepolicyDetails.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteLeavepolicyDetails);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // check for mapping in Employee Leave policy while deleting
    public int CheckLeavePolicy(int LeavePolicy)
    {
        DataSet ds_LeavePolicy = new DataSet();
        try
        {
            ds_LeavePolicy = DBCon.ExecuteDataSet("Proc_TA_CheckLeavePolicy", new object[] { LeavePolicy });
            count = Convert.ToInt32(ds_LeavePolicy.Tables[0].Rows[0]["count"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    // Check for Duplicate while Restoring
    public DataSet CheckLeavePolicyDuplicate(int LeavePolicy)
    {
        DataSet ds_LeavePolicy = new DataSet();
        try
        {
            ds_LeavePolicy = DBCon.ExecuteDataSet("Proc_TA_CheckRestoreLeavePolicy", new object[] { LeavePolicy });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeavePolicy;
    }
    //select Max Leave Policy Id
    public int selectMAXLeavePolicyID()
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectMAXLeavePolicyID", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        int MAX_ID = Convert.ToInt32(ds.Tables[0].Rows[0]["MAX_PolicyID"]);
        return MAX_ID;
    }
    public LeaveEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public DataSet SelectLeavePolicyDetailsBasedOnFilter(int EmployeeCategory, int EmployeeType, string gender, int Religion)
    {
        try
        {
            ds_LeaveDetails = DBCon.ExecuteDataSet("Proc_TA_SelectLeavePolicyDetailsBasedOnFilter", new object[] { EmployeeCategory, EmployeeType, gender, Religion });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LeaveDetails;
    }
    public string[] commaStringToArray(string strComma)
    {
        string[] strArray;
        strArray = strComma.Split(new char[] { ',' });
        string[] intArray = new string[strArray.Length];
        for (int i = 0; i < strArray.Length; i++)
            intArray[i] = Convert.ToString(strArray[i]);
        return intArray;
    }
}
