using System;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
/// <summary>
/// Summary description for TerminalDatatypeEventData
/// </summary>
/// 
public class TerminalDatatypeEventData
{
    DataAccess objDataAccess = new DataAccess();
    Database db = DatabaseFactory.CreateDatabase("DBConnection");
    // Selecting Terminal Datatype details
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet Select_TerminalDatatype(string strUserGroupName)
    {
        DataSet ds_TerminalDatatype = new DataSet();
        try
        {
            ds_TerminalDatatype = db.ExecuteDataSet("Proc_TA_SelectTerminalDatatype", new object[] { 'A', 0, strUserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TerminalDatatype;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet Select_DeviceFromBiostar(string Conn)
    {
        DataSet ds_TerminalDevice = new DataSet();
        try
        {
            ds_TerminalDevice = db.ExecuteDataSet("Proc_TA_SelectDeviceFromBiostar", new object[] { Conn });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TerminalDevice;
    }
    // Selecting Terminal datatype details by Id
    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public DataSet Select_TerminalDatatypebyId(int TerminalDatatypeId, string strUserGroupName)
    {
        DataSet ds_TerminalDatatype = new DataSet();
        try
        {
            ds_TerminalDatatype = db.ExecuteDataSet("Proc_TA_SelectTerminalDatatype", new object[] { 'P', TerminalDatatypeId, strUserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TerminalDatatype;
    }
    //Gets the brand details
    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public DataSet SelectBrandDetails()
    {
        DataSet ds_BrandType = new DataSet();
        try
        {
            ds_BrandType = db.ExecuteDataSet("Proc_TA_GetBrandDetails", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_BrandType;
    }
    // Update Terminal Datatype Details
    public void Update_TerminalDatatype(string Type, int TerminalDatatypeId, string RawDataFormat, string FileType, string FileSourcePath, string FileBackupPath, string FileBackupType,
        int NoOfFields, string Delimiter, string StringEnclosedBy, string Del_ReaderNo, string Del_CardNo, int Del_DateTimeBit, string Del_Date,
        string Del_Time, string Del_DateTime, string Del_Type, string Del_TransactionIdentifier, int FL_ReaderNoFrom, int FL_ReaderNoTo,
        int FL_CardNoFrom, int FL_CardNoTo, int FL_DateTimeBit, int FL_DateFrom, int FL_DateTo, int FL_TimeFrom, int FL_TimeTo, int FL_DateTimeFrom,
        int FL_DateTimeTo, int FL_TypeFrom, int FL_TypeTo, int FL_TransactionIdentifierFrom, int FL_TransactionIdentifierTo, string ConnectionString,
        string TableName, string MDB_ReaderNo, string MDB_CardNo, int MDB_DateTimeBit, string MDB_Date, string MDB_Time, string MDB_DateTime,
        string MDB_Type, string MDB_TransactionIdentifier, string RDBMS_ReaderNo, string RDBMS_CardNo, int RDBMS_DateTimeBit, string RDBMS_Date,
        string RDBMS_Time, string RDBMS_DateTime, string RDBMS_Type, string RDBMS_TransactionIdentifier, string MDB_RDBMS_Flag, int IsEmployeeIdBit, string DateTimeFormat, string DateFormat,
        string TimeFormat, int IsEncryptedBit, int TransactionIdentifierBit, string TransactionIdentifierValue, int Empid, string BrandType, int IsFreeScan)
    {
        try
        {
            DbCommand cmd_updateTerminalDatatype = db.GetStoredProcCommand("Proc_TA_InsertTerminalDatatype", new object[] { Type, TerminalDatatypeId, RawDataFormat, FileType, FileSourcePath, FileBackupPath, FileBackupType, NoOfFields, Delimiter, StringEnclosedBy, Del_ReaderNo, Del_CardNo, Del_DateTimeBit, Del_Date, Del_Time, Del_DateTime, Del_Type, Del_TransactionIdentifier, FL_ReaderNoFrom, FL_ReaderNoTo, FL_CardNoFrom, FL_CardNoTo, FL_DateTimeBit, FL_DateFrom, FL_DateTo, FL_TimeFrom, FL_TimeTo, FL_DateTimeFrom, FL_DateTimeTo, FL_TypeFrom, FL_TypeTo, FL_TransactionIdentifierFrom, FL_TransactionIdentifierTo, ConnectionString, TableName, MDB_ReaderNo, MDB_CardNo, MDB_DateTimeBit, MDB_Date, MDB_Time, MDB_DateTime, MDB_Type, MDB_TransactionIdentifier, RDBMS_ReaderNo, RDBMS_CardNo, RDBMS_DateTimeBit, RDBMS_Date, RDBMS_Time, RDBMS_DateTime, RDBMS_Type, RDBMS_TransactionIdentifier, MDB_RDBMS_Flag, IsEmployeeIdBit, DateTimeFormat, DateFormat, TimeFormat, IsEncryptedBit, TransactionIdentifierBit, TransactionIdentifierValue, Empid, BrandType, IsFreeScan });
            cmd_updateTerminalDatatype.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_updateTerminalDatatype);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Check Terminal Datatype Details for Duplicate
    public int CheckTerminalDatatype(char Type, int TerminalDataTypeId, string RawDataFormat, string FileType, string FileSourcePath, string FileBackupPath, int NoOfFields, string Delimiter, string StringEnclosedBy, string Del_ReaderNo, string Del_CardNo, int Del_DateTimeBit, string Del_Date, string Del_Time, string Del_DateTime, string Del_Type, int FL_ReaderNoFrom, int FL_ReaderNoTo, int FL_CardNoFrom, int FL_CardNoTo, int FL_DateTimeBit, int FL_DateFrom, int FL_DateTo, int FL_TimeFrom, int FL_TimeTo, int FL_DateTimeFrom, int FL_DateTimeTo, int FL_TypeFrom, int FL_TypeTo, string ConnectionString, string TableName, string MDB_ReaderNo, string MDB_CardNo, int MDB_DateTimeBit, string MDB_Date, string MDB_Time, string MDB_DateTime, string MDB_Type, string RDBMS_ReaderNo, string RDBMS_CardNo, int RDBMS_DateTimeBit, string RDBMS_Date, string RDBMS_Time, string RDBMS_DateTime, string RDBMS_Type, string MDB_RDBMS_Flag)
    {
        DataSet ds_TerminalDatatype = new DataSet();
        int TotTerminal = 0;
        try
        {
            DbCommand cmdDVEmployeeCreation = db.GetStoredProcCommand("Proc_TA_CheckTerminalDatatype", new object[] { Type, TerminalDataTypeId, RawDataFormat, FileType, FileSourcePath, FileBackupPath, NoOfFields, Delimiter, StringEnclosedBy, Del_ReaderNo, Del_CardNo, Del_DateTimeBit, Del_Date, Del_Time, Del_DateTime, Del_Type, FL_ReaderNoFrom, FL_ReaderNoTo, FL_CardNoFrom, FL_CardNoTo, FL_DateTimeBit, FL_DateFrom, FL_DateTo, FL_TimeFrom, FL_TimeTo, FL_DateTimeFrom, FL_DateTimeTo, FL_TypeFrom, FL_TypeTo, ConnectionString, TableName, MDB_ReaderNo, MDB_CardNo, MDB_DateTimeBit, MDB_Date, MDB_Time, MDB_DateTime, MDB_Type, RDBMS_ReaderNo, RDBMS_CardNo, RDBMS_DateTimeBit, RDBMS_Date, RDBMS_Time, RDBMS_DateTime, RDBMS_Type, MDB_RDBMS_Flag });
            cmdDVEmployeeCreation.CommandTimeout = 0;
            TotTerminal = Convert.ToInt32(db.ExecuteScalar(cmdDVEmployeeCreation));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return (TotTerminal);
    }
    // In Activating the Terminal Datatypes
    public void DeleteTerminalDataTypes(string TerminalDatatypes, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteTerminalDatatypes = db.GetStoredProcCommand("Proc_TA_DeleteRestoreTerminalDatatype", new object[] { "TemporaryDelete", TerminalDatatypes, auditEmpId });
            cmd_DeleteTerminalDatatypes.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_DeleteTerminalDatatypes);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Permanently Deleting the Terminal Datatypes
    public void PermanentDeleteTerminalDataTypes(string TerminalDatatypes, int auditEmpId, string Type)
    {
        try
        {
            DbCommand cmd_DeleteTerminalDatatypes = db.GetStoredProcCommand("Proc_TA_DeleteRestoreTerminalDatatype", new object[] { Type, TerminalDatatypes, auditEmpId });
            cmd_DeleteTerminalDatatypes.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_DeleteTerminalDatatypes);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Check for Duplicate Terminal DataType Record while Restoring
    public int CheckRestoreTerminalDataType(int TerminalDataTypeID)
    {
        int Count;
        DataSet ds_TerminalDatatype = new DataSet();
        try
        {
            ds_TerminalDatatype = db.ExecuteDataSet("Proc_TA_CheckRestoreTerminalDataType", new object[] { TerminalDataTypeID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        Count = Convert.ToInt32(ds_TerminalDatatype.Tables[0].Rows[0]["Count"]);
        return Count;
    }
    // Restoring the Terminal Datatypes
    public void RestoreTerminalDataTypes(string TerminalDatatypes, int auditEmpId)
    {
        try
        {
            DbCommand cmd_RestoreTerminalDatatypes = db.GetStoredProcCommand("Proc_TA_DeleteRestoreTerminalDatatype", new object[] { "Restore", TerminalDatatypes, auditEmpId });
            cmd_RestoreTerminalDatatypes.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_RestoreTerminalDatatypes);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void ExecuteTriggerAndTableScript(string Script, string DeviceDB_ConnectionString)
    {
        objDataAccess.ExecuteTriggerAndTableScript(Script, DeviceDB_ConnectionString);
    }
    public TerminalDatatypeEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = db.DbProviderFactory;
        db = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public int intTerminalCreationCount()
    {
        int countTerminal = 0;
        try
        {
            DbCommand cmdDVEmployeeCreation = db.GetSqlStringCommand("SELECT COUNT(*) FROM TA_Tbl_Terminal WHERE IsDeleted=0 and Terminal_ReaderID not in('787','788')");
            cmdDVEmployeeCreation.CommandTimeout = 0;
            countTerminal = Convert.ToInt32(db.ExecuteScalar(cmdDVEmployeeCreation));
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return countTerminal;
    }
}
