using System;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
public class cls_Master_Transportation
{
    //creating DB connection
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    //creating datasets
    DataSet ds_TransporationRoute = new DataSet();
    DataSet ds_TransportationVehicle = new DataSet();
    int count;
    #region Transportation-Route
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    //for grid view
    public DataSet SelectTransportationRouteDetails(string usergroupname)
    {
        try
        {
            ds_TransporationRoute = DBCon.ExecuteDataSet("Proc_TA_GetTransportation_RouteDetails", new object[] { usergroupname });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TransporationRoute;
    }
    //for modify page
    public DataSet SelectTransportationRouteDetailsById(int id)
    {
        try
        {
            ds_TransporationRoute = DBCon.ExecuteDataSet("Proc_TA_GetTransportation_RouteDetailsByID", new object[] { id });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TransporationRoute;
    }
    //for view page
    public DataSet SelectTransportationRouteMasterDetailsById(int id)
    {
        try
        {
            ds_TransporationRoute = DBCon.ExecuteDataSet("Proc_TA_GetTransportationRouteMasterDetailsById", new object[] { id });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TransporationRoute;
    }
    //insert Route details
    public void InsertTransportationRouteDetails(int LevelId, int vehicleID, string RouteName, string RouteDescription, int EmpID)
    {
        try
        {
            DbCommand cmd_InsertRoute = DBCon.GetStoredProcCommand("Proc_TA_Insert_Transportation_RouteDetails", new object[] { LevelId, vehicleID, RouteName, RouteDescription, EmpID });
            cmd_InsertRoute.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_InsertRoute);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update Route details
    public void UpdateTransportationRouteDetails(int LevelId, int vehicleID, string RouteName, string RouteDescription, int EmpID, int Routeid)
    {
        try
        {
            DbCommand cmd_UpdateTransactionRoute = DBCon.GetStoredProcCommand("Proc_Update_TA_TBL_Transportation_Route", new object[] { LevelId, vehicleID, RouteName, RouteDescription, EmpID, Routeid });
            cmd_UpdateTransactionRoute.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_UpdateTransactionRoute);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void DeleteRouteDetails(string Type, string RouteIds, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteTransportationRoute = DBCon.GetStoredProcCommand("Proc_TA_Transportation_Route_Delete", new object[] { Type, RouteIds, auditEmpId });
            cmd_DeleteTransportationRoute.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteTransportationRoute);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // Permanently delete Route Details
    public void PermanentDeleteRouteDetails(string RouteIds, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteTransportationRoute = DBCon.GetStoredProcCommand("Proc_TA_Transportation_Route_Delete", new object[] { 'C', 0, RouteIds, auditEmpId });
            cmd_DeleteTransportationRoute.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteTransportationRoute);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //check for already existing Route name while insert
    public int CheckRouteName_Update(int RouteId)
    {
        DataSet ds_CheckRoute = new DataSet();
        try
        {
            ds_CheckRoute = DBCon.ExecuteDataSet("Proc_TA_CheckRoute_Update", new object[] { RouteId });
            count = Convert.ToInt32(ds_CheckRoute.Tables[0].Rows[0]["RName"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int CheckRouteName_Update(string RouteName, int RouteId)
    {
        DataSet ds_CheckRoute = new DataSet();
        try
        {
            ds_CheckRoute = DBCon.ExecuteDataSet("Proc_TA_CheckRoute_ForModification", new object[] { RouteName, RouteId });
            count = Convert.ToInt32(ds_CheckRoute.Tables[0].Rows[0]["RName"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //check for already existing Route name while update
    public int CheckRouteName_Insert(int intVehicleID, string RouteName)
    {
        DataSet ds_CheckRoute = new DataSet();
        try
        {
            ds_CheckRoute = DBCon.ExecuteDataSet("Proc_TA_CheckRoute_Insert", new object[] { intVehicleID, RouteName });
            count = Convert.ToInt32(ds_CheckRoute.Tables[0].Rows[0]["RName"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //check for already existing Route name while update
    public int GetRouteCountFromEmployee(int RouteId)
    {
        DataSet ds_RouteCountFromEmployee = new DataSet();
        try
        {
            ds_RouteCountFromEmployee = DBCon.ExecuteDataSet("Proc_TA_GetRouteCountFromEmployee", new object[] { RouteId });
            count = Convert.ToInt32(ds_RouteCountFromEmployee.Tables[0].Rows[0]["RouteCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    #endregion
    #region Transprotation Vehicle - Master
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    //select Vehicle details for grid view
    public DataSet SelectTransportationVehicleDetails(string UserGroupName)
    {
        try
        {
            ds_TransportationVehicle = DBCon.ExecuteDataSet("Proc_TA_GetTransportation_VehicleDetails", new object[] { UserGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TransportationVehicle;
    }
    //select Vehicle details for view page & Modify page
    public DataSet SelectTransportationVehicleDetailsById(int id)
    {
        try
        {
            ds_TransportationVehicle = DBCon.ExecuteDataSet("Proc_TA_GetTransportationVehicleDetailsById", new object[] { id });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TransportationVehicle;
    }
    //insert Vehicle details
    public void InsertTransportationVehicleDetails(string VehicleNo, string VehicleDescription, int EmpID)
    {
        try
        {
            DbCommand cmd_InsertVehicle = DBCon.GetStoredProcCommand("Proc_TA_Insert_TransportationVehicleDetails", new object[] { VehicleNo, VehicleDescription, EmpID });
            cmd_InsertVehicle.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_InsertVehicle);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update Vehicle details
    public void UpdateTransportationVehicleDetails(string VehicleNo, string VehicleDescription, int VehicleId, int EmpID)
    {
        try
        {
            DbCommand cmd_UpdateTransactionVehicle = DBCon.GetStoredProcCommand("Proc_Update_TA_TBL_TransportationVehicle", new object[] { VehicleNo, VehicleDescription, VehicleId, EmpID });
            cmd_UpdateTransactionVehicle.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_UpdateTransactionVehicle);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void Delete_Vehicles(string Type, string Vehicles, int auditEmpId)
    {
        try
        {
            DbCommand cmd_DeleteVehicles = DBCon.GetStoredProcCommand("Proc_TA_Transportation_Vehicle_Delete", new object[] { Type, Vehicles, auditEmpId });
            cmd_DeleteVehicles.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_DeleteVehicles);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //checking for already existing Vehicle no while update
    public int CheckVehicleNO_Update(int VehicleId)
    {
        DataSet ds_CheckVehicleNO = new DataSet();
        try
        {
            ds_CheckVehicleNO = DBCon.ExecuteDataSet("Proc_TA_CheckVehicle_Update", new object[] { VehicleId });
            count = Convert.ToInt32(ds_CheckVehicleNO.Tables[0].Rows[0]["VNO"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int CheckVehicleNO_Update(string VehicleNo, int VehicleId)
    {
        DataSet ds_CheckVehicleNO = new DataSet();
        try
        {
            ds_CheckVehicleNO = DBCon.ExecuteDataSet("Proc_TA_CheckVehicle_ForModification", new object[] { VehicleNo, VehicleId });
            count = Convert.ToInt32(ds_CheckVehicleNO.Tables[0].Rows[0]["VNO"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //checking for already existing Vehicle no while insert
    public int CheckVehicleNO_Insert(string VehicleNo)
    {
        DataSet ds_CheckVehicleNO = new DataSet();
        try
        {
            ds_CheckVehicleNO = DBCon.ExecuteDataSet("Proc_TA_CheckVehicle_Insert", new object[] { VehicleNo });
            count = Convert.ToInt32(ds_CheckVehicleNO.Tables[0].Rows[0]["VNO"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //checking for Mapped Vehicle no
    public int CheckVehicleNoBYVehicleID(string VehicleId)
    {
        DataSet ds_CheckVehicleId = new DataSet();
        try
        {
            ds_CheckVehicleId = DBCon.ExecuteDataSet("Proc_TA_CheckVehicleNo", new object[] { VehicleId });
            count = Convert.ToInt32(ds_CheckVehicleId.Tables[0].Rows[0]["VNO"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    #endregion
    public cls_Master_Transportation()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
