using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for GenericEventdata
/// </summary>
///
public class GenericEventdata
{
    //creating DB connection
    Database db = DatabaseFactory.CreateDatabase("DBConnection");
    //selecting all countries
    public DataSet Getcountries(string userGroupName)
    {
        DataSet ds_countries = new DataSet();
        try
        {
            ds_countries = db.ExecuteDataSet("Proc_TA_SelectLookupData", new object[] { 'C', 0, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_countries;
    }
    //selecting country by ID
    public DataSet Getcountry(int ID, string userGroupName)
    {
        DataSet ds_country = new DataSet();
        try
        {
            ds_country = db.ExecuteDataSet("Proc_TA_SelectLookupData", new object[] { 'D', ID, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_country;
    }
    //insert country
    public void Insertcountry(string country, int EmpID)
    {
        try
        {
            DbCommand cmd_Insertcountry = db.GetStoredProcCommand("Proc_TA_InsertLookupTable", new object[] { 'I', 0, 1, country, 0, "country", EmpID });
            cmd_Insertcountry.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_Insertcountry);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update country
    public void Updatecountry(int ID, string country, int EmpID)
    {
        try
        {
            DbCommand cmd_Updatecountry = db.GetStoredProcCommand("Proc_TA_InsertLookupTable", new object[] { 'U', ID, 1, country, 0, "country", EmpID });
            cmd_Updatecountry.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_Updatecountry);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //delete look up data
    public void delete_lookupdata(int dataID)
    {
        try
        {
            DbCommand cmd_deletelookup = db.GetStoredProcCommand("Proc_TA_DeleteLookupdata", new object[] { 'I', dataID, "" });
            cmd_deletelookup.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_deletelookup);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //using checkbox
    // permanent delete - lookup
    public void PermanentDelete_lookupdata(string lookupIds, int auditEmpId)
    {
        try
        {
            DbCommand cmd_PermanentDeletelookup = db.GetStoredProcCommand("Proc_TA_DeleteRestoreLookupdata", new object[] { "PermanentDelete", lookupIds, auditEmpId });
            cmd_PermanentDeletelookup.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_PermanentDeletelookup);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // temporary delete - lookup
    public void TemporaryDelete_lookupdata(string lookupIds, int auditEmpId)
    {
        try
        {
            DbCommand cmd_TemporaryDeletelookup = db.GetStoredProcCommand("Proc_TA_DeleteRestoreLookupdata", new object[] { "TemporaryDelete", lookupIds, auditEmpId });
            cmd_TemporaryDeletelookup.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_TemporaryDeletelookup);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // restore - lookup
    public void Restore_lookupdata(string lookupIds, int auditEmpId)
    {
        try
        {
            DbCommand cmd_Restorelookup = db.GetStoredProcCommand("Proc_TA_DeleteRestoreLookupdata", new object[] { "Restore", lookupIds, auditEmpId });
            cmd_Restorelookup.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_Restorelookup);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet GetCityDetails(int ID, string Type)
    {
        DataSet ds_states = new DataSet();
        try
        {
            ds_states = db.ExecuteDataSet("Proc_TA_GetCityDetails", new object[] { ID, Type });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_states;
    }
    public DataSet Getstates(string userGroupName)
    {
        DataSet ds_states = new DataSet();
        try
        {
            ds_states = db.ExecuteDataSet("Proc_TA_SelectLookupData", new object[] { 'S', 0, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_states;
    }
    //selecting state by ID
    public DataSet Getstate(int ID, string userGroupName)
    {
        DataSet ds_states = new DataSet();
        try
        {
            ds_states = db.ExecuteDataSet("Proc_TA_SelectLookupData", new object[] { 'T', ID, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_states;
    }
    //insert state
    public void Insertstate(string state, int country, int EmpID)
    {
        try
        {
            DbCommand cmd_Insertstate = db.GetStoredProcCommand("Proc_TA_InsertLookupTable", new object[] { 'I', 0, 2, state, country, "state", EmpID });
            cmd_Insertstate.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_Insertstate);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update state
    public void Updatestate(int ID, string state, int country, int EmpID)
    {
        try
        {
            DbCommand cmd_Updatestate = db.GetStoredProcCommand("Proc_TA_InsertLookupTable", new object[] { 'U', ID, 2, state, country, "state", EmpID });
            cmd_Updatestate.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_Updatestate);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //selecting all cities
    public DataSet Getcities(string userGroupName)
    {
        DataSet ds_cities = new DataSet();
        try
        {
            ds_cities = db.ExecuteDataSet("Proc_TA_SelectLookupData", new object[] { 'N', 0, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_cities;
    }
    //selecting city by ID
    public DataSet Getcity(int ID, string userGroupName)
    {
        DataSet ds_cities = new DataSet();
        try
        {
            ds_cities = db.ExecuteDataSet("Proc_TA_SelectLookupData", new object[] { 'O', ID, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_cities;
    }
    //insert city
    public void Insertcity(string city, int state, int EmpID)
    {
        try
        {
            DbCommand cmd_Insertcity = db.GetStoredProcCommand("Proc_TA_InsertLookupTable", new object[] { 'I', 0, 3, city, state, "city", EmpID });
            cmd_Insertcity.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_Insertcity);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update city
    public void Updatecity(int ID, string city, int state, int EmpID)
    {
        try
        {
            DbCommand cmd_Updatecity = db.GetStoredProcCommand("Proc_TA_InsertLookupTable", new object[] { 'U', ID, 3, city, state, "city", EmpID });
            cmd_Updatecity.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_Updatecity);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //selecting all Grades
    public DataSet Getgrades(string userGroupName)
    {
        DataSet ds_grades = new DataSet();
        try
        {
            ds_grades = db.ExecuteDataSet("Proc_TA_SelectGrades", new object[] { 'A', 0, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_grades;
    }
    //selecting Grade by Id
    public DataSet Getgrade(int Id, string userGroupName)
    {
        DataSet ds_grades = new DataSet();
        try
        {
            ds_grades = db.ExecuteDataSet("Proc_TA_SelectGrades", new object[] { 'I', Id, userGroupName });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_grades;
    }
    //insert Grade
    public void InsertGrade(string GradeName, int GradeLevel, int EmpID)
    {
        try
        {
            DbCommand cmd_InsertGrade = db.GetStoredProcCommand("Proc_TA_InsertGrade", new object[] { 'I', 0, GradeName, GradeLevel, EmpID });
            cmd_InsertGrade.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_InsertGrade);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //update Grade
    public void UpdateGrade(int GradeID, string GradeName, int GradeLevel, int EmpID)
    {
        try
        {
            DbCommand cmd_UpdateGrade = db.GetStoredProcCommand("Proc_TA_InsertGrade", new object[] { 'U', GradeID, GradeName, GradeLevel, EmpID });
            cmd_UpdateGrade.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_UpdateGrade);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Delete Grade using checkbox
    // permanent delete - grade
    public void PermanentDeleteGrade(string GradeIDs, int auditEmpId)
    {
        try
        {
            DbCommand cmd_PermanentDeleteGrade = db.GetStoredProcCommand("Proc_TA_DeleteRestoreGrade", new object[] { "PermanentDelete", GradeIDs, auditEmpId });
            cmd_PermanentDeleteGrade.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_PermanentDeleteGrade);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public int CheckPermanentDeleteGrade(string GradeIDs)
    {
        int Count = 0;
        try
        {
            Count = Convert.ToInt32(db.ExecuteScalar("Proc_TA_CheckPermanentDelete", GradeIDs));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Count;
    }
    // temporary delete - grade
    public void TemporaryDeleteGrade(string GradeIDs, int auditEmpId)
    {
        try
        {
            DbCommand cmd_TemporaryDeleteGrade = db.GetStoredProcCommand("Proc_TA_DeleteRestoreGrade", new object[] { "TemporaryDelete", GradeIDs, auditEmpId });
            cmd_TemporaryDeleteGrade.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_TemporaryDeleteGrade);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    // restore - grade
    public void RestoreGrade(string GradeIDs, int auditEmpId)
    {
        try
        {
            DbCommand cmd_RestoreGrade = db.GetStoredProcCommand("Proc_TA_DeleteRestoreGrade", new object[] { "Restore", GradeIDs, auditEmpId });
            cmd_RestoreGrade.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_RestoreGrade);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void DeleteGrade(int GradeID)
    {
        try
        {
            DbCommand cmd_DeleteGrade = db.GetStoredProcCommand("Proc_TA_DeleteGrade", new object[] { 'I', GradeID, 0 });
            cmd_DeleteGrade.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_DeleteGrade);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //checking for mapping of lookup data in Employee & in Look up itself
    public int CountLookup(int lookup)
    {
        DataSet ds = new DataSet();
        int count = 0;
        //count = Convert.ToInt32(db.ExecuteScalar("Proc_TA_delLookup", lookup));
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_delLookup", lookup);
            if (ds != null)
            {
                if (ds.Tables.Count > 0)
                {
                    if (ds.Tables[0].Rows.Count > 0)
                    {
                        if (ds.Tables[0].Rows[0][0] != DBNull.Value)
                        {
                            count = Convert.ToInt16(ds.Tables[0].Rows[0][0]);
                        }
                    }
                }
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //checking for mapping of grade in title(designation)
    public int CountGrade(int grade)
    {
        int count = 0;
        try
        {
            count = Convert.ToInt32(db.ExecuteScalar("Proc_TA_CountGrade", grade));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //checking for already existing Grade Name while insert
    public int CheckGradeName_Insert(string Grade_Name)
    {
        DataSet ds_CheckGradeName = new DataSet();
        int count = 0;
        try
        {
            ds_CheckGradeName = db.ExecuteDataSet("Proc_TA_CheckGradeName_Insert", new object[] { Grade_Name });
            count = Convert.ToInt16(ds_CheckGradeName.Tables[0].Rows[0]["GradeNameCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //checking for already existing Grade Name while update
    public int CheckGradeName_Update(int GradeId)
    {
        DataSet ds_CheckGradeName = new DataSet();
        int count = 0;
        try
        {
            ds_CheckGradeName = db.ExecuteDataSet("Proc_TA_CheckGradeName_Update", new object[] { GradeId });
            count = Convert.ToInt16(ds_CheckGradeName.Tables[0].Rows[0]["GradeNameCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public int CheckGradeName_Updates(int GradeId, string GradeName)
    {
        DataSet ds_CheckGradeName = new DataSet();
        int count = 0;
        try
        {
            ds_CheckGradeName = db.ExecuteDataSet("Proc_TA_CheckGradeName_Updates", new object[] { GradeId, GradeName });
            count = Convert.ToInt16(ds_CheckGradeName.Tables[0].Rows[0]["GradeNameCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //checking for already existing Country name while insert and update
    public int CheckCountryInsertUpdate(string Mode, int ID, string Title)
    {
        DataSet ds_CheckCountryInsertUpdate = new DataSet();
        int count = 0;
        try
        {
            ds_CheckCountryInsertUpdate = db.ExecuteDataSet("Proc_TA_CheckCountryInsertUpdate", new object[] { Mode, ID, Title });
            count = Convert.ToInt16(ds_CheckCountryInsertUpdate.Tables[0].Rows[0]["CountryCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    //checking for already existing state or city name while insert and update
    public int CheckStateCityInsertUpdate(string Mode, int ID, string Title, int Parent, int TypeId)
    {
        DataSet ds_CheckStateCityInsertUpdate = new DataSet();
        int count = 0;
        try
        {
            ds_CheckStateCityInsertUpdate = db.ExecuteDataSet("Proc_TA_CheckStateCityInsertUpdate", new object[] { Mode, ID, Title, Parent, TypeId });
            count = Convert.ToInt16(ds_CheckStateCityInsertUpdate.Tables[0].Rows[0]["StateCityCount"]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public GenericEventdata()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = db.DbProviderFactory;
        db = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
