using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
public class HolidaySettingsEventData
{
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    int count1, count2;
    public void InsertHolidaySettings(int GlobalMaxdays, int YearlyMaxdays, int YearSettings_Id)
    {
        try
        {
            htable.Clear();
            htable.Add("@GlobalHoliday_Maxno", GlobalMaxdays);
            htable.Add("@YearlyHoliday_Maxno", YearlyMaxdays);
            htable.Add("@YearSettingId", YearSettings_Id);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_HolidaySettings");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public int GetNumberofGlobalHolidays()
    {
        DataSet ds_GlobalHolidays = new DataSet();
        try
        {
            ds_GlobalHolidays = objDataAccess.ExecuteDataSet("Proc_TA_CountGlobalHoliday");
            if (ds_GlobalHolidays.Tables[0].Rows[0]["Days"] != DBNull.Value)
            {
                count1 = Convert.ToInt16(ds_GlobalHolidays.Tables[0].Rows[0]["Days"]);
            }
            else
            {
                count1 = 0;
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count1;
    }
    public int GetNumberofYearlyHolidays()
    {
        DataSet ds_YearlyHolidays = new DataSet();
        try
        {
            ds_YearlyHolidays = objDataAccess.ExecuteDataSet("Proc_TA_CountYearlyHoliday");
            if (ds_YearlyHolidays.Tables[0].Rows[0]["Days"] != DBNull.Value)
            {
                count2 = Convert.ToInt16(ds_YearlyHolidays.Tables[0].Rows[0]["Days"]);
            }
            else
            {
                count2 = 0;
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count2;
    }
    public DataSet GetHolidaySettings()
    {
        DataSet ds_HolidaySettings = new DataSet();
        try
        {
            ds_HolidaySettings = objDataAccess.ExecuteDataSet("Proc_TA_GetHolidaySettings");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_HolidaySettings;
    }
    public int GetNumberOfRestrictedHolidaysCount()
    {
        DataSet ds_HolidayYearlyCount = new DataSet();
        try
        {
            ds_HolidayYearlyCount = objDataAccess.ExecuteDataSet("Proc_TA_GetRestrictedHolidaysCountLeaveApplication");
            if (ds_HolidayYearlyCount.Tables[0].Rows.Count > 0)
            {
                return Convert.ToInt32(ds_HolidayYearlyCount.Tables[0].Rows[0][0]);
            }
            else
            {
                return 0;
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
}
