using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.ComponentModel;
using System.Collections.Generic;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;

/// <summary>
/// Summary description for LeaveSettingsEventData
/// </summary>
public class LeaveSettingsEventData_Angler
{
    Database dbCon = DatabaseFactory.CreateDatabase("DBConnection");

    public LeaveSettingsEventData_Angler()
	{
		//
		// TODO: Add constructor logic here
		//
        string strDecryptedString = string.Empty;

        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
	}

    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = dbCon.DbProviderFactory;
        dbCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }

    public void InsertUpdateLeaveSettings(int CompanyId, int LeaveApproval, int FirstLevelIntimation, int SecondLevelIntimation, string ApprovalCC,string DailyReportTO,string DailyReportCC)
    {
        DbCommand cmd_Insert = dbCon.GetStoredProcCommand("Proc_TA_InsertUpdateLeaveSettings", new object[] { CompanyId, LeaveApproval, FirstLevelIntimation, SecondLevelIntimation, ApprovalCC,DailyReportTO,DailyReportCC });

        try
        {
            dbCon.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    public DataSet GetLeaveSettingsByComId(int CompanyId)
    {
        DataSet dsLeaveSettings = new DataSet();

        try
        {
            dsLeaveSettings = dbCon.ExecuteDataSet("Proc_TA_GetLeaveSettingsByComId", new object[] { CompanyId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsLeaveSettings;
    }
    public DataSet GetDepartmentMailIds(int intLevelId)
    {
        DataSet dsDepartmentMailIds = new DataSet();

        try
        {
            dsDepartmentMailIds = dbCon.ExecuteDataSet("Proc_TA_GetDepartmentMailIds", new object[] { intLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsDepartmentMailIds;
    }

    public void UpdateDepartmentToCCMailIds(int LevelId, string ToMailIds,string CCMailIds)
    {
        DbCommand cmd_Update = dbCon.GetStoredProcCommand("Proc_TA_UpdateDepartmentToCCMailIds", new object[] {  LevelId,  ToMailIds, CCMailIds });

        try
        {
            dbCon.ExecuteNonQuery(cmd_Update);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
}
