using System;
using System.Collections;
using System.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using DataAccessLayer;
public class YearSettingsEventData
{
    Hashtable htable = new Hashtable();
    DataAccess objDataAccess = new DataAccess();
    public DataSet GetYearSettingsByID(int YearsettingId)
    {
        DataSet ds_YearSettings = new DataSet();
       
        try
        {
            htable.Clear();
            htable.Add("@YearSettingId", YearsettingId);
            ds_YearSettings = objDataAccess.GetStoredProcCommand("Proc_TA_SelectYearSettingbyId", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_YearSettings;
    }
    public DataSet GetActiveYearSettings()
    {
        DataSet ds_YearSettings = new DataSet();
        try
        {
            ds_YearSettings = objDataAccess.ExecuteDataSet("Proc_TA_SelectYearSetting");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_YearSettings;
    }
    public DataSet GetYearsettings()
    {
        DataSet ds_Yearseting = new DataSet();
        try
        {
            ds_Yearseting = objDataAccess.ExecuteDataSet("Proc_TA_SelectYearSettings");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Yearseting;
    }
    public DataSet GetAllYearSettings()
    {
        DataSet ds_YearSettings = new DataSet();
        try
        {
            ds_YearSettings = objDataAccess.ExecuteDataSet("Proc_TA_SelectAllYearSetting");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_YearSettings;
    }
    public int InsertYearsettingDetails(string StarMonth, int StartYear, string EndMonth, int EndYear, string FromDate, string ToDate, string Employee_Id)
    {
        DataSet ds_YearSettingsID = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@StartMonth", StarMonth);
            htable.Add("@StartYear", StartYear);
            htable.Add("@EndMonth", EndMonth);
            htable.Add("@EndYear", EndYear);
            htable.Add("@FromDate", FromDate);
            htable.Add("@ToDate", ToDate);
            htable.Add("@Employee_Id", Employee_Id);
            ds_YearSettingsID=objDataAccess.GetStoredProcCommand("Proc_TA_InsertYearSetting", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Convert.ToInt32(ds_YearSettingsID.Tables[0].Rows[0]["YearSettingsID"]);

    }
    public void UpdateYearSettingId(int NewID)
    {
        
        try
        {
            htable.Clear();
            htable.Add("@NewId", NewID);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_UpdateYearsetting");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Get All year form Year settings
    public int CheckYearSettingExists(string FromDate, string ToDate, char YearType, int YearSettings_Id)
    {
        DataSet ds_YearSettingsExists = new DataSet();
      
        try
        {
            htable.Clear();
            htable.Add("@FromDate", FromDate);
            htable.Add("@ToDate", ToDate);
            htable.Add("@YearType", YearType);
            htable.Add("@YearSettings_Id", YearSettings_Id);
            ds_YearSettingsExists = objDataAccess.GetStoredProcCommand("Proc_TA_CheckYearSettingExists", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Convert.ToInt32(ds_YearSettingsExists.Tables[0].Rows[0]["YearCount"]);
    }
    public int CheckYearSettingExistsWhileYearClosing(string fromDate, string toDate, string yearSettingId)
    {
        int existingCount = 0;
       
        try
        {
            htable.Clear();
            htable.Add("@fromDate", fromDate);
            htable.Add("@toDate", toDate);
            htable.Add("@yearSettingId", yearSettingId);
            existingCount = objDataAccess.ExecuteScaler("Proc_TA_CheckYearSettingExistsWhileYearClosing", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return existingCount;
    }
    public int CheckYearClosureAlreadyProcessedOrNot(int yearSettingId, int organizationId)
    {
        int existingCount = 0;       
        try
        {
            htable.Clear();
            htable.Add("@yearSettingId", yearSettingId);
            htable.Add("@organizationId", organizationId);
            existingCount = objDataAccess.ExecuteScaler("Proc_TA_CheckYearClosureAlreadyProcessedOrNot", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return existingCount;
    }
    public void DeleteYearSettingYearSetting(int YearSettingId)
    {       
        try
        {
            htable.Clear();
            htable.Add("@YearSettingId", YearSettingId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteYearsetting");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    public void DeleteShiftHolidayYearSetting(int YearSettingId)
    {
        try
        {
            htable.Clear();
            htable.Add("@YearSettingId", YearSettingId);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_DeleteShiftHoliday_YrSettings");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    public void AutoInsertHoliday(int OldYearsettingId, int InsertedYearSettingsID)
    {
        try
        {
            htable.Clear();
            htable.Add("@OldYearSettingsID", OldYearsettingId);
            htable.Add("@NewYearSettingsID", InsertedYearSettingsID);
            objDataAccess.GetStoredProcCommand(htable, "Proc_Ta_HolidayInsert_YearCreation");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    public void AutoInsertShiftAllocation(string ToDate,int InsertedYearSettingsID,string UserGroupName, string ParentId, string LoggedInEmployeeId,string WeekOff)
    {
        try
        {
            htable.Clear();
            htable.Add("@ToDat", ToDate);
            htable.Add("@InsertedYearSettingsID", InsertedYearSettingsID);
            htable.Add("@UserGroupName", UserGroupName);
            htable.Add("@ParentId", ParentId);
            htable.Add("@LoggedInEmployeeId", LoggedInEmployeeId);
            htable.Add("@WeekOff", WeekOff);
            objDataAccess.GetStoredProcCommand(htable, "Proc_Ta_Emp_ShiftAlloc_YearCreation");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
}
