using System;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Collections;
using System.Data.SqlClient;
using System.Globalization;
using System.Web;
/// <summary>
/// Summary description for GetReports
/// </summary>
public class GetReports
{
    Database db_Con = DatabaseFactory.CreateDatabase("DBConnection");
    string FromDate = string.Empty;
    string ToDate = string.Empty;
    int AllSwipesReportType = 0;
    public GetReports()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = db_Con.DbProviderFactory;
        db_Con = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    //Organization settings report
    public DataSet SelectLevelDetails()
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand cmd_InsertRights = db_Con.GetStoredProcCommand("Proc_TA_RptOrgSettings", new object[] { });
            cmd_InsertRights.CommandTimeout = 0;
            ds = db_Con.ExecuteDataSet(cmd_InsertRights);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Organization settings report
    public DataSet SelectLevelDetailsBasedOnRights(string groupName)
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand cmd_InsertRights = db_Con.GetStoredProcCommand("Proc_Ta_GetLevelDetailsForHoiday", new object[] { groupName });
            cmd_InsertRights.CommandTimeout = 0;
            ds = db_Con.ExecuteDataSet(cmd_InsertRights);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //Audit Trail Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectAuditTrailReport(string fromDate, string toDate, string tableDescription, string opr)
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptAuditTrail");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDate", DbType.DateTime, fromDate);
            db_Con.AddInParameter(dbcmd, "@toDate", DbType.DateTime, toDate);
            db_Con.AddInParameter(dbcmd, "@TableDescription", DbType.String, tableDescription);
            db_Con.AddInParameter(dbcmd, "@opr", DbType.String, opr);
            db_Con.LoadDataSet(dbcmd, ds, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //new early out report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectEarlyOutReportNew(string dtFromDate, string dtToDate, string empId, int shft, string empName, string levId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int ExportType, string MinExceptkHours, int EmpAutoID)
    {
        DataSet ds_EarlyOutNew = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("proc_TA_EarlyExit");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shft);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@ExportType", DbType.Int32, ExportType);
            db_Con.AddInParameter(dbcmd, "@MINExceptionHOURS", DbType.String, MinExceptkHours);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_EarlyOutNew, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_EarlyOutNew;
    }
    // Punctuality report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectPunctuality(string dtFromDate, string dtToDate, string empId, int shft, string empName, string levId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, Int64 EmpAutoID, int ExportType)
    {
        DataSet ds_Punctuality = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("proc_ta_rptPunctuality");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shft);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@ExportType", DbType.Int32, ExportType);
            db_Con.LoadDataSet(dbcmd, ds_Punctuality, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Punctuality;
    }
    // OverTime report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectOverTime(string dtFromDate, string dtToDate, string empId, int shft, string empName, string levId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string Status, string strSwipeCard, int ParentId, int DesignationId, string Gender, String SanctionType, Int64 EmpAutoID)
    {
        DataSet ds_overTime = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("proc_OtCalculation");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shft);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@Status", DbType.String, Status);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@SanctionType", DbType.String, SanctionType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_overTime, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_overTime;
    }
    // OverTime report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectOverTimeCompOff(string dtFromDate, string dtToDate, string empId, int shft, string empName, string levId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string Status, string strSwipeCard, int ParentId, int DesignationId, string Gender, int EmpAutoID)
    {
        DataSet ds_overTime = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptEmployeeCompOffStatus");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmpId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@ShiftId", DbType.Int32, shft);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@Status", DbType.String, Status);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_overTime, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_overTime;
    }
    // OverTime with Amount Details report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectOverTimewithAmountDetails(string dtFromDate, string dtToDate, string empId, int shft, string empName, string levId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string Status, string strSwipeCard, int ParentId, int DesignationId, string Gender, decimal Amount, int EmpAutoID)
    {
        DataSet ds_overTime = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptOverTimewithAmountDetails");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shft);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@Status", DbType.String, Status);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@Amount", DbType.String, Amount);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_overTime, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_overTime;
    }

    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet GetFirstInPunchDifference(string strEmpId, string strLevelID, string strFromDate, string strToDate, string strEmpName, int iEmpCategory, int iEmpType, string strUserGroupName, string strGradeLevel, int iEmpAutoID, string strMaxWorkPlaceIn, string strPunchType, int ParentId)
    {
        DataSet dsPunchDiff = new DataSet();

        try
        {
            DbCommand dbcmd;

            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptFirstInPunchDifference");
            dbcmd.CommandTimeout = 0;
            // Assigns the parameters to the command
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, strFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, strToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, strEmpName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, strLevelID);
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, strEmpId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, iEmpCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, iEmpType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, strGradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, iEmpAutoID);
            db_Con.AddInParameter(dbcmd, "@MaxWorkPlaceIn", DbType.String, strMaxWorkPlaceIn);
            db_Con.AddInParameter(dbcmd, "@PunchType", DbType.String, strPunchType);
            //db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int32, ParentId);

            db_Con.LoadDataSet(dbcmd, dsPunchDiff, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsPunchDiff;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectWeeklyWorkHours_Angler(string strEmpId, string strLevelID, string strFromDate, string strToDate, string strEmpName, int iEmpCategory, int iEmpType, string strUserGroupName, string strGradeLevel, string strSwipeCard, int iEmpAutoID, int ParentId, int shift)
    {
        DataSet dsWeeklyWorkHrs = new DataSet();

        try
        {
            if (strEmpName == null)
                strEmpName = "";

            DbCommand dbcmd;

            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptWeeklyWorkHours_Angler");
            dbcmd.CommandTimeout = 0;
            // Assigns the parameters to the command
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, strFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, strToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, strEmpName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, strLevelID);
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, strEmpId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, iEmpCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, iEmpType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, strGradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, iEmpAutoID);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);

            db_Con.LoadDataSet(dbcmd, dsWeeklyWorkHrs, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsWeeklyWorkHrs;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectWeeklyWorkHours(string strEmpId, string strLevelID, string strFromDate, string strToDate, string strEmpName, int iEmpCategory, int iEmpType, string strUserGroupName, string strGradeLevel, string strSwipeCard, int ParentId, int shift, int DesignationID, string Gender, int strEmpAutoId)
    {
        DataSet dsWeeklyWorkHrs = new DataSet();
        try
        {
            if (strEmpName == null)
                strEmpName = "";
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptWeeklyWorkHours");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.DateTime, strFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.DateTime, strToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, strEmpName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, strLevelID);
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, strEmpId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, iEmpCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, iEmpType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, strGradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationID);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.LoadDataSet(dbcmd, dsWeeklyWorkHrs, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsWeeklyWorkHrs;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectOverTimewithAmountSummary()
    {
        DataSet ds_overTimewithAmountSummary = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptOverTimewithAmountSummary");
            dbcmd.CommandTimeout = 0;
            db_Con.LoadDataSet(dbcmd, ds_overTimewithAmountSummary, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_overTimewithAmountSummary;
    }
    //Discrepancy Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectDiscrepancy(string dtFromDate, string dtToDate, string empId, int shift, string empName, string levId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, Int64 strEmpAutoId, int ExportType)
    {
        DataSet ds_discrepancy = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("proc_ta_RptDiscrepancy");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.AddInParameter(dbcmd, "@ExportType", DbType.Int32, ExportType);
            db_Con.LoadDataSet(dbcmd, ds_discrepancy, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_discrepancy;
    }
    //Document Expiry Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectDocumentExpiry(string dtFromDate, string dtToDate, string EmployeeId, int shift, string empName, string levId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int EmpAutoID)
    {
        DataSet ds_doc = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_Ta_RptDocumentExpiry");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_doc, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_doc;
    }
    // Report Leave Application
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLeave(string dtFromDate, string dtToDate, string empId, int shift, string empName, string levId, string LeaveType, string LeaveStatus, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int EmpAutoID, int selectedYear)
    {
        DataSet ds_Leave = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptLeave");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@LeaveType", DbType.String, LeaveType);
            db_Con.AddInParameter(dbcmd, "@LeaveStatus", DbType.String, LeaveStatus);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@YearSettingsId", DbType.Int32, selectedYear);
            db_Con.LoadDataSet(dbcmd, ds_Leave, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Leave;
    }

    // Report Leave Application
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLeave_Angler(string dtFromDate, string dtToDate, string empId, int shift, string empName, string levId, string LeaveType, string LeaveStatus, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, Int64 strEmpAutoId, int chkunplan, int ParentId, int DesignationId, string Gender)
    {
        DataSet ds_Leave = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptLeave_Angler");
            dbcmd.CommandTimeout = 0;

            // Assigns the parameters to the command
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@LeaveType", DbType.String, LeaveType);
            db_Con.AddInParameter(dbcmd, "@LeaveStatus", DbType.String, LeaveStatus);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);

            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.AddInParameter(dbcmd, "@Unplanned", DbType.Int16, chkunplan);
            db_Con.LoadDataSet(dbcmd, ds_Leave, "Table");
            //ds_Leave = db_Con.ExecuteDataSet("Proc_TA_RptLeave", new object[] { dtFromDate, dtToDate, empId, shift, empName, levId, LeaveType, LeaveStatus, employeeCategory, employeeType, userGroupName, gradeLevel });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds_Leave;
    }


    // Report Leave Summary Report 
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLeaveSummary(string dtFromDate, string dtToDate, string empId, int shift, string empName, string LeaveType, string LeaveStatus, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int EmpAutoID, int selectedYear)
    {
        DataSet ds_Leave = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_Rpt_LeaveSummaryDetails");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LeaveType", DbType.String, LeaveType);
            db_Con.AddInParameter(dbcmd, "@LeaveStatus", DbType.String, LeaveStatus);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@YearSettingsId", DbType.Int32, selectedYear);
            db_Con.LoadDataSet(dbcmd, ds_Leave, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Leave;
    }

    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLeaveSummary_Angler(string dtFromDate, string dtToDate, string empId, int shift, string empName, string LeaveType, string LeaveStatus, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender)
    {
        DataSet ds_Leave = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_Rpt_LeaveSummaryDetails_Angler");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LeaveType", DbType.String, LeaveType);
            db_Con.AddInParameter(dbcmd, "@LeaveStatus", DbType.String, LeaveStatus);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.LoadDataSet(dbcmd, ds_Leave, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Leave;
    }

    // Late Exit Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLateExit(string dtFromDate, string dtToDate, string EmployeeId, int shift, string empName, string levId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, string MinExceptkHours, int strEmpAutoId)
    {
        DataSet ds_lateExit = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("proc_TA_RptLateExit");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@MINExceptionHOURS", DbType.String, MinExceptkHours);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.LoadDataSet(dbcmd, ds_lateExit, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_lateExit;
    }
    /// <summary>
    /// Shift Not Allocation Report
    /// </summary>
    /// <param name="dtFromDate"></param>
    /// <param name="dtToDate"></param>
    /// <param name="empName"></param>
    /// <param name="levelId"></param>
    /// <param name="EmployeeId"></param>
    /// <param name="employeeCategory"></param>
    /// <param name="employeeType"></param>
    /// <param name="userGroupName"></param>
    /// <param name="gradeLevel"></param>
    /// <param name="strSwipeCard"></param>
    /// <param name="ParentId"></param>
    /// <returns></returns>
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectNotAllocationReport(string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, Int64 strEmpAutoId)
    {
        DataSet dsShiftNotAllocation = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptShiftNotAllocated");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.LoadDataSet(dbcmd, dsShiftNotAllocation, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsShiftNotAllocation;
    }
    //Shift Allocation  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectShiftAllocationReport(string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int Religion, Int64 EmpAutoID)
    {
        DataSet ds_ShiftAllocation = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptShiftAllocation");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@Religion", DbType.Int32, Religion);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_ShiftAllocation, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftAllocation;
    }
    //Temporary Shift Allocation  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectTempShiftAllocationReport(string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int Religion, Int64 EmpAutoID)
    {
        DataSet ds_TempShiftAllocation = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptTempShiftAllocation");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@Religion", DbType.Int32, Religion);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_TempShiftAllocation, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TempShiftAllocation;
    }
    //Shift Permanent Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectPermanentShiftReport(string dtFromDate, string levelId, string EmployeeId, string employeeName, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int ShiftId, Int64 EmpAutoID)
    {
        DataSet ds_PermanentShift = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptPermanentShift");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDate", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, employeeName);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, ShiftId);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_PermanentShift, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PermanentShift;
    }
    //Monthly Attendance Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMonthlyAttendanceReport(string MinWorkHours, string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int shift, int DataLoading, Int64 EmpAutoID, int Export)
    {
        DataSet ds_MonthlyAttendance = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMonthlyAttendance");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@MinWorkHours", DbType.String, MinWorkHours);
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@Shift", DbType.Int16, shift);
            db_Con.AddInParameter(dbcmd, "@DataLoading", DbType.Int16, DataLoading);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@Export", DbType.Int16, Export);
            db_Con.LoadDataSet(dbcmd, ds_MonthlyAttendance, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_MonthlyAttendance;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMonthlyAttendanceDetailReport(string MinWorkHours, string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int shift, int DataLoading, int EmpAutoID)
    {
        DataSet ds_MonthlyAttendance = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMonthlyAttendance_Detail");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@MinWorkHours", DbType.String, MinWorkHours);
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@Shift", DbType.Int16, shift);
            db_Con.AddInParameter(dbcmd, "@DataLoading", DbType.Int16, DataLoading);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_MonthlyAttendance, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_MonthlyAttendance;
    }
    //Monthly Attendance Report in Dashboard
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMonthlyAttendanceReportDashboard(string MinWorkHours, string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int shift, int DataLoading, Int64 EmpAutoID)
    {
        DataSet ds_MonthlyAttendance = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMonthlyAttendance_Dashboard");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@MinWorkHours", DbType.String, MinWorkHours);
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@Shift", DbType.Int16, shift);
            db_Con.AddInParameter(dbcmd, "@DataLoading", DbType.Int16, DataLoading);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_MonthlyAttendance, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_MonthlyAttendance;
    }
    //Total Days Worked Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectTotalDaysWorkedReport(string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, int NoOfDays, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, string TotalDays, int EmpAutoID)
    {
        DataSet dsTotalDaysWorked = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptTotalDaysWorked");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@NoOfDays", DbType.Int32, NoOfDays);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@TotalDays", DbType.String, TotalDays);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsTotalDaysWorked, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsTotalDaysWorked;
    }
    //Report Employee Schedule
    public DataSet SelectEmpSchedule(string dtFromDate, string dtToDate, string empId, int shift, string empName, int levId)
    {
        DataSet dsEmpSchedule = new DataSet();
        try
        {
            dsEmpSchedule = db_Con.ExecuteDataSet("Proc_TA_rptEmployeeSchedule ", new object[] { dtFromDate, dtToDate, "", shift, empName, levId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmpSchedule;
    }
    //Employee Details Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectEmployee(string dtFromDate, string dtToDate, string EmployeeId, int shift, string empName, string levId, int employeeCategory, int employeeType, string EmployeeStatus, string UserGroupName, string GradeLevel, string strSwipeCardOpt, string strSwipeCard, int ParentId, int DesignationId, string Gender, int EmpAutoID)
    {
        DataSet dsEmp = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_Ta_RptEmployee");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@EmployeeStatus", DbType.String, EmployeeStatus);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@SwipeOpt", DbType.String, strSwipeCardOpt);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsEmp, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmp;
    }
    //select employee shift not allocated
    public DataSet SelectEmployeeShiftNotAlloc(string dtFromDate, string dtToDate, string EmployeeId, int shift, string empName, string levId, int employeeCategory, int employeeType, string EmployeeStatus, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, Int64 EmpAutoID)
    {
        DataSet dsEmp = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_Ta_RptEmployeeShiftNotAlloc");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@EmployeeStatus", DbType.String, EmployeeStatus);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsEmp, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmp;
    }
    public DataSet GetNearestShiftDetails(string dtFromDate, string EmployeeId, int shift, string empName, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, int ParentId, int DesignationId, string Gender, Int64 EmpAutoID)
    {
        DataSet dsnearestShift = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptGettingNearShiftDetailsUsingInpunch");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsnearestShift, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsnearestShift;
    }
    public DataSet GetNearestShiftDetails_ShiftAllocation(string dtFromDate, string EmployeeId, int shift, string empName, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, int ParentId, int DesignationId, string Gender, Int64 EmpAutoID, string dtTodate)
    {
        DataSet dsnearestShift = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_GettingNearShiftDetailsUsingInpunch");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@Todate", DbType.String, dtTodate);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsnearestShift, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsnearestShift;
    }
    //Report Absent
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectAbsent(string dtFromDate, string dtToDate, string empId, int shift, string empName, string levId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int Designation, string Gender, int absentType, Int64 EmpAutoID, int ExportType, int Noofdays, int checkContinousLeave)
    {
        DataSet ds_Absent = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_Ta_rptAbsent");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, Designation);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@session", DbType.String, absentType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@ExportType", DbType.Int32, ExportType);
            //
            db_Con.AddInParameter(dbcmd, "@NoofLeaves", DbType.Int32, Noofdays);
            db_Con.AddInParameter(dbcmd, "@ContinuousAbsent", DbType.Int16, checkContinousLeave);
            //
            db_Con.LoadDataSet(dbcmd, ds_Absent, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Absent;
    }


    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectEmployeeDetail(string EmployeeID, string dtFrom, string dtTo, string EmployeeName, int employeeCategory, int employeeType, int intEmailAvail, int OTCompOff, int UserGroupID, int LeavePolicy, int Reporting_To, int ApprovalAuthority, string EmployeeStatus, string userGroupName, string gradeLevel, int ParentId, int Designation, string Gender, Int64 EmpAutoID)
    {
        DataSet ds_EmployeeDetails = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptEmployeeDetailsReport");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeID);
            db_Con.AddInParameter(dbcmd, "@dtFrom", DbType.String, dtFrom);
            db_Con.AddInParameter(dbcmd, "@dtTo", DbType.String, dtTo);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, EmployeeName);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@EmailAvail", DbType.Int32, intEmailAvail);
            db_Con.AddInParameter(dbcmd, "@OTCompStatus", DbType.Int32, OTCompOff);
            db_Con.AddInParameter(dbcmd, "@FilterUserGroup", DbType.Int32, UserGroupID);
            db_Con.AddInParameter(dbcmd, "@LeavePolicy", DbType.Int32, LeavePolicy);
            db_Con.AddInParameter(dbcmd, "@Reportingto", DbType.Int32, Reporting_To);
            db_Con.AddInParameter(dbcmd, "@ApprovalAuthority", DbType.Int32, ApprovalAuthority);
            db_Con.AddInParameter(dbcmd, "@EmpStatus", DbType.String, EmployeeStatus);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, Designation);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_EmployeeDetails, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_EmployeeDetails;
    }

    public DataSet SelectDetailAttend_Old(string dtFromDate, string dtToDate, string empId, string empName, string levId, string UserGroupName, string GradeLevel, string strSwipeCard, Int64 EmpAutoID, int DesignationId, string Gender, int ParentId, int Export)
    {
        DataSet dsDetAtt = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptDetailAttendanceDynamic");
            dbcmd.CommandTimeout = 0;
            //Sets the Cultural Information
            //ds_MovEntry.Locale = CultureInfo.InvariantCulture;
            // Assigns the parameters to the command
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@DesignationId", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@ParentID", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@Export", DbType.Int16, Export);
            db_Con.LoadDataSet(dbcmd, dsDetAtt, "Table");
            //dsDetAtt = db_Con.ExecuteDataSet("Proc_TA_RptDetailAttendanceDynamic ", new object[] { dtFromDate, dtToDate, empId, empName, levId, UserGroupName, GradeLevel });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsDetAtt;
    }
    //Employee Detailed Attendance
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectDetailAttend(string dtFromDate, string dtToDate, string empId, string empName, string levId, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int EmployeeCategory, int EmployeeType, int EmpAutoID)
    {
        DataSet dsDetAtt = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptDetailAttendanceDynamicNew");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationId", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int16, EmployeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int16, EmployeeType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsDetAtt, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsDetAtt;
    }
    //Employee Detailed Attendance
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectDetailAttend_Straight(string dtFromDate, string dtToDate, string empId, string empName, string levId, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int EmployeeCategory, int EmployeeType, int EmpAutoID)
    {
        DataSet dsDetAtt = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptDetailAttendanceDynamicNew_StraightShift");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationId", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int16, EmployeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int16, EmployeeType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsDetAtt, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsDetAtt;
    }

    //Employee Detailed Attendance
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet Select_DetailAttendanceforExportTally(string dtFromDate, string dtToDate, string empId, string empName, string levId, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int EmployeeCategory, int EmployeeType, int EmpAutoID)
    {
        DataSet dsDetAtt = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_DetailAttendanceforExportTally");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationId", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int16, EmployeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int16, EmployeeType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsDetAtt, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsDetAtt;
    }

    //Movements Entry  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMovementsEntryReport(string EmployeeId, string LevelID, string dtFromDate, string dtToDate,
        string empName, int shift, int employeeCategory, int employeeType, string userGroupName,
        string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, string InTime, string OutTime,
        int AllSwipesReportType, string punchTypeValue, Int64 strEmpAutoId, int ExportType)
    {
        DataSet ds_MovEntry = new DataSet();
        try
        {
            DbCommand dbcmd;
            if (AllSwipesReportType == 0)
            {
                dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMovementsEntry");
            }
            else if (AllSwipesReportType == 3)
            {
                dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMovementsEntry_NotMatched");
            }
            else
            {
                dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMovementsEntry_FirstAndLast");
            }
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, LevelID);
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@InTime", DbType.String, InTime);
            db_Con.AddInParameter(dbcmd, "@OutTime", DbType.String, OutTime);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.AddInParameter(dbcmd, "@ExportType", DbType.Int32, ExportType);
            if (AllSwipesReportType == 0)
            {
                db_Con.AddInParameter(dbcmd, "@punchTypeValue", DbType.String, punchTypeValue);
            }
            db_Con.LoadDataSet(dbcmd, ds_MovEntry, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_MovEntry;
    }
    //Matched Movements Entry  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMatchedMovementsEntryReport(string EmployeeId, string LevelID, string dtFromDate, string dtToDate,
        string empName, int shift, int employeeCategory, int employeeType, string userGroupName,
        string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, string InTime, string OutTime, int Type, Int64 strEmpAutoId, int ExportType)
    {
        DataSet ds_MovEntry = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMovementsEntryWithMatchedPunches");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, LevelID);
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@InTime", DbType.String, InTime);
            db_Con.AddInParameter(dbcmd, "@OutTime", DbType.String, OutTime);
            db_Con.AddInParameter(dbcmd, "@Type", DbType.String, Type);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.AddInParameter(dbcmd, "@ExportType", DbType.Int32, ExportType);
            db_Con.LoadDataSet(dbcmd, ds_MovEntry, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_MovEntry;
    }
    /// <summary>
    /// To fetch the Employee In Out report according to the search criteria
    /// </summary>
    /// <param name="EmployeeId"></param>
    /// <param name="LevelID"></param>
    /// <param name="dtFromDate"></param>
    /// <param name="dtToDate"></param>
    /// <param name="empName"></param>
    /// <param name="shift"></param>
    /// <param name="employeeCategory"></param>
    /// <param name="employeeType"></param>
    /// <param name="userGroupName"></param>
    /// <param name="gradeLevel"></param>
    /// <param name="strSwipeCard"></param>
    /// <param name="ParentId"></param>
    /// <param name="Gender"></param>
    /// <returns></returns>
    public DataSet EmployeeInOutDetails(string EmployeeID, string FromDate, string ToDate, string EmployeeName, int shift, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string EmpSwipeCard, int ParentId, int DesignationId, string Gender, int EmpAutoID)
    {
        DataSet dsEmployeeInOut = new DataSet();
        try
        {
            DbCommand cmd = db_Con.GetStoredProcCommand("Proc_TA_RptEmployeeInOut", new object[] { EmployeeID, FromDate, ToDate, EmployeeName, shift, employeeCategory, employeeType, UserGroupName, GradeLevel, EmpSwipeCard, ParentId, DesignationId, Gender, EmpAutoID });
            cmd.CommandTimeout = 0;
            dsEmployeeInOut = db_Con.ExecuteDataSet(cmd);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return dsEmployeeInOut;
    }
    //Late Instance  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLateInstanceReport(string Emp_Id, string levelID, string dtFromDate, string dtToDate, string empName, int shift, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, Int64 strEmpAutoId, int ExportType, string minExceptHrs)
    {
        DataSet ds_LateOut = new DataSet();
        try
        {
            if (empName == null)
            {
                empName = "";
            }
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptLateIn");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, Emp_Id);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelID);
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.AddInParameter(dbcmd, "@ExportType", DbType.Int32, ExportType);
            db_Con.AddInParameter(dbcmd, "@MINExceptionHOURS", DbType.String, minExceptHrs);
            db_Con.LoadDataSet(dbcmd, ds_LateOut, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LateOut;
    }
    // Exception Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectExceptionReport(string Emp_Id, string levelID, string dtFromDate, string dtToDate, string empName, int shift, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, string minExceptHrs, int EmpAutoID)
    {
        DataSet ds_LateOut = new DataSet();
        try
        {
            if (empName == null)
            {
                empName = "";
            }
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptAllException");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, Emp_Id);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelID);
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@MINExceptionHOURS", DbType.String, minExceptHrs);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_LateOut, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LateOut;
    }
    public DataSet SelectLessHoursWorkedReport(string Emp_Id, string dtFromDate, string dtToDate, string empName, int shift, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, string SummaryOrDetail, Int64 strEmpAutoId)
    {
        DataSet ds_LateOut = new DataSet();
        try
        {
            if (empName == null)
            {
                empName = "";
            }
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptLessHoursWorked");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, Emp_Id);
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@TypeOfReport", DbType.String, SummaryOrDetail);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.LoadDataSet(dbcmd, ds_LateOut, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LateOut;
    }
    //Late Instance  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet Select_Graph_Late_PunctualityReport(string Emp_Id, string levelID, string dtFromDate, string dtToDate, string empName, int shift, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int strEmpAutoId)
    {
        DataSet ds_LateOut = new DataSet();
        if (empName == null)
        {
            empName = "";
        }
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptGAttendance");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, Emp_Id);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelID);
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.LoadDataSet(dbcmd, ds_LateOut, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LateOut;
    }
    //Year Closure  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectYearClosureReport(string levelID, string empName, string Year_SettingID, string EmployeeId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, Int64 strEmpAutoId)
    {
        DataSet ds_YearClosure = new DataSet();
        if (empName == null)
        {
            empName = "";
        }
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptYearClosure");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelID);
            db_Con.AddInParameter(dbcmd, "@Year_SettingID", DbType.String, Year_SettingID);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.LoadDataSet(dbcmd, ds_YearClosure, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_YearClosure;
    }
    //Payroll  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectPayrollReport(string levelID, string empName, string MonthClosureId, string EmployeeId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int strEmpAutoId)
    {
        DataSet ds_Payroll = new DataSet();
        if (empName == null)
        {
            empName = "";
        }
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMonthClosure");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelID);
            db_Con.AddInParameter(dbcmd, "@MonthClosureId", DbType.String, MonthClosureId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, strEmpAutoId);
            db_Con.LoadDataSet(dbcmd, ds_Payroll, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Payroll;
    }
    //Payroll Duration
    public DataSet SelectPayrollDurtaion()
    {
        DataSet ds_PayrollDuration = new DataSet();
        try
        {
            ds_PayrollDuration = db_Con.ExecuteDataSet("Proc_TA_SelectPayrollMonthClosureDetails", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PayrollDuration;
    }
    //Reason entry for LateIn report
    public void ReasonEntry_LateIn(int Process_Rec_ID, string Reason)
    {
        try
        {
            DbCommand cmd_LateIn = db_Con.GetStoredProcCommand("Proc_TA_EnterReason_LateIn", new object[] { Reason, Process_Rec_ID });
            cmd_LateIn.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_LateIn);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //Reason entry for Early Exit report
    public void ReasonEntry_EarlyExit(string Reason, int Process_Rec_ID)
    {
        try
        {
            DbCommand cmd_EarlyExit = db_Con.GetStoredProcCommand("Proc_TA_EnterReason_EarlyOut", new object[] { Reason, Process_Rec_ID });
            cmd_EarlyExit.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_EarlyExit);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //report filter
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet setFilter(string levId)
    {
        DataSet dsFilt = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RPT_FilterLevel");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@lid", DbType.String, levId);
            db_Con.LoadDataSet(dbcmd, dsFilt, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsFilt;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet setFilterUpdated(string levId, string TotalLevels)
    {
        DataSet dsFilt = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RPT_FilterLevelUpdated");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@lid", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@TotLevels", DbType.String, TotalLevels);
            db_Con.LoadDataSet(dbcmd, dsFilt, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsFilt;
    }
    //Get the Terminal Name
    public DataSet SelectTerminalName()
    {
        DataSet ds_Terminal = new DataSet();
        try
        {
            ds_Terminal = db_Con.ExecuteDataSet("Proc_TA_SelectTerminalName");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Terminal;
    }
    //Get the Leave type
    public DataSet SelectLeaveType()
    {
        DataSet ds_Leave = new DataSet();
        try
        {
            ds_Leave = db_Con.ExecuteDataSet("Proc_TA_SelectLeaveType");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Leave;
    }
    //Get Shift ShortName from ta_tbl_shift
    public DataTable GetShiftShortName()
    {
        DataSet ds_ShiftShortName = new DataSet();
        try
        {
            ds_ShiftShortName = db_Con.ExecuteDataSet("Proc_TA_GetShiftShortName", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftShortName.Tables[0];
    }
    public DataTable GetShiftShortNameWithOutTime()
    {
        DataSet ds_ShiftShortName = new DataSet();
        try
        {
            ds_ShiftShortName = db_Con.ExecuteDataSet("Proc_TA_GetShiftShortNameWithOutTime", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftShortName.Tables[0];
    }
    //Report header
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataTable getHeader(int id)
    {
        DataSet dsHead = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_Rpt_header");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@LevelId", DbType.Int32, id);
            db_Con.LoadDataSet(dbcmd, dsHead, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsHead.Tables[0];
    }
    //Get the top organization level Id
    public DataSet getMinLevel()
    {
        DataSet ds_ParentLevels = new DataSet();
        try
        {
            ds_ParentLevels = db_Con.ExecuteDataSet("Proc_TA_getMinimumLevel", new object[] { });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ParentLevels;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet RawData(string dtFromDate, string dtToDate, string empId, string empName, string userGroupName, int ParentId, int employeeCategory, int employeeType, int DesignationId, string Gender, int ProcessType, int EmpAutoID)
    {
        DataSet ds_RawData = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_rptRawData");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@ParentID", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@ProcessType", DbType.Int16, ProcessType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_RawData, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_RawData;
    }
    // Method derived for the raw data report in the dashboard
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet RawDataDashBoard(string dtFromDate, string dtToDate, string empId, string empName, string userGroupName, int ParentId, int employeeCategory, int employeeType, int DesignationId, string Gender, int EmpAutoID)
    {
        DataSet ds_RawData = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptRawDataPunches_Dashboard");
            dbcmd.CommandTimeout = 0;
            //Sets the Cultural Information
            // Assigns the parameters to the command
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, empId);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@ParentID", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_RawData, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_RawData;
    }
    //Get the top organization level Id
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet getMinLevelUpdated(string LevelIDs)
    {
        DataSet ds_ParentLevels = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_getMinimumLevelUpdated");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@LevelIDs", DbType.String, LevelIDs);
            db_Con.LoadDataSet(dbcmd, ds_ParentLevels, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ParentLevels;
    }
    /// <summary>
    /// Permission Report
    /// </summary>
    /// <param name="dtFromDate"></param>?
    /// <param name="dtToDate"></param>
    /// <param name="empName"></param>
    /// <param name="levelId"></param>
    /// <param name="EmployeeId"></param>
    /// <returns></returns>
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectPermissionReport(string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string Status, string strSwipeCard, int ParentId, int DesignationId, string Gender, Int64 EmpAutoID)
    {
        DataSet dsPermission = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptPermission");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@LeaveStatus", DbType.String, Status);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsPermission, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsPermission;
    }
    //manual time entry  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectManualTimeEntryReport(string empName, string EmployeeId, string dtFromDate, string dtToDate, string LevelID, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string Status, string strSwipeCard, int ParentId, int Designation, string Gender, Int64 EmpAutoID)
    {
        DataSet dsManualEntry = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptManualTimeEntry");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@employeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@fromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@levelId", DbType.String, LevelID);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@Status", DbType.String, Status);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, Designation);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsManualEntry, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsManualEntry;
    }
    //manual time entry  Export
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectManualTimeEntryExport(int EmpAutoID, string empName, string EmployeeId, string dtFromDate, string dtToDate, string LevelID, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string Status, string strSwipeCard, int ParentId, int Designation, string Gender)
    {
        DataSet dsManualEntry = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_ManualTimeEntryExport");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@employeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@fromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@levelId", DbType.String, LevelID);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@Status", DbType.String, Status);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, Designation);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.LoadDataSet(dbcmd, dsManualEntry, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsManualEntry;
    }
    //OnDuty entry  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectOnDutyEntryReport(string empName, string EmployeeId, string dtFromDate, string dtToDate, string LevelID, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string Status, string strSwipeCard, int ParentId, int Designation, string Gender, int EmpAutoID)
    {
        DataSet dsOnDutyEntry = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptOnDutyEntry");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@employeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@fromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@levelId", DbType.String, LevelID);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@Status", DbType.String, Status);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, Designation);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsOnDutyEntry, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsOnDutyEntry;
    }
    //Employee History Details Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectEmployeeHistory(string dtFromDate, string dtToDate, string EmployeeId, int shift, string empName, string levId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int Designation, string Gender, int EmpAutoID)
    {
        DataSet dsEmpHistory = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_Ta_RptEmployeeHistoryNew");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, Designation);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsEmpHistory, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmpHistory;
    }
    //Employee History Details Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectEmployeeHistory_Arabic(string dtFromDate, string dtToDate, string EmployeeId, int shift, string empName, string levId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int Designation, string Gender, int EmpAutoID)
    {
        DataSet dsEmpHistory = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_Ta_RptEmployeeHistoryNew_Arabic");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, Designation);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsEmpHistory, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmpHistory;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectAttendanceXtraGrid(string FromDate, string ToDate, string UserGroupName, string GradeLevel, string LevelRights, int ParentId, Int64 EmpAutoID)
    {
        DataSet dsAttendance = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_SelectAttendanceXtraGrid");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, FromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, ToDate);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@LevelRights", DbType.String, LevelRights);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsAttendance, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsAttendance;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMovementsEntryXtraGrid(string FromDate, string ToDate, string UserGroupName, string GradeLevel, string LevelRights, int ParentId, Int64 EmpAutoID)
    {
        DataSet dsAttendance = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_SelectMovementsEntryXtraGrid");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, FromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, ToDate);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@LevelRights", DbType.String, LevelRights);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsAttendance, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsAttendance;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectEmployeeDetailXtraGrid1(string FromDate, string ToDate, string UserGroupName, string GradeLevel, string LevelRights, int parentLevelId, Int64 EmpAutoID)
    {
        DataSet dsEmployeeDetail = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_SelectEmployeeDetailXtraGrid");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, FromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, ToDate);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@LevelRights", DbType.String, LevelRights);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, parentLevelId);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsEmployeeDetail, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmployeeDetail;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectEmployeeDetailXtraGrid(string UserGroupName, string GradeLevel, string LevelRights, int parentLevelId, Int64 EmpAutoID)
    {
        DataSet dsEmployeeDetail = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_SelectEmployeeDetailXtraGrid");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@LevelRights", DbType.String, LevelRights);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, parentLevelId);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsEmployeeDetail, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmployeeDetail;
    }
    public DataSet SelectEmployeeShiftDetailXtraGrid(string UserGroupName, string GradeLevel)
    {
        DataSet dsEmployeeShiftDetail = new DataSet();
        try
        {
            dsEmployeeShiftDetail = db_Con.ExecuteDataSet("Proc_TA_SelectEmployeeShiftDetailXtraGrid", new object[] { UserGroupName, GradeLevel });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsEmployeeShiftDetail;
    }
    public int SelectShiftNotAllocatedEmployees(string ShiftDay, int employeeId, int year, int month)
    {
        int count = 0;
        try
        {
            DbCommand cmdSelectShiftNotAllocated = db_Con.GetStoredProcCommand("Proc_TA_SelectShiftNotAllocated", new object[] { ShiftDay, employeeId, year, month });
            cmdSelectShiftNotAllocated.CommandTimeout = 0;
            count = Convert.ToInt32(db_Con.ExecuteScalar(cmdSelectShiftNotAllocated));
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return count;
    }
    public DataSet SelectInOutEmployeeNew(string empId, string empName, string levId, string employeeCategory, string employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, string Fromdate, string Todate, int DesignationId, string Gender, int EmpAutoID)
    {
        try
        {
            DataSet ds = new DataSet();
            DbCommand cmd = db_Con.GetStoredProcCommand("Proc_TA_RptEmployeeInOutDetails", new object[] { empId, empName, levId, employeeCategory, employeeType, UserGroupName, GradeLevel, strSwipeCard, ParentId, Fromdate, Todate, DesignationId, Gender, EmpAutoID });
            cmd.CommandTimeout = 0;
            ds = db_Con.ExecuteDataSet(cmd);
            return ds;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public DataSet SelectInOutEmployeeSummary(string empId, string empName, string levId, string employeeCategory, string employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, string Fromdate, string Todate, int DesignationId, string Gender, int EmpAutoID)
    {
        DataSet ds = new DataSet();
        DbCommand cmd = db_Con.GetStoredProcCommand("Proc_TA_RptEmployeeInOutSummary", new object[] { empId, empName, levId, employeeCategory, employeeType, UserGroupName, GradeLevel, strSwipeCard, ParentId, Fromdate, Todate, DesignationId, Gender, EmpAutoID });
        cmd.CommandTimeout = 0;
        ds = db_Con.ExecuteDataSet(cmd);
        return ds;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet LeavePolicyNotAllocationReport(string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, Int64 EmpAutoID)
    {
        DataSet dsLeavePolicyNotAllocation = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptLeavePolicyNotAllocated");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, dsLeavePolicyNotAllocation, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsLeavePolicyNotAllocation;
    }
    //get total working days
    public DataSet SelectTotalWorkingDays(string SelectedMonth, string SelectedYear)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db_Con.ExecuteDataSet("Proc_TA_SelectWorkingDays", new object[] { SelectedMonth, SelectedYear });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return ds;
    }
    public DataSet SelectSummaryReportCount(string dtFromDate, string userGroupName, int ParentId)
    {
        DataSet ds_SummaryCount = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptSummaryCount");
            dbcmd.CommandTimeout = 0;
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@Date", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.LoadDataSet(dbcmd, ds_SummaryCount, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_SummaryCount;
    }
    public DataSet SelectSummaryReport(string dtFromDate, string userGroupName, int ParentId, int Shift, int ExportType, int EmpAutoID)
    {
        DataSet ds_SummaryReport = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptHeadCountSummary");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@Date", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@ShiftId", DbType.Int16, Shift);
            db_Con.AddInParameter(dbcmd, "@ExportType", DbType.Int32, ExportType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_SummaryReport, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_SummaryReport;
    }
    public DataSet SelectDetailsReport(string dtFromDate, string userGroupName, int ParentId, int Shift, int EmpAutoID)
    {
        DataSet ds_SummaryReport = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptHeadCountDetails");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@Date", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@ShiftId", DbType.Int16, Shift);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_SummaryReport, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_SummaryReport;
    }
    public DataTable GetDateMonth(string from, string to)
    {
        DataSet ds_DateFormat = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_GetDatesWithFormat");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@From", DbType.String, from);
            db_Con.AddInParameter(dbcmd, "@To", DbType.String, to);
            db_Con.LoadDataSet(dbcmd, ds_DateFormat, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_DateFormat.Tables[0];
    }
    /// <summary>
    /// Added by MAnjula.P on 09-Jan-2014 for selecting count factor reports dataset
    /// </summary>
    /// <returns></returns>
    public DataSet SelectCountfactorWorkingdays(string empName, string EmployeeId, string dtFromDate, string dtToDate, string LevelID, Int32 employeeCategory, Int32 employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, Int16 ParentId, Int32 Designation, string Gender, int EmpAutoID)
    {
        DataSet ds_CountFactorWorkingdays = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptTotalWorkingDays");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@employeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@fromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@levelId", DbType.String, LevelID);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, Designation);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_CountFactorWorkingdays, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_CountFactorWorkingdays;
    }
    //Temporary Shift Allocation  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet ExportTempShiftAllocation(int EmpID, string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender)
    {
        DataSet ds_TempShiftAllocation = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_ExportTempShiftAllocation");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@Employee_ID", DbType.Int32, EmpID);
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.LoadDataSet(dbcmd, ds_TempShiftAllocation, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TempShiftAllocation;
    }
    public DataSet ExportShiftAllocation(int EmpID, string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender)
    {
        DataSet ds_ShiftAllocation = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_ExportShiftAllocation");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@Employee_ID", DbType.Int32, EmpID);
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.LoadDataSet(dbcmd, ds_ShiftAllocation, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftAllocation;
    }
    #region Not Used
    //EmployeeInOut Report
    public DataSet SelectInOut(string SelectedMonth, string SelectedYear, string empId, string empName, string levId, string employeeCategory, string employeeType)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db_Con.ExecuteDataSet("Proc_TA_RptEmployeeInOut", new object[] { SelectedMonth, SelectedYear, empId, empName, levId, employeeCategory, employeeType });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return ds;
    }
    //EmployeeInOuReport
    public DataSet SelectInOutEmployee(string SelectedMonth, string SelectedYear, string empId, string empName, string levId, string employeeCategory, string employeeType, string UserGroupName, string GradeLevel, string strSwipeCard)
    {
        DataSet ds = new DataSet();
        ds = db_Con.ExecuteDataSet("Proc_TA_RptEmployeeInOutSelectEmployee", new object[] { SelectedMonth, SelectedYear, empId, empName, levId, employeeCategory, employeeType, UserGroupName, GradeLevel, strSwipeCard });
        return ds;
    }
    //Movements Entry  Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMovementsEntryShiftNotAllocatedReport(string EmployeeId, string LevelID, string dtFromDate, string dtToDate,
        string empName, int shift, int employeeCategory, int employeeType, string userGroupName,
        string gradeLevel, int EmpAutoID)
    {
        DataSet ds_MovEntry = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMovementsEntryShiftNotAllocated");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, LevelID);
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_MovEntry, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_MovEntry;
    }
    //Shift Temp Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectTempShiftReport(string dtFromDate, string levelId, string EmployeeId, string employeeName, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int ShiftId, Int64 EmpAutoID)
    {
        DataSet ds_TempShift = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptTemporaryShift");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDate", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, employeeName);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, ShiftId);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_TempShift, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_TempShift;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectEarlyEntryReport(string Emp_Id, string levelID, string dtFromDate, string dtToDate, string empName, int shift, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int ExportType, string MinExceptkHours, int EmpAutoID)
    {
        DataSet ds_LateOut = new DataSet();
        try
        {
            if (empName == null)
            {
                empName = "";
            }
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptEarlyEntry");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, Emp_Id);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelID);
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@ExportType", DbType.Int32, ExportType);
            db_Con.AddInParameter(dbcmd, "@MINExceptionHOURS", DbType.String, MinExceptkHours);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int32, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_LateOut, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LateOut;
    }
    #endregion
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet GetEmailSchedulerFilterDetails(int scheduleId)
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_Ta_GetEmailScheduler_FilterDetails");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@scheduleId", DbType.Int32, scheduleId);
            db_Con.LoadDataSet(dbcmd, ds, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    //General Monthly Attendance Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectGeneralMonthlyAttendanceReport(string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, int ParentId, int DesignationId, string Gender, int shftId, int EmpAutoID)
    {
        DataSet ds_MonthlyAttendance = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptGeneralMonthlyAttendance");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int32, DesignationId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@ShiftId", DbType.Int16, shftId);
            db_Con.AddInParameter(dbcmd, "@EmpAutoID", DbType.Int16, EmpAutoID);
            db_Con.LoadDataSet(dbcmd, ds_MonthlyAttendance, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_MonthlyAttendance;
    }
    public DataSet SelectReportData(string Filters, string ReportName, string ReportType)
    {
        DataSet ds_ReportData = new DataSet();
        try
        {
            char[] split = { ',' };
            string[] strFilters = Filters.Split(split);
            Hashtable htParameters = new Hashtable();
            foreach (string strFilter in strFilters)
            {
                char[] splitData = { '=' };
                string[] strData = strFilter.Split(splitData);
                if (strData[0].ToString() == "@fromDat" || strData[0].ToString() == "@FromDate1")
                    FromDate = Convert.ToString(strData[1]);
                if (strData[0].ToString() == "@ToDat" || strData[0].ToString() == "@ToDate1")
                    ToDate = Convert.ToString(strData[1]);
                if (strData[0] != "@AllSwipesReportType")
                {
                    strData[1] = strData[1].Replace('~', ',');
                    htParameters.Add(strData[0].ToString(), strData[1].ToString());
                    if (ReportName == "MustoRollReport")
                    {
                        if (strData[0] == "@Type")
                        {
                            HttpContext.Current.Session["strReportType"] = strData[1];
                        }
                    }
                }
                else
                {
                    AllSwipesReportType = Convert.ToInt32(Convert.ToString(strData[1]));
                    if (AllSwipesReportType == 2 || AllSwipesReportType == 4)
                    {
                        htParameters.Remove("@Type");
                        htParameters.Add("@Type", strData[1].ToString());
                    }
                }
            }
            switch (ReportName)
            {
                case "Report_WeeklyWorkHours":
                    htParameters.Remove("@ReportType");
                    ds_ReportData = GetDataSet("Proc_TA_RptWeeklyWorkHours", htParameters);
                    break;
                case "DailyReport-DailyLeave":
                    if (htParameters.Contains("@IntimationType"))
                    {
                        htParameters["@IntimationType"] = "P";
                        ds_ReportData = GetDataSet("Proc_TA_RptDailyLeaves_email", htParameters);
                    }
                    break;
                case "DailyReport-DailyLeaveUnplanned":
                    if (htParameters.Contains("@IntimationType"))
                    {
                        htParameters["@IntimationType"] = "U";
                        ds_ReportData = GetDataSet("Proc_TA_RptDailyLeaves_email", htParameters);
                    }
                    break;
                case "DailyReport-DailyPermission":
                    if (htParameters.Contains("@IntimationType"))
                    {
                        htParameters.Add("@Type", "P");
                        htParameters.Remove("@IntimationType");
                        ds_ReportData = GetDataSet("Proc_TA_RptDailyPermission_email", htParameters);
                    }
                    break;
                case "DailyReport-DailyPermissionUnplanned":
                    if (htParameters.Contains("@IntimationType"))
                    {
                        htParameters.Add("@Type", "U");
                        htParameters.Remove("@IntimationType");
                        ds_ReportData = GetDataSet("Proc_TA_RptDailyPermission_email", htParameters);
                    }
                    break;
                case "Report_Absent":
                    ds_ReportData = GetDataSet("Proc_Ta_rptAbsent", htParameters);
                    break;
                case "Report_GeneralMonthly_Attendance":
                    ds_ReportData = GetDataSet("Proc_TA_RptGeneralMonthlyAttendance", htParameters);
                    break;
                case "Report_EarltEntry":
                    ds_ReportData = GetDataSet("Proc_TA_RptEarlyEntry", htParameters);
                    break;
                case "Report_Late_Entry":
                    ds_ReportData = GetDataSet("Proc_TA_RptLateIn", htParameters);
                    break;
                case "Report_Early_Exit":
                    ds_ReportData = GetDataSet("proc_TA_EarlyExit", htParameters);
                    break;
                case "Report_Late_Exit":
                    ds_ReportData = GetDataSet("proc_TA_RptLateExit", htParameters);
                    break;
                case "Report_OnDutyEntry":
                    ds_ReportData = GetDataSet("Proc_TA_RptOnDutyEntry", htParameters);
                    break;
                case "Report_Leave":
                    if (ReportType == "0")
                    {
                        ds_ReportData = GetDataSet("Proc_TA_RptLeave", htParameters);
                    }
                    else
                    {
                        ds_ReportData = GetDataSet("Proc_TA_Rpt_LeaveSummaryDetails", htParameters);
                    }
                    break;
                case "Report_All_Swipes":
                    if (AllSwipesReportType == 0)
                    {
                        ds_ReportData = GetDataSet("Proc_TA_RptMovementsEntry", htParameters);
                    }
                    else if (AllSwipesReportType == 1)
                    {
                        ds_ReportData = GetDataSet("Proc_TA_RptMovementsEntry_FirstAndLast", htParameters);
                    }
                    else if (AllSwipesReportType == 2 || AllSwipesReportType == 4)
                    {
                        ds_ReportData = GetDataSet("Proc_TA_RptMovementsEntryWithMatchedPunches", htParameters);
                    }
                    else if (AllSwipesReportType == 3)
                    {
                        ds_ReportData = GetDataSet("Proc_TA_RptMovementsEntry_NotMatched", htParameters);
                    }
                    break;
                case "Report_Detailed_Attendance":
                    ds_ReportData = GetDataSet("Proc_TA_RptDetailAttendanceDynamicNew", htParameters);
                    break;
                case "Report_Monthly_Attendance":
                    if (ReportType == "0")
                        ds_ReportData = GetDataSet("Proc_TA_RptMonthlyAttendance", htParameters);
                    else
                        ds_ReportData = GetDataSet("Proc_TA_RptMonthlyAttendance_Detail", htParameters);
                    break;
                case "Report_Punctuality":
                    ds_ReportData = GetDataSet("proc_ta_rptPunctuality", htParameters);
                    break;
                case "Report_Permission":
                    ds_ReportData = GetDataSet("Proc_TA_RptPermission", htParameters);
                    break;
                case "Report_Discrepancy":
                    ds_ReportData = GetDataSet("proc_ta_RptDiscrepancy", htParameters);
                    break;
                case "Report_ManualTimeEntry":
                    ds_ReportData = GetDataSet("Proc_TA_RptManualTimeEntry", htParameters);
                    break;
                case "Report_RawData":
                case "RawDataDetailed":
                    ds_ReportData = GetDataSet("Proc_TA_rptRawData", htParameters);
                    break;
                case "MustoRollReport":

                    if (ReportType == "0")
                    {
                        ds_ReportData = GetDataSet("Proc_TA_RptEmployeeInOutSummary", htParameters);
                    }
                    else
                    {
                        htParameters.Remove("@Type");
                        ds_ReportData = GetDataSet("Proc_TA_RptEmployeeInOutDetails", htParameters);
                    }
                    break;
                case "Report_SummaryReport":
                    ds_ReportData = GetDataSet("Proc_TA_RptHeadCountSummary", htParameters);
                    break;
                case "Report_Overtime":
                    if (ReportType == "OTCompOff")
                    {
                        htParameters.Remove("@SanctionType");
                        ds_ReportData = GetDataSet("Proc_TA_RptEmployeeCompOffStatus", htParameters);
                    }
                    else
                    {
                        ds_ReportData = GetDataSet("proc_OtCalculation", htParameters);
                    }
                    break;
                case "Report_LessHoursWorked":
                    ds_ReportData = GetDataSet("Proc_TA_RptLessHoursWorked", htParameters);
                    break;
                case "Report_ShiftNotAllocated":
                    ds_ReportData = GetDataSet("Proc_TA_RptShiftNotAllocated", htParameters);
                    break;
                case "Report_Employee_Shift_Allocation":
                    if (ReportType == "0")
                    {
                        DataSet ds_temp = new DataSet();
                        DataTable dtTempShiftAllocation = new DataTable();
                        dtTempShiftAllocation = TempShiftAllocation(htParameters);
                        ds_ReportData = GetDataSet("Proc_TA_RptShiftAllocation", htParameters);
                        DataTable dtSift = new DataTable();
                        //Check the Empty table 
                        if ((ds_ReportData.Tables["Table"] == null || ds_ReportData.Tables["Table"].Rows.Count == 0) && (dtTempShiftAllocation != null && dtTempShiftAllocation.Rows.Count != 0))
                        {
                            dtSift = dtTempShiftAllocation;
                        }
                        else if ((ds_ReportData.Tables["Table"] == null || ds_ReportData.Tables["Table"].Rows.Count == 0) && (dtTempShiftAllocation == null || dtTempShiftAllocation.Rows.Count == 0))
                        {
                        }
                        else
                        {
                            int fromDay = 0;
                            int fromMonth = 0;
                            int fromYear = 0;
                            int toMonth = 0;
                            int toDay = 0;
                            int toYear = 0;
                            DataTable dtmonthdayYear = new DataTable();
                            dtmonthdayYear = GetDateMonthYear(FromDate, ToDate);
                            if (dtmonthdayYear.Rows.Count > 0)
                            {
                                fromDay = Convert.ToInt32(dtmonthdayYear.Rows[0][2]);
                                fromMonth = Convert.ToInt32(dtmonthdayYear.Rows[0][1]);
                                fromYear = Convert.ToInt32(dtmonthdayYear.Rows[0][0]);
                                toMonth = Convert.ToInt32(dtmonthdayYear.Rows[1][2]);
                                toDay = Convert.ToInt32(dtmonthdayYear.Rows[1][1]);
                                toYear = Convert.ToInt32(dtmonthdayYear.Rows[1][0]);
                            }
                            int j = 0;
                            DataTable dtShiftShortName = new DataTable();
                            DataSet dstemp = new DataSet();
                            Hashtable htable = new Hashtable();
                            dstemp = GetDataSet("Proc_TA_GetShiftShortName", htable);
                            dtShiftShortName = dstemp.Tables[0];
                            for (int k = 0; k <= ds_ReportData.Tables[0].Columns.Count - 5; k++)
                            {
                                if (k == 0)
                                {
                                    dtSift.Columns.Add("Employee Name");
                                }
                                else if (k == 1)
                                {
                                    dtSift.Columns.Add("Employee Id");
                                }
                                else if (k == 2)
                                {
                                    dtSift.Columns.Add("Year");
                                }
                                else if (k == 3)
                                {
                                    dtSift.Columns.Add("Month");
                                }
                                else if (k == ds_ReportData.Tables[0].Columns.Count - 5)
                                {
                                    dtSift.Columns.Add("Gender");
                                }
                                else
                                {
                                    dtSift.Columns.Add((k - 3).ToString());
                                }
                            }
                            foreach (DataRow dr in ds_ReportData.Tables[0].Rows)
                            {
                                j = j + 1;
                                dtSift.Rows.Add();
                                for (int i = 0; i <= ds_ReportData.Tables[0].Columns.Count - 5; i++)
                                {
                                    if (i == 4 && Convert.ToInt32(dr["Month"]) == fromMonth)
                                    {
                                        if (Convert.ToInt32(dr["Year"]) != fromYear)
                                        {
                                        }
                                        else
                                        {
                                            i = fromDay + 3;
                                        }
                                    }
                                    if (i > 3 && i < ds_ReportData.Tables[0].Columns.Count - 5)
                                    {
                                        foreach (DataRow dRow in dtShiftShortName.Rows)
                                        {
                                            if (dr[i].ToString() == dRow["Shift_Id"].ToString())
                                            {
                                                dtSift.Rows[j - 1][i] = dRow["Shift_ShortName"];
                                            }
                                            else if (dr[i].ToString() == "-1")
                                            {
                                                dtSift.Rows[j - 1][i] = "Off";
                                            }
                                        }
                                    }
                                    else if (i == 3)
                                    {
                                        DateTimeFormatInfo dtfi = new CultureInfo("en-US", true).DateTimeFormat;
                                        string temp = dtfi.GetMonthName(Convert.ToInt32(dr[i].ToString()));
                                        dtSift.Rows[j - 1][i] = temp;
                                    }
                                    else if (i == ds_ReportData.Tables[0].Columns.Count - 5)
                                    {
                                        dtSift.Rows[j - 1][i] = dr["Gender"];
                                    }
                                    else
                                    {
                                        dtSift.Rows[j - 1][i] = dr[i];
                                    }
                                    if (toDay + 3 == i && Convert.ToInt32(dr["Month"]) == toMonth && Convert.ToInt32(dr["Year"]) == toYear)
                                    {
                                        i = ds_ReportData.Tables[0].Columns.Count - 6;
                                    }
                                }
                            }
                            //Check Temporary shift Exists or not 
                            Boolean boolTempShiftExists = false;
                            if (dtTempShiftAllocation != null)
                            {
                                foreach (DataRow dRowTempShift in dtTempShiftAllocation.Rows)
                                {
                                    boolTempShiftExists = false;
                                    foreach (DataRow dRowPermanentShift in dtSift.Rows)
                                    {
                                        if (dRowTempShift["Employee Id"].ToString() == dRowPermanentShift["Employee Id"].ToString() && dRowTempShift["Year"].ToString() == dRowPermanentShift["Year"].ToString() && dRowTempShift["Month"].ToString() == dRowPermanentShift["Month"].ToString())
                                        {
                                            boolTempShiftExists = true;
                                            for (int i = 0; i <= dtTempShiftAllocation.Columns.Count - 1; i++)
                                            {
                                                if (i > 3)
                                                {
                                                    if (dRowTempShift[i].ToString() == "0" || dRowTempShift[i].ToString() == "")
                                                    {
                                                    }
                                                    else
                                                    {
                                                        dRowPermanentShift[i] = dRowTempShift[i];
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    if (boolTempShiftExists == false)
                                    {
                                        DataRow dRowTemp;
                                        dRowTemp = dRowTempShift;
                                        dtSift.ImportRow(dRowTemp);
                                    }
                                }
                            }
                        }
                        ds_ReportData.Tables.Add(dtSift);
                    }
                    else
                    {
                        htParameters.Remove("@Religion");
                        ds_ReportData = GetDataSet("Proc_TA_RptShiftNotAllocated", htParameters);
                    }
                    break;
                case "System_MultiLingual":
                    ds_ReportData = GetDataSet("Proc_TA_RptFirstInPunchDifference_email", htParameters);
                    break;
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ReportData;
    }
    public static DataSet GetDataSet(string sql, Hashtable param)
    {
        try
        {
            DataSet dsData = new DataSet();
            SqlDataAdapter sqlAdap = new SqlDataAdapter();
            sqlAdap.SelectCommand = GetDataCommand(sql, param);
            sqlAdap.Fill(dsData);
            sqlAdap.SelectCommand.Connection.Close();
            sqlAdap.SelectCommand.Dispose();
            sqlAdap.Dispose();
            return dsData;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public static SqlCommand GetDataCommand(string sql, Hashtable param)
    {
        try
        {
            SqlCommand sqlCom = new SqlCommand();
            sqlCom.CommandText = sql;
            sqlCom.CommandType = CommandType.StoredProcedure;
            sqlCom.Connection = GetConnection();
            if (param != null)
            {
                if (param.Count > 0)
                {
                    foreach (string hshKey in param.Keys)
                    {
                        sqlCom.Parameters.Add(new SqlParameter(hshKey, param[hshKey]));
                    }
                }
            }
            return sqlCom;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public static SqlConnection GetConnection()
    {
        try
        {
            SqlConnection sqlCon = new SqlConnection(GetString());
            if (sqlCon.State != ConnectionState.Closed)
            {
                sqlCon.Close();
            }
            else if (sqlCon.State == ConnectionState.Closed)
            {
                sqlCon.Open();
            }
            return sqlCon;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public static string GetString()
    {
        try
        {
            string connString;
            connString = Cryptographys.Cryptography.GetDecryptedConnectionString();
            return connString;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public DataTable GetDateMonthYear(string from, string to)
    {
        try
        {
            DataSet ds = new DataSet();
            Hashtable htEmailSchedule = new Hashtable();
            htEmailSchedule.Add("@From", from);
            htEmailSchedule.Add("@To", to);
            ds = GetDataSet("GetDateMonthYear", htEmailSchedule);
            return ds.Tables[0];
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    private DataTable TempShiftAllocation(Hashtable htable)
    {
        DataTable dtSift = new DataTable();
        try
        {
            DataSet dsTempShiftAllocation = new DataSet();
            dsTempShiftAllocation = GetDataSet("Proc_TA_RptTempShiftAllocation", htable);
            if (dsTempShiftAllocation.Tables["Table"] == null || dsTempShiftAllocation.Tables["Table"].Rows.Count == 0)
            {
                dtSift = null;
            }
            else
            {
                int fromDay = DateTime.Parse(Convert.ToString(FromDate)).Day;
                int fromMonth = DateTime.Parse(Convert.ToString(FromDate)).Month;
                int fromYear = DateTime.Parse(Convert.ToString(FromDate)).Year;
                int toMonth = DateTime.Parse(Convert.ToString(ToDate)).Month;
                int toDay = DateTime.Parse(Convert.ToString(ToDate)).Day;
                int toYear = DateTime.Parse(Convert.ToString(ToDate)).Year;
                int j = 0;
                DataTable dtShiftShortName = new DataTable();
                DataSet dstemp = new DataSet();
                htable = new Hashtable();
                dstemp = GetDataSet("Proc_TA_GetShiftShortName", htable);
                for (int k = 0; k <= dsTempShiftAllocation.Tables[0].Columns.Count - 5; k++)
                {
                    if (k == 0)
                    {
                        dtSift.Columns.Add("Employee Name");
                    }
                    else if (k == 1)
                    {
                        dtSift.Columns.Add("Employee Id");
                    }
                    else if (k == 2)
                    {
                        dtSift.Columns.Add("Year");
                    }
                    else if (k == 3)
                    {
                        dtSift.Columns.Add("Month");
                    }
                    else if (k == dsTempShiftAllocation.Tables[0].Columns.Count - 5)
                    {
                        dtSift.Columns.Add("Gender");
                    }
                    else
                    {
                        dtSift.Columns.Add((k - 3).ToString());
                    }
                }
                foreach (DataRow dr in dsTempShiftAllocation.Tables[0].Rows)
                {
                    j = j + 1;
                    dtSift.Rows.Add();
                    for (int i = 0; i <= dsTempShiftAllocation.Tables[0].Columns.Count - 5; i++)
                    {
                        if (i == 4 && Convert.ToInt32(dr["Month"]) == fromMonth)
                        {
                            if (Convert.ToInt32(dr["Year"]) != fromYear)
                            {
                            }
                            else
                            {
                                i = fromDay + 3;
                            }
                        }
                        if (i > 3 && i < dsTempShiftAllocation.Tables[0].Columns.Count - 5)
                        {
                            foreach (DataRow dRow in dtShiftShortName.Rows)
                            {
                                if (dr[i].ToString() == dRow["Shift_Id"].ToString())
                                {
                                    dtSift.Rows[j - 1][i] = dRow["Shift_ShortName"];
                                }
                                else if (dr[i].ToString() == "-1")
                                {
                                    dtSift.Rows[j - 1][i] = "Off";
                                }
                            }
                        }
                        else if (i == 3)
                        {
                            DateTimeFormatInfo dtfi = new CultureInfo("en-US", true).DateTimeFormat;
                            string temp = dtfi.GetMonthName(Convert.ToInt32(dr[i].ToString()));
                            dtSift.Rows[j - 1][i] = temp;
                        }
                        else if (i == dsTempShiftAllocation.Tables[0].Columns.Count - 5)
                        {
                            dtSift.Rows[j - 1][i] = dr["Gender"];
                        }
                        else
                        {
                            dtSift.Rows[j - 1][i] = dr[i];
                        }
                        if (toDay + 3 == i && Convert.ToInt32(dr["Month"]) == toMonth && Convert.ToInt32(dr["Year"]) == toYear)
                        {
                            i = dsTempShiftAllocation.Tables[0].Columns.Count - 6;
                        }
                    }
                }
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return dtSift;
    }
    //Angler Functions
    //Leave Permission Daily Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLeavePermissionDailyReport_Leaves_Angler(string dtFromDate, string levelId, string IntimationType, Int64 EmpAutoID, Int64 ReportingTo, Int64 SanctioningAuthority, int ParentId, string strUserGroupName)
    {
        DataSet dsDailyLeave = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptDailyLeaves");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@IntimationType", DbType.String, IntimationType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@ReportingTo", DbType.Int64, ReportingTo);
            db_Con.AddInParameter(dbcmd, "@SanctioningAuthority", DbType.Int64, SanctioningAuthority);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.LoadDataSet(dbcmd, dsDailyLeave, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsDailyLeave;
    }
    //Leave Permission Daily Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLeavePermissionDailyReport_Permission_Angler(string dtFromDate, string levelId, string strType, Int64 EmpAutoID, Int64 ReportingTo, Int64 SanctioningAuthority, int ParentId, string strUserGroupName)
    {
        DataSet dsDailyPermission = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptDailyPermission");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@Type", DbType.String, strType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@ReportingTo", DbType.String, ReportingTo);
            db_Con.AddInParameter(dbcmd, "@SanctioningAuthority", DbType.String, SanctioningAuthority);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.LoadDataSet(dbcmd, dsDailyPermission, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsDailyPermission;
    }
    //Report header
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet getHeader1_Angler(int id)
    {
        DataSet dsHead = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_Rpt_header");
            dbcmd.CommandTimeout = 0;
            //Sets the Cultural Information
            //ds_MovEntry.Locale = CultureInfo.InvariantCulture;
            // Assigns the parameters to the command
            db_Con.AddInParameter(dbcmd, "@LevelId", DbType.Int32, id);
            db_Con.LoadDataSet(dbcmd, dsHead, "Table");
            // dsHead = db_Con.ExecuteDataSet("Proc_TA_Rpt_header", new object[] { id });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsHead;
    }
    public void InsertLeaveAnalysisNotes_Angler(string Notes, string strEntryDate, string iEmpID)
    {
        DbCommand dbcmd;
        try
        {
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_InsertLeaveAnalysisNotes", new object[] { Notes, strEntryDate, iEmpID });
            //dbcmd.CommandTimeout = 0;
            //db_Con.AddInParameter(dbcmd, "@Notes", DbType.String, Notes);
            //db_Con.AddInParameter(dbcmd, "@iDate", DbType.DateTime, strEntryDate);
            //db_Con.AddInParameter(dbcmd, "@EmpID", DbType.String, iEmpID);
            db_Con.ExecuteNonQuery(dbcmd);
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public void UpdateLeaveAnalysisNotes_Angler(string strOpr, int Id, string Notes, string iEmpID, string DateIns)
    {
        DbCommand dbcmd;
        try
        {
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_UpdateLeaveAnalysisNotes", new object[] { strOpr, Id, Notes, iEmpID });
            //dbcmd.CommandTimeout = 0;
            //db_Con.AddInParameter(dbcmd, "@Opr", DbType.String, strOpr);
            //db_Con.AddInParameter(dbcmd, "@ID", DbType.Int16, Id);
            //db_Con.AddInParameter(dbcmd, "@Notes", DbType.String, Notes);
            //db_Con.AddInParameter(dbcmd, "@EmpID", DbType.String, iEmpID);
            db_Con.ExecuteNonQuery(dbcmd);
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    //Total Hours List Report :
    public DataSet SelectTotalHrsList_Angler(string MinWorkHours, string dtFromDate, string dtToDate, string empId, string empName, string levId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, Int64 EmpAutoID, string BreakLate, int ParentLevelId, int DesignationID, string Gender)
    {
        DataSet dsTotHrsList = new DataSet();
        try
        {
            DbCommand dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptTotalHoursList", new object[] { MinWorkHours, dtFromDate, dtToDate, empId, empName, levId, employeeCategory, employeeType, UserGroupName, GradeLevel, EmpAutoID, BreakLate, ParentLevelId, DesignationID, Gender });
            dbcmd.CommandTimeout = 0;
            dsTotHrsList = db_Con.ExecuteDataSet(dbcmd);
            //dsTotHrsList = db_Con.ExecuteDataSet("Proc_TA_RptTotalHoursList", new object[] { MinWorkHours, dtFromDate, dtToDate, empId, empName, levId, employeeCategory, employeeType, UserGroupName, GradeLevel, EmpAutoID, BreakLate,ParentLevelId,DesignationID,Gender });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return dsTotHrsList;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectWorkedDaysDetailsWithDeviations_Angler(string strEmpId, string strLevelID, string strFromDate, string strToDate, string strEmpName, int iEmpCategory, int iEmpType, string strUserGroupName, string strGradeLevel, string strSwipeCard, int iEmpAutoID, int designation, int ParentId, string gender)
    {
        DataSet dsWorkHrs = new DataSet();

        try
        {
            if (strEmpName == null)
                strEmpName = "";

            DbCommand dbcmd;

            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptPayslip_General");
            dbcmd.CommandTimeout = 0;

            // Assigns the parameters to the command
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, strFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.String, strToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, strEmpName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, strLevelID);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, strEmpId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, iEmpCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, iEmpType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, strGradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, iEmpAutoID);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int16, designation);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, gender);
            db_Con.LoadDataSet(dbcmd, dsWorkHrs, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsWorkHrs;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectEarlyEntryReport_Angler(string Emp_Id, string levelID, string dtFromDate, string dtToDate, string empName, int shift, int employeeCategory, int employeeType, string userGroupName, string gradeLevel, string strSwipeCard, int ParentId)
    {
        DataSet ds_LateOut = new DataSet();
        try
        {
            if (empName == null)
            {
                empName = "";
            }
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptEarlyEntry");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, Emp_Id);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelID);
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@shift", DbType.Int32, shift);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, userGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, gradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.LoadDataSet(dbcmd, ds_LateOut, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_LateOut;
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectWorkedDaysDetailsWithDeviationsExport_Angler(string strEmpId, string strLevelID, string strFromDate, string strToDate, string strEmpName, int iEmpCategory, int iEmpType, string strUserGroupName, string strGradeLevel, string strSwipeCard, int iEmpAutoID, int designation, int ParentId, string gender)
    {
        DataSet dsWorkHrs = new DataSet();
        try
        {
            if (strEmpName == null)
                strEmpName = "";
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptPayslip_GeneralExport");
            dbcmd.CommandTimeout = 0;
            // Assigns the parameters to the command
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.String, strFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.String, strToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, strEmpName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, strLevelID);
            db_Con.AddInParameter(dbcmd, "@empId", DbType.String, strEmpId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, iEmpCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, iEmpType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, strGradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, iEmpAutoID);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int16, designation);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, gender);
            db_Con.LoadDataSet(dbcmd, dsWorkHrs, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsWorkHrs;
    }
    /// <summary>
    /// Angler Specific Report  - Daily Deviation Report
    /// </summary>
    /// <param name="dtFromDate"></param>
    /// <param name="dtToDate"></param>
    /// <param name="empName"></param>
    /// <param name="levelId"></param>
    /// <param name="EmployeeId"></param>
    /// <param name="employeeCategory"></param>
    /// <param name="employeeType"></param>
    /// <param name="UserGroupName"></param>
    /// <param name="GradeLevel"></param>
    /// <param name="strSwipeCard"></param>
    /// <param name="EmpAutoID"></param>
    /// <param name="ParentLevelId"></param>
    /// <param name="DesignationID"></param>
    /// <param name="Gender"></param>
    /// <returns></returns>
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectDailyDeviationReport(string dtFromDate, string dtToDate, string empName, string levelId, string EmployeeId, int employeeCategory, int employeeType, string UserGroupName, string GradeLevel, string strSwipeCard, Int64 EmpAutoID, int ParentLevelId, int DesignationID, string Gender, Int16 Export)
    {
        DataSet ds_DailyDeviation = new DataSet();
        try
        {
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptDailyDeviation");
            dbcmd.CommandTimeout = 0;
            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDat", DbType.DateTime, dtToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, empName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@EmployeeId", DbType.String, EmployeeId);
            db_Con.AddInParameter(dbcmd, "@employeeCategory", DbType.Int32, employeeCategory);
            db_Con.AddInParameter(dbcmd, "@employeeType", DbType.Int32, employeeType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, UserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, GradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@ParentID", DbType.Int64, ParentLevelId);
            db_Con.AddInParameter(dbcmd, "@DesignationID", DbType.Int16, DesignationID);
            db_Con.AddInParameter(dbcmd, "@Gender", DbType.String, Gender);
            db_Con.AddInParameter(dbcmd, "@Export", DbType.Int16, Export);
            db_Con.LoadDataSet(dbcmd, ds_DailyDeviation, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_DailyDeviation;
    }
    /// <summary>
    /// Angler Specific Report - ARMIS & Cumulative Work Hours Deviation Report
    /// </summary>
    /// <param name="strEmpId"></param>
    /// <param name="strLevelID"></param>
    /// <param name="strFromDate"></param>
    /// <param name="strToDate"></param>
    /// <param name="strEmpName"></param>
    /// <param name="iEmpCategory"></param>
    /// <param name="iEmpType"></param>
    /// <param name="strUserGroupName"></param>
    /// <param name="strGradeLevel"></param>
    /// <param name="strSwipeCard"></param>
    /// <param name="iEmpAutoID"></param>
    /// <param name="iDeviation"></param>
    /// <param name="ParentId"></param>
    /// <returns></returns>
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMonthlyDeviationHrs(string strEmpId, string strLevelID, string strFromDate, string strToDate, string strEmpName, int iEmpCategory, int iEmpType, string strUserGroupName, string strGradeLevel, string strSwipeCard, int iEmpAutoID, int iDeviation, int ParentId)
    {
        DataSet dsWorkHrs = new DataSet();
        try
        {
            if (strEmpName == null)
                strEmpName = "";
            DbCommand dbcmd;
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptMonthlyDeviationHrs");
            dbcmd.CommandTimeout = 0;
            // Assigns the parameters to the command
            db_Con.AddInParameter(dbcmd, "@FromDate", DbType.String, strFromDate);
            db_Con.AddInParameter(dbcmd, "@ToDate", DbType.String, strToDate);
            db_Con.AddInParameter(dbcmd, "@EmployeeName", DbType.String, strEmpName);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, strLevelID);
            db_Con.AddInParameter(dbcmd, "@EmployeeID", DbType.String, strEmpId);
            db_Con.AddInParameter(dbcmd, "@EmployeeCategory", DbType.Int32, iEmpCategory);
            db_Con.AddInParameter(dbcmd, "@EmployeeType", DbType.Int32, iEmpType);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.AddInParameter(dbcmd, "@GradeLevel", DbType.String, strGradeLevel);
            db_Con.AddInParameter(dbcmd, "@EmpSwipeCard", DbType.String, strSwipeCard);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, iEmpAutoID);
            db_Con.AddInParameter(dbcmd, "@Deviation", DbType.Boolean, Convert.ToBoolean(iDeviation));
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.LoadDataSet(dbcmd, dsWorkHrs, "Table");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsWorkHrs;
    }

    public DataSet SelectLeaveAnalysis(string dtFromDate, string dtToDate, string empId, string empName, string levId, string UserGroupName, string GradeLevel, string strLeavePlanned, string strLeaveWI, string strLeaveWOI, Int64 EmpAutoID)
    {
        DataSet dsLeaveAnalysis = new DataSet();
        try
        {
            //dsLeaveAnalysis = db_Con.ExecuteDataSet("Proc_TA_RptLeaveAnalysis", new object[] { dtFromDate, dtToDate, empId, empName, levId, UserGroupName, GradeLevel, strLeavePlanned, strLeaveWI, strLeaveWOI, EmpAutoID });
            DbCommand dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptLeaveAnalysis", new object[] { dtFromDate, dtToDate, empId, empName, levId, UserGroupName, GradeLevel, strLeavePlanned, strLeaveWI, strLeaveWOI, EmpAutoID });
            dbcmd.CommandTimeout = 0;
            dsLeaveAnalysis = db_Con.ExecuteDataSet(dbcmd);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsLeaveAnalysis;
    }
    public void InsertLeaveAnalysisNotes(string Notes, string strEntryDate, string iEmpID)
    {
        DbCommand dbcmd;
        try
        {
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_InsertLeaveAnalysisNotes", new object[] { Notes, strEntryDate, iEmpID });
            //dbcmd.CommandTimeout = 0;
            //db_Con.AddInParameter(dbcmd, "@Notes", DbType.String, Notes);
            //db_Con.AddInParameter(dbcmd, "@iDate", DbType.DateTime, strEntryDate);
            //db_Con.AddInParameter(dbcmd, "@EmpID", DbType.String, iEmpID);
            db_Con.ExecuteNonQuery(dbcmd);
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public void UpdateLeaveAnalysisNotes(string strOpr, int Id, string Notes, string iEmpID, string DateIns)
    {

        DbCommand dbcmd;
        try
        {
            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_UpdateLeaveAnalysisNotes", new object[] { strOpr, Id, Notes, iEmpID });
            //dbcmd.CommandTimeout = 0;
            //db_Con.AddInParameter(dbcmd, "@Opr", DbType.String, strOpr);
            //db_Con.AddInParameter(dbcmd, "@ID", DbType.Int16, Id);
            //db_Con.AddInParameter(dbcmd, "@Notes", DbType.String, Notes);
            //db_Con.AddInParameter(dbcmd, "@EmpID", DbType.String, iEmpID);
            db_Con.ExecuteNonQuery(dbcmd);
        }
        catch (Exception ex)
        {
            throw ex;
        }

    }

    //Report header
    //[DataObjectMethod(DataObjectMethodType.Select, true)]
    //public DataSet getHeader(int id)
    //{
    //    DataSet dsHead = new DataSet();

    //    try
    //    {
    //        DbCommand dbcmd;

    //        dbcmd = db_Con.GetStoredProcCommand("Proc_TA_Rpt_header");
    //        dbcmd.CommandTimeout = 0;

    //        //Sets the Cultural Information
    //        //ds_MovEntry.Locale = CultureInfo.InvariantCulture;

    //        // Assigns the parameters to the command

    //        db_Con.AddInParameter(dbcmd, "@id", DbType.Int32, id);

    //        db_Con.LoadDataSet(dbcmd, dsHead, "Table");

    //        // dsHead = db_Con.ExecuteDataSet("Proc_TA_Rpt_header", new object[] { id });
    //    }
    //    catch (Exception Ex)
    //    {
    //        throw Ex;
    //    }

    //    return dsHead;
    //}

    public DataSet SelectLeaveAnalysisNotes(string strDate)
    {
        DataSet ds = new DataSet();
        DbCommand dbcmd;

        dbcmd = db_Con.GetStoredProcCommand("Proc_TA_SelectLeaveAnalysisNotes");
        dbcmd.CommandTimeout = 0;
        db_Con.AddInParameter(dbcmd, "@fromDate", DbType.DateTime, strDate);
        db_Con.LoadDataSet(dbcmd, ds, "Table");
        return ds;
    }
    //Leave Permission Daily Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLeavePermissionDailyReport_Leaves(string dtFromDate, string levelId, string IntimationType, Int64 EmpAutoID, Int64 ReportingTo, Int64 SanctioningAuthority, int ParentId, string strUserGroupName)
    {
        DataSet dsDailyLeave = new DataSet();

        try
        {
            DbCommand dbcmd;

            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptDailyLeaves");
            dbcmd.CommandTimeout = 0;

            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@IntimationType", DbType.String, IntimationType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@ReportingTo", DbType.Int64, ReportingTo);
            db_Con.AddInParameter(dbcmd, "@SanctioningAuthority", DbType.Int64, SanctioningAuthority);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.LoadDataSet(dbcmd, dsDailyLeave, "Table");

        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsDailyLeave;
    }


    //Leave Permission Daily Report
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectLeavePermissionDailyReport_Permission(string dtFromDate, string levelId, string strType, Int64 EmpAutoID, Int64 ReportingTo, Int64 SanctioningAuthority, int ParentId, string strUserGroupName)
    {
        DataSet dsDailyPermission = new DataSet();

        try
        {
            DbCommand dbcmd;

            dbcmd = db_Con.GetStoredProcCommand("Proc_TA_RptDailyPermission");
            dbcmd.CommandTimeout = 0;

            db_Con.AddInParameter(dbcmd, "@fromDat", DbType.DateTime, dtFromDate);
            db_Con.AddInParameter(dbcmd, "@LevelID", DbType.String, levelId);
            db_Con.AddInParameter(dbcmd, "@Type", DbType.String, strType);
            db_Con.AddInParameter(dbcmd, "@EmpAutoId", DbType.Int64, EmpAutoID);
            db_Con.AddInParameter(dbcmd, "@ReportingTo", DbType.String, ReportingTo);
            db_Con.AddInParameter(dbcmd, "@SanctioningAuthority", DbType.String, SanctioningAuthority);
            db_Con.AddInParameter(dbcmd, "@ParentId", DbType.Int16, ParentId);
            db_Con.AddInParameter(dbcmd, "@UserGroupName", DbType.String, strUserGroupName);
            db_Con.LoadDataSet(dbcmd, dsDailyPermission, "Table");

        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return dsDailyPermission;
    }
}
