using System;
using System.Collections;
using System.Data;
using DataAccessLayer;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for AuditTrailEventData
/// </summary>
public class AuditTrailEventData
{
    DataAccess objDataAccess = new DataAccess();
    Hashtable htable = new Hashtable();
    public DataSet SelectAllTableNames()
    {
        DataSet dsTable = new DataSet();
        try
        {
            dsTable = objDataAccess.ExecuteDataSet("Proc_TA_SelectAllTableNames");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsTable;
    }
    public DataSet SelectAllColumnNames(Decimal tableId)
    {
        DataSet dsColumn = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@tableId", tableId);
            dsColumn = objDataAccess.GetStoredProcCommand("Proc_TA_SelectAllColumnNames", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsColumn;
    }
    public DataSet InsertAuditTable(string tableName, string tableDescription, bool tableStatus)
    {
        DataSet dsAuditTable = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@tableName", tableName);
            htable.Add("@tableDescription", tableDescription);
            htable.Add("@tableStatus", tableStatus);
            dsAuditTable = objDataAccess.GetStoredProcCommand("Proc_TA_InserAuditTable", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsAuditTable;
    }
    public void InsertAuditField(decimal tableId, string fieldName, string fieldDescription, bool insertBitStatus, bool updateBitStatus, bool deleteBitStatus, bool fieldStatus)
    {
        try
        {
            htable.Clear();
            htable.Add("@tableId", tableId);
            htable.Add("@fieldName", fieldName);
            htable.Add("@fieldDescription", fieldDescription);
            htable.Add("@insertBitStatus", insertBitStatus);
            htable.Add("@updateBitStatus", updateBitStatus);
            htable.Add("@deleteBitStatus", deleteBitStatus);
            htable.Add("@fieldStatus", fieldStatus);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_InsertAuditField");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void TriggerCreation(string tableName, string insertFields, string updateFields, string deleteFields)
    {
        try
        {
            htable.Clear();
            htable.Add("@tableName", tableName);
            htable.Add("@InsertFields", insertFields);
            htable.Add("@UpdateFields", updateFields);
            htable.Add("@DeleteFields", deleteFields);
            objDataAccess.GetStoredProcCommand(htable, "Proc_TA_CreateTrigger");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public bool IsAuditTrailBeforeSaved()
    {
        int auditTrailCount;
        bool isAuditTrailSaved = false;
        try
        {
            auditTrailCount = Convert.ToInt32(objDataAccess.ExecuteScaler("Proc_TA_IsAuditTrailSaved"));
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        if (auditTrailCount > 0)
        {
            isAuditTrailSaved = true;
        }
        else
        {
            isAuditTrailSaved = false;
        }
        return isAuditTrailSaved;
    }
    public DataSet SelectAllAuditTableNames()
    {
        DataSet dsTable = new DataSet();
        try
        {
            dsTable = objDataAccess.ExecuteDataSet("Proc_TA_SelectAllAuditTableNames");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsTable;
    }
    public DataSet SelectAllAuditColumnNames(Decimal tableId)
    {
        DataSet dsColumn = new DataSet();
        try
        {
            htable.Clear();
            htable.Add("@tableId", tableId);
            dsColumn = objDataAccess.GetStoredProcCommand("Proc_TA_SelectAllAuditColumnNames", htable);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsColumn;
    }
}