using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for BonusLeave
/// </summary>
public class BonusLeave
{
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    public BonusLeave()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    public DataSet SelectBonusLeaveDetails(int EmpID, string EmployeeId, string EmployeeName, string LevelIds, int EmployeeCategory, int EmployeeType, string UserGroupName, string GradeLevel, int YearSettingsId, string strSwipeCard, int ParentId)
    {
        DataSet dsBonusLeave = new DataSet();
        try
        {
            dsBonusLeave = DBCon.ExecuteDataSet("Proc_TA_EmployeeBonusLeave", new object[] { EmpID, EmployeeId, EmployeeName, LevelIds, EmployeeCategory, EmployeeType, UserGroupName, GradeLevel, YearSettingsId, strSwipeCard, ParentId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsBonusLeave;
    }
    public DataTable SelectProcessDataBonusLeaveDetails(string EmployeeId, DateTime FromTime, DateTime ToTime)
    {
        DataSet dtBonusLeave = new DataSet();
        try
        {
            dtBonusLeave = DBCon.ExecuteDataSet("Proc_TA_EmployeeProcessBonusLeave", new object[] { EmployeeId, FromTime, ToTime });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dtBonusLeave.Tables[0];
    }
    public void InsertUpdateBonusLeave(int YearSettingId, int EmployeeId, int BonusLeaveQuota, int EmpId)
    {
        DbCommand cmdInsertUpdateBonusLeave = DBCon.GetStoredProcCommand("Proc_TA_AddUpdateEmployeeBonusLeave", new object[] { YearSettingId, EmployeeId, BonusLeaveQuota, EmpId });
        DBCon.ExecuteNonQuery(cmdInsertUpdateBonusLeave);
    }
    public void UpdateProcessFlagForBonusLeave(string employeeCodeId, string processFromDate)
    {
        DbCommand cmdUpdateProcessFlagForBonusLeave = DBCon.GetStoredProcCommand("Proc_TA_UpdateProcessFlagForBonusLeave", new object[] { employeeCodeId, processFromDate });
        DBCon.ExecuteNonQuery(cmdUpdateProcessFlagForBonusLeave);
    }
}
