using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;

/// <summary>
/// Summary description for GroupPolicyAllocationEventData
/// </summary>
public class GroupPolicyAllocationEventData
{
    Database db_Con = DatabaseFactory.CreateDatabase("DBConnection");
    public GroupPolicyAllocationEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = db_Con.DbProviderFactory;
        db_Con = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    //insert into tempShift allocation
    public void InsertEmpDetails(int EmpID, string EmployeeId, string EmpName, int loginEmployeeId, string DatetOfJoin, int LevelID)
    {
        try
        {
            DbCommand cmd_Insert = db_Con.GetStoredProcCommand("Proc_TA_InsertEmpNameGroupPolicy", new object[] { EmpID, EmployeeId, EmpName, loginEmployeeId, DatetOfJoin, LevelID });
            cmd_Insert.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //deleting all records from tempShift allocation
    public void DeleteEmpNameGroupPolicy(int loginEmployeeId)
    {
        try
        {
            DbCommand cmd_Insert = db_Con.GetStoredProcCommand("Proc_TA_DeleteEmpNameGroupPolicy", new object[] { 'A', 0, loginEmployeeId });
            cmd_Insert.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //deleting from tempShift allocation for individual Empid
    public void DeleteEmpDetails(int EmpId, int loginEmployeeId)
    {
        try
        {
            DbCommand cmd_Insert = db_Con.GetStoredProcCommand("Proc_TA_DeleteEmpNameGroupPolicy", new object[] { 'I', EmpId, loginEmployeeId });
            cmd_Insert.CommandTimeout = 0;
            db_Con.ExecuteNonQuery(cmd_Insert);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //selecting Employees for shift allocation from tempShift Allocation
    public DataSet SelectEmployeeDetails(int loginEmployeeId)
    {
        DataSet ds_EmployeeDetails = new DataSet();
        try
        {
            ds_EmployeeDetails = db_Con.ExecuteDataSet("Proc_TA_SelectDetailsGroupPolicy", new object[] { loginEmployeeId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_EmployeeDetails;
    }
    public string dsSelectPolicyAllocatedEmployeeDetails(int EmployeeAutoId)
    {
        string ExistsOrNot;
        try
        {
            ExistsOrNot = (string)db_Con.ExecuteScalar("Proc_TA_SelectPolicyAllocatedEmployeeDetails", new object[] { EmployeeAutoId });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return ExistsOrNot;
    }
}
