using System;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for MonthlyLeaveClosureEventData
/// </summary>
public class MonthlyLeaveClosureEventData
{
    public MonthlyLeaveClosureEventData()
    {
    }
    Database db = DatabaseFactory.CreateDatabase("DBConnection");
    #region SelectMonthlyLeaveMasterCloseDetails.
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMonthlyLeaveMasterCloseDetails()
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_SelectMonthlyLeaveCloseDetails", new object[] { 'A', DateTime.Now, 0 });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    #endregion
    #region SelectMonthlyLeaveMasterCloseDetails1.
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet SelectMonthlyLeaveMasterCloseDetails1(char Type, int OrganisationID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_SelectMonthlyLeaveCloseDetails", new object[] { Type, DateTime.Now, OrganisationID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    #endregion
    #region InsertMonthlyLeaveClosureMaster.
    [DataObjectMethod(DataObjectMethodType.Insert, true)]
    public void InsertMonthlyLeaveClosureMaster(int OrgLevel_Id, DateTime MonthClosure_Month, int AuditEmp_Id,
        DateTime TimeStamp, int YearSettings_Id)
    {
        DbCommand cmd_InsertMonthlyLeaveClosureMaster = db.GetStoredProcCommand("Proc_TA_Insert_MonthlyLeaveClosureMaster",
            new object[] { 'I', 0, OrgLevel_Id, MonthClosure_Month, AuditEmp_Id, TimeStamp, YearSettings_Id });
        try
        {
            cmd_InsertMonthlyLeaveClosureMaster.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_InsertMonthlyLeaveClosureMaster);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    #endregion
    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public DataSet SelectMonthlyLeaveMasterCloseDetailsByIDview(DateTime MonthCloseMonth, int LevelId)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_SelectMonthlyLeaveCloseDetails", new object[] { 'I', MonthCloseMonth, LevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    #region DeleteMonthlyLeaveClosureMaster.
    public void DeleteMonthlyLeaveClosureMaster(int MonthClosureMasterId)
    {
        DbCommand cmd_DeleteMonthlyLeaveClosureMaster = db.GetStoredProcCommand("Proc_TA_Delete_MonthlyLeaveClosureMaster", new object[] { MonthClosureMasterId });
        try
        {
            cmd_DeleteMonthlyLeaveClosureMaster.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_DeleteMonthlyLeaveClosureMaster);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    #endregion
    //select Month closure details for modify grid
    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public DataSet SelectMonthlyLeaveCloseDetailsForModify(DateTime MonthClosure_Month, string OrglLevelId, string IsMonthProcessed)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_SelectMonthlyLeaveCloseDetailsForModify", new object[] { MonthClosure_Month, OrglLevelId, IsMonthProcessed });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public int CheckMonthlyClosureMasterProcessFlag(DateTime MonthClosureMonth, int OrglLevelId)
    {
        try
        {
            int count = 0;
            DataSet dsMonthClosureProcessFlag = new DataSet();
            dsMonthClosureProcessFlag = db.ExecuteDataSet("Proc_TA_CheckMonthlyClosureMasterProcessFlag", new object[] { MonthClosureMonth, OrglLevelId });
            if (dsMonthClosureProcessFlag.Tables[0].Rows.Count > 0)
            {
                count = 1;
            }
            return count;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    [DataObjectMethod(DataObjectMethodType.Delete, true)]
    public void DeleteMonthlyClosureMasterDetails(string MonthCloseID, int EmpAutoId)
    {
        try
        {
            DbCommand cmd_DeleteMonthlyClosureMasterDetails = db.GetStoredProcCommand("Proc_TA_DeleteMonthlyClosureMasterDetails", new object[] { MonthCloseID, EmpAutoId });
            cmd_DeleteMonthlyClosureMasterDetails.CommandTimeout = 0;
            db.ExecuteNonQuery(cmd_DeleteMonthlyClosureMasterDetails);
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public void UpdateMonthlyClosureModify(int MonthlyClosureId, float CarryPrevMonth, float CurrentQuota,
     float LeaveTaken, float AvailableLeave, float Encashment)
    {
        DbCommand cmdUpdateMonthlyClosureModify = db.GetStoredProcCommand("Proc_TA_UpdateYMonthlyClosureModify",
            new object[] { MonthlyClosureId, CarryPrevMonth, CurrentQuota,LeaveTaken, 
                AvailableLeave, Encashment });
        try
        {
            cmdUpdateMonthlyClosureModify.CommandTimeout = 0;
            db.ExecuteNonQuery(cmdUpdateMonthlyClosureModify);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public float GetAvailableCount(int EmployeeId, int LeaveTypeId, float CarryPrev)
    {
        float count = 0;
        try
        {
            DbCommand dbGetAvailableCount = db.GetStoredProcCommand("Proc_TA_CheckCarryPrevMonth", new object[] { EmployeeId, LeaveTypeId, CarryPrev });
            dbGetAvailableCount.CommandTimeout = 0;

            count = Convert.ToSingle(db.ExecuteScalar(dbGetAvailableCount));
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return count;
    }
    #region selectMonthClosuredetails.
    public DataSet selectMonthClosuredetails(int YearSettingID, string LevelID, DateTime MonthClosureMonth)
    {
        DataSet ds_Monthclosure = new DataSet();
        try
        {
            ds_Monthclosure = db.ExecuteDataSet("Proc_TA_SelectMonthlyClosuredetails", new object[] { YearSettingID, LevelID, MonthClosureMonth });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Monthclosure;
    }
    #endregion
    public DataSet selectLeavedetails_Monthclosure(int EmpID, int YearSettingID, DateTime ClosingMonth)
    {
        DataSet ds_Monthclosure = new DataSet();
        try
        {
            ds_Monthclosure = db.ExecuteDataSet("Proc_TA_SelectLeaveDetails_MonthClosure", new object[] { EmpID, YearSettingID, ClosingMonth });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_Monthclosure;
    }
    //update year closure
    public void updateMonthlyLeaveClosure(int LevelID, int EmpID, int YearID, int LeaveID, float availLeave, int EmployeeID, DateTime ClosedMonth)
    {
        DbCommand cmdUpdateMonthlyLeaveClosure = db.GetStoredProcCommand("Proc_TA_UpdateMonthlyLeaveClosure", new object[] { LevelID, EmpID, YearID, LeaveID, availLeave, EmployeeID, ClosedMonth });
        try
        {
            cmdUpdateMonthlyLeaveClosure.CommandTimeout = 0;
            db.ExecuteNonQuery(cmdUpdateMonthlyLeaveClosure);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    //insert new entry after Year closure
    public void InsertDataAfterMlonthlyLeaveClosure(int YearsettingID, int OrgLevelId, int EmployeeID, int LeaveTypeID, float CarryPrevMonth, float CurrentQuota, float AvailableLeaves, int AuditEmpID, DateTime MonthClosureMonth, float Encashment, float LeaveTaken)
    {
        DbCommand cmdInsertDataAfterMlonthlyLeaveClosure = db.GetStoredProcCommand("Proc_TA_InsertDataAfterMlonthlyLeaveClosure", new object[] { YearsettingID, OrgLevelId, EmployeeID, LeaveTypeID, CarryPrevMonth, CurrentQuota, AvailableLeaves, AuditEmpID, MonthClosureMonth, Encashment, LeaveTaken });
        try
        {
            cmdInsertDataAfterMlonthlyLeaveClosure.CommandTimeout = 0;
            db.ExecuteNonQuery(cmdInsertDataAfterMlonthlyLeaveClosure);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public DataSet GetNextMonthQuota(int EmployeeID, int? LeaveTypeID, DateTime NextMonth)
    {
        DataSet ds_NextMonthQuota = new DataSet();
        try
        {
            ds_NextMonthQuota = db.ExecuteDataSet("Proc_Ta_GetNextMonthQuota", new object[] { EmployeeID, LeaveTypeID, NextMonth });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_NextMonthQuota;
    }
    public void UpdateMonthlyLeaveClosureMaster_ProcessFlag(DateTime ClosedMonth, int OrgLevelId)
    {
        try
        {
            db.ExecuteDataSet("Proc_TA_UpdateMonthlyLeaveClosureMaster_ProcessFlag", new object[] { ClosedMonth, OrgLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public Single GetEmployeeWorkedDaysMonthly(string EmployeeId, string FromDate, string ToDate)
    {
        DataSet ds_EmpWorkedDays = new DataSet();
        try
        {
            ds_EmpWorkedDays = db.ExecuteDataSet("Proc_TA_GetEmployeeWorkedDays_Monthly", new object[] { EmployeeId, FromDate, ToDate });
            if (ds_EmpWorkedDays != null)
            {
                if (ds_EmpWorkedDays.Tables.Count > 0)
                {
                    if (ds_EmpWorkedDays.Tables[0].Rows.Count > 0)
                    {
                        if (ds_EmpWorkedDays.Tables[0].Rows[0]["WorkedDays"] != DBNull.Value)
                        {
                            return (Convert.ToSingle(ds_EmpWorkedDays.Tables[0].Rows[0]["WorkedDays"]));
                        }
                    }
                }
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return 0;
    }
    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public DataSet Select_MonthlyLeaveClosure(string MonthlyClosureId, string YearSettingID, string OrglLevelId, string EmployeeId, string LeaveTypeId, string MonthClosureMonth)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = db.ExecuteDataSet("Proc_TA_Select_MonthlyLeaveClosure", new object[] { MonthlyClosureId, YearSettingID, OrglLevelId, EmployeeId, LeaveTypeId, MonthClosureMonth });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public int GetLeaveDetails_MonthlyLeaveClosure(string LevelID, string ClosingMonth)
    {
        try
        {
            int count = 0;
            DbCommand dbTotalPending_ForwardLeave = db.GetStoredProcCommand("Proc_TA_GetLeaveDetails_MonthlyLeaveClosure", new object[] { LevelID, ClosingMonth });
            dbTotalPending_ForwardLeave.CommandTimeout = 0;
            count = Convert.ToInt32(db.ExecuteScalar(dbTotalPending_ForwardLeave));
            return count;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public string SelectProcessCountMonthlyClosure(int YearSettingID, string Level, DateTime ClosingMonth)
    {
        string strResult = string.Empty;
        try
        {
            DbCommand DBcmdSelectProcessCountMonthlyClosure = db.GetStoredProcCommand("Proc_TA_SelectProcessCountMonthlyClosure", new object[] { YearSettingID, Level, ClosingMonth });
            DBcmdSelectProcessCountMonthlyClosure.CommandTimeout = 0;
            strResult = Convert.ToString(db.ExecuteScalar(DBcmdSelectProcessCountMonthlyClosure));
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return strResult;
    }
    public DataSet GetCurrentLeaveQuota(int EmpID)
    {
        DataSet ds = new DataSet();
        ds = db.ExecuteDataSet("Proc_TA_GetCurrentLeaveType", new object[] { EmpID });
        return ds;
    }
    //Insert Leave Policy on Year Closure 
    public int InsertLeavePolicyMonthlyLeaveClosure(int Empid, int LpId, string from, string to, int auEmployeeid, int YearSettingId)
    {
        int Emp_LeavePolicyId = 0;
        DataSet ds = new DataSet();
        try
        {
            DbCommand cmd_InsertPolicy = db.GetStoredProcCommand("Proc_TA_InsertEmp_LeavePolicy_MonthlyLeaveClosure", new object[] { Empid, LpId, from, to, auEmployeeid, YearSettingId });
            cmd_InsertPolicy.CommandTimeout = 0;
            ds = db.ExecuteDataSet(cmd_InsertPolicy);
            if (ds != null)
            {
                if (ds.Tables.Count > 0)
                {
                    if (ds.Tables[0].Rows.Count > 0)
                    {
                        if (ds.Tables[0].Rows[0]["Emp_LeavePolicyId"] != DBNull.Value)
                        {
                            Emp_LeavePolicyId = Convert.ToInt32(ds.Tables[0].Rows[0]["Emp_LeavePolicyId"]);
                        }
                    }
                }
            }
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return Emp_LeavePolicyId;
    }
    //Select the leave policy setting details
    public DataSet SelectMaximunClosedMonth()
    {
        DataSet dsMaximunClosedMonth = new DataSet();
        try
        {
            dsMaximunClosedMonth = db.ExecuteDataSet("Proc_TA_Select_MaxClosedMonth", new object[] { null });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return dsMaximunClosedMonth;
    }
    public DataSet SelectMaximunClosedMonthForOrg(int OrgID)
    {
        DataSet dsMaximunClosedMonth = new DataSet();
        try
        {
            dsMaximunClosedMonth = db.ExecuteDataSet("Proc_TA_Select_MaxClosedMonth", new object[] { OrgID });
        }
        catch (Exception ex)
        {
            throw ex;
        }
        return dsMaximunClosedMonth;
    }
}
