using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.ComponentModel;
using System.Collections.Generic;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;

/// <summary>
/// Summary description for PermissionEventData
/// </summary>
public class PermissionEventData_Angler
{

    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    DataSet ds_PermissionDetails = new DataSet();
    DataSet ds_CheckPermissionHours = new DataSet();
    DataSet ds_PermissionByPermissionID = new DataSet();
    DataSet ds_PermissionHoursAlreadyTaken = new DataSet();
    DataSet ds_EmailIdOfSanctionAuthority = new DataSet();
    DataSet ds_EmailIdOfReportingTo = new DataSet();
    DataSet ds_CheckPermissionUpdate = new DataSet();
    DataSet ds_PermissionByPermissionId = new DataSet();
    DataSet ds_PermissionSanctionDetailsForSuperAdmin = new DataSet();
    DataSet ds_PermissionSanctionDetails = new DataSet();

    int count;


    public PermissionEventData_Angler()
    {
        //
        // TODO: Add constructor logic here
        //
        string strDecryptedString = string.Empty;

        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }

    }

    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public DataSet selectPermissionDetails(int Employee_Id, string GradeLevel, string LevelRights, string PermissionStartDate, string PermissionEndDate, string UserGroupName, int parentLevelId)
    {
        if (PermissionStartDate != "01/01/1900")
        {
            cls_Common objClassCommon = new cls_Common();
            string strDateFormat = Convert.ToString(HttpContext.Current.Session["MDateFormat"]);
            PermissionStartDate = objClassCommon.DateConvertion(strDateFormat, PermissionStartDate);
            //PermissionEndDate = objClassCommon.DateConvertion(strDateFormat, PermissionEndDate);
            if (PermissionEndDate == "01/01/1900")
            {
                PermissionEndDate = (Convert.ToDateTime(System.DateTime.Now.ToShortDateString())).ToString(HttpContext.Current.Session["MDateFormat"].ToString());
                PermissionEndDate = objClassCommon.DateConvertion(strDateFormat, PermissionEndDate);
            }
            else
            {
                PermissionEndDate = objClassCommon.DateConvertion(strDateFormat, PermissionEndDate);
            }
        }

        try
        {
            ds_PermissionDetails = DBCon.ExecuteDataSet("Proc_TA_SelectPermissionDetailsByEmpId", new object[] { Employee_Id, GradeLevel, LevelRights, PermissionStartDate, PermissionEndDate, UserGroupName, parentLevelId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PermissionDetails;
    }

    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public DataSet selectPermissionDetailsSuperAdmin(string UserGroupName, string GradeLevel, string LevelRights, string EmpCodeId, string EmpFirstName, string PermissionStartDate, string PermissionEndDate, string strSwipeCard, int parentLevelId)
    {
        if (EmpFirstName != null && EmpFirstName != "")
        {
            //EmpFirstName = EmpFirstName.Replace("%", "");
            //EmpFirstName = EmpFirstName.Replace(" ", "");
        }

        if (PermissionStartDate != "01/01/1900")
        {
            cls_Common objClassCommon = new cls_Common();
            string strDateFormat = Convert.ToString(HttpContext.Current.Session["MDateFormat"]);
            PermissionStartDate = objClassCommon.DateConvertion(strDateFormat, PermissionStartDate);
            //PermissionEndDate = objClassCommon.DateConvertion(strDateFormat, PermissionEndDate);
            if (PermissionEndDate == "01/01/1900")
            {
                PermissionEndDate = (Convert.ToDateTime(System.DateTime.Now.ToShortDateString())).ToString(HttpContext.Current.Session["MDateFormat"].ToString());
                PermissionEndDate = objClassCommon.DateConvertion(strDateFormat, PermissionEndDate);
            }
            else
            {
                PermissionEndDate = objClassCommon.DateConvertion(strDateFormat, PermissionEndDate);
            }
        }

        try
        {
            ds_PermissionDetails = DBCon.ExecuteDataSet("Proc_TA_SelectPermissionDetails", new object[] { UserGroupName, GradeLevel, LevelRights, EmpCodeId, EmpFirstName, PermissionStartDate, PermissionEndDate, strSwipeCard, parentLevelId });
            // UserGroupName, GradeLevel, LevelRights, EmpCodeId, EmpFirstName, PermissionStartDate, PermissionEndDate ,strSwipeCard,parentLevelId}
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PermissionDetails;
    }

    ///Commented below function and added after below function with permission date parameters.
    //public DataSet GetMaxNoOfHours_ByLeavePolicy(int Employee_Id)
    //{
    //    DataSet MaxNoOfHours = new DataSet();

    //    try
    //    {
    //    MaxNoOfHours = DBCon.ExecuteDataSet("Proc_TA_GetMaxPermissionHoursByLeavePolicy", new object[] { Employee_Id });
    //    }
    //    catch (Exception Ex)
    //    {
    //        throw Ex;
    //    }
    //    return MaxNoOfHours;
    //}
    public DataSet GetMaxNoOfHours_ByLeavePolicy(int Employee_Id, string PermissionDate)
    {
        DataSet MaxNoOfHours = new DataSet();

        try
        {
            MaxNoOfHours = DBCon.ExecuteDataSet("Proc_TA_GetMaxPermissionHoursByLeavePolicy", new object[] { Employee_Id, PermissionDate });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return MaxNoOfHours;
    }

    public int CheckPermissionHours(int Employee_Id, string PermissionDate, string Permission_FromTime, string Permission_EndTime)
    {
        try
        {
            ds_CheckPermissionHours = DBCon.ExecuteDataSet("Proc_TA_CheckPermissionHours", new object[] { Employee_Id, PermissionDate, Permission_FromTime, Permission_EndTime });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        count = Convert.ToInt32(ds_CheckPermissionHours.Tables[0].Rows[0]["CS"]);

        return count;
    }

    //Check permission application while update its alreaday there

    public int CheckPermissionUpdate(int Employee_Id, string PermissionDate, string Permission_FromTime, string Permission_EndTime)
    {
        try
        {
            ds_CheckPermissionUpdate = DBCon.ExecuteDataSet("Proc_TA_CheckPermissionUpdate", new object[] { Employee_Id, PermissionDate, Permission_FromTime, Permission_EndTime });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        count = Convert.ToInt32(ds_CheckPermissionUpdate.Tables[0].Rows[0]["CS"]);

        return count;
    }
    ///Added and commented by Manjula.P on 17-Apr-2014 for ANGLER DEVELOPMENT WITH strCCMail parameter
    //public DataSet InsertPermissionHours(int EmployeeID, string Permission_Date, int PermissionType_id, string Permission_FromTime, string Permission_EndTime, string Reason, string auEmpId, string YearSettings_Id, string strPermissionStatus, string NoOfHours)
    //{
    //    DataSet dsPermission = new DataSet();
    //    tryre
    //    {
    //        DbCommand cmd_InsertPermission = DBCon.GetStoredProcCommand("Proc_TA_InsertPermission", new object[] { EmployeeID, Permission_Date, PermissionType_id, Permission_FromTime, Permission_EndTime, Reason, auEmpId, YearSettings_Id, strPermissionStatus, NoOfHours });
    //        dsPermission = DBCon.ExecuteDataSet(cmd_InsertPermission);
    //    }
    //    catch (Exception Ex)
    //    {
    //        throw Ex;
    //    }
    //    return dsPermission;
    //}
    public DataSet InsertPermissionHours(int EmployeeID, string Permission_Date, int PermissionType_id, string Permission_FromTime, string Permission_EndTime, string Reason, string auEmpId, string YearSettings_Id, string strPermissionStatus, string strCcMail, string strPerHours)
    {
        try
        {
            ds_PermissionDetails = DBCon.ExecuteDataSet("Proc_TA_InsertPermission", new object[] { EmployeeID, Permission_Date, PermissionType_id, Permission_FromTime, Permission_EndTime, Reason, auEmpId, YearSettings_Id, strPermissionStatus, strCcMail, strPerHours });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds_PermissionDetails;
    }

    //Get Permission Details of a Particular permission Using permission Id

    public DataSet SelectLeavePermissionByPermissionId(int Permission_Id)
    {
        try
        {
            //ds_PermissionByPermissionID = DBCon.ExecuteDataSet("Proc_TA_SelectPermissionDetailsByPermissionId", new object[] { Permission_Id });
            ds_PermissionByPermissionID = DBCon.ExecuteDataSet("Proc_TA_GetPermissionByPermissionId", new object[] { Permission_Id });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PermissionByPermissionID;
    }
    //Commented and added the below functions with extra parameters for ANGLER DEVELOPMENT by Manjula.P on 17-Apr-2014
    //Update Permission Application Details
    //public void EditPermissionApplication(int Permission_Id, int PermissionType_id, string PermissionDate, string Permission_FromTime, string Permission_EndTime, string Reason, string auEmpId, string NumberOfHours)
    //{
    //    DbCommand cmd_editPermissionApplication = DBCon.GetStoredProcCommand("Proc_TA_UpdatePermissionApplication", new object[] { Permission_Id, PermissionType_id, PermissionDate, Permission_FromTime, Permission_EndTime, Reason, auEmpId, NumberOfHours });

    //    try
    //    {
    //        DBCon.ExecuteNonQuery(cmd_editPermissionApplication);
    //    }
    //    catch (Exception Ex)
    //    {
    //        throw Ex;
    //    }
    //}
    public DataSet EditPermissionApplication(int Permission_Id, int PermissionType_id, string PermissionDate, string Permission_FromTime, string Permission_EndTime, string Reason, string auEmpId, string status, string strCCMail, string strPerHours, string YearSettingId)
    {
        try
        {
            ds_PermissionDetails = DBCon.ExecuteDataSet("Proc_TA_UpdatePermissionApplication", new object[] { Permission_Id, PermissionType_id, PermissionDate, Permission_FromTime, Permission_EndTime, Reason, auEmpId, status, strCCMail, strPerHours, YearSettingId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds_PermissionDetails;
    }
    //delete Permission Application Details

    public void Delete_PermissionApplication(int Permission_Id, int auEmpId)
    {
        DbCommand cmd_deletePermissionApplication = DBCon.GetStoredProcCommand("Proc_TA_DeletePermissionApplication", new object[] { Permission_Id, auEmpId });

        try
        {
            DBCon.ExecuteNonQuery(cmd_deletePermissionApplication);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }



    public DataSet GetHoursAlreadyTaken(int Employee_Id, DateTime permissionDate)
    {

        try
        {
            ds_PermissionHoursAlreadyTaken = DBCon.ExecuteDataSet("Proc_TA_GetPermissionHoursAlreadyTaken", new object[] { Employee_Id, permissionDate });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PermissionHoursAlreadyTaken;

    }

    public DataSet SelectMailIdOfSanctionAuthority(int Employee_Id)
    {
        try
        {
            ds_EmailIdOfSanctionAuthority = DBCon.ExecuteDataSet("Proc_TA_SelectEmailOfSanctionAuthorityByEmpId", new object[] { Employee_Id });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_EmailIdOfSanctionAuthority;
    }
    public DataSet SelectMailIdOfReportingTo(int Employee_Id)
    {
        try
        {
            ds_EmailIdOfReportingTo = DBCon.ExecuteDataSet("Proc_TA_SelectEmailOfReportingToByEmpId", new object[] { Employee_Id });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_EmailIdOfReportingTo;
    }

    //Get Permission By PermissionId

    public DataTable GetPermissionByPermissionId(int Permission_Id)
    {
        DataSet ds_PermissionByPermissionId = new DataSet();

        try
        {
            ds_PermissionByPermissionId = DBCon.ExecuteDataSet("Proc_TA_GetPermissionByPermissionId", new object[] { Permission_Id });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds_PermissionByPermissionId.Tables[0];
    }

    //Update Permission Sanction Details 

    public void UpdatePermissionSanction(int Permission_Id, string Status, string Remarks, int auEmpId)
    {
        DbCommand cmd_UpdatePermissionSanction = DBCon.GetStoredProcCommand("Proc_TA_UpdatePermissionSanction", new object[] { Permission_Id, Status, Remarks, auEmpId });

        try
        {
            DBCon.ExecuteNonQuery(cmd_UpdatePermissionSanction);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }

    //Get Permission Sanction Details For Super Admin
    public DataTable GetPermissionSanctionDetailsForSuperAdmin(string LevelId, string Status, DateTime From_Date, DateTime To_Date, string strSwipeCardNo, string strEmployeeName, string strEmployeeCodeId, string UserGroupName, int ParentId)
    {
        if (strEmployeeName != null && strEmployeeName != "")
        {
            //strEmployeeName = strEmployeeName.Replace("%", "");
            //strEmployeeName = strEmployeeName.Replace(" ", "");
        }
        try
        {
            ds_PermissionSanctionDetailsForSuperAdmin = DBCon.ExecuteDataSet("Proc_TA_GetPermissionSanctionDetailsForSuperAdmin_Angler", new object[] { LevelId.ToString(), Status, From_Date, To_Date, 0, strSwipeCardNo, strEmployeeName, strEmployeeCodeId, UserGroupName, ParentId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_PermissionSanctionDetailsForSuperAdmin.Tables[0];
    }

    //Get Permission Sanction Details For Super Admin
    public DataTable GetPermissionSanctionDetails(int Employee_Id, string LevelId, string Status, DateTime From_Date, DateTime To_Date, string strSwipeCardNo, string strEmployeeName, string strEmployeeCodeId, string UserGroupName, int ParentId)
    {
        try
        {
            ds_PermissionSanctionDetails = DBCon.ExecuteDataSet("Proc_TA_GetPermissionSanctionDetails_Angler", new object[] { Employee_Id, LevelId, Status, From_Date, To_Date, 0, strSwipeCardNo, strEmployeeName, strEmployeeCodeId, UserGroupName, ParentId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds_PermissionSanctionDetails.Tables[0];
    }

    //Check Permission Before, After or on Leave Days

    public DataSet CheckPermissionBeforeAfterWithLeave(string PermissionFromDate, string PermissionToDate, string PermissionType, int EmployeeId)//, string Shiftdate
    {
        try
        {
            ds_CheckPermissionHours = DBCon.ExecuteDataSet("Proc_TA_CheckPermissionBeforeAfterWithLeave", new object[] { PermissionFromDate, PermissionToDate, PermissionType, EmployeeId });//, Shiftdate 
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        // count = Convert.ToInt16(ds_CheckPermissionHours.Tables[0].Rows[0]["LeaveCount"]);

        return ds_CheckPermissionHours;
    }

    public DataSet GetShiftID(string EmployeeID, int iyear, int imonth, int idate)
    {
        DataSet ds = new DataSet();

        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_SelectShiftId", new object[] { EmployeeID, iyear, imonth, idate });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }

    public DataSet GetShiftTime(int ShiftID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckShiftTime", new object[] { ShiftID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    public DataSet GetEmployeeCodeID(int EmployeeID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_GetEmployeeCodeID", new object[] { EmployeeID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds;
    }
    /// <summary>
    /// Added by Manjula.P on 17-Apr-2014 for ANGLER DEVELOPMENT
    /// </summary>
    /// <param name="permissionApplicationId"></param>
    /// <returns></returns>
    public DataSet GetPermissionConversation(int permissionApplicationId)
    {
        DataSet ds_PermissionConversation = new DataSet();
        try
        {
            ds_PermissionConversation = DBCon.ExecuteDataSet("Proc_TA_GetPermissionConversation", new object[] { permissionApplicationId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds_PermissionConversation;
    }
    /// <summary>
    /// Added by Manjula.P on 17-Apr-2014 for ANGLER DEVELOPMENT 
    /// </summary>
    /// <param name="PermissionApplicationId"></param>
    /// <param name="status"></param>
    /// <param name="commentsBy"></param>
    /// <param name="remarks"></param>
    /// <param name="empAutoId"></param>
    public void UpdatePermissionApplicationConversation(int PermissionApplicationId, string status, int commentsBy, string remarks, int empAutoId)
    {
        try
        {
            DbCommand cmd_UpdateLeaveApplicationConversation = DBCon.GetStoredProcCommand("Proc_TA_UpdatePermissionApplicationConversation", new object[] { PermissionApplicationId, status, commentsBy, remarks, empAutoId });
            DBCon.ExecuteNonQuery(cmd_UpdateLeaveApplicationConversation);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    /// <summary>
    /// Added by Manjula.P on 25-Apr-2014 for getting report authority for migrating from PRODUCT to ANGLER
    /// </summary>
    /// <param name="iEmpID"></param>
    /// <returns></returns>
    public DataSet CheckReportingPerson(int iEmpID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckReportingPerson", new object[] { iEmpID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds;
    }
    /// <summary>
    /// Added by Manjula.P on 25-Apr-2014 for getting sanction authority for migrating from PRODUCT to ANGLER
    /// </summary>
    /// <param name="iEmpID"></param>
    /// <returns></returns>
    public DataSet CheckSanctioningPerson(int iEmpID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckSanctioningPerson", new object[] { iEmpID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds;
    }

    /// <summary>
    /// Added by Gopinath on 13-Jun-2014 for getting Forwarding authority for OD application
    /// </summary>
    /// <param name="iEmpID"></param>
    /// <returns></returns>
    public DataSet CheckODForwardingPerson(int iEmpID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckLeaveForwardingPerson", new object[] { iEmpID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds;
    }

    /// <summary>
    /// Added by Gopinath on 13-Jun-2014 for getting Approval authority for OD application
    /// </summary>
    /// <param name="iEmpID"></param>
    /// <returns></returns>
    public DataSet CheckODApprovalPerson(int iEmpID)
    {
        DataSet ds = new DataSet();
        try
        {
            ds = DBCon.ExecuteDataSet("Proc_TA_CheckLeaveSanctioningPerson", new object[] { iEmpID });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }

        return ds;
    }
}
