using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for ShiftExchangeEventData
/// </summary>
public class ShiftExchangeEventData
{
    int ShiftId;
    string ShiftName;
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    DataSet ds_ShiftId, ds_ShiftName;
    public int SelectShiftId(string Employeecode, string year, string month, string date)
    {
        try
        {
            ds_ShiftId = DBCon.ExecuteDataSet("Proc_TA_SelectShiftId", new object[] { Employeecode, year, month, date });
            ShiftId = Convert.ToInt32(ds_ShiftId.Tables[0].Rows[0][0]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ShiftId;
    }
    public DataSet SelectShiftId_Group(string year, string month, string date, string XMLData)
    {
        try
        {
            ds_ShiftId = DBCon.ExecuteDataSet("Proc_TA_SelectShiftId_Group", new object[] { year, month, date, XMLData });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftId;
    }
    public DataTable SelectPermanentShiftId(string Employeecode, string year, string month, string date)
    {
        try
        {
            ds_ShiftId = DBCon.ExecuteDataSet("Proc_TA_SelectShiftId", new object[] { Employeecode, year, month, date });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftId.Tables[0];
    }
    public int CheckShiftExchangeEmployee(string level, string EmployeeId)
    {
        int count;
        DataSet dsEmployee = new DataSet();
        try
        {
            dsEmployee = DBCon.ExecuteDataSet("Proc_TA_CheckShiftExchangeEmployee", new object[] { level, EmployeeId });
            count = Convert.ToInt32(dsEmployee.Tables[0].Rows[0][0]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return count;
    }
    public DataSet SelectShiftExchangeDetails(int EmpID, string mode, string fromdate, string todate, string UserGroupName, string GradeLevel, string LevelRights, int ParentId)
    {
        DataSet dsShiftExchange = new DataSet();
        try
        {
            dsShiftExchange = DBCon.ExecuteDataSet("Proc_TA_GetShiftExchangeDetails", new object[] { EmpID, mode, fromdate, todate, UserGroupName, GradeLevel, LevelRights, ParentId });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return dsShiftExchange;
    }
    public DataTable SelectTemporaryShiftId(string Employeecode, string year, string month, string date)
    {
        try
        {
            ds_ShiftId = DBCon.ExecuteDataSet("Proc_TA_SelectTemporaryShiftId", new object[] { Employeecode, year, month, date });
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ds_ShiftId.Tables[0];
    }
    public string SelectShiftName(int ShiftId)
    {
        try
        {
            ds_ShiftName = DBCon.ExecuteDataSet("Proc_TA_SelectEmployeeShift", new object[] { ShiftId });
            ShiftName = Convert.ToString(ds_ShiftName.Tables[0].Rows[0][0]);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        return ShiftName;
    }
    //update Temporary shift allocation for shift exchange
    public void UpdateTempShift_ShiftExch(int EmployeeID, int Shift, int date, int month, int year, int EmpId, string Timestamp, string Dateshift)
    {
        try
        {
            DbCommand cmdUpdateTempShift = DBCon.GetStoredProcCommand("Proc_TA_UpdateTempShiftAlloc", new object[] { EmployeeID, Shift, date, month, year, EmpId, Timestamp, Dateshift });
            cmdUpdateTempShift.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmdUpdateTempShift);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void InsertEmployeeShiftExchange(int levelId, string date, int Employee1ID, int Employee1ActualShift, int Employee2ID, int Employee2ActualShift, int EmpId, string TimeStamp, int YearSettingsId)
    {
        try
        {
            DbCommand cmdInsertShiftExchange = DBCon.GetStoredProcCommand("Proc_TA_InsertShiftExchange", new object[] { levelId, date, Employee1ID, Employee1ActualShift, Employee2ID, Employee2ActualShift, EmpId, TimeStamp, YearSettingsId });
            cmdInsertShiftExchange.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmdInsertShiftExchange);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public void Delete_EmployeeDetails()
    {
        try
        {
            DbCommand cmd_Delete = DBCon.GetSqlStringCommand("DELETE FROM TA_Tbl_TempShiftExchange");
            cmd_Delete.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd_Delete);
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
    }
    public string GetEmployeeCode()
    {
        DataSet ds_EmpCode = new DataSet();
        string EmployeeCode = "";
        try
        {
            ds_EmpCode = DBCon.ExecuteDataSet(CommandType.Text, "SELECT EmployeeId FROM TA_Tbl_TempShiftExchange");
        }
        catch (Exception Ex)
        {
            throw Ex;
        }
        if (ds_EmpCode.Tables[0].Rows.Count > 0)
        {
            EmployeeCode = Convert.ToString(ds_EmpCode.Tables[0].Rows[0][0]);
        }
        return EmployeeCode;
    }
    public ShiftExchangeEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString == string.Empty)
        {
        }
        else
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
