using System;
using System.Data;
using System.Data.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
/// <summary>
/// Summary description for SwipesHandlingEventData
/// </summary>
public class SwipesHandlingEventData
{
    Database DBCon = DatabaseFactory.CreateDatabase("DBConnection");
    public DataSet SelectPunches(int EmpAutoID, string EmployeeID, string EmployeeName, int employeeCategory, int employeeType, string FromDate, string ToDate, string SwipesType, string VoidUnVoid, string LevelID, string strSwipeCard, string UserGroupName, int ParentId)
    {
        DataSet ds = new DataSet();
        try
        {
            DbCommand cmd = DBCon.GetStoredProcCommand("Proc_TA_SelectSwipesHandling", new object[] { EmpAutoID, EmployeeID, EmployeeName, employeeCategory, employeeType, FromDate, ToDate, SwipesType, VoidUnVoid, LevelID, strSwipeCard, UserGroupName, ParentId });
            cmd.CommandTimeout = 0;
            ds = DBCon.ExecuteDataSet(cmd);
            return ds;
        }
        catch (Exception ex)
        {
            throw ex;
        }        
    }
    public void UpdateSwipes(int ClkID, string opr)
    {
        try
        {
            DBCon.ExecuteNonQuery("Proc_TA_UpdateVoidUnVoid", new object[] { ClkID, opr });
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public void UpdateSwipes_Group(string opr, string XMLData)
    {
        try
        {
            DbCommand cmd = DBCon.GetStoredProcCommand("Proc_TA_UpdateVoidUnVoid_Group", new object[] { opr, XMLData });
            cmd.CommandTimeout = 0;
            DBCon.ExecuteNonQuery(cmd);
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    public SwipesHandlingEventData()
    {
        string strDecryptedString = string.Empty;
        strDecryptedString = Cryptographys.Cryptography.GetDecryptedConnectionString();
        if (strDecryptedString != string.Empty)
        {
            ResetDatabaseConnection(strDecryptedString);
        }
    }
    public void ResetDatabaseConnection(string strDecryptedString)
    {
        DbProviderFactory objData = DBCon.DbProviderFactory;
        DBCon = new Microsoft.Practices.EnterpriseLibrary.Data.Sql.SqlDatabase(strDecryptedString);
    }
}
