using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Diagnostics;
using System.ServiceProcess;
using System.Text;
using System.Timers;
using System.IO;
using System.Configuration;
using System.Collections;
using System.Threading;
using System.Globalization;
namespace TimecheckDataProcess
{
    public partial class TimeCheckDataProcessService : ServiceBase
    {
        #region VariableDeclaration
        DataFunction objDatafunction = new DataFunction();
        //DateTime gdtmMonthClosureEndDate = new DateTime();
        public System.Timers.Timer timer;
        //string gstrSQLCompany, 
        string gstrCompanyId;
        string gstrDefaultMonthClosureDate = string.Empty;
        int gintCompanyId = 0;
        string gStrOverTimeStatus = string.Empty;
        DataTable dtPermission = new DataTable();
        DataTable dtPermissionEndtime = new DataTable();
        DataTable dtPermissionEndtimeFlexi1 = new DataTable();
        DataTable dtPermissionEndtimeFlexi2 = new DataTable();
        DataTable dtPermissionEndtimeFlexi3 = new DataTable();
        DateTime dtmPermissionFromDateTime = new DateTime();
        DateTime dtmPermissionToDateTime = new DateTime();
        string strLeaveDay = string.Empty;
        #endregion
        #region InitializeComponent
        public TimeCheckDataProcessService()
        {
            InitializeComponent();
            timer = new System.Timers.Timer(180000);
            timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
            if (!System.Diagnostics.EventLog.SourceExists("TC2.7.0DataProcessLogSource"))
                System.Diagnostics.EventLog.CreateEventSource("TC2.7.0DataProcessLogSource", "TC2.7.0DataProcessLog");
            eventLog1.Source = "TC2.7.0DataProcessLogSource";
            // the event log source by which the application is registered on the computer
            eventLog1.Log = "TC2.7.0DataProcessLog";
        }
        #endregion
        #region WriteErrorToEventLog
        public void WriteErrorToEventLog(string applicationName, string msg)
        {
            StackFrame CallStack = new StackFrame(1, true);
            int lineNumber = CallStack.GetFileLineNumber();
            string msg2 = CallStack.GetFileName() + "\r\n";           // This get calling module's file name and adds to event log.
            msg2 += "Line: " + lineNumber.ToString() + "\r\n";        // This get calling module's line number of call to this function.
            msg2 += msg;
            if (!EventLog.SourceExists("TC2.7.0DataProcessLogSource"))
            {
                EventLog.CreateEventSource("TC2.7.0DataProcessLogSource", "TC2.7.0DataProcessLog");
            }
            EventLog.WriteEntry("TC2.7.0DataProcessLogSource", msg2, EventLogEntryType.Error, lineNumber);
        }
        #endregion
        #region OnStart
        protected override void OnStart(string[] args)
        {
            timer.Start();
        }
        #endregion
        #region OnStop
        protected override void OnStop()
        {
            timer.Stop();
        }
        #endregion
        #region timer_Elapsed
        private void timer_Elapsed(object source, ElapsedEventArgs e)
        {
            try
            {
                timer.Stop();
                CultureInfo CI = new CultureInfo("en-us");
                CI.DateTimeFormat.ShortDatePattern = "MM/dd/yyyy";
                System.Threading.Thread.CurrentThread.CurrentCulture = CI;
                //Get Companies
                DataTable dtCompaniesData = new DataTable();
                dtCompaniesData = objDatafunction.SelectCompanyDetails("Proc_Ta_GettingCompanyDetailsForService");
                foreach (DataRow dRowCompanies in dtCompaniesData.Rows)
                {
                    gintCompanyId = Convert.ToInt32(dRowCompanies["CompanyId"]);
                    gStrOverTimeStatus = GetOverTimeApprovalStatus(gintCompanyId, "OTApproval");
                    ProcessData();
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : Timer_Elapsed(Proc.Name:Proc_Ta_GettingCompanyDetailsForService)" + "\r\n" + ex.ToString());
            }
            finally
            {
                timer.Start();
            }
        }
        #endregion
        #region GetOverTimeApprovalStatus
        public string GetOverTimeApprovalStatus(int intCompanyId, string strModule)
        {
            //Get Approval Settings Based on Company Id
            DataTable dtApprovalSettings = new DataTable();
            string strStatus = string.Empty;
            try
            {
                OleDbParameter pgCompanyId = new OleDbParameter("@CompanyId", intCompanyId);
                OleDbParameter[] pParams ={ pgCompanyId };
                dtApprovalSettings = objDatafunction.SelectDatas(pParams, "Proc_Ta_GetOverTimeApprovalStatusForService");
                if (dtApprovalSettings.Rows.Count > 0)
                {
                    if (Convert.ToBoolean(dtApprovalSettings.Rows[0][strModule]) == false)
                    {
                        strStatus = "Approved";
                    }
                }
                else
                {
                    strStatus = "Approved";
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : GetOverTimeApprovalStatus(Proc.Name:Proc_Ta_GetOverTimeApprovalStatusForService(" + intCompanyId + ")" + "\r\n" + " Error : " + ex.ToString());
            }
            return strStatus;
        }
        #endregion
        #region ProcessData
        private void ProcessData()
        {
            try
            {
                #region VariableDeclaration
                //Get Shift Settings of Each Company based on Company Id
                string strIsFlexible = "False", strIsHalfDayAttendance = "False";
                Int64 intShiftSettingsId = 0;
                int intFlexibleFlag = 0, EarlyEntryCal = 0, EarlyOutCal = 0, lateEntryCal = 0, LateOutCal = 0;
                DataTable dtShiftSettings = new DataTable();
                string strHolidayOnWeeklyOff = string.Empty, strIsOTRoundOff = string.Empty;
                double dblShftWeekOffOverTime = 0, dblShftHolyOverTime = 0;
                gstrDefaultMonthClosureDate = string.Empty;
                #endregion
                #region GetttingShiftSettingDetails
                OleDbParameter pgCompanyId = new OleDbParameter("@CompanyId", gintCompanyId);
                OleDbParameter[] pParams ={ pgCompanyId };
                dtShiftSettings = objDatafunction.SelectDatas(pParams, "Proc_Ta_GetBasicShiftSettingDetailsForService");
                if (dtShiftSettings.Rows.Count > 0)
                {
                    gstrDefaultMonthClosureDate = Convert.ToString(dtShiftSettings.Rows[0]["MonthClosure_EndDate"]);
                    // Code added by Kumuthini on May 18 2009
                    if (dtShiftSettings.Rows[0]["IsFlexible"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["IsFlexible"]) != string.Empty)
                    {
                        strIsFlexible = Convert.ToString(dtShiftSettings.Rows[0]["IsFlexible"]);
                        if (strIsFlexible == "True")
                        {
                            if (dtShiftSettings.Rows[0]["FlexibleFlag"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["FlexibleFlag"]) != string.Empty)
                            {
                                intFlexibleFlag = int.Parse(Convert.ToString(dtShiftSettings.Rows[0]["FlexibleFlag"]));
                            }
                        }
                    }
                    if (dtShiftSettings.Rows[0]["HalfDayAttendance"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["HalfDayAttendance"]) != string.Empty)
                    {
                        strIsHalfDayAttendance = Convert.ToString(dtShiftSettings.Rows[0]["HalfDayAttendance"]);
                    }
                    if (dtShiftSettings.Rows[0]["WeekOffOT"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["WeekOffOT"]) != string.Empty)
                    {
                        dblShftWeekOffOverTime = Convert.ToDouble(dtShiftSettings.Rows[0]["WeekOffOT"]);
                    }
                    if (dtShiftSettings.Rows[0]["HolidayOT"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["HolidayOT"]) != string.Empty)
                    {
                        dblShftHolyOverTime = Convert.ToDouble(dtShiftSettings.Rows[0]["HolidayOT"]);
                    }
                    if (dtShiftSettings.Rows[0]["otOption"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["otOption"]) != string.Empty)
                    {
                        strHolidayOnWeeklyOff = Convert.ToString(dtShiftSettings.Rows[0]["otOption"]);
                    }
                    if (dtShiftSettings.Rows[0]["ShiftSettingId"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["ShiftSettingId"]) != string.Empty)
                    {
                        intShiftSettingsId = Int64.Parse(Convert.ToString(dtShiftSettings.Rows[0]["ShiftSettingId"]));
                    }
                    if (dtShiftSettings.Rows[0]["OTRoundoffEnable"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["OTRoundoffEnable"]) != string.Empty)
                    {
                        strIsOTRoundOff = Convert.ToString(dtShiftSettings.Rows[0]["OTRoundoffEnable"]);
                    }
                    if (dtShiftSettings.Rows[0]["LateExit"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["LateExit"]) != string.Empty)
                    {
                        LateOutCal = Convert.ToInt16(dtShiftSettings.Rows[0]["LateExit"]);
                    }
                    if (dtShiftSettings.Rows[0]["EarlyExit"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["EarlyExit"]) != string.Empty)
                    {
                        EarlyOutCal = Convert.ToInt16(dtShiftSettings.Rows[0]["EarlyExit"]);
                    }
                    if (dtShiftSettings.Rows[0]["LateEntry"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["LateEntry"]) != string.Empty)
                    {
                        lateEntryCal = Convert.ToInt16(dtShiftSettings.Rows[0]["LateEntry"]);
                    }
                    if (dtShiftSettings.Rows[0]["EarlyEntry"] != DBNull.Value && Convert.ToString(dtShiftSettings.Rows[0]["EarlyEntry"]) != string.Empty)
                    {
                        EarlyEntryCal = Convert.ToInt16(dtShiftSettings.Rows[0]["EarlyEntry"]);
                    }
                }
                else
                {
                    gstrDefaultMonthClosureDate = DateTime.Now.ToString("yyyy-MM-dd");
                }
                #endregion
                #region FillDatas
                FillTempProcessTable();
                FillMissedOutEmployees();
                #endregion
                #region GettingUnProcessedData
                DataTable dtUnprocessedData = new DataTable();
                dtUnprocessedData = objDatafunction.SelectCompanyDetails("Proc_Ta_GettingUnProcessedDataForService");
                foreach (DataRow drUnprocessedData in dtUnprocessedData.Rows)
                {
                    bool blnAllowFlexibleHours = false;
                    string strIsEmployeewiseFlexiHours = "False";
                    string strOTEligible = "False";
                    string strCompOffEligible = "False";
                    if (drUnprocessedData["IsFlexible"] != DBNull.Value && Convert.ToString(drUnprocessedData["IsFlexible"]) != string.Empty)
                    {
                        strIsEmployeewiseFlexiHours = Convert.ToString(drUnprocessedData["IsFlexible"]);
                    }
                    if (strIsFlexible == "True")
                    {
                        blnAllowFlexibleHours = AllowFlexibleHours(intFlexibleFlag, strIsEmployeewiseFlexiHours);
                    }
                    if (drUnprocessedData["OT_Eligible"] != DBNull.Value && Convert.ToString(drUnprocessedData["OT_Eligible"]) != string.Empty)
                    {
                        strOTEligible = Convert.ToString(drUnprocessedData["OT_Eligible"]);
                    }
                    if (drUnprocessedData["CompOff_Eligible"] != DBNull.Value && Convert.ToString(drUnprocessedData["CompOff_Eligible"]) != string.Empty)
                    {
                        strCompOffEligible = Convert.ToString(drUnprocessedData["CompOff_Eligible"]);
                    }
                    string levelId = string.Empty;
                    if (drUnprocessedData["LevelId"] != DBNull.Value && Convert.ToString(drUnprocessedData["LevelId"]) != string.Empty)
                    {
                        levelId = Convert.ToString(drUnprocessedData["LevelId"]);
                    }
                    if (blnAllowFlexibleHours == false)
                    {
                        #region NonFlexibleHoursCalculation
                        try
                        {
                            NonFlexibleHoursCalculation(Int64.Parse(Convert.ToString(drUnprocessedData["Process_Rec_ID"])), int.Parse(Convert.ToString(drUnprocessedData["Employee_Id"])), Convert.ToString(drUnprocessedData["Employee_Code_Id"]), Convert.ToString(drUnprocessedData["Date"]), Convert.ToString(drUnprocessedData["InTime"]), strOTEligible, Convert.ToString(drUnprocessedData["Status"]), dblShftWeekOffOverTime, dblShftHolyOverTime, strHolidayOnWeeklyOff, intShiftSettingsId, strIsOTRoundOff, levelId, strCompOffEligible, EarlyEntryCal, LateOutCal);
                        }
                        catch (Exception ex)
                        {
                            string errorMessage = ex.Message.ToString().Replace("'", "");
                            OleDbParameter pmError_Process_Rec_ID = new OleDbParameter("@Process_Rec_ID", Int64.Parse(Convert.ToString(drUnprocessedData["Process_Rec_ID"])));
                            OleDbParameter pmError_errormessage = new OleDbParameter("@errorMessage", errorMessage);
                            OleDbParameter[] pmters_errors ={ pmError_Process_Rec_ID, pmError_errormessage };
                            objDatafunction.SP_Execute(pmters_errors, "Proc_Ta_SkipErroredDataForService");
                            WriteErrorToEventLog("DataProcess", "function : NonFlexibleHoursCalculation(); ProcessRecID : " + drUnprocessedData["Process_Rec_ID"].ToString() + "; EmployeeId : " + drUnprocessedData["Employee_Id"].ToString() + "; Date : " + drUnprocessedData["Date"].ToString() + "; Error : " + ex.ToString());
                            return;
                        }
                        #endregion
                    }
                    else
                    {
                        #region FlexibleHoursCalculation
                        try
                        {
                            FlexibleHoursCalculation(Int64.Parse(Convert.ToString(drUnprocessedData["Process_Rec_ID"])), int.Parse(Convert.ToString(drUnprocessedData["Employee_Id"])), Convert.ToString(drUnprocessedData["Employee_Code_Id"]), Convert.ToString(drUnprocessedData["Date"]), Convert.ToString(drUnprocessedData["InTime"]), strOTEligible, Convert.ToString(drUnprocessedData["Status"]), dblShftWeekOffOverTime, dblShftHolyOverTime, strHolidayOnWeeklyOff, intShiftSettingsId, strIsOTRoundOff, strIsHalfDayAttendance, levelId, strCompOffEligible, lateEntryCal, EarlyOutCal, EarlyEntryCal, LateOutCal);
                        }
                        catch (Exception ex)
                        {
                            string errorMessage = ex.Message.ToString().Replace("'", "");
                            OleDbParameter pmError_Process_Rec_ID = new OleDbParameter("@Process_Rec_ID", Int64.Parse(Convert.ToString(drUnprocessedData["Process_Rec_ID"])));
                            OleDbParameter pmError_errormessage = new OleDbParameter("@errorMessage", errorMessage);
                            OleDbParameter[] pmters_errors ={ pmError_Process_Rec_ID, pmError_errormessage };
                            objDatafunction.SP_Execute(pmters_errors, "Proc_Ta_SkipErroredDataForService");
                            WriteErrorToEventLog("DataProcess", "function : NonFlexibleHoursCalculation(); ProcessRecID : " + drUnprocessedData["Process_Rec_ID"].ToString() + "; EmployeeId : " + drUnprocessedData["Employee_Id"].ToString() + "; Date : " + drUnprocessedData["Date"].ToString() + "; Error : " + ex.ToString());
                            return;
                        }
                        #endregion
                    }
                    // End
                }
                #region BonusLeaveApplicationCalculation
                // Update BL Leaves                
                UpdateBLLeave();
                #endregion
                #endregion
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : ProcessData" + ex.ToString());
            }
        }
        #endregion
        #region NonFlexibleHoursCalculation
        private void NonFlexibleHoursCalculation(Int64 inProcess_Rec_ID, int inEmployee_Id, string inEmployee_Code_Id, string inDate, string inInTime, string inOT_Eligible, string inStatus, double inShftWeekOffOverTime, double inShftHolyOverTime, string inHolidayOnWeeklyOff, Int64 inShiftSettingsId, string inIsOTRoundOff, string levelId, string InCompoffEligible, int EarlyEntryCalc, int lateExitCalc)
        {
            try
            {
                #region VariableDeclaration
                bool blnInDateTime = false, blnOutDateTime = false, Is24Hrs = false, isTempWeekday = false;
                string gstrAttendance = string.Empty, strFNAttendanceCode = "Absent", strANAttendanceCode = "Absent";
                DateTime dtmFirstHalfEnd = new DateTime();
                DateTime dtmSecondHalfStart = new DateTime();
                DataTable dtOTSettings = new DataTable();
                string strShiftStartTime = string.Empty, strShiftEndTime = string.Empty, strLunShiftEndTime = string.Empty, strLeaveCode = string.Empty;
                int intYearSettingId = 0, intShiftId = 0;
                DateTime dtmDate = new DateTime();
                DataTable dtShift = new DataTable();
                DateTime dtmWorkHrs = new DateTime();
                string strWorkHrs = "00:00";
                string strStraightShift = "00:00";
                Boolean isStraightShift = false;
                dtmDate = DateTime.Parse(inDate);
                intYearSettingId = GetYearSettingId(dtmDate);
                string strDate = string.Empty;
                strDate = dtmDate.ToString("yyyy-MM-dd");
                #endregion
                #region GetShiftId
                // Get Shift ID for appropriate Employee and Date   
                //Due to additional weedkly off lunch hours deduction point we kept the below two line here.
                int countShift = 0;
                countShift = CheckAdditionalWeekOff(dtmDate, inEmployee_Code_Id);
                intShiftId = GetShiftId(inEmployee_Id, dtmDate, inEmployee_Code_Id);
                #endregion
                #region CheckingHoliday
                // Check for Holiday
                string strSQLHoliDay = string.Empty;
                int HolidayId = 0;
                try
                {
                    OleDbParameter FromDate = new OleDbParameter("@FromDate", strDate);
                    OleDbParameter HolidayType = new OleDbParameter("@HolidayType", "G");
                    OleDbParameter EmployeeAutoId = new OleDbParameter("@EmployeeAutoId", inEmployee_Id);
                    OleDbParameter[] pParams ={ FromDate, HolidayType, EmployeeAutoId };
                    HolidayId = objDatafunction.SP_ExecuteWithReturn(pParams, "Proc_TA_CheckHolidayForService");
                    if (HolidayId != 0)
                    {
                        strANAttendanceCode = "Holiday";
                        strFNAttendanceCode = "Holiday";
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "Proc.Name: Proc_TA_CheckHolidayForService(" + inProcess_Rec_ID + "," + inEmployee_Id + "," + strDate + "); Error : " + ex.ToString());
                    return;
                }
                #endregion
                #region GettingShiftDetailsUsingShiftId
                try
                {
                    dtShift = GettingShiftDetailsUsingShiftId(intShiftId);
                    if (intShiftId != -1 && HolidayId == 0 && countShift == 0)
                    {
                        if (dtShift.Rows.Count > 0)
                        {
                            if (dtShift.Rows[0]["Shift_TotalWorkingHours"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_TotalWorkingHours"]) != string.Empty)
                            {
                                dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_TotalWorkingHours"]);
                            }
                            //First half end time
                            if (dtShift.Rows[0]["Shift_FirstHalf_EndTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_FirstHalf_EndTime"]) != string.Empty)
                            {
                                dtmFirstHalfEnd = Convert.ToDateTime(dtShift.Rows[0]["Shift_FirstHalf_EndTime"]);
                            }
                            //Second half start time
                            if (dtShift.Rows[0]["Shift_SecondHalf_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_SecondHalf_StartTime"]) != string.Empty)
                            {
                                dtmSecondHalfStart = Convert.ToDateTime(dtShift.Rows[0]["Shift_SecondHalf_StartTime"]);
                            }
                            //For 24hrs Shift
                            if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && dtShift.Rows[0]["24HrsShift"].ToString() != string.Empty)
                            {
                                Is24Hrs = Convert.ToBoolean(dtShift.Rows[0]["24HrsShift"]);
                            }
                            if (dtShift.Rows[0]["isStraightShift"] != DBNull.Value && dtShift.Rows[0]["isStraightShift"].ToString() != string.Empty)
                            {
                                if (Convert.ToInt32(dtShift.Rows[0]["isStraightShift"]) == 1)
                                {
                                    isStraightShift = Convert.ToBoolean(dtShift.Rows[0]["isStraightShift"]);
                                    strStraightShift = Convert.ToString(dtShift.Rows[0]["StraightPresentTime"]);
                                }
                            }
                        }
                    }
                    else
                    {
                        if (countShift == 1 || intShiftId == -1)
                        {
                            strANAttendanceCode = "Weekly Off";
                            strFNAttendanceCode = "Weekly Off";
                        }
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "Function : NonFlexibleHoursCalculation(Shift); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    return;
                }
                #endregion
                #region CheckingLeave
                // Check for Leave
                strLeaveDay = string.Empty;
                string strLeaveType = string.Empty, strLeaveCategory = string.Empty;
                DataTable dtLeave = new DataTable();
                try
                {
                    dtLeave = CheckLeaveAppliedorNot(inEmployee_Code_Id, dtmDate);
                    if (dtLeave.Rows.Count > 0)
                    {
                        for (int i = 0; i < dtLeave.Rows.Count; i++)
                        {
                            // check whether the leave for Full Day or First Session or Second Session for particular Employee and Date
                            strLeaveDay = CheckLeave(dtmDate, Convert.ToString(dtLeave.Rows[i]["Leave_FromDate"]), Convert.ToString(dtLeave.Rows[i]["Leave_ToDate"]), Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]), Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]));
                            // Get the Leave Type whether normal leave or restricted holiday or comp off or LOP or ESI
                            strLeaveCategory = GetLeaveCategory(Convert.ToString(dtLeave.Rows[i]["Type"]));
                            //}
                            //if (strLeaveCategory != string.Empty)
                            //{
                            //    if (strLeaveCategory == "Leave")
                            //    {
                            //        if (int.Parse(Convert.ToString(dtLeave.Rows[0]["LeaveType_id"])) > 0)
                            //        {
                            //            // Get Leave Type by passing Leave Type Id
                            //            strLeaveType = GetLeaveType(int.Parse(Convert.ToString(dtLeave.Rows[0]["LeaveType_id"])));
                            //        }
                            //    }
                            //}
                            if (strLeaveCategory != string.Empty && strLeaveCategory == "Leave")
                            {
                                if (int.Parse(Convert.ToString(dtLeave.Rows[i]["LeaveType_id"])) > 0)
                                {
                                    // Get Leave Type by passing Leave Type Id
                                    strLeaveType = GetLeaveType(int.Parse(Convert.ToString(dtLeave.Rows[i]["LeaveType_id"])));
                                    if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "First half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "Second half")
                                    {
                                        strFNAttendanceCode = strANAttendanceCode = strLeaveType;
                                    }
                                    else if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "First half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "First half")
                                    {
                                        strFNAttendanceCode = strLeaveType;
                                    }
                                    else if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "Second half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "Second half")
                                    {
                                        strANAttendanceCode = strLeaveType;
                                    }
                                }
                            }
                            else
                            {
                                if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "First half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "Second half")
                                {
                                    strFNAttendanceCode = strANAttendanceCode = strLeaveCategory;
                                }
                                else if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "First half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "First half")
                                {
                                    strFNAttendanceCode = strLeaveCategory;
                                }
                                else if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "Second half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "Second half")
                                {
                                    strANAttendanceCode = strLeaveCategory;
                                }
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    return;
                }
                #endregion
                #region VariableDeclaration
                string strFirstIn = string.Empty, strLastOut = string.Empty, strLateInTime = "00:00", strEarlyExit = "00:00", strEarlyIn = "00:00", strLateOut = "00:00";
                double dLateInMins = 0, dEarlyOutMins = 0, dLateExitMins = 0, dblTotalDays = 1, dEarlyInMins = 0, dLateOutMins = 0, dExtraMins = 0;
                string strFirstInDateTime = string.Empty, strLastOutDateTime = string.Empty;
                //TODO: Need to add below lines into service
                string strFirstInPunchType = string.Empty, strLastOutPunchType = string.Empty;
                string strFirstInDate = string.Empty;
                string strLastOutDate = string.Empty;
                DateTime dtmFirstInDateTime = new DateTime();
                DateTime dtmLastOutDateTime = new DateTime();
                string strFirstHalfEnd = string.Empty, strSecondHalfStart = string.Empty, strIsHoliday = "N";
                #endregion
                #region GettingFirstInAndLastOutPunchDetails
                try
                {
                    strFirstInDateTime = GetFirstIn(inEmployee_Code_Id, strDate);
                    //TODO: Need to add below lines into service
                    strFirstInPunchType = GetFirstInPunchType(inEmployee_Code_Id, strDate);
                    if (strFirstInDateTime != string.Empty)
                    {
                        dtmFirstInDateTime = DateTime.Parse(strFirstInDateTime);
                        strFirstIn = dtmFirstInDateTime.ToShortTimeString();
                        //TODO: Need to add below lines into service
                        strFirstInDate = dtmFirstInDateTime.ToShortDateString();
                        blnInDateTime = true;
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "Function : NonFlexibleHoursCalculation(GetFirstIn); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    return;
                }
                try
                {
                    strLastOutDateTime = GetLastOut(inEmployee_Code_Id, strDate);
                    //TODO: Need to add below lines into service
                    strLastOutPunchType = GetLastOutPunchType(inEmployee_Code_Id, strDate);
                    if (strLastOutDateTime != string.Empty)
                    {
                        dtmLastOutDateTime = DateTime.Parse(strLastOutDateTime);
                        strLastOut = dtmLastOutDateTime.ToShortTimeString();
                        //TODO: Need to add below lines into service
                        strLastOutDate = dtmLastOutDateTime.ToShortDateString();
                        blnOutDateTime = true;
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "Function : NonFlexibleHoursCalculation(GetLastOut); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    return;
                }
                #endregion
                // If Employee Attendance is Present
                if (strFirstInDateTime != string.Empty || strLastOutDateTime != string.Empty)
                {
                    TimeSpan tsFirstInTime = new TimeSpan();
                    TimeSpan tsLastOutTime = new TimeSpan();
                    if (strFirstIn != string.Empty)
                    {
                        tsFirstInTime = DateTime.Parse(Convert.ToString(strFirstIn)).TimeOfDay;
                    }
                    if (strLastOut != string.Empty)
                    {
                        tsLastOutTime = DateTime.Parse(Convert.ToString(strLastOut)).TimeOfDay;
                    }
                    #region VariableDeclaration
                    // Get Actual Shift Details from Shift Table
                    string ActualShfInTime = string.Empty, ActualShfOutTime = string.Empty, strShftGraceInTime = "00:00", strShftGraceOutTime = "00:00", strShftMinOTTime = "00:00", strShftMaxOTTime = "00:00";
                    string strFirstBreakStartTime = "00:00", strFirstBreakEndTime = "00:00", strSecondBreakStartTime = "00:00", strSecondBreakEndTime = "00:00", strThirdBreakStartTime = "00:00", strThirdBreakEndTime = "00:00";
                    double ShftWorkOverTime = 0, ShftWeekOffOverTime = 0, ShftHolyOverTime = 0;
                    int TotalHrs = 0, Totalmin = 0;
                    bool shftType = true;
                    string strLunchStartTime = "00:00", strLunchEndTime = "00:00";
                    string LunchInTime = string.Empty;
                    string LunchOutTime = string.Empty;
                    string strActualLunchStartTime = "00:00", strActualLunchEndTime = "00:00";
                    string strLunchOutTimeGraceBefore = "00:00", strLunchOutTimeGraceAfter = "00:00", strLunchInTimeGraceBefore = "00:00", strLunchInTimeGraceAfter = "00:00";
                    string strLunchBreakLate = "00:00", strTotalLate = "00:00";
                    int intLunchOutTimeGraceBefore = 0, intLunchOutTimeGraceAfter = 0, intLunchInTimeGraceBefore = 0, intLunchInTimeGraceAfter = 0;
                    #endregion
                    #region GettingShiftDetails
                    if (dtShift.Rows.Count > 0)
                    {
                        if (dtShift.Rows[0]["Shift_TotalWorkingHours"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_TotalWorkingHours"]) != string.Empty)
                        {
                            TotalHrs = dtmWorkHrs.Hour;
                            Totalmin = dtmWorkHrs.Minute;
                        }
                        if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                        {
                            ActualShfInTime = Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_EndTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]) != string.Empty)
                        {
                            ActualShfOutTime = Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakStartTime1"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime1"]) != string.Empty)
                        {
                            strFirstBreakStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime1"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakEndTime1"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime1"]) != string.Empty)
                        {
                            strFirstBreakEndTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime1"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakStartTime2"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime2"]) != string.Empty)
                        {
                            strSecondBreakStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime2"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakEndTime2"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime2"]) != string.Empty)
                        {
                            strSecondBreakEndTime = dtShift.Rows[0]["Shift_BreakEndTime2"].ToString();
                        }
                        if (dtShift.Rows[0]["Shift_BreakStartTime3"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime3"]) != string.Empty)
                        {
                            strThirdBreakStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime3"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakEndTime3"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime3"]) != string.Empty)
                        {
                            strThirdBreakEndTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime3"]);
                        }
                        if (dtShift.Rows[0]["Shift_GraceInTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_GraceInTime"]) != string.Empty)
                        {
                            strShftGraceInTime = Convert.ToString(dtShift.Rows[0]["Shift_GraceInTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_GraceOutTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_GraceOutTime"]) != string.Empty)
                        {
                            strShftGraceOutTime = Convert.ToString(dtShift.Rows[0]["Shift_GraceOutTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_WorkingDay_OverTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_WorkingDay_OverTime"]) != string.Empty)
                        {
                            ShftWorkOverTime = Convert.ToDouble(dtShift.Rows[0]["Shift_WorkingDay_OverTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_MinTimeOT"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_MinTimeOT"]) != string.Empty)
                        {
                            strShftMinOTTime = Convert.ToString(dtShift.Rows[0]["Shift_MinTimeOT"]);
                        }
                        if (dtShift.Rows[0]["shift_FirstHalf_EndTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["shift_FirstHalf_EndTime"]) != string.Empty)
                        {
                            strFirstHalfEnd = Convert.ToString(dtShift.Rows[0]["shift_FirstHalf_EndTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_SecondHalf_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_SecondHalf_StartTime"]) != string.Empty)
                        {
                            strSecondHalfStart = Convert.ToString(dtShift.Rows[0]["Shift_SecondHalf_StartTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_MaxTimeOT"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_MaxTimeOT"]) != string.Empty)
                        {
                            strShftMaxOTTime = Convert.ToString(dtShift.Rows[0]["Shift_MaxTimeOT"]);
                        }
                        if (dtShift.Rows[0]["ShiftType"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["ShiftType"]) != string.Empty)
                        {
                            shftType = Convert.ToBoolean(dtShift.Rows[0]["ShiftType"]);
                        }
                    }
                    #endregion
                    if (HolidayId != 0)
                    {
                        strIsHoliday = "Y";
                        strANAttendanceCode = "Holiday";
                        strFNAttendanceCode = "Holiday";
                    }
                    if (strFirstIn != string.Empty && strLastOut != string.Empty)
                    {
                        #region FirstInAndLastOutPunchDetailsAvailed
                        bool blnIsPMAM = false;
                        bool blnIsPMAMFirstHalfStartEnd = false;
                        DateTime dtmActualShiftStartTime = new DateTime();
                        DateTime dtmShiftEndTime = new DateTime();
                        DateTime dtmShiftFirstHalfEndTime = new DateTime();
                        string strActShiftStartTime = strDate + " " + ActualShfInTime;
                        dtmActualShiftStartTime = DateTime.Parse(strActShiftStartTime);
                        string strShiftEndTim = strDate + " " + ActualShfOutTime;
                        dtmShiftEndTime = DateTime.Parse(strShiftEndTim);
                        string strShiftFirstHalfEndTime = strDate + " " + strFirstHalfEnd;
                        dtmShiftFirstHalfEndTime = DateTime.Parse(strShiftFirstHalfEndTime);
                        string strActualShiftStartTime = dtmActualShiftStartTime.ToString("hh:mm:ss tt");
                        string strShift_EndTime = dtmShiftEndTime.ToString("hh:mm:ss tt");
                        if ((strActualShiftStartTime.Substring(9, 2) == "PM") && (strShift_EndTime.Substring(9, 2) == "AM"))
                        {
                            blnIsPMAM = true;
                            dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                        }
                        if (Is24Hrs)
                        {
                            dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                        }
                        //Check First half start and end time in PM  AM
                        if ((strActualShiftStartTime.Substring(strActualShiftStartTime.Length - 2, 2) == "PM") && (strFirstHalfEnd.Substring(strFirstHalfEnd.Length - 2, 2) == "AM"))
                        {
                            blnIsPMAMFirstHalfStartEnd = true;
                            dtmShiftFirstHalfEndTime = dtmShiftFirstHalfEndTime.AddDays(1);
                        }
                        #region CheckAttendance
                        // Check attandance
                        TimeSpan tsFnAttandance, tsAnAttandance, tsStraightShift;
                        if (strLeaveDay != "Full Day")
                        {
                            if (isStraightShift == true)
                            {
                                tsStraightShift = TimeSpan.Parse(strStraightShift);
                                if (strFirstInDateTime != "" && strLastOutDateTime != string.Empty)
                                {
                                    tsFnAttandance = DateTime.Parse(strLastOutDateTime).Subtract(DateTime.Parse(strFirstInDateTime));
                                    strANAttendanceCode = strFNAttendanceCode = (tsFnAttandance.TotalMinutes >= tsStraightShift.TotalMinutes) ? "Present" : "Absent";
                                }
                            }
                            else
                            {
                                if (strFirstHalfEnd != "")
                                {
                                    tsFnAttandance = DateTime.Parse(DateTime.Parse(strFirstInDateTime).ToShortTimeString()).Subtract(DateTime.Parse(DateTime.Parse(strFirstHalfEnd).ToShortTimeString()));
                                    if (blnIsPMAM == true)
                                    {
                                        if (strFirstInDateTime.Substring(strFirstInDateTime.Length - 2, 2) == "PM" && strFirstHalfEnd.Substring(strFirstHalfEnd.Length - 2, 2) == "AM")
                                        {
                                            tsFnAttandance = DateTime.Parse(DateTime.Parse(strFirstInDateTime).ToShortTimeString()).Subtract(DateTime.Parse(DateTime.Parse(strFirstHalfEnd).AddDays(1).ToShortTimeString()));
                                            strFNAttendanceCode = (tsFnAttandance.TotalMinutes > 0) ? "Present" : "Absent";
                                        }
                                        else if (blnIsPMAMFirstHalfStartEnd == true)
                                        {
                                            strFNAttendanceCode = (DateTime.Parse(strFirstInDateTime) >= dtmActualShiftStartTime && DateTime.Parse(strFirstInDateTime) <= dtmShiftFirstHalfEndTime) ? "Present" : "Absent";
                                        }
                                        else
                                        {
                                            strFNAttendanceCode = (tsFnAttandance.TotalMinutes < 0) ? "Present" : "Absent";
                                        }
                                    }
                                    else
                                    {
                                        strFNAttendanceCode = (tsFnAttandance.TotalMinutes < 0) ? "Present" : "Absent";
                                    }
                                }
                                if (strSecondHalfStart != string.Empty)
                                {
                                    if (blnIsPMAM == true)
                                    {
                                        if (strSecondHalfStart.Substring(strSecondHalfStart.Length - 2, 2) == "AM")
                                        {
                                            tsAnAttandance = Convert.ToDateTime(strLastOutDateTime).Subtract(Convert.ToDateTime(dtmDate.AddDays(1).ToString("yyyy-MM-dd") + " " + strSecondHalfStart));
                                        }
                                        else
                                        {
                                            tsAnAttandance = Convert.ToDateTime(strLastOutDateTime).Subtract(Convert.ToDateTime(dtmDate.ToString("yyyy-MM-dd") + " " + strSecondHalfStart));
                                        }
                                        strANAttendanceCode = (tsAnAttandance.TotalMinutes > 0) ? "Present" : "Absent";
                                    }
                                    else
                                    {
                                        tsAnAttandance = Convert.ToDateTime(strLastOutDateTime).Subtract(Convert.ToDateTime(dtmDate.ToString("yyyy-MM-dd") + " " + strSecondHalfStart));
                                        strANAttendanceCode = (tsAnAttandance.TotalMinutes > 0) ? "Present" : "Absent";
                                    }
                                }
                            }
                        }
                        //End of Check Attandance
                        #endregion
                        ShftWeekOffOverTime = inShftWeekOffOverTime;
                        ShftHolyOverTime = inShftHolyOverTime;
                        #region VariableDeclaration
                        // Calculate the Total Work Hours for a particular Employee and Date
                        string strTotalWorkHours = string.Empty;
                        double dTotalMinsWorked = 0;
                        string strLessHours = "00:00", strExtraHours = "00:00", strHrsOT = "00:00", strNorOT = "00:00",
                                strWeekOffOT = "00:00", strHoliOT = "00:00", strLateExitHours = "00:00";
                        // Check for Holiday
                        double dShftHolyOverTime = 0, dShftWeekOffOverTime = 0, dOT = 0;
                        TimeSpan tsLunchBreakMins = new TimeSpan();
                        double LunchTakenedByEmployee = 0;
                        TimeSpan tsLateExit = new TimeSpan();
                        TimeSpan tsAfter = new TimeSpan();
                        TimeSpan tsBefore = new TimeSpan();
                        TimeSpan tsShftMaxOTTime = new TimeSpan();
                        TimeSpan tsShftMinOTTime = new TimeSpan();
                        string strNormOTFlag = "N";
                        double dblOTMins = 0;
                        #endregion
                        // To calculate Work Hours using First In and Last Out
                        #region CheckingPermissionAndCalculatingWorkHours
                        TimeSpan tsWorkedHrs = new TimeSpan();
                        dtPermissionEndtime = CheckPermissionAppliedorNot(inEmployee_Code_Id, dtmDate);
                        if (dtPermissionEndtime.Rows.Count > 0)
                        {
                            dtmPermissionFromDateTime = DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_FromTime"]));
                            dtmPermissionToDateTime = DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"]));
                            if (dtmShiftEndTime >= dtmPermissionFromDateTime && dtmShiftEndTime <= dtmPermissionToDateTime)
                            {
                                if (dtmLastOutDateTime > dtmPermissionFromDateTime)
                                {
                                    tsWorkedHrs = DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_FromTime"])).Subtract(dtmFirstInDateTime);
                                    dTotalMinsWorked = tsWorkedHrs.TotalMinutes;
                                }
                                else if (dtmLastOutDateTime >= dtmFirstInDateTime)
                                {
                                    tsWorkedHrs = dtmLastOutDateTime.Subtract(dtmFirstInDateTime);
                                    dTotalMinsWorked = tsWorkedHrs.TotalMinutes;
                                }
                            }
                            else if (dtmFirstInDateTime >= dtmPermissionFromDateTime && dtmFirstInDateTime <= dtmPermissionToDateTime)
                            {
                                dtmFirstInDateTime = DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"]));
                                tsWorkedHrs = dtmLastOutDateTime.Subtract(dtmFirstInDateTime);
                                dTotalMinsWorked = tsWorkedHrs.TotalMinutes;
                            }
                            else if (dtmPermissionFromDateTime >= dtmFirstInDateTime && dtmPermissionToDateTime <= dtmLastOutDateTime)
                            {
                                tsWorkedHrs = dtmLastOutDateTime.Subtract(dtmFirstInDateTime);
                                tsWorkedHrs = tsWorkedHrs - Convert.ToDateTime(Convert.ToString(dtPermissionEndtime.Rows[0]["No_Of_Hours"])).TimeOfDay;
                                dTotalMinsWorked = tsWorkedHrs.TotalMinutes;
                            }
                            else if (dtmLastOutDateTime >= dtmFirstInDateTime)
                            {
                                tsWorkedHrs = dtmLastOutDateTime.Subtract(dtmFirstInDateTime);
                                dTotalMinsWorked = tsWorkedHrs.TotalMinutes;
                            }
                        }
                        else if (dtmLastOutDateTime >= dtmFirstInDateTime)
                        {
                            tsWorkedHrs = dtmLastOutDateTime.Subtract(dtmFirstInDateTime);
                            dTotalMinsWorked = tsWorkedHrs.TotalMinutes;
                        }
                        #endregion
                        #region CalculatingTotalBreakHoursBasedOnBreakPunches
                        double BreakTakenedByEmployee = 0;
                        OleDbParameter BreakempCodeId = new OleDbParameter("@clk_empid", inEmployee_Code_Id);
                        OleDbParameter BreakClockdate = new OleDbParameter("@clk_date", strDate);
                        OleDbParameter[] BreakParamValues ={ BreakempCodeId, BreakClockdate };
                        BreakTakenedByEmployee = objDatafunction.SP_ExecuteWithReturn(BreakParamValues, "Proc_Ta_TotalBreakHours");
                        if (BreakTakenedByEmployee > 0)
                        {
                            if ((dTotalMinsWorked - (BreakTakenedByEmployee)) >= 0)
                            {
                                dTotalMinsWorked = dTotalMinsWorked - BreakTakenedByEmployee;
                            }
                        }
                        #endregion
                        // Calculate Less Hours Work,Extra Hours Work and Over Time                        
                        #region "Calculating TotalLunchHours"
                        // CALCULATE LATE DURING LUNCH
                        DataTable dtLunchInOutTime = new DataTable();
                        DataTable dtLunchInTime = new DataTable();
                        DataTable dtLunchOutTime = new DataTable();
                        // Set Second Break as Lunch Timings
                        strActualLunchStartTime = strFirstBreakStartTime;
                        strActualLunchEndTime = strFirstBreakEndTime;
                        if (strANAttendanceCode != "Absent" && strFNAttendanceCode != "Absent" ||
                           (strANAttendanceCode == "Weekly Off" && strFNAttendanceCode == "Weekly Off") ||
                           (strANAttendanceCode == "Holiday" && strFNAttendanceCode == "Holiday"))
                        {
                            int luncountOnAdditional = 0;
                            luncountOnAdditional = CheckAdditionalWeekOff(dtmDate, inEmployee_Code_Id);
                            OleDbParameter lunempCodeId = new OleDbParameter("@EmployeeCodeId", inEmployee_Code_Id);
                            OleDbParameter lunClockdate = new OleDbParameter("@Clockdate", strDate);
                            OleDbParameter lunShiftid = new OleDbParameter("@ShiftId", intShiftId);
                            OleDbParameter luninLevelId = new OleDbParameter("@levelid", levelId);
                            OleDbParameter lunAdditional = new OleDbParameter("@addWeekOff", luncountOnAdditional);
                            OleDbParameter[] lunParamValues ={ lunempCodeId, lunClockdate, lunShiftid, luninLevelId, lunAdditional };
                            LunchTakenedByEmployee = objDatafunction.SP_ExecuteWithReturn(lunParamValues, "Proc_Ta_ToGetLunchHours");
                            if (LunchTakenedByEmployee > 0)
                            {
                                if ((dTotalMinsWorked - (LunchTakenedByEmployee)) >= 0)
                                {
                                    dTotalMinsWorked = dTotalMinsWorked - LunchTakenedByEmployee;
                                }
                            }
                        }
                        #endregion
                        if (HolidayId != 0)
                        {
                            strANAttendanceCode = "Holiday";
                            strFNAttendanceCode = "Holiday";
                            strIsHoliday = "Y";
                            // Check for Over Time Eligible
                            #region CalculatingOverTimeOnHoliday/Weekly off & RoundOffBasedOnConfiguration
                            if (inOT_Eligible == "True" || InCompoffEligible == "True")
                            {
                                if (intShiftId == -1)
                                {
                                    if (inHolidayOnWeeklyOff == "WeeklyOff")
                                    {
                                        ShftHolyOverTime = ShftWeekOffOverTime;
                                    }
                                }
                                if (ShftHolyOverTime != 0)
                                {
                                    // Multiply by Calculation Factor if Holiday OT
                                    dShftHolyOverTime = dTotalMinsWorked * ShftHolyOverTime;
                                }
                                else
                                {
                                    dShftHolyOverTime = dTotalMinsWorked;
                                }
                                // Call OT Round Off
                                if (inIsOTRoundOff == "True")
                                {
                                    dShftHolyOverTime = OverTimeRoundOff(dShftHolyOverTime, inShiftSettingsId, "True");
                                }
                                // Convert Total Holiday OverTime Minutes into Time Format
                                strHoliOT = TimeFormat(dShftHolyOverTime);
                            }
                            else
                            {
                                strHoliOT = "00:00";
                                dShftHolyOverTime = 0;
                            }
                            #endregion
                        }
                        else
                        {
                            int count = 0;
                            count = CheckAdditionalWeekOff(dtmDate, inEmployee_Code_Id);
                            // Calculate Weekly Off OT
                            if (intShiftId == -1 || count == 1)
                            {
                                // Check for Over Time Eligible
                                #region CalculatingOverTimeOnHoliday/Weekly Off & RoundOffBasedOnConfiguration
                                if (inOT_Eligible == "True" || InCompoffEligible == "True")
                                {
                                    if (ShftWeekOffOverTime != 0)
                                    {
                                        dShftWeekOffOverTime = dTotalMinsWorked * ShftWeekOffOverTime;
                                    }
                                    else
                                    {
                                        dShftWeekOffOverTime = dTotalMinsWorked;
                                    }
                                    // Call OT Round Off
                                    if (inIsOTRoundOff == "True")
                                    {
                                        dShftWeekOffOverTime = OverTimeRoundOff(dShftWeekOffOverTime, inShiftSettingsId, inIsOTRoundOff);
                                    }
                                    // Convert Total WeekOff OverTime Minutes into Time Format
                                    strWeekOffOT = TimeFormat(dShftWeekOffOverTime);
                                }
                                else
                                {
                                    strWeekOffOT = "00:00";
                                    dShftWeekOffOverTime = 0;
                                }
                                #endregion
                                intShiftId = -1;
                                gstrAttendance = "Weekly Off";
                                strANAttendanceCode = "Weekly Off";
                                strFNAttendanceCode = "Weekly Off";
                            }
                            else if (intShiftId > 0)
                            {
                                // CALCULATE LATE INTIME
                                strShiftStartTime = string.Empty;
                                if (dtLeave.Rows.Count > 0)
                                {
                                    // Check for First half Leave. If so then set the Shift Start time as Lunch End Time
                                    if (strLeaveDay == "First Session")
                                    {
                                        dblTotalDays = 0.5;
                                        strLeaveCode = (strLeaveCategory == "Leave") ? strLeaveType : strLeaveCategory;
                                        strFNAttendanceCode = strLeaveCode;
                                        strShiftStartTime = dtShift.Rows[0]["Shift_SecondHalf_StartTime"].ToString();
                                    }
                                    // Check for Second half Leave. If so then set the Shift End time as Lunch Start Time
                                    else if (strLeaveDay == "Second Session")
                                    {
                                        dblTotalDays = 0.5;
                                        strLeaveCode = (strLeaveCategory == "Leave") ? strLeaveType : strLeaveCategory;
                                        strANAttendanceCode = strLeaveCode;
                                        strShiftEndTime = dtShift.Rows[0]["Shift_FirstHalf_EndTime"].ToString();
                                    }
                                    else if (strLeaveDay == "Full Day")
                                    {
                                        //strANAttendanceCode = (strLeaveCategory == "Leave") ? strLeaveType : strLeaveCategory;
                                        //strFNAttendanceCode = (strLeaveCategory == "Leave") ? strLeaveType : strLeaveCategory;
                                    }
                                    else
                                    {
                                        //
                                    }
                                }
                                TimeSpan tsLateInTime_Reduce_DueToPermission = new TimeSpan();
                                bool IsLateTimeREductionExists = false;
                                if (strShiftStartTime == string.Empty)
                                {
                                    // Check whether there is Permission during the Shift Start Time
                                    if (dtPermissionEndtime.Rows.Count > 0)
                                    {
                                        if (DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"])).ToShortTimeString() == DateTime.Parse(Convert.ToString(dtShift.Rows[0]["Shift_FirstHalf_EndTime"])).ToShortTimeString())
                                        {
                                            strShiftStartTime = Convert.ToString(dtShift.Rows[0]["Shift_SecondHalf_StartTime"]);
                                        }
                                        else if (DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"])).ToShortTimeString() == DateTime.Parse(strSecondBreakStartTime).ToShortTimeString())
                                        {
                                            strShiftStartTime = strSecondBreakEndTime;
                                        }
                                        else
                                        {
                                            if (dtmActualShiftStartTime >= dtmPermissionFromDateTime && dtmActualShiftStartTime <= dtmPermissionToDateTime)
                                            {
                                                strShiftStartTime = Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"]);
                                                // Add permission hours in work hours
                                                TimeSpan tsTimeDiff, tsPermissionDiff;
                                                tsTimeDiff = dtmFirstInDateTime.Subtract(dtmPermissionFromDateTime);
                                                tsPermissionDiff = dtmPermissionToDateTime.Subtract(dtmPermissionFromDateTime);
                                            }
                                            else
                                            {// Nothing
                                            }
                                        }
                                        if (dtmFirstInDateTime >= DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"])))
                                        {
                                            IsLateTimeREductionExists = true;
                                            if (dtPermissionEndtime.Rows[0]["No_Of_Hours"] != DBNull.Value)
                                            {
                                                if (Convert.ToString(dtPermissionEndtime.Rows[0]["No_Of_Hours"]) != string.Empty)
                                                {
                                                    tsLateInTime_Reduce_DueToPermission = Convert.ToDateTime(Convert.ToString(dtPermissionEndtime.Rows[0]["No_Of_Hours"])).TimeOfDay;
                                                }
                                            }
                                            else
                                            {
                                                tsLateInTime_Reduce_DueToPermission = DateTime.Parse(dtPermissionEndtime.Rows[0]["Permission_ToTime"].ToString()).Subtract(DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_FromTime"])));
                                            }
                                        }
                                        else if (dtmFirstInDateTime > DateTime.Parse(dtPermissionEndtime.Rows[0]["Permission_FromTime"].ToString()) && dtmFirstInDateTime < DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"])))
                                        {
                                            IsLateTimeREductionExists = true;
                                            tsLateInTime_Reduce_DueToPermission = dtmFirstInDateTime.Subtract(DateTime.Parse(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_FromTime"])));
                                        }
                                    }
                                }
                                if (strShiftStartTime == string.Empty)
                                {
                                    strShiftStartTime = ActualShfInTime;
                                }
                                // Calculate Late In Time
                                #region CalculatingLateEntry
                                TimeSpan tsActualShiftStartTime = DateTime.Parse(strShiftStartTime).TimeOfDay;
                                TimeSpan tsShftStartTimePlusGrace = new TimeSpan();
                                DateTime dtmShftStartTimePlusGrace = new DateTime();
                                DateTime dtmShift_StartTime = new DateTime();
                                TimeSpan tsLateIn = new TimeSpan();
                                // Add Grace In with Shift Start Time
                                tsShftStartTimePlusGrace = tsActualShiftStartTime.Add(DateTime.Parse(strShftGraceInTime).TimeOfDay);
                                dtmShift_StartTime = DateTime.Parse(strDate + " " + Convert.ToString(tsActualShiftStartTime));
                                dtmShftStartTimePlusGrace = DateTime.Parse(strDate + " " + Convert.ToString(tsShftStartTimePlusGrace));
                                tsFirstInTime = DateTime.Parse(tsFirstInTime.ToString().Substring(0, 5)).TimeOfDay;
                                if (Convert.ToString(dtmShftStartTimePlusGrace).Contains("AM") && blnIsPMAM == true)
                                {
                                    dtmShftStartTimePlusGrace = dtmShftStartTimePlusGrace.AddDays(1);
                                    dtmShift_StartTime = dtmShift_StartTime.AddDays(1);
                                }
                                // If not Holiday, then Calculate Late In                                
                                if (strIsHoliday != "Y" && strLeaveDay != "Full Day")
                                {
                                    // Calculate Late In, if Actual InTime is greater that Shift Start Time
                                    if (dtmFirstInDateTime > dtmShftStartTimePlusGrace)
                                    {
                                        tsLateIn = dtmFirstInDateTime.Subtract(dtmShift_StartTime);
                                        dLateInMins = double.Parse(Convert.ToString(tsLateIn.TotalMinutes));
                                        strLateInTime = GetTotalHours(tsLateIn);
                                    }
                                }
                                else
                                {
                                    strLateInTime = "00:00";
                                    dLateInMins = 0;
                                }
                                #endregion                                
                                // If there is permission during the Shift End Time, then Set End Time as
                                // Permission From Time and Calculate Early Out. Else check for Second half Leave.
                                // Early Out should not be calculated during Permission Hours or Second half Leave.
                                // If Second Half Leave                                
                                #region CheckingTemporaryWeekday
                                DataTable dtTemporaryWeekDay = new DataTable();
                                string strClosingTime = string.Empty;
                                string strClosingDateTime = string.Empty;
                                try
                                {
                                    string strSQLTemporaryWeekDay = string.Empty;
                                    if (blnIsPMAM)
                                    {
                                        strSQLTemporaryWeekDay = "SELECT T.ClosingTime,T.ShiftId FROM TA_Tbl_TemWeekday T ";
                                        strSQLTemporaryWeekDay = strSQLTemporaryWeekDay + " inner join Ta_Tbl_Temporary_WeeklyOff_Levels TL on T.TempWeekday_Id = TL.TempWeekday_Id WHERE (T.TempWeekday_FromDate between '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "' and '" + dtmShiftEndTime.ToString("yyyy-MM-dd") + "')";
                                        strSQLTemporaryWeekDay = strSQLTemporaryWeekDay + " AND T.IsDeleted = 0 AND TL.LevelId=" + levelId + " AND '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "' Between  T.TempWeekday_FromDate And T.TempWeekday_ToDate ";
                                    }
                                    else if (Is24Hrs)
                                    {
                                        strSQLTemporaryWeekDay = "SELECT T.ClosingTime,T.ShiftId FROM TA_Tbl_TemWeekday T ";
                                        strSQLTemporaryWeekDay = strSQLTemporaryWeekDay + " inner join Ta_Tbl_Temporary_WeeklyOff_Levels TL on T.TempWeekday_Id = TL.TempWeekday_Id WHERE (T.TempWeekday_FromDate = '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "')";
                                        strSQLTemporaryWeekDay = strSQLTemporaryWeekDay + " AND T.IsDeleted = 0 AND TL.LevelId=" + levelId + "";
                                    }
                                    else
                                    {
                                        strSQLTemporaryWeekDay = "SELECT T.ClosingTime,T.ShiftId FROM TA_Tbl_TemWeekday T inner join Ta_Tbl_Temporary_WeeklyOff_Levels TL on T.TempWeekday_Id = TL.TempWeekday_Id WHERE (T.TempWeekday_FromDate <= '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "' and T.TempWeekday_ToDate >= '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "') AND T.IsDeleted = 0 AND TL.LevelId=" + levelId + " ";
                                    }
                                    dtTemporaryWeekDay = objDatafunction.ExeQuery(strSQLTemporaryWeekDay, "TA_Tbl_TemWeekday");
                                    if (dtTemporaryWeekDay.Rows.Count > 0)
                                    {
                                        for (int intTempWeeklyOff = 0; intTempWeeklyOff < dtTemporaryWeekDay.Rows.Count; intTempWeeklyOff++)
                                        {
                                            string strShiftId = Convert.ToString(dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ShiftId"]);
                                            string[] arrShiftId = strShiftId.Split(',');
                                            bool isShiftIdMatch = false;
                                            //for getting whether the shiftid is match to the temp week day shiftid
                                            for (int intShiftIdLen = 0; intShiftIdLen < arrShiftId.Length; intShiftIdLen++)
                                            {
                                                // This indicates first half end time in am means thats next day for night shift
                                                DateTime dttFirstHalfEnd = DateTime.Parse(strDate + " " + strFirstHalfEnd);
                                                //int intTempWeeklyOff = 0;
                                                if (dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"] != DBNull.Value && dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"].ToString() != string.Empty)
                                                {
                                                    if (Convert.ToString(arrShiftId[intShiftIdLen]) == Convert.ToString(intShiftId))
                                                    {
                                                        isShiftIdMatch = true;
                                                        break;
                                                    }
                                                }
                                            }
                                            if (isShiftIdMatch == true)
                                            {
                                                // This indicates first half end time in am means thats next day for night shift
                                                DateTime dttFirstHalfEnd = DateTime.Parse(strDate + " " + strFirstHalfEnd);
                                                //int intTempWeeklyOff = 0;
                                                if (dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"] != DBNull.Value && dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"].ToString() != string.Empty)
                                                {
                                                    // CALCULATE EARLY EXIT
                                                    //Added by Manikandan.R on 24-11-2015  Bug id:0031303
                                                    strShiftEndTime = string.Empty;
                                                    strClosingTime = DateTime.Parse(dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"].ToString()).ToShortTimeString();
                                                    //strClosingDateTime = strDate + " " + strClosingTime;
                                                    if (blnIsPMAM && strClosingTime.Contains("AM"))
                                                    {
                                                        strClosingDateTime = strDate + " " + strClosingTime;
                                                        strClosingDateTime = DateTime.Parse(strClosingDateTime).AddDays(1).ToString();
                                                        strDate = DateTime.Parse(strDate).AddDays(1).ToString("yyyy-MM-dd");
                                                    }
                                                    else if (Is24Hrs)
                                                    {
                                                        strClosingDateTime = strDate + " " + strClosingTime;
                                                        strClosingDateTime = DateTime.Parse(strClosingDateTime).AddDays(1).ToString();
                                                    }
                                                    else
                                                    {
                                                        strClosingDateTime = strDate + " " + strClosingTime;
                                                    }
                                                    if (dtmActualShiftStartTime <= DateTime.Parse(strClosingDateTime) && dtmShiftEndTime >= DateTime.Parse(strClosingDateTime))
                                                    {
                                                    }
                                                    else
                                                    {
                                                        strClosingTime = string.Empty;
                                                    }
                                                    //Added by Manjula.P  on 20-Dec-2013 for adding oneday if its night shift
                                                    if (strFirstHalfEnd.Contains("AM") == true)
                                                    {
                                                        dttFirstHalfEnd = dttFirstHalfEnd.AddDays(1);
                                                    }
                                                }
                                                if ((DateTime.Parse(dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"].ToString()) <= DateTime.Parse(strFirstHalfEnd)) || DateTime.Parse(strClosingDateTime) <= dttFirstHalfEnd)
                                                {
                                                    strANAttendanceCode = "Present";
                                                }
                                            }
                                        }
                                    }
                                }
                                catch (Exception ex)
                                {
                                    WriteErrorToEventLog("DataProcess", "function : NonFlexibleHoursCalculation(TemporaryWeekDay); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.Message);
                                    return;
                                }
                                if (strShiftEndTime == string.Empty)
                                {
                                    if (strClosingTime != string.Empty)
                                    {
                                        strShiftEndTime = strClosingTime;
                                        if (DateTime.Parse(strClosingDateTime) <= DateTime.Parse(strDate + " " + strFirstHalfEnd))
                                        {
                                            DateTime dttFirstHalfWorkingHoursLocal = Convert.ToDateTime(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                            DateTime dttFirstHalfEndLocal = Convert.ToDateTime(strFirstHalfEnd);
                                            DateTime dttFirstHalfShiftEndLocal = Convert.ToDateTime(strShiftEndTime);
                                            TimeSpan tsVariation = (dttFirstHalfEndLocal.Subtract(dttFirstHalfShiftEndLocal));
                                            DateTime dttShiftVariation = Convert.ToDateTime(tsVariation.ToString());
                                            TimeSpan tsWorkHours = dttFirstHalfWorkingHoursLocal.Subtract(dttShiftVariation);
                                            dtmWorkHrs = Convert.ToDateTime(tsWorkHours.ToString());
                                            strWorkHrs = GetTotalHours(tsWorkHours);
                                            isTempWeekday = true;
                                        }
                                        else if (DateTime.Parse(strClosingDateTime) >= DateTime.Parse(strDate + " " + strFirstBreakStartTime) && DateTime.Parse(strClosingDateTime) <= DateTime.Parse(strDate + " " + strFirstBreakEndTime))
                                        {
                                            strLunShiftEndTime = strFirstBreakStartTime;
                                            DateTime dttShift_EndTimeLocal = Convert.ToDateTime(strShiftStartTime);
                                            DateTime dttShiftEndTimeLocal = Convert.ToDateTime(strLunShiftEndTime);
                                            TimeSpan tsVariation = dttShiftEndTimeLocal.Subtract(dttShift_EndTimeLocal);
                                            DateTime dttShiftVariation = Convert.ToDateTime(tsVariation.ToString());
                                            TimeSpan tsWorkHours = dtmWorkHrs.Subtract(dttShiftVariation);
                                            strWorkHrs = GetTotalHours(tsWorkHours);
                                            isTempWeekday = true;
                                            dtmWorkHrs = Convert.ToDateTime(tsWorkHours.ToString());
                                        }
                                        else
                                        {
                                            DateTime dttShift_EndTimeLocal = Convert.ToDateTime(strShift_EndTime);
                                            DateTime dttShiftEndTimeLocal = Convert.ToDateTime(strShiftEndTime);
                                            TimeSpan tsVariation = dttShift_EndTimeLocal.Subtract(dttShiftEndTimeLocal);
                                            DateTime dttShiftVariation = Convert.ToDateTime(tsVariation.ToString());
                                            TimeSpan tsWorkHours = dtmWorkHrs.Subtract(dttShiftVariation);
                                            strWorkHrs = GetTotalHours(tsWorkHours);
                                            isTempWeekday = true;
                                            dtmWorkHrs = dtmWorkHrs - Convert.ToDateTime(strShift_EndTime).Subtract(Convert.ToDateTime(strShiftEndTime));
                                        }
                                    }
                                    else
                                    {
                                        if (dtPermissionEndtime.Rows.Count > 0)
                                        {
                                            if (dtmShiftEndTime >= dtmPermissionFromDateTime && dtmShiftEndTime <= dtmPermissionToDateTime)
                                            {
                                                strShiftEndTime = dtPermissionEndtime.Rows[0]["Permission_FromTime"].ToString();
                                                TimeSpan tsTimeDiff, tsPermissionDiff;
                                                tsTimeDiff = dtmPermissionToDateTime.Subtract(dtmLastOutDateTime);
                                                tsPermissionDiff = dtmPermissionToDateTime.Subtract(dtmPermissionFromDateTime);
                                            }
                                            else
                                            {
                                                strShiftEndTime = ActualShfOutTime;
                                            }
                                        }
                                        else
                                        {
                                            strShiftEndTime = ActualShfOutTime;
                                        }
                                    }
                                }
                                #endregion
                                // Calculating Early Out
                                TimeSpan tsEarlyOut = new TimeSpan();
                                TimeSpan tsShiftEndTime = new TimeSpan();
                                TimeSpan tsShift_EndTime = DateTime.Parse(strShiftEndTime).TimeOfDay;
                                DateTime dtmShftEndTimeMinusGrace = new DateTime();
                                DateTime dtmFirst_HalfEndTime = DateTime.Parse(strDate + " " + dtmFirstHalfEnd.TimeOfDay.ToString());
                                DateTime dtmShift_EndTime = new DateTime();
                                if (strClosingTime != string.Empty)
                                {
                                    dtmShift_EndTime = DateTime.Parse(strDate + " " + strClosingTime.ToString());
                                }
                                else
                                {
                                    dtmShift_EndTime = DateTime.Parse(strDate + " " + tsShift_EndTime.ToString());
                                }
                                if ((dtmShift_StartTime.ToString().Substring(dtmShift_StartTime.ToString().Length - 2, 2) == "PM") && (dtmFirstHalfEnd.ToString().Substring(dtmFirstHalfEnd.ToString().Length - 2, 2) == "AM"))
                                {
                                    dtmFirst_HalfEndTime = dtmFirst_HalfEndTime.AddDays(1);
                                }
                                DateTime dtmSecond_HalfStartTime = DateTime.Parse(strDate + " " + dtmSecondHalfStart.TimeOfDay.ToString());
                                if ((dtmShift_StartTime.ToString().Substring(dtmShift_StartTime.ToString().Length - 2, 2) == "PM") && (dtmSecondHalfStart.ToString().Substring(dtmSecondHalfStart.ToString().Length - 2, 2) == "AM"))
                                {
                                    dtmSecond_HalfStartTime = dtmSecond_HalfStartTime.AddDays(1);
                                }
                                if (dtShift.Rows[0]["Shift_GraceOutTime"] != DBNull.Value && dtShift.Rows[0]["Shift_GraceOutTime"].ToString() != string.Empty)
                                {
                                    strShftGraceOutTime = dtShift.Rows[0]["Shift_GraceOutTime"].ToString();
                                }
                                tsShiftEndTime = DateTime.Parse(dtShift.Rows[0]["Shift_EndTime"].ToString()).TimeOfDay;
                                dtmShftEndTimeMinusGrace = dtmShift_EndTime.Subtract(DateTime.Parse(strDate + " " + strShftGraceOutTime).TimeOfDay);
                                if ((blnIsPMAM || Is24Hrs) && strClosingDateTime == string.Empty && strANAttendanceCode != "CL")
                                {
                                    dtmShftEndTimeMinusGrace = dtmShftEndTimeMinusGrace.AddDays(1);
                                    dtmShift_EndTime = dtmShift_EndTime.AddDays(1);
                                }
                                else if ((blnIsPMAM || Is24Hrs) && strClosingDateTime != string.Empty &&
                                    (strClosingDateTime.Contains("AM")) &&
                                    (dtmActualShiftStartTime <= DateTime.Parse(strClosingDateTime) &&
                                    dtmShiftEndTime >= DateTime.Parse(strClosingDateTime)) &&
                                    (DateTime.Parse(dtmShiftEndTime.ToString("yyyy-MM-dd")) != DateTime.Parse(DateTime.Parse(strClosingDateTime).ToString("yyyy-MM-dd"))))
                                {
                                    dtmShftEndTimeMinusGrace = dtmShftEndTimeMinusGrace.AddDays(1);
                                }
                                else if ((blnIsPMAM || Is24Hrs) && strClosingTime.Contains("AM") && strANAttendanceCode != "CL")
                                {
                                    dtmShift_EndTime = dtmShift_EndTime.AddDays(1);
                                }
                                // If not Holiday, then Calculate Early Out
                                #region CalculatingEarlyOut
                                if (strIsHoliday != "Y" && strLeaveDay != "Full Day")
                                {
                                    if (dtmLastOutDateTime < dtmShftEndTimeMinusGrace)
                                    {
                                        tsEarlyOut = dtmShift_EndTime.Subtract(dtmLastOutDateTime);
                                        dEarlyOutMins = double.Parse(tsEarlyOut.TotalMinutes.ToString());
                                        strEarlyExit = GetTotalHours(tsEarlyOut);
                                    }
                                    else
                                    {
                                        strEarlyExit = "00:00";
                                        dEarlyOutMins = 0;
                                    }
                                }
                                else
                                {
                                    strEarlyExit = "00:00";
                                    dEarlyOutMins = 0;
                                }
                                #endregion
                                if (dtLeave.Rows.Count > 0)
                                {
                                    // Check for Second half Leave. If so then set the Shift End time as Lunch Start Time
                                    if (strLeaveDay == "Second Session")
                                    {
                                        dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                        strWorkHrs = Convert.ToString(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                    }
                                    else if (strLeaveDay == "First Session")
                                    {
                                        dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]);
                                        strWorkHrs = Convert.ToString(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]);
                                    }
                                }
                                else if (dtPermissionEndtime.Rows.Count > 0)
                                {
                                    //To subtract the permission hours for supposed hours calculation
                                    if (dtPermissionEndtime.Rows[0]["No_Of_Hours"] != DBNull.Value)
                                    {
                                        if (Convert.ToString(dtPermissionEndtime.Rows[0]["No_Of_Hours"]) != string.Empty)
                                        {
                                            DateTime dttNoOfHours = Convert.ToDateTime(Convert.ToString(dtPermissionEndtime.Rows[0]["No_Of_Hours"]));
                                            TimeSpan tsWorkHours = (dtmWorkHrs.Subtract(dttNoOfHours));
                                            dtmWorkHrs = Convert.ToDateTime(tsWorkHours.ToString());
                                            strWorkHrs = GetTotalHours(tsWorkHours);
                                        }
                                        else
                                        {
                                            DateTime dttPermissionTo = Convert.ToDateTime(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"]));
                                            DateTime dttPermissionFrom = Convert.ToDateTime(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_FromTime"]));
                                            TimeSpan tsVariation = (dttPermissionTo.Subtract(dttPermissionFrom));
                                            DateTime dttShiftVariation = Convert.ToDateTime(tsVariation.ToString());
                                            TimeSpan tsWorkHours = dtmWorkHrs.Subtract(dttShiftVariation);
                                            dtmWorkHrs = Convert.ToDateTime(tsWorkHours.ToString());
                                            strWorkHrs = GetTotalHours(tsWorkHours);
                                            if (dtmShiftEndTime >= dtmPermissionFromDateTime && dtmShiftEndTime <= dtmPermissionToDateTime)
                                            {
                                                TimeSpan tsPermissionDifference;
                                                tsPermissionDifference = dtmPermissionToDateTime.Subtract(dtmPermissionFromDateTime);
                                                dTotalMinsWorked = dTotalMinsWorked - tsPermissionDifference.TotalMinutes;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        DateTime dttPermissionTo = Convert.ToDateTime(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"]));
                                        DateTime dttPermissionFrom = Convert.ToDateTime(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_FromTime"]));
                                        TimeSpan tsVariation = (dttPermissionTo.Subtract(dttPermissionFrom));
                                        DateTime dttShiftVariation = Convert.ToDateTime(tsVariation.ToString());
                                        TimeSpan tsWorkHours = dtmWorkHrs.Subtract(dttShiftVariation);
                                        dtmWorkHrs = Convert.ToDateTime(tsWorkHours.ToString());
                                        strWorkHrs = GetTotalHours(tsWorkHours);
                                        if (dtmShiftEndTime >= dtmPermissionFromDateTime && dtmShiftEndTime <= dtmPermissionToDateTime)
                                        {
                                            TimeSpan tsPermissionDifference;
                                            tsPermissionDifference = dtmPermissionToDateTime.Subtract(dtmPermissionFromDateTime);
                                            dTotalMinsWorked = dTotalMinsWorked - tsPermissionDifference.TotalMinutes;
                                        }
                                    }
                                }
                                if (strIsHoliday != "Y")
                                {
                                    int intCompanyId = Convert.ToInt32(GetLevelId(inEmployee_Code_Id, dtmDate.ToString("yyyy-MM-dd")));
                                    try
                                    {
                                        #region SplitUpAfterAndBeforeOverTime
                                        dtOTSettings = OverTimeStatus(intCompanyId);
                                        if (dtOTSettings.Rows.Count > 0)
                                        {
                                            if (inOT_Eligible == "True" || InCompoffEligible == "True")
                                            {
                                                if (Convert.ToString(dtOTSettings.Rows[0]["AfterShiftTime"]) == "True")
                                                {
                                                    if (strLeaveDay == "Second Session")
                                                    {
                                                        if (dtmLastOutDateTime > dtmFirst_HalfEndTime)
                                                        {
                                                            tsLateExit = dtmLastOutDateTime.Subtract(dtmFirst_HalfEndTime);
                                                        }
                                                    }
                                                    else
                                                    {
                                                        if (dtmLastOutDateTime > dtmShift_EndTime)
                                                        {
                                                            tsLateExit = dtmLastOutDateTime.Subtract(dtmShift_EndTime);
                                                        }
                                                    }
                                                }
                                                else
                                                {
                                                    if (dtmLastOutDateTime > dtmShift_EndTime)
                                                    {
                                                        tsAfter = dtmLastOutDateTime.Subtract(dtmShift_EndTime);
                                                    }
                                                }
                                                if (Convert.ToString(dtOTSettings.Rows[0]["BeforeShiftTime"]) == "True")
                                                {
                                                    if (strLeaveDay == "First Session")
                                                    {
                                                        if (dtmFirstInDateTime < dtmSecond_HalfStartTime)
                                                        {
                                                            tsLateExit = tsLateExit + dtmSecond_HalfStartTime.TimeOfDay.Subtract(dtmFirstInDateTime.TimeOfDay);
                                                        }
                                                    }
                                                    else
                                                    {
                                                        if (dtmFirstInDateTime < dtmShift_StartTime)
                                                        {
                                                            tsLateExit = tsLateExit + dtmShift_StartTime.TimeOfDay.Subtract(dtmFirstInDateTime.TimeOfDay);
                                                        }
                                                    }
                                                }
                                                else
                                                {
                                                    if (dtmFirstInDateTime < dtmShift_StartTime)
                                                    {
                                                        tsBefore = dtmShift_StartTime.TimeOfDay.Subtract(dtmFirstInDateTime.TimeOfDay);
                                                    }
                                                }
                                            }
                                        }
                                        #endregion
                                    }
                                    catch (Exception ex)
                                    {
                                        WriteErrorToEventLog("DataProcess", "function : NonFlexibleHoursCalculation(ShiftSettings); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.Message);
                                        return;
                                    }
                                    #region CalculatingLateExit
                                    if (dtmLastOutDateTime > dtmShift_EndTime)
                                    {
                                        TimeSpan tsLate = new TimeSpan();
                                        tsLate = dtmLastOutDateTime.Subtract(dtmShift_EndTime);
                                        dLateExitMins = double.Parse(dtmLastOutDateTime.Subtract(dtmShift_EndTime).TotalMinutes.ToString());
                                        strExtraHours = GetTotalHours(tsLate);
                                    }
                                    #endregion
                                    TimeSpan TotalWrkhours = new TimeSpan();
                                    TimeSpan DefinedWrkHrs = new TimeSpan();
                                    // Check for Over Time Eligible // Updated this for WorkingDay OverTime
                                    #region CalculatingOverTime
                                    if ((inOT_Eligible == "True" || InCompoffEligible == "True") && ShftWorkOverTime != 0)
                                    {
                                        if (strShftMinOTTime != "00:00")
                                        {
                                            tsShftMinOTTime = DateTime.Parse(strShftMinOTTime).TimeOfDay;
                                        }
                                        if (strShftMaxOTTime != "00:00")
                                        {
                                            tsShftMaxOTTime = DateTime.Parse(strShftMaxOTTime).TimeOfDay;
                                        }
                                        // Normal OT
                                        if (tsShftMinOTTime <= tsLateExit && tsLateExit <= tsShftMaxOTTime)
                                        {
                                            dblOTMins = Double.Parse(tsLateExit.TotalMinutes.ToString());
                                            strNormOTFlag = "Y";
                                        }
                                        else if (tsLateExit >= tsShftMaxOTTime)
                                        {
                                            if (inOT_Eligible == "True" && InCompoffEligible == "True")
                                            {
                                                dblOTMins = Double.Parse(tsLateExit.TotalMinutes.ToString());
                                                strNormOTFlag = "Y";
                                            }
                                            else
                                            {
                                                dblOTMins = Double.Parse(tsShftMaxOTTime.TotalMinutes.ToString());
                                                strNormOTFlag = "Y";
                                            }
                                        }
                                        if (strNormOTFlag == "Y")
                                        {
                                            if (ShftWorkOverTime != 0)
                                            {
                                                dblOTMins = dblOTMins * ShftWorkOverTime;
                                            }
                                            // Call OT Round Off
                                            dblOTMins = OverTimeRoundOff(dblOTMins, inShiftSettingsId, inIsOTRoundOff);
                                            strNorOT = ConvertMinutesToHoursMins(dblOTMins);
                                            dOT = dOT + dblOTMins;
                                        }
                                    }
                                    else
                                    {
                                        strNorOT = "00:00";
                                        dOT = 0;
                                    }
                                    #endregion
                                }
                                else
                                {
                                    strExtraHours = "00:00"; dExtraMins = 0;
                                    dLateExitMins = 0;
                                    strNorOT = "00:00";
                                    dOT = 0;
                                }
                            }
                        }
                        // Calculating less Hour Work
                        double dMinLess = 0;
                        if (intShiftId != -1 && strIsHoliday != "Y")
                        {
                            double dActWorkMins = 0;
                            dActWorkMins = (dtmWorkHrs.Hour * 60) + dtmWorkHrs.Minute;
                            if (dActWorkMins > dTotalMinsWorked)
                            {
                                dMinLess = dActWorkMins - dTotalMinsWorked;
                                strLessHours = TimeFormat(dMinLess);
                            }
                        }
                        double dTotHrs = Math.Floor(dTotalMinsWorked / 60);
                        double dTotMins = dTotalMinsWorked % 60;
                        int iTotHrs = Convert.ToInt32(dTotHrs);
                        int iTotMins = Convert.ToInt32(dTotMins);
                        if (Convert.ToInt32(dTotMins) >= 60)
                        {
                            iTotMins = Convert.ToInt32(dTotMins) % 60;
                            iTotHrs += Convert.ToInt32(dTotMins) / 60;
                        }
                        strTotalWorkHours = iTotHrs.ToString("00") + ":" + iTotMins.ToString("00");
                        TimeSpan tsTotalWorkHours = new TimeSpan(int.Parse(strTotalWorkHours.Split(':')[0]), int.Parse(strTotalWorkHours.Split(':')[1]), 0);
                        TimeSpan TotalWrkhours_New = new TimeSpan();
                        TimeSpan DefinedWrkHrs_New = new TimeSpan();
                        TimeSpan ExtraWrkHrs = new TimeSpan();
                        if (strIsHoliday != "Y")
                        {
                            if ((inOT_Eligible == "True" || InCompoffEligible == "True") && ShftWorkOverTime != 0)
                            {
                                if (intShiftId != -1)
                                {
                                    TimeSpan TotalWrkhours = new TimeSpan();
                                    TimeSpan DefinedWrkHrs = new TimeSpan();
                                    #region CalculatingOverTime
                                    if (Convert.ToString(dtOTSettings.Rows[0]["DefinedWorkhrs"]) == "True")
                                    {
                                        if (tsTotalWorkHours.TotalMinutes < (dtmWorkHrs.TimeOfDay.TotalMinutes))
                                        {
                                            strNorOT = "00:00";
                                            dOT = 0;
                                        }
                                        else
                                        {
                                            TotalWrkhours_New = (DateTime.Parse(strTotalWorkHours).TimeOfDay);
                                            DefinedWrkHrs_New = dtmWorkHrs.TimeOfDay;
                                            strNormOTFlag = "N";
                                            if (TotalWrkhours_New > DefinedWrkHrs_New)
                                            {
                                                ExtraWrkHrs = TotalWrkhours_New - DefinedWrkHrs_New;
                                                strExtraHours = GetTotalHours(ExtraWrkHrs);
                                                dLateExitMins = Convert.ToDouble(ExtraWrkHrs.TotalMinutes);
                                                dExtraMins = Convert.ToDouble(ExtraWrkHrs.TotalMinutes);
                                            }
                                            if (Convert.ToString(dtOTSettings.Rows[0]["AfterShiftTime"]) == "True" || (Convert.ToString(dtOTSettings.Rows[0]["BeforeShiftTime"]) == "True"))
                                            {
                                                //TotalWrkhours = (DateTime.Parse(strTotalWorkHours).TimeOfDay);
                                                TotalWrkhours = tsTotalWorkHours;
                                                if (Convert.ToString(dtOTSettings.Rows[0]["AfterShiftTime"]) == "True" && (Convert.ToString(dtOTSettings.Rows[0]["BeforeShiftTime"]) == "False"))
                                                {
                                                    //dbefore = Convert.ToDouble(tsBefore);
                                                    //TotalWrkhours = DateTime.Parse(Convert.ToString(dTotalMinsWorked - dbefore)).TimeOfDay;
                                                    TotalWrkhours = TotalWrkhours.Subtract(tsBefore);
                                                }
                                                else if (Convert.ToString(dtOTSettings.Rows[0]["AfterShiftTime"]) == "False" && (Convert.ToString(dtOTSettings.Rows[0]["BeforeShiftTime"]) == "True"))
                                                {
                                                    TotalWrkhours = TotalWrkhours.Subtract(tsAfter);
                                                }
                                                DefinedWrkHrs = dtmWorkHrs.TimeOfDay;
                                                DefinedWrkHrs = TotalWrkhours - DefinedWrkHrs;
                                                if (tsShftMinOTTime <= DefinedWrkHrs && DefinedWrkHrs <= tsShftMaxOTTime)
                                                {
                                                    dblOTMins = Double.Parse(DefinedWrkHrs.TotalMinutes.ToString());
                                                    strNormOTFlag = "Y";
                                                }
                                                else if (DefinedWrkHrs >= tsShftMaxOTTime)
                                                {
                                                    if (inOT_Eligible == "True" && InCompoffEligible == "True")
                                                    {
                                                        dblOTMins = Double.Parse(DefinedWrkHrs.TotalMinutes.ToString());
                                                        strNormOTFlag = "Y";
                                                    }
                                                    else
                                                    {
                                                        dblOTMins = Double.Parse(tsShftMaxOTTime.TotalMinutes.ToString());
                                                        strNormOTFlag = "Y";
                                                    }
                                                }
                                                else
                                                {
                                                    dblOTMins = 0;
                                                    strNormOTFlag = "Y";
                                                }
                                                if (strNormOTFlag == "Y")
                                                {
                                                    if (ShftWorkOverTime != 0)
                                                    {
                                                        dblOTMins = dblOTMins * ShftWorkOverTime;
                                                    }
                                                    // Call OT Round Off
                                                    dblOTMins = OverTimeRoundOff(dblOTMins, inShiftSettingsId, inIsOTRoundOff);
                                                    strNorOT = ConvertMinutesToHoursMins(dblOTMins);
                                                    dOT = dblOTMins;
                                                }
                                            }
                                            else
                                            {
                                                strNorOT = "00:00";
                                                dOT = 0;
                                            }
                                        }
                                    }
                                    else
                                    {
                                        strExtraHours = ConvertMinutesToHoursMins(dOT);
                                        dExtraMins = dOT;
                                    }
                                    #endregion
                                }
                            }
                            else
                            {
                                strNorOT = "00:00";
                                dOT = 0;
                                if (intShiftId != -1)
                                {
                                    TotalWrkhours_New = (DateTime.Parse(strTotalWorkHours).TimeOfDay);
                                    DefinedWrkHrs_New = dtmWorkHrs.TimeOfDay;
                                    strNormOTFlag = "N";
                                    if (TotalWrkhours_New > DefinedWrkHrs_New)
                                    {
                                        ExtraWrkHrs = TotalWrkhours_New - DefinedWrkHrs_New;
                                        strExtraHours = GetTotalHours(ExtraWrkHrs);
                                        dLateExitMins = Convert.ToDouble(ExtraWrkHrs.TotalMinutes);
                                        dExtraMins = Convert.ToDouble(ExtraWrkHrs.TotalMinutes);
                                    }
                                }
                                else
                                {
                                    TotalWrkhours_New = (DateTime.Parse(strTotalWorkHours).TimeOfDay);
                                    ExtraWrkHrs = TotalWrkhours_New - DefinedWrkHrs_New;
                                    strExtraHours = GetTotalHours(ExtraWrkHrs);
                                    dLateExitMins = Convert.ToDouble(ExtraWrkHrs.TotalMinutes);
                                    dExtraMins = Convert.ToDouble(ExtraWrkHrs.TotalMinutes);
                                }
                            }
                        }
                        else
                        {
                            TotalWrkhours_New = (DateTime.Parse(strTotalWorkHours).TimeOfDay);
                            ExtraWrkHrs = TotalWrkhours_New;
                            strExtraHours = GetTotalHours(ExtraWrkHrs);
                            dLateExitMins = Convert.ToDouble(ExtraWrkHrs.TotalMinutes);
                            dExtraMins = Convert.ToDouble(ExtraWrkHrs.TotalMinutes);
                        }
                        // Calculate OT
                        double dOTmins = 0;
                        dOTmins = dShftHolyOverTime + dShftWeekOffOverTime + dOT;
                        if (inStatus == "BL")
                        {
                            ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                        }
                        try
                        {
                            // Update the All the calculated data to the Processed Data table
                            #region UpdateFlagInProcessedData
                            string strSQLProcessUpdate = string.Empty;
                            string strSQLUpdateOverTimeStatus = string.Empty;
                            string strBreakHours = "00", strBreakMinute = "00";
                            string strLunchHours = "00", strLunchMinute = "00";
                            if (BreakTakenedByEmployee >= 60)
                            {
                                strBreakHours = Convert.ToInt32(BreakTakenedByEmployee / 60).ToString().Length > 1 ? Convert.ToInt32(BreakTakenedByEmployee / 60).ToString() : ("0" + Convert.ToString(Math.Floor(BreakTakenedByEmployee / 60)));
                                strBreakMinute = Convert.ToInt32(BreakTakenedByEmployee % 60).ToString().Length > 1 ? Convert.ToInt32(BreakTakenedByEmployee % 60).ToString() : ("0" + Convert.ToString(BreakTakenedByEmployee % 60));
                            }
                            else
                            {
                                strBreakHours = "00";
                                strBreakMinute = Convert.ToInt32(BreakTakenedByEmployee % 60).ToString().Length > 1 ? Convert.ToInt32(BreakTakenedByEmployee % 60).ToString() : ("0" + Convert.ToString(BreakTakenedByEmployee % 60));
                            }
                            if (LunchTakenedByEmployee >= 60)
                            {
                                strLunchHours = Convert.ToInt32(LunchTakenedByEmployee / 60).ToString().Length > 1 ? Convert.ToInt32(LunchTakenedByEmployee / 60).ToString() : ("0" + Convert.ToString(Math.Floor(LunchTakenedByEmployee / 60)));
                                strLunchMinute = Convert.ToInt32(LunchTakenedByEmployee % 60).ToString().Length > 1 ? Convert.ToInt32(LunchTakenedByEmployee % 60).ToString() : ("0" + Convert.ToString(LunchTakenedByEmployee % 60));
                            }
                            else
                            {
                                strLunchHours = "00";
                                strLunchMinute = Convert.ToInt32(LunchTakenedByEmployee % 60).ToString().Length > 1 ? Convert.ToInt32(LunchTakenedByEmployee % 60).ToString() : ("0" + Convert.ToString(LunchTakenedByEmployee % 60));
                            }
                            // TODO: I need to check this point on holiday
                            TimeSpan tsEarlyIn = new TimeSpan();
                            TimeSpan tsLateOut = new TimeSpan();
                            if (strFirstIn != "")
                            {
                                if (intShiftId != -1 && strIsHoliday != "Y" && strLeaveDay != "Full Day")
                                {
                                    // Calculate Early Entry , if Actual InTime is greater that Shift Start Time
                                    if (DateTime.Parse(ActualShfInTime) > DateTime.Parse(strFirstIn))
                                    {
                                        tsEarlyIn = DateTime.Parse(ActualShfInTime).Subtract(DateTime.Parse(strFirstIn));
                                        dEarlyInMins = double.Parse(Convert.ToString(tsEarlyIn.TotalMinutes));
                                        strEarlyIn = GetTotalHours(tsEarlyIn);
                                    }
                                }
                            }
                            if (strLastOut != "")
                            {
                                if (intShiftId != -1 && strIsHoliday != "Y" && strLeaveDay != "Full Day")
                                {
                                    if (DateTime.Parse(strShiftEndTime) < DateTime.Parse(strLastOut))
                                    {
                                        tsLateOut = DateTime.Parse(strLastOut).Subtract(DateTime.Parse(strShiftEndTime));
                                        dLateOutMins = double.Parse(Convert.ToString(tsLateOut.TotalMinutes));
                                        strLateOut = GetTotalHours(tsLateOut);
                                    }
                                }
                            }
                            strSQLProcessUpdate = "UPDATE TA_Tbl_ProcessedData SET InTime = '" + strFirstIn + "',OutTime = '" + strLastOut + "',Shift_Id = " + intShiftId + ",HrsWork = '" + strTotalWorkHours + "',LateIn = '" + strLateInTime + "',LateInMins = " + dLateInMins + ",EarlyOut = '" + strEarlyExit + "',EarlyOutMins = " + dEarlyOutMins + ",HrsOT = '" + strHrsOT + "', NormOT = '" + strNorOT + "',Status = NULL,";
                            strSQLProcessUpdate += "OffOT = '" + strWeekOffOT + "', HolOT = '" + strHoliOT + "', Attendance = 'Present',";
                            strSQLProcessUpdate += " FNAttendanceCode='" + strFNAttendanceCode.Replace("'", "''") + "' , ANAttendanceCode='" + strANAttendanceCode + "',";
                            strSQLProcessUpdate += "BreakHrs = '" + strBreakHours + ":" + strBreakMinute + "',";
                            strSQLProcessUpdate += "LunchHrs = '" + strLunchHours + ":" + strLunchMinute + "',";
                            strSQLProcessUpdate += "HoursWorkInMins = '" + dTotalMinsWorked + "',";
                            strSQLProcessUpdate += "BreakHrsInMins = '" + BreakTakenedByEmployee + "',";
                            strSQLProcessUpdate += "LunchHrsInMins = '" + LunchTakenedByEmployee + "',";
                            strSQLProcessUpdate += "YearSettingId = '" + intYearSettingId + "',";
                            //TODO: Need to add below lines into service
                            strSQLProcessUpdate += " Indate='" + strFirstInDate + "' , Outdate='" + strLastOutDate + "',";
                            strSQLProcessUpdate += " Inpunch='" + strFirstInPunchType + "' , Outpunch='" + strLastOutPunchType + "',";
                            if (dtPermissionEndtime.Rows.Count > 1)
                            {
                                DateTime PermissionTo = Convert.ToDateTime(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_ToTime"]));
                                DateTime PermissionFrom = Convert.ToDateTime(Convert.ToString(dtPermissionEndtime.Rows[0]["Permission_FromTime"]));
                                TimeSpan Variation = (PermissionTo.Subtract(PermissionFrom));
                                strSQLProcessUpdate += "PermissionHrsInMins= '" + Variation + "',";
                                strSQLProcessUpdate += "PermissionHrs = '" + Convert.ToString(dtPermissionEndtime.Rows[0]["No_Of_Hours"]) + "',";
                            }
                            else
                            {
                                strSQLProcessUpdate += "PermissionHrsInMins= 0,";
                                strSQLProcessUpdate += "PermissionHrs = '00:00',";
                            }
                            if (intShiftId > 0)
                            {
                                string strHours = string.Empty, strMinute = string.Empty;
                                strSQLProcessUpdate += "Shift_StartTime = '" + DateTime.Parse(strActualShiftStartTime).ToString("hh:mm tt") + "',";
                                strSQLProcessUpdate += "Shift_EndTime = '" + DateTime.Parse(strShift_EndTime).ToString("hh:mm tt") + "',";
                                if (strLeaveDay == "Full Day")
                                {
                                    strSQLProcessUpdate += "WorkHrs = '00:00'";
                                    strSQLProcessUpdate += ",WorkHoursInMins = '0'";
                                }
                                else if (isTempWeekday == true)
                                    strSQLProcessUpdate += "WorkHrs = '" + strWorkHrs + "'";
                                else
                                {
                                    strHours = dtmWorkHrs.Hour.ToString().Length > 1 ? dtmWorkHrs.Hour.ToString() : ("0" + dtmWorkHrs.Hour.ToString());
                                    strMinute = dtmWorkHrs.Minute.ToString().Length > 1 ? dtmWorkHrs.Minute.ToString() : ("0" + dtmWorkHrs.Minute.ToString());
                                    strSQLProcessUpdate += "WorkHrs = '" + strHours + ":" + strMinute + "'";
                                    strSQLProcessUpdate += ",WorkHoursInMins = '" + (dtmWorkHrs.Hour * 60 + dtmWorkHrs.Minute) + "'";
                                    //strSQLProcessUpdate += "WorkHrs = '" + dtmWorkHrs.ToString("hh:mm") + "'";
                                }
                            }
                            else
                            {
                                strSQLProcessUpdate += "Shift_StartTime = NULL,";
                                strSQLProcessUpdate += "Shift_EndTime = NULL,";
                                strSQLProcessUpdate += "WorkHrs = NULL";
                            }
                            DataTable dtOverTimeStatus = new DataTable();
                            if (dOTmins > 0 && gStrOverTimeStatus != string.Empty)
                            {
                                if (inOT_Eligible == "True" && InCompoffEligible == "True")
                                {
                                    strSQLUpdateOverTimeStatus = "select * from TA_Tbl_OverTimeStatus where Process_RecID=" + inProcess_Rec_ID;
                                    dtOverTimeStatus = objDatafunction.ExeQuery(strSQLUpdateOverTimeStatus, "TA_Tbl_OverTimeStatus");
                                    if (dtOverTimeStatus.Rows.Count > 0)
                                    {
                                        strSQLProcessUpdate += ",OvertimeStatus = (select OverTimeStatus from TA_Tbl_OverTimeStatus where Process_RecID=" + inProcess_Rec_ID + ")";
                                    }
                                    else
                                    {
                                        strSQLProcessUpdate += ",OvertimeStatus = 'Pending'";
                                    }
                                }
                                else if (inOT_Eligible == "True" || InCompoffEligible == "True")
                                {
                                    strSQLProcessUpdate += ",OvertimeStatus = '" + gStrOverTimeStatus + "'";
                                }
                            }
                            else
                            {
                                if (inOT_Eligible == "True" && InCompoffEligible == "True")
                                {
                                    strSQLUpdateOverTimeStatus = "select * from TA_Tbl_OverTimeStatus where Process_RecID=" + inProcess_Rec_ID;
                                    dtOverTimeStatus = objDatafunction.ExeQuery(strSQLUpdateOverTimeStatus, "TA_Tbl_OverTimeStatus");
                                    if (dtOverTimeStatus.Rows.Count > 0)
                                    {
                                        strSQLProcessUpdate += ",OvertimeStatus = (select OverTimeStatus from TA_Tbl_OverTimeStatus where Process_RecID=" + inProcess_Rec_ID + ")";
                                    }
                                    else
                                    {
                                        strSQLProcessUpdate += ",OvertimeStatus = 'Pending'";
                                    }
                                }
                                else if (inOT_Eligible == "True" || InCompoffEligible == "True")
                                {
                                    strSQLProcessUpdate += ",OvertimeStatus =NULL";
                                }
                            }
                            if (intShiftId != -1 && strIsHoliday != "Y")
                            {
                                if (strFirstIn != "")
                                {
                                    if (DateTime.Parse(strShiftStartTime) > DateTime.Parse(strFirstIn))
                                    {
                                        strSQLProcessUpdate += ",EarlyEntry = 1";
                                        strSQLProcessUpdate += ",EarlyInmins = " + dEarlyInMins;
                                        strSQLProcessUpdate += ",EarlyInHrs = '" + strEarlyIn + "'";
                                    }
                                    else
                                    {
                                        strSQLProcessUpdate += ",EarlyEntry = 0";
                                        strSQLProcessUpdate += ",EarlyInmins = 0";
                                        strSQLProcessUpdate += ",EarlyInHrs = '00:00'";
                                    }
                                }
                                else
                                {
                                    strSQLProcessUpdate += ",EarlyEntry = 0";
                                    strSQLProcessUpdate += ",EarlyInmins = 0";
                                    strSQLProcessUpdate += ",EarlyInHrs = '00:00'";
                                }
                                if (dLateExitMins > 0)
                                {
                                    strSQLProcessUpdate += ",LateExit = 1";
                                    strSQLProcessUpdate += ",lateExitMins =" + dLateOutMins;
                                    strSQLProcessUpdate += ",lateExitHours ='" + strLateOut + "'";
                                }
                                else
                                {
                                    strSQLProcessUpdate += ",LateExit = 0";
                                    strSQLProcessUpdate += ",lateExitMins =0";
                                    strSQLProcessUpdate += ",lateExitHours ='00:00'";
                                }
                            }
                            else
                            {
                                strSQLProcessUpdate += ",LateExit = 0,EarlyEntry = 0";
                                strSQLProcessUpdate += ",lateExitMins =0";
                                strSQLProcessUpdate += ",lateExitHours =0";
                                strSQLProcessUpdate += ",EarlyInmins = 0";
                                strSQLProcessUpdate += ",EarlyInHrs = '00:00'";
                            }
                            strSQLProcessUpdate += ",HrsLess = '" + strLessHours + "',HrsExtra = '" + strExtraHours + "',ExtraMins = " + dExtraMins + ",OtMins = " + dOTmins + ",TotalDays = " + dblTotalDays + ",LeaveCode = '" + strLeaveCode.Replace("'", "''") + "',ProcessFlag = 1 ";
                            strSQLProcessUpdate += ",LessHoursInMins = '" + dMinLess + "'";
                            strSQLProcessUpdate += "WHERE Process_Rec_ID = " + inProcess_Rec_ID + "";
                            if (strSQLProcessUpdate != string.Empty)
                            {
                                OleDbParameter pgUpdateQuery = new OleDbParameter("@UpdateQuery", strSQLProcessUpdate);
                                OleDbParameter[] pParams_UpdateQuery ={ pgUpdateQuery };
                                objDatafunction.SP_Execute(pParams_UpdateQuery, "Proc_Ta_UpdateProcessedDataForService");
                            }
                            #endregion
                        }
                        catch (Exception ex)
                        {
                            WriteErrorToEventLog("DataProcess", "function : NonFlexibleHoursCalculation(UPDATE TA_Tbl_ProcessedData1); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                            return;
                        }
                        #endregion
                    }
                    else
                    {
                        #region FirstInOrLastOutPunchDetailsAvailed
                        bool blnIsPMAM = false;
                        DateTime dtmActualShiftStartTime = new DateTime();
                        DateTime dtmShiftEndTime = new DateTime();
                        string strActualShiftStartTime = string.Empty;
                        string strShift_EndTime = string.Empty;
                        if (intShiftId != -1 && intShiftId != 0 && strIsHoliday != "Y")
                        {
                            string strActShiftStartTime = strDate + " " + ActualShfInTime;
                            dtmActualShiftStartTime = DateTime.Parse(strActShiftStartTime);
                            string strShiftEndTim = strDate + " " + ActualShfOutTime;
                            dtmShiftEndTime = DateTime.Parse(strShiftEndTim);
                            strActualShiftStartTime = dtmActualShiftStartTime.ToString("hh:mm:ss tt");
                            strShift_EndTime = dtmShiftEndTime.ToString("hh:mm:ss tt");
                            if ((strActualShiftStartTime.Substring(9, 2) == "PM") && (strShift_EndTime.Substring(9, 2) == "AM"))
                            {
                                blnIsPMAM = true;
                                dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                            }
                            if (Is24Hrs)
                            {
                                dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                            }
                            if (blnInDateTime == true && blnOutDateTime == false)
                            {
                                TimeSpan tsLateIn = new TimeSpan();
                                if (strFirstIn == string.Empty)
                                {
                                    strFirstIn = inInTime;
                                }
                                tsLateIn = CalculateLateEntry(inEmployee_Code_Id, dtmDate, ActualShfInTime, strShftGraceInTime, strSecondHalfStart, tsFirstInTime, dtmFirstInDateTime, strDate);
                                dLateInMins = double.Parse(tsLateIn.TotalMinutes.ToString());
                                strLateInTime = GetTotalHours(tsLateIn);
                            }
                        }
                        // Update the ProcessFlag to 1
                        string strSQLProcessFlagUpdate = string.Empty;
                        strSQLProcessFlagUpdate = "UPDATE TA_Tbl_ProcessedData SET Shift_Id = " + intShiftId + "";
                        if (strFirstIn == string.Empty)
                        {
                            strSQLProcessFlagUpdate += ",InTime = NULL,LateIn='00:00',LateInMins=0";
                            //TODO: We need to add below lines into service
                            strSQLProcessFlagUpdate += " ,Indate=NULL";
                            strSQLProcessFlagUpdate += " ,Inpunch=NULL";
                        }
                        else
                        {
                            strSQLProcessFlagUpdate += ",InTime = '" + strFirstIn + "',LateIn = '" + strLateInTime + "',LateInMins = " + dLateInMins + "";
                            //TODO: We need to add below lines into service
                            strSQLProcessFlagUpdate += " ,Indate='" + strFirstInDate + "'";
                            strSQLProcessFlagUpdate += " ,Inpunch='" + strFirstInPunchType + "' ";
                        }
                        if (strLastOut == string.Empty)
                        {
                            strSQLProcessFlagUpdate += ",OutTime = NULL,EarlyOut='00:00',EarlyOutMins=0,HrsExtra='00:00',ExtraMins=0,OtMins=0,OvertimeStatus=NULL,NormOT='00:00',OffOT='00:00',HolOT='00:00'";
                            //TODO: We need to add below lines into service
                            strSQLProcessFlagUpdate += " ,Outdate=NULL";
                            strSQLProcessFlagUpdate += " ,Outpunch=NULL";
                        }
                        else
                        {
                            strSQLProcessFlagUpdate += ",OutTime = '" + strLastOut + "'";
                            //TODO: We need to add below lines into service
                            strSQLProcessFlagUpdate += " ,Outdate='" + strLastOutDate + "'";
                            strSQLProcessFlagUpdate += " ,Outpunch='" + strLastOutPunchType + "'";
                        }
                        bool blnIsPMAMFirstHalfStartEnd = false;
                        DateTime dtmShiftFirstHalfEndTime = new DateTime();
                        string strShiftFirstHalfEndTime = strDate + " " + strFirstHalfEnd;
                        dtmShiftFirstHalfEndTime = DateTime.Parse(strShiftFirstHalfEndTime);
                        DateTime dtmActualShiftStartTime1 = new DateTime();
                        string strActShiftStartTime1 = strDate + " " + ActualShfInTime;
                        dtmActualShiftStartTime1 = DateTime.Parse(strActShiftStartTime1);
                        string strActualShiftStartTime1 = dtmActualShiftStartTime1.ToString("hh:mm:ss tt");
                        //Check First half start and end time in PM  AM
                        if ((strActualShiftStartTime1.Substring(strActualShiftStartTime1.Length - 2, 2) == "PM") && (strFirstHalfEnd.Substring(strFirstHalfEnd.Length - 2, 2) == "AM"))
                        {
                            blnIsPMAMFirstHalfStartEnd = true;
                            dtmShiftFirstHalfEndTime = dtmShiftFirstHalfEndTime.AddDays(1);
                        }
                        TimeSpan tsFnAttandance, tsAnAttandance;
                        if (strLeaveDay != "Full Day")
                        {
                            if (strFirstIn != string.Empty)
                            {
                                if (strFirstHalfEnd != "")
                                {
                                    tsFnAttandance = DateTime.Parse(DateTime.Parse(strFirstInDateTime).ToShortTimeString()).Subtract(DateTime.Parse(DateTime.Parse(strFirstHalfEnd).ToShortTimeString()));
                                    if (blnIsPMAM == true)
                                    {
                                        if (strFirstInDateTime.Substring(strFirstInDateTime.Length - 2, 2) == "PM" && strFirstHalfEnd.Substring(strFirstHalfEnd.Length - 2, 2) == "AM")
                                        {
                                            tsFnAttandance = DateTime.Parse(DateTime.Parse(strFirstInDateTime).ToShortTimeString()).Subtract(DateTime.Parse(DateTime.Parse(strFirstHalfEnd).AddDays(1).ToShortTimeString()));
                                            strFNAttendanceCode = (tsFnAttandance.TotalMinutes > 0) ? "Present" : "Absent";
                                        }
                                        else if (blnIsPMAMFirstHalfStartEnd == true)
                                        {
                                            strFNAttendanceCode = (DateTime.Parse(strFirstInDateTime) >= dtmActualShiftStartTime1 && DateTime.Parse(strFirstInDateTime) <= dtmShiftFirstHalfEndTime) ? "Present" : "Absent";
                                        }
                                        else
                                        {
                                            strFNAttendanceCode = (tsFnAttandance.TotalMinutes < 0) ? "Present" : "Absent";
                                        }
                                    }
                                    else
                                    {
                                        strFNAttendanceCode = (tsFnAttandance.TotalMinutes < 0) ? "Present" : "Absent";
                                    }
                                }
                            }
                            if (strLastOut != string.Empty)
                            {
                                if (strSecondHalfStart != string.Empty)
                                {
                                    if (blnIsPMAM == true)
                                    {
                                        if (strSecondHalfStart.Substring(strSecondHalfStart.Length - 2, 2) == "AM")
                                        {
                                            tsAnAttandance = Convert.ToDateTime(strLastOutDateTime).Subtract(Convert.ToDateTime(dtmDate.AddDays(1).ToString("yyyy-MM-dd") + " " + strSecondHalfStart));
                                        }
                                        else
                                        {
                                            tsAnAttandance = Convert.ToDateTime(strLastOutDateTime).Subtract(Convert.ToDateTime(dtmDate.ToString("yyyy-MM-dd") + " " + strSecondHalfStart));
                                        }
                                        strANAttendanceCode = (tsAnAttandance.TotalMinutes > 0) ? "Present" : "Absent";
                                    }
                                    else
                                    {
                                        tsAnAttandance = Convert.ToDateTime(strLastOutDateTime).Subtract(Convert.ToDateTime(dtmDate.ToString("yyyy-MM-dd") + " " + strSecondHalfStart));
                                        strANAttendanceCode = (tsAnAttandance.TotalMinutes > 0) ? "Present" : "Absent";
                                    }
                                }
                            }
                        }
                        if (intShiftId == -1)
                        {
                            strFNAttendanceCode = "Weekly Off";
                            strANAttendanceCode = "Weekly Off";
                            gstrAttendance = "Weekly Off";
                        }
                        if (strIsHoliday == "Y")
                        {
                            strFNAttendanceCode = "Holiday";
                            strANAttendanceCode = "Holiday";
                            gstrAttendance = "Holiday";
                        }
                        //Check leave
                        if (dtLeave.Rows.Count > 0)
                        {
                            // Half day calculation
                            if (strLeaveCategory != string.Empty)
                            {
                                if (strLeaveCategory == "Leave")
                                {
                                    if (dtLeave.Rows[0]["LeaveType_id"] != DBNull.Value)
                                    {
                                        if (int.Parse(dtLeave.Rows[0]["LeaveType_id"].ToString()) > 0)
                                        {
                                            strLeaveType = GetLeaveType(int.Parse(dtLeave.Rows[0]["LeaveType_id"].ToString()));
                                            if (strLeaveType != string.Empty)
                                            {
                                                if (strLeaveDay == "Full Day")
                                                {
                                                    //strFNAttendanceCode = strLeaveType;
                                                    //strANAttendanceCode = strFNAttendanceCode;
                                                    dblTotalDays = 1;
                                                }
                                                else if (strLeaveDay == "First Session")
                                                {
                                                    strFNAttendanceCode = strLeaveType;
                                                    dblTotalDays = 0.5;
                                                }
                                                else if (strLeaveDay == "Second Session")
                                                {
                                                    strANAttendanceCode = strLeaveType;
                                                    dblTotalDays = 0.5;
                                                }
                                                gstrAttendance = strLeaveType;
                                            }
                                        }
                                        //Adeed by Manikandan on 04-11-2015 12.19 PM
                                        //if employee applied half day comp off or other leaves and remaining session is cl
                                        else
                                        {
                                            if (strLeaveDay == "Full Day")
                                            {
                                                dblTotalDays = 1;
                                            }
                                            gstrAttendance = Convert.ToString(dtLeave.Rows[0]["Type"]);
                                        }
                                    }
                                }
                                else
                                {
                                    gstrAttendance = strLeaveCategory;
                                    if (strLeaveDay == "Full Day")
                                    {
                                        //strFNAttendanceCode = strLeaveCategory;
                                        //strANAttendanceCode = strFNAttendanceCode;
                                        dblTotalDays = 1;
                                    }
                                    else if (strLeaveDay == "First Session")
                                    {
                                        strFNAttendanceCode = strLeaveCategory;
                                        dblTotalDays = 0.5;
                                    }
                                    else if (strLeaveDay == "Second Session")
                                    {
                                        strANAttendanceCode = strLeaveCategory;
                                        dblTotalDays = 0.5;
                                    }
                                }
                            }
                        }
                        // TODO: I need to check this point on holiday
                        TimeSpan tsEarlyIn = new TimeSpan();
                        TimeSpan tsLateOut = new TimeSpan();
                        if (strFirstIn != "")
                        {
                            if (intShiftId != -1 && strIsHoliday != "Y" && strLeaveDay != "Full Day")
                            {
                                // Calculate Early Entry , if Actual InTime is greater that Shift Start Time
                                if (DateTime.Parse(ActualShfInTime) > DateTime.Parse(strFirstIn))
                                {
                                    tsEarlyIn = DateTime.Parse(ActualShfInTime).Subtract(DateTime.Parse(strFirstIn));
                                    dEarlyInMins = double.Parse(Convert.ToString(tsEarlyIn.TotalMinutes));
                                    strEarlyIn = GetTotalHours(tsEarlyIn);
                                }
                            }
                        }
                        if (strLastOut != "")
                        {
                            if (intShiftId != -1 && strIsHoliday != "Y" && strLeaveDay != "Full Day")
                            {
                                if (DateTime.Parse(ActualShfOutTime) < DateTime.Parse(strLastOut))
                                {
                                    tsLateOut = DateTime.Parse(ActualShfOutTime).Subtract(DateTime.Parse(strLastOut));
                                    dLateOutMins = double.Parse(Convert.ToString(tsLateOut.TotalMinutes));
                                    strLateOut = GetTotalHours(tsLateOut);
                                }
                            }
                        }
                        //End of Check Attandance
                        if (strFirstIn != string.Empty || strLastOut != string.Empty)
                        {
                            if (inStatus == "BL")
                            {
                                ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                            }
                            strSQLProcessFlagUpdate += ",Status = NULL";
                        }
                        if (strFirstIn == string.Empty && strLastOut == string.Empty)
                        {
                            if (inStatus == "BL")
                            {
                                if (HolidayId != 0)
                                {
                                    strSQLProcessFlagUpdate += ",Attendance = 'Holiday',FNAttendanceCode = 'Holiday',ANAttendanceCode = 'Holiday',Status = NULL";
                                    ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                }
                                else if (intShiftId == -1)
                                {
                                    strSQLProcessFlagUpdate += ",Attendance = 'Weekly Off',FNAttendanceCode = 'Weekly Off',ANAttendanceCode = 'Weekly Off',Status = NULL";
                                    ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                }
                                else if (dtLeave.Rows.Count > 0)
                                {
                                    //half day calculation
                                    if (strLeaveCategory != string.Empty)
                                    {
                                        if (strLeaveCategory == "Leave")
                                        {
                                            if (dtLeave.Rows[0]["LeaveType_id"] != DBNull.Value)
                                            {
                                                if (int.Parse(dtLeave.Rows[0]["LeaveType_id"].ToString()) > 0)
                                                {
                                                    // Get Leave Type by passing Leave Type Id
                                                    strLeaveType = GetLeaveType(int.Parse(dtLeave.Rows[0]["LeaveType_id"].ToString()));
                                                    if (strLeaveType != string.Empty)
                                                    {
                                                        if (strLeaveDay == "Full Day")
                                                        {
                                                            //strFNAttendanceCode = strLeaveType;
                                                            //strANAttendanceCode = strFNAttendanceCode;
                                                            dblTotalDays = 1;
                                                        }
                                                        else if (strLeaveDay == "First Session")
                                                        {
                                                            strFNAttendanceCode = strLeaveType;
                                                            dblTotalDays = 0.5;
                                                        }
                                                        else if (strLeaveDay == "Second Session")
                                                        {
                                                            strANAttendanceCode = strLeaveType;
                                                            dblTotalDays = 0.5;
                                                        }
                                                        gstrAttendance = strLeaveType;
                                                    }
                                                }
                                            }
                                        }
                                        else
                                        {
                                            gstrAttendance = strLeaveCategory;
                                            if (strLeaveDay == "Full Day")
                                            {
                                                //strFNAttendanceCode = strLeaveCategory;
                                                //strANAttendanceCode = strFNAttendanceCode;
                                                dblTotalDays = 1;
                                            }
                                            else if (strLeaveDay == "First Session")
                                            {
                                                strFNAttendanceCode = strLeaveCategory;
                                                dblTotalDays = 0.5;
                                            }
                                            else if (strLeaveDay == "Second Session")
                                            {
                                                strANAttendanceCode = strLeaveCategory;
                                                dblTotalDays = 0.5;
                                            }
                                        }
                                    }
                                    //End of half day calculation
                                    strSQLProcessFlagUpdate += ",Attendance = '" + gstrAttendance.Replace("'", "''") + "',LeaveCode = '" + strLeaveCode.Replace("'", "''") + "',Status = NULL  , FNAttendanceCode= '" + strFNAttendanceCode.Replace("'", "''") + "' ,ANAttendanceCode='" + strANAttendanceCode.Replace("'", "''") + "'";
                                    ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                }
                                else
                                {                                    // Nothing
                                }
                            }
                            else
                            {
                                strSQLProcessFlagUpdate += " ,FNAttendanceCode= '" + strFNAttendanceCode.Replace("'", "''") + "' ,ANAttendanceCode='" + strANAttendanceCode.Replace("'", "''") + "'";
                            }
                        }
                        else
                        {
                            strSQLProcessFlagUpdate += " ,FNAttendanceCode= '" + strFNAttendanceCode.Replace("'", "''") + "' ,ANAttendanceCode='" + strANAttendanceCode.Replace("'", "''") + "'";
                        }
                        if (intShiftId != -1 && strIsHoliday != "Y")
                        {
                            if (strFirstIn != "")
                            {
                                if (DateTime.Parse(ActualShfInTime) > DateTime.Parse(strFirstIn))
                                {
                                    strSQLProcessFlagUpdate += ",EarlyEntry = 1";
                                    strSQLProcessFlagUpdate += ",EarlyInmins = " + dEarlyInMins;
                                    strSQLProcessFlagUpdate += ",EarlyInHrs = '" + strEarlyIn + "'";
                                }
                                else
                                {
                                    strSQLProcessFlagUpdate += ",EarlyEntry = 0";
                                    strSQLProcessFlagUpdate += ",EarlyInmins = 0";
                                    strSQLProcessFlagUpdate += ",EarlyInHrs = '00:00'";
                                }
                            }
                            else
                            {
                                strSQLProcessFlagUpdate += ",EarlyEntry = 0";
                            }
                            if (strLastOut != "")
                            {
                                if (DateTime.Parse(ActualShfOutTime) < DateTime.Parse(strLastOut))
                                {
                                    strSQLProcessFlagUpdate += ",LateExit = 1";
                                    strSQLProcessFlagUpdate += ",lateExitMins =" + dLateOutMins;
                                    strSQLProcessFlagUpdate += ",LateExitHours = '" + strLateOut + "'";
                                }
                                else
                                {
                                    strSQLProcessFlagUpdate += ",LateExit = 0";
                                    strSQLProcessFlagUpdate += ",lateExitMins = 0";
                                    strSQLProcessFlagUpdate += ",LateExitHours = '00:00'";
                                }
                            }
                            strSQLProcessFlagUpdate += ",Shift_StartTime = '" + DateTime.Parse(strActualShiftStartTime).ToString("hh:mm tt") + "'";
                            strSQLProcessFlagUpdate += ",Shift_EndTime = '" + DateTime.Parse(strShift_EndTime).ToString("hh:mm tt") + "'";
                        }
                        else
                        {
                            strSQLProcessFlagUpdate += ",LateExit = 0,EarlyEntry = 0";
                            strSQLProcessFlagUpdate += ",Shift_StartTime = NULL";
                            strSQLProcessFlagUpdate += ",Shift_EndTime = NULL";
                        }
                        strSQLProcessFlagUpdate += ",BreakHrs = '00:00'";
                        strSQLProcessFlagUpdate += ",LunchHrs = '00:00'";
                        strSQLProcessFlagUpdate += ",HoursWorkInMins = '0'";
                        strSQLProcessFlagUpdate += ",BreakHrsInMins = '0'";
                        strSQLProcessFlagUpdate += ",LunchHrsInMins = '0'";
                        strSQLProcessFlagUpdate += ",YearSettingId = '" + intYearSettingId + "'";
                        strSQLProcessFlagUpdate += ",HrsWork = NULL,TotalDays = " + dblTotalDays + ",ProcessFlag = 1 WHERE Process_Rec_ID = " + inProcess_Rec_ID + "";
                        try
                        {
                            if (strSQLProcessFlagUpdate != string.Empty)
                            {
                                OleDbParameter pgUpdateQuery = new OleDbParameter("@UpdateQuery", strSQLProcessFlagUpdate);
                                OleDbParameter[] pParams_UpdateQuery ={ pgUpdateQuery };
                                objDatafunction.SP_Execute(pParams_UpdateQuery, "Proc_Ta_UpdateProcessedDataForService");
                            }
                        }
                        catch (Exception ex)
                        {
                            WriteErrorToEventLog("DataProcess", "function : NonFlexibleHoursCalculation(UPDATE TA_Tbl_ProcessedData2); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                        }
                        #endregion
                    }
                }
                // If Employee Attendance is not Present
                else
                {
                    #region PunchesNotAvailed
                    dblTotalDays = 1;
                    string strStatus = string.Empty;
                    string strActualShfInTime = string.Empty;
                    string strActualShfOutTime = string.Empty;
                    if (dtShift.Rows.Count > 0)
                    {
                        if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                        {
                            strActualShfInTime = Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_EndTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]) != string.Empty)
                        {
                            strActualShfOutTime = Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]);
                        }
                    }
                    // Check for Holiday
                    if (HolidayId != 0)
                    {
                        gstrAttendance = "Holiday";
                        strANAttendanceCode = "Holiday";
                        strFNAttendanceCode = "Holiday";
                        ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                    }
                    else
                    {
                        if (intShiftId == -1)
                        {
                            gstrAttendance = "Weekly Off";
                            strANAttendanceCode = "Weekly Off";
                            strFNAttendanceCode = "Weekly Off";
                            ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                        }
                        else
                        {
                            int intcount = 0;
                            intcount = CheckAdditionalWeekOff(dtmDate, inEmployee_Code_Id);
                            if (intcount == 1)
                            {
                                gstrAttendance = "Weekly Off";
                                strANAttendanceCode = "Weekly Off";
                                strFNAttendanceCode = "Weekly Off";
                                intShiftId = -1;
                                ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                            }
                            else
                            {   // Check in the TimeCheck Leave Application Table
                                if (dtLeave.Rows.Count > 0)
                                {
                                    if (strLeaveCategory != string.Empty)
                                    {
                                        if (strLeaveCategory == "Leave")
                                        {
                                            if (dtLeave.Rows[0]["LeaveType_id"] != DBNull.Value)
                                            {
                                                if (int.Parse(Convert.ToString(dtLeave.Rows[0]["LeaveType_id"])) > 0)
                                                {
                                                    // Get Leave Type by passing Leave Type Id
                                                    strLeaveType = GetLeaveType(int.Parse(Convert.ToString(dtLeave.Rows[0]["LeaveType_id"])));
                                                    if (strLeaveType != string.Empty)
                                                    {
                                                        if (strLeaveDay == "Full Day")
                                                        {
                                                            //strFNAttendanceCode = strLeaveType;
                                                            //strANAttendanceCode = strFNAttendanceCode;
                                                            dblTotalDays = 1;
                                                        }
                                                        else if (strLeaveDay == "First Session")
                                                        {
                                                            strFNAttendanceCode = strLeaveType;
                                                            dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]);
                                                            dblTotalDays = 0.5;
                                                        }
                                                        else if (strLeaveDay == "Second Session")
                                                        {
                                                            strANAttendanceCode = strLeaveType;
                                                            dblTotalDays = 0.5;
                                                            dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                                        }
                                                        gstrAttendance = strLeaveType;
                                                    }
                                                }
                                                //Adeed by Manikandan on 04-11-2015 12.19 PM
                                                //if employee applied half day comp off or other leaves and remaining session is cl
                                                else
                                                {
                                                    if (strLeaveDay == "Full Day")
                                                    {
                                                        dblTotalDays = 1;
                                                    }
                                                    gstrAttendance = Convert.ToString(dtLeave.Rows[0]["Type"]);
                                                }
                                            }
                                        }
                                        else
                                        {
                                            gstrAttendance = strLeaveCategory;
                                            if (strLeaveDay == "Full Day")
                                            {
                                                //strFNAttendanceCode = strLeaveCategory;
                                                //strANAttendanceCode = strFNAttendanceCode;
                                                dblTotalDays = 1;
                                            }
                                            else if (strLeaveDay == "First Session")
                                            {
                                                strFNAttendanceCode = strLeaveCategory;
                                                dblTotalDays = 0.5;
                                                dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]);
                                            }
                                            else if (strLeaveDay == "Second Session")
                                            {
                                                strANAttendanceCode = strLeaveCategory;
                                                dblTotalDays = 0.5;
                                                dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                            }
                                        }
                                    }
                                    ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                }
                                else
                                {
                                    if (intShiftId > 0)
                                    {
                                        gstrAttendance = "Absent";
                                        strFNAttendanceCode = "Absent";
                                        strANAttendanceCode = "Absent";
                                        ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                    }
                                    else
                                    {
                                        gstrAttendance = string.Empty;
                                    }
                                    dtPermission = CheckPermissionAppliedorNot(inEmployee_Code_Id, dtmDate);
                                    if (dtPermission.Rows.Count > 0)
                                    {
                                        if (dtPermission.Rows[0]["No_Of_Hours"] != DBNull.Value)
                                        {
                                            if (dtPermission.Rows[0]["No_Of_Hours"].ToString() != string.Empty)
                                            {
                                                dtmWorkHrs = Convert.ToDateTime(dtmWorkHrs.Subtract(Convert.ToDateTime(dtPermission.Rows[0]["No_Of_Hours"].ToString()).TimeOfDay));
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    #region UpdateFlagInProcessedData
                    try
                    {
                        string strSQLProcessUpdate = "UPDATE TA_Tbl_ProcessedData SET Shift_Id = " + intShiftId + ",TotalDays = " + dblTotalDays + ",LeaveCode = '" + strLeaveCode.Replace("'", "''") + "',ProcessFlag = 1,Status = NULL,";
                        if (gstrAttendance == string.Empty)
                        {
                            strSQLProcessUpdate += "Attendance = NULL,";
                        }
                        else
                        {
                            strSQLProcessUpdate += "Attendance = '" + gstrAttendance.Replace("'", "''") + "',";
                            strSQLProcessUpdate += " FNAttendanceCode='" + strFNAttendanceCode.Replace("'", "''") + "' , ANAttendanceCode='" + strANAttendanceCode + "',";
                        }
                        if (strFirstInDateTime == string.Empty)
                        {
                            strSQLProcessUpdate += "InTime = '00:00',LateIn='00:00',LateInMins=0,";
                            strSQLProcessUpdate += " Inpunch=NULL,";
                            strSQLProcessUpdate += "Indate=NULL,";
                        }
                        if (strLastOutDateTime == string.Empty)
                        {
                            strSQLProcessUpdate += "OutTime = '00:00',EarlyOut='00:00',EarlyOutMins=0,HrsExtra='00:00',ExtraMins=0,OtMins=0,OvertimeStatus=NULL,NormOT='00:00',OffOT='00:00',HolOT='00:00',";
                            strSQLProcessUpdate += "Outdate=NULL,";
                            strSQLProcessUpdate += "Outpunch=NULL,";
                        }
                        if (intShiftId > 0)
                        {
                            string strHours = string.Empty, strMinute = string.Empty;
                            if (strLeaveDay == "Full Day")
                                strSQLProcessUpdate += "WorkHrs = '00:00'";
                            else if (isTempWeekday == true)
                                strSQLProcessUpdate += "WorkHrs = '" + strWorkHrs + "'";
                            else
                            {
                                strHours = dtmWorkHrs.Hour.ToString().Length > 1 ? dtmWorkHrs.Hour.ToString() : ("0" + dtmWorkHrs.Hour.ToString());
                                strMinute = dtmWorkHrs.Minute.ToString().Length > 1 ? dtmWorkHrs.Minute.ToString() : ("0" + dtmWorkHrs.Minute.ToString());
                                strSQLProcessUpdate += "WorkHrs = '" + strHours + ":" + strMinute + "'";
                                //strSQLProcessUpdate += "WorkHrs = '" + dtmWorkHrs.ToString("hh:mm") + "'";
                            }
                            strSQLProcessUpdate += ",Shift_StartTime = '" + strActualShfInTime + "'";
                            strSQLProcessUpdate += ",Shift_EndTime = '" + strActualShfOutTime + "'";
                        }
                        else
                        {
                            strSQLProcessUpdate += "WorkHrs = NULL";
                            strSQLProcessUpdate += ",Shift_StartTime = NULL";
                            strSQLProcessUpdate += ",Shift_EndTime = NULL";
                        }
                        strSQLProcessUpdate += ",LateExit = 0,EarlyEntry = 0 ";
                        strSQLProcessUpdate += ",HrsWork = '00:00'";
                        strSQLProcessUpdate += ",HrsLess = '00:00'";
                        strSQLProcessUpdate += ",BreakHrs = '00:00'";
                        strSQLProcessUpdate += ",LunchHrs = '00:00'";
                        strSQLProcessUpdate += ",HoursWorkInMins = '0'";
                        strSQLProcessUpdate += ",BreakHrsInMins = '0'";
                        strSQLProcessUpdate += ",LunchHrsInMins = '0'";
                        strSQLProcessUpdate += ",YearSettingId = '" + intYearSettingId + "'";
                        if (dtPermission.Rows.Count > 1)
                        {
                            DateTime PermissionTo = Convert.ToDateTime(Convert.ToString(dtPermission.Rows[0]["Permission_ToTime"]));
                            DateTime PermissionFrom = Convert.ToDateTime(Convert.ToString(dtPermission.Rows[0]["Permission_FromTime"]));
                            TimeSpan Variation = (PermissionTo.Subtract(PermissionFrom));
                            strSQLProcessUpdate += ",PermissionHrsInMins= '" + Variation + "'";
                            strSQLProcessUpdate += ",PermissionHrs = '" + Convert.ToString(dtPermission.Rows[0]["No_Of_Hours"]) + "'";
                        }
                        else
                        {
                            strSQLProcessUpdate += ",PermissionHrsInMins= 0";
                            strSQLProcessUpdate += ",PermissionHrs = '00:00'";
                        }
                        strSQLProcessUpdate += " WHERE Process_Rec_ID = " + inProcess_Rec_ID + "";
                        if (strSQLProcessUpdate != string.Empty)
                        {
                            OleDbParameter pgUpdateQuery = new OleDbParameter("@UpdateQuery", strSQLProcessUpdate);
                            OleDbParameter[] pParams_UpdateQuery ={ pgUpdateQuery };
                            objDatafunction.SP_Execute(pParams_UpdateQuery, "Proc_Ta_UpdateProcessedDataForService");
                        }
                    }
                    catch (Exception ex)
                    {
                        WriteErrorToEventLog("DataProcess", "function : NonFlexibleHoursCalculation(UPDATE TA_Tbl_ProcessedData3); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    }
                    #endregion
                    #endregion
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : NonFlexibleHoursCalculation(); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region FlexibleHoursCalculation
        private void FlexibleHoursCalculation(Int64 inProcess_Rec_ID, int inEmployee_Id, string inEmployee_Code_Id, string inDate, string inInTime, string inOT_Eligible, string inStatus, double inShftWeekOffOverTime, double inShftHolyOverTime, string inHolidayOnWeeklyOff, Int64 inShiftSettingsId, string inIsOTRoundOff, string inIsHalfDayAttendance, string levelId, string InCompoffEligible, int lateEntryCalc, int earlyOutCalc, int EarlyEntryCalc, int lateExitCalc)
        {
            try
            {
                #region VariableDeclaration
                bool blnInDateTime = false, blnOutDateTime = false, Is24Hrs = false;
                string gstrAttendance = string.Empty;
                string strFNAttendanceCode = "Absent", strANAttendanceCode = "Absent";
                string strFullDayAttendanceHrs = "00:00", strHalfDayAttendanceHrs = "00:00";
                string strFirstHalfAttendanceHrs = "00:00", strSecondHalfAttendanceHrs = "00:00";
                int intYearSettingId = 0;
                string strLeaveCode = string.Empty;
                double dblPermissionMins = 0;
                DateTime dtmDate = new DateTime();
                #endregion
                dtmDate = DateTime.Parse(inDate);
                intYearSettingId = GetYearSettingId(dtmDate);
                // Get Shift ID for appropriate Employee and Date
                int intShiftId = 0;
                intShiftId = GetShiftId(inEmployee_Id, dtmDate, inEmployee_Code_Id);
                DataTable dtShift = new DataTable();
                DateTime dtmWorkHrs = new DateTime();
                string strWorkHrs = "00:00";
                bool isTempWeekday = false;
                #region CheckHoliday
                string strDate = string.Empty;
                strDate = dtmDate.ToString("yyyy-MM-dd");
                int HolidayId = 0;
                try
                {
                    HolidayId = CheckHoliday(strDate, inEmployee_Id);
                    if (HolidayId != 0)
                    {
                        strANAttendanceCode = "Holiday";
                        strFNAttendanceCode = "Holiday";
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(Holiday); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                }
                #endregion
                #region GettingShiftDetails
                try
                {
                    dtShift = GettingShiftDetailsUsingShiftId(intShiftId);
                    if (HolidayId == 0 && intShiftId != -1)
                    {
                        if (dtShift.Rows.Count > 0)
                        {
                            if (dtShift.Rows[0]["Shift_TotalWorkingHours"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_TotalWorkingHours"]) != string.Empty)
                            {
                                dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_TotalWorkingHours"]);
                            }
                            if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && dtShift.Rows[0]["24HrsShift"].ToString() != string.Empty)
                            {
                                Is24Hrs = Convert.ToBoolean(dtShift.Rows[0]["24HrsShift"]);
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(Shift); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    return;
                }
                #endregion
                // Check for Leave
                #region CheckLeave
                strLeaveDay = "";
                string strLeaveCategory = string.Empty;
                string strLeaveType = string.Empty;
                DataTable dtLeave = new DataTable();
                try
                {
                    dtLeave = CheckLeaveAppliedorNot(inEmployee_Code_Id, dtmDate);
                    if (dtLeave.Rows.Count > 0)
                    {
                        for (int i = 0; i < dtLeave.Rows.Count; i++)
                        {
                            // check whether the leave for Full Day or First Session or Second Session for particular Employee and Date
                            strLeaveDay = CheckLeave(dtmDate, dtLeave.Rows[0]["Leave_FromDate"].ToString(), dtLeave.Rows[0]["Leave_ToDate"].ToString(), dtLeave.Rows[0]["Leave_SessionFrom"].ToString(), dtLeave.Rows[0]["Leave_SessionTo"].ToString());
                            // Get the Leave Type whether normal leave or restricted holiday or comp off or LOP or ESI
                            strLeaveCategory = GetLeaveCategory(dtLeave.Rows[0]["Type"].ToString());
                            //}
                            //if (strLeaveCategory != string.Empty)
                            //{
                            //    if (strLeaveCategory == "Leave")
                            //    {
                            //        if (int.Parse(dtLeave.Rows[0]["LeaveType_id"].ToString()) > 0)
                            //        {
                            //            // Get Leave Type by passing Leave Type Id
                            //            strLeaveType = GetLeaveType(int.Parse(dtLeave.Rows[0]["LeaveType_id"].ToString()));
                            //        }
                            //    }
                            if (strLeaveCategory != string.Empty && strLeaveCategory == "Leave")
                            {
                                if (int.Parse(Convert.ToString(dtLeave.Rows[i]["LeaveType_id"])) > 0)
                                {
                                    // Get Leave Type by passing Leave Type Id
                                    strLeaveType = GetLeaveType(int.Parse(Convert.ToString(dtLeave.Rows[i]["LeaveType_id"])));
                                    if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "First half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "Second half")
                                    {
                                        strFNAttendanceCode = strANAttendanceCode = strLeaveType;
                                    }
                                    else if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "First half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "First half")
                                    {
                                        strFNAttendanceCode = strLeaveType;
                                    }
                                    else if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "Second half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "Second half")
                                    {
                                        strANAttendanceCode = strLeaveType;
                                    }
                                }
                            }
                            else
                            {
                                if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "First half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "Second half")
                                {
                                    strFNAttendanceCode = strANAttendanceCode = strLeaveCategory;
                                }
                                else if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "First half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "First half")
                                {
                                    strFNAttendanceCode = strLeaveCategory;
                                }
                                else if (Convert.ToString(dtLeave.Rows[i]["Leave_SessionFrom"]) == "Second half" && Convert.ToString(dtLeave.Rows[i]["Leave_SessionTo"]) == "Second half")
                                {
                                    strANAttendanceCode = strLeaveCategory;
                                }
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(Leave); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    return;
                }
                #endregion
                #region VariableDeclaration
                string strLateInTime = "00:00", strEarlyExit = "00:00", strFirstIn = string.Empty, strLastOut = string.Empty, strLateExitHours = "00:00";
                double dblTotalDays = 1, dLateInMins = 0, dEarlyOutMins = 0, dLateExitMins = 0;
                string strLastOutDateTime = string.Empty, strFirstInDateTime = string.Empty;
                string strFirstInPunchType = string.Empty, strLastOutPunchType = string.Empty;
                string strFirstInDate = string.Empty, strLastOutDate = string.Empty;
                DateTime dtmFirstInDateTime = new DateTime();
                DateTime dtmLastOutDateTime = new DateTime();
                string strIsHoliday = "N", strSecondHalfStart = string.Empty, strFirstHalfEnd = string.Empty;
                #endregion
                #region GettingFirstInAndLastOutPunchDetails
                try
                {
                    strFirstInDateTime = GetFirstIn(inEmployee_Code_Id, strDate);
                    //TODO: Need to add below lines into service
                    strFirstInPunchType = GetFirstInPunchType(inEmployee_Code_Id, strDate);
                    if (strFirstInDateTime != string.Empty)
                    {
                        dtmFirstInDateTime = DateTime.Parse(strFirstInDateTime);
                        strFirstIn = dtmFirstInDateTime.ToShortTimeString();
                        strFirstInDate = dtmFirstInDateTime.ToShortDateString();
                        blnInDateTime = true;
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(GetFirstIn); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    return;
                }
                try
                {
                    strLastOutDateTime = GetLastOut(inEmployee_Code_Id, strDate);
                    //TODO: Need to add below lines into service
                    strLastOutPunchType = GetLastOutPunchType(inEmployee_Code_Id, strDate);
                    if (strLastOutDateTime != string.Empty)
                    {
                        dtmLastOutDateTime = DateTime.Parse(strLastOutDateTime);
                        strLastOut = dtmLastOutDateTime.ToShortTimeString();
                        strLastOutDate = dtmLastOutDateTime.ToShortDateString();
                        blnOutDateTime = true;
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(GetLastOut); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    return;
                }
                #endregion
                // If Employee Attendance is Present
                if (strFirstInDateTime != string.Empty || strLastOutDateTime != string.Empty)
                {
                    TimeSpan tsFirstInTime = new TimeSpan();
                    TimeSpan tsLastOutTime = new TimeSpan();
                    if (strFirstIn != string.Empty)
                    {
                        tsFirstInTime = DateTime.Parse(strFirstIn.ToString()).TimeOfDay;
                    }
                    if (strLastOut != string.Empty)
                    {
                        tsLastOutTime = DateTime.Parse(strLastOut.ToString()).TimeOfDay;
                    }
                    // Get Actual Shift Details from Shift Table
                    #region VariableDeclaration
                    string ActualShfInTime = string.Empty, ActualShfOutTime = string.Empty, strShftGraceInTime = "00:00", strShftGraceOutTime = "00:00", strShftMinOTTime = "00:00", strShftMaxOTTime = "00:00";
                    string strFirstBreakStartTime = "00:00", strFirstBreakEndTime = "00:00", strSecondBreakStartTime = "00:00", strSecondBreakEndTime = "00:00", strThirdBreakStartTime = "00:00", strThirdBreakEndTime = "00:00";
                    double ShftWorkOverTime = 0, ShftWeekOffOverTime = 0, ShftHolyOverTime = 0;
                    double dblFlexiHoursLess = 0;
                    int TotalHrs = 0, Totalmin = 0;
                    string LunchOutTime = string.Empty, LunchInTime = string.Empty;
                    bool shftType = true;
                    #endregion
                    #region GettingShiftDetails
                    if (dtShift.Rows.Count > 0)
                    {
                        if (dtShift.Rows[0]["Shift_TotalWorkingHours"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_TotalWorkingHours"]) != string.Empty)
                        {
                            TotalHrs = dtmWorkHrs.Hour;
                            Totalmin = dtmWorkHrs.Minute;
                        }
                        if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                        {
                            ActualShfInTime = Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_EndTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]) != string.Empty)
                        {
                            ActualShfOutTime = Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakStartTime1"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime1"]) != string.Empty)
                        {
                            strFirstBreakStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime1"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakEndTime1"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime1"]) != string.Empty)
                        {
                            strFirstBreakEndTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime1"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakStartTime2"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime2"]) != string.Empty)
                        {
                            strSecondBreakStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime2"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakEndTime2"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime2"]) != string.Empty)
                        {
                            strSecondBreakEndTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime2"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakStartTime3"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime3"]) != string.Empty)
                        {
                            strThirdBreakStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime3"]);
                        }
                        if (dtShift.Rows[0]["Shift_BreakEndTime3"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime3"]) != string.Empty)
                        {
                            strThirdBreakEndTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime3"]);
                        }
                        if (dtShift.Rows[0]["Shift_GraceInTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_GraceInTime"]) != string.Empty)
                        {
                            strShftGraceInTime = Convert.ToString(dtShift.Rows[0]["Shift_GraceInTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_GraceOutTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_GraceOutTime"]) != string.Empty)
                        {
                            strShftGraceOutTime = Convert.ToString(dtShift.Rows[0]["Shift_GraceOutTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_WorkingDay_OverTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_WorkingDay_OverTime"]) != string.Empty)
                        {
                            ShftWorkOverTime = Convert.ToDouble(dtShift.Rows[0]["Shift_WorkingDay_OverTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_MinTimeOT"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_MinTimeOT"]) != string.Empty)
                        {
                            strShftMinOTTime = Convert.ToString(dtShift.Rows[0]["Shift_MinTimeOT"]);
                        }
                        if (dtShift.Rows[0]["shift_FirstHalf_EndTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["shift_FirstHalf_EndTime"]) != string.Empty)
                        {
                            strFirstHalfEnd = Convert.ToString(dtShift.Rows[0]["shift_FirstHalf_EndTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_SecondHalf_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_SecondHalf_StartTime"]) != string.Empty)
                        {
                            strSecondHalfStart = Convert.ToString(dtShift.Rows[0]["Shift_SecondHalf_StartTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_MaxTimeOT"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_MaxTimeOT"]) != string.Empty)
                        {
                            strShftMaxOTTime = Convert.ToString(dtShift.Rows[0]["Shift_MaxTimeOT"]);
                        }
                        if (dtShift.Rows[0]["Shift_FirstHalfWorkingHours"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]) != string.Empty)
                        {
                            strFirstHalfAttendanceHrs = Convert.ToString(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                        }
                        if (dtShift.Rows[0]["Shift_SecondHalfWorkingHours"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]) != string.Empty)
                        {
                            strSecondHalfAttendanceHrs = Convert.ToString(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]);
                        }
                        if (dtShift.Rows[0]["ShiftType"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["ShiftType"]) != string.Empty)
                        {
                            shftType = Convert.ToBoolean(dtShift.Rows[0]["ShiftType"]);
                        }
                    }
                    #endregion
                    TimeSpan tsShftMaxOTTime = new TimeSpan();
                    TimeSpan tsShftMinOTTime = new TimeSpan();
                    if (strShftMinOTTime != "00:00")
                    {
                        tsShftMinOTTime = DateTime.Parse(strShftMinOTTime).TimeOfDay;
                    }
                    if (strShftMaxOTTime != "00:00")
                    {
                        tsShftMaxOTTime = DateTime.Parse(strShftMaxOTTime).TimeOfDay;
                    }
                    if (HolidayId != 0)
                    {
                        strIsHoliday = "Y";
                        strANAttendanceCode = "Holiday";
                        strFNAttendanceCode = "Holiday";
                    }
                    if (strFirstIn != string.Empty && strLastOut != string.Empty)
                    {
                        #region FirstAndLastOutPunchesAvailed
                        bool blnIsPMAM = false;
                        string strTotalWorkHours = "00:00", strLessHours = "00:00", strExtraHours = "00:00";
                        string strHrsOT = "00:00", strNorOT = "00:00", strWeekOffOT = "00:00", strHoliOT = "00:00";
                        double dblTotalMinsWorked = 0, dblPhysicalWorkHrs = 0, dblShftHolyOverTime = 0, dblShftWeekOffOverTime = 0, dOT = 0;
                        DateTime dtmActualShiftStartTime = new DateTime();
                        DateTime dtmShiftEndTime = new DateTime();
                        string strActShiftStartTime = strDate + " " + ActualShfInTime;
                        dtmActualShiftStartTime = DateTime.Parse(strActShiftStartTime);
                        string strShiftEndTim = strDate + " " + ActualShfOutTime;
                        dtmShiftEndTime = DateTime.Parse(strShiftEndTim);
                        string strActualShiftStartTime = dtmActualShiftStartTime.ToString("hh:mm:ss tt");
                        string strShift_EndTime = dtmShiftEndTime.ToString("hh:mm:ss tt");
                        if ((strActualShiftStartTime.Substring(9, 2) == "PM") && (strShift_EndTime.Substring(9, 2) == "AM"))
                        {
                            blnIsPMAM = true;
                            dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                        }
                        if (Is24Hrs)
                        {
                            dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                        }
                        ShftWeekOffOverTime = inShftWeekOffOverTime;
                        ShftHolyOverTime = inShftHolyOverTime;
                        // Call the CalculatePhysicalWorkHours function to get the actual physical hours worked
                        #region CalculatePhysicalWorkHours
                        dblPhysicalWorkHrs = CalculatePhysicalWorkHours(inEmployee_Code_Id, strDate);
                        #endregion
                        #region CalculateTotalBreakhours
                        // Get the Total Break Hours
                        double dblTotalBreakMins = 0;
                        dblTotalBreakMins = CalculateTotalBreakHours(strDate, blnIsPMAM, strFirstBreakStartTime, strFirstBreakEndTime, strSecondBreakStartTime, strSecondBreakEndTime, strThirdBreakStartTime, strThirdBreakEndTime);
                        #endregion
                        // Check for Holiday
                        if (HolidayId != 0)
                        {
                            strANAttendanceCode = "Holiday";
                            strFNAttendanceCode = "Holiday";
                            gstrAttendance = "Holiday";
                            strIsHoliday = "Y";
                            if (intShiftId > 0)
                            {
                                dblPhysicalWorkHrs = dblPhysicalWorkHrs;
                            }
                            else if (intShiftId == -1)
                            {
                                dblPhysicalWorkHrs = dblPhysicalWorkHrs;
                            }
                            if (dblPhysicalWorkHrs < 0)
                            {
                                dblPhysicalWorkHrs = 0;
                            }
                            // Check for Over Time Eligible
                            #region CalculateOverTime
                            if (inOT_Eligible == "True" || InCompoffEligible == "True")
                            {
                                if (intShiftId == -1)
                                {
                                    if (inHolidayOnWeeklyOff == "WeeklyOff")
                                    {
                                        ShftHolyOverTime = ShftWeekOffOverTime;
                                    }
                                }
                                if (ShftHolyOverTime != 0)
                                {
                                    // Multiply by Calculation Factor if Holiday OT
                                    dblShftHolyOverTime = dblPhysicalWorkHrs * ShftHolyOverTime;
                                }
                                else
                                {
                                    dblShftHolyOverTime = dblPhysicalWorkHrs;
                                }
                                // Call OT Round Off
                                if (inIsOTRoundOff == "True")
                                    dblShftHolyOverTime = OverTimeRoundOff(dblShftHolyOverTime, inShiftSettingsId, inIsOTRoundOff);
                                // Convert Total Holiday OverTime Minutes into Time Format
                                strHoliOT = TimeFormat(dblShftHolyOverTime);
                            }
                            else
                            {
                                strHoliOT = "00:00";
                                dblShftHolyOverTime = 0;
                            }
                            #endregion
                            // Set Work Hours as Physical Hours
                            dblTotalMinsWorked = dblPhysicalWorkHrs;
                        }
                        else
                        {
                            int count = 0;
                            count = CheckAdditionalWeekOff(dtmDate, inEmployee_Code_Id);
                            // Calculate Weekly Off OT
                            if (intShiftId == -1 || count == 1)
                            {
                                dblTotalBreakMins = GetWeeklyOffBreakMins(inEmployee_Id, dtmDate.ToString("yyyy-MM-dd"), inEmployee_Code_Id);
                                dblPhysicalWorkHrs = dblPhysicalWorkHrs;
                                if (dblPhysicalWorkHrs < 0)
                                {
                                    dblPhysicalWorkHrs = 0;
                                }
                                // Check for Over Time Eligible
                                #region CalculateOverTime
                                if (inOT_Eligible == "True" || InCompoffEligible == "True")
                                {
                                    dblShftWeekOffOverTime = (ShftWeekOffOverTime != 0) ? dblPhysicalWorkHrs * ShftWeekOffOverTime : dblPhysicalWorkHrs;
                                    // Call OT Round Off
                                    if (inIsOTRoundOff == "True")
                                        dblShftWeekOffOverTime = OverTimeRoundOff(dblShftWeekOffOverTime, inShiftSettingsId, inIsOTRoundOff);
                                    // Convert Total WeekOff OverTime Minutes into Time Format
                                    strWeekOffOT = TimeFormat(dblShftWeekOffOverTime);
                                }
                                else
                                {
                                    strWeekOffOT = "00:00";
                                    dblShftWeekOffOverTime = 0;
                                }
                                #endregion
                                intShiftId = -1;
                                gstrAttendance = "Weekly Off";
                                strANAttendanceCode = "Weekly Off";
                                strFNAttendanceCode = "Weekly Off";
                                dblTotalMinsWorked = dblPhysicalWorkHrs;
                            }
                            else if (intShiftId > 0)
                            {
                                // Check for Permission
                                DataTable dtPermission = new DataTable();
                                TimeSpan tsPermissionHrs = new TimeSpan();
                                string strPermissionHrs = "00:00";
                                try
                                {
                                    dtPermission = CheckPermissionAppliedorNot(inEmployee_Code_Id, dtmDate);
                                    DateTime dtmPermissionFromDateTime = new DateTime();
                                    DateTime dtmPermissionToDateTime = new DateTime();
                                    if (dtPermission.Rows.Count > 0)
                                    {
                                        dtmPermissionFromDateTime = DateTime.Parse(Convert.ToString(dtPermission.Rows[0]["Permission_FromTime"]));
                                        dtmPermissionToDateTime = DateTime.Parse(Convert.ToString(dtPermission.Rows[0]["Permission_ToTime"]));
                                        tsPermissionHrs = dtmPermissionToDateTime.Subtract(dtmPermissionFromDateTime);
                                        strPermissionHrs = tsPermissionHrs.ToString();
                                    }
                                }
                                catch (Exception ex)
                                {
                                    WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(Permission); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                                }
                                // CALCULATE LATE INTIME
                                string strShiftStartTime = string.Empty;
                                // If there is permission during the Shift Start Time, then Set Start Time as
                                // Permission To Time and Calculate Late. Else check if there is First half Leave
                                // Late should not be calculated during Permission Hours or First half Leave.
                                // If First Half Leave
                                if (dtLeave.Rows.Count > 0)
                                {
                                    // Check for First half Leave. If so then set the Shift Start time as Lunch End Time
                                    if (strLeaveDay == "First Session")
                                    {
                                        dblTotalDays = 0.5;
                                        strShiftStartTime = dtShift.Rows[0]["Shift_SecondHalf_StartTime"].ToString();
                                    }
                                }
                                if (strShiftStartTime == string.Empty)
                                {
                                    // Check whether there is Permission during the Shift Start Time
                                    if (dtPermission.Rows.Count > 0)
                                    {
                                        if (DateTime.Parse(dtPermission.Rows[0]["Permission_ToTime"].ToString()).ToShortTimeString() == DateTime.Parse(dtShift.Rows[0]["Shift_FirstHalf_EndTime"].ToString()).ToShortTimeString())
                                        {
                                            strShiftStartTime = dtShift.Rows[0]["Shift_SecondHalf_StartTime"].ToString();
                                        }
                                        else if (DateTime.Parse(dtPermission.Rows[0]["Permission_ToTime"].ToString()).ToShortTimeString() == DateTime.Parse(strSecondBreakStartTime).ToShortTimeString())
                                        {
                                            strShiftStartTime = strSecondBreakEndTime;
                                        }
                                        else
                                        {
                                            if (dtmActualShiftStartTime >= dtmPermissionFromDateTime && dtmActualShiftStartTime <= dtmPermissionToDateTime)
                                            {
                                                strShiftStartTime = dtPermission.Rows[0]["Permission_ToTime"].ToString();
                                            }
                                            else
                                            {
                                                // Nothing
                                            }
                                        }
                                    }
                                }
                                if (strShiftStartTime == string.Empty)
                                {
                                    strShiftStartTime = ActualShfInTime;
                                }
                                // Calculate Late In Time
                                TimeSpan tsActualShiftStartTime = DateTime.Parse(strShiftStartTime).TimeOfDay;
                                TimeSpan tsShftStartTimePlusGrace = new TimeSpan();
                                DateTime dtmShftStartTimePlusGrace = new DateTime();
                                DateTime dtmShift_StartTime = new DateTime();
                                TimeSpan tsLateIn = new TimeSpan();
                                // Add Grace In with Shift Start Time
                                tsShftStartTimePlusGrace = tsActualShiftStartTime.Add(DateTime.Parse(strShftGraceInTime).TimeOfDay);
                                dtmShift_StartTime = DateTime.Parse(strDate + " " + tsActualShiftStartTime.ToString());
                                dtmShftStartTimePlusGrace = DateTime.Parse(strDate + " " + tsShftStartTimePlusGrace.ToString());
                                tsFirstInTime = DateTime.Parse(tsFirstInTime.ToString().Substring(0, 5)).TimeOfDay;
                                // If not Holiday, then Calculate Late In
                                if (lateEntryCalc == 1)
                                {
                                    if (strIsHoliday != "Y" && strLeaveDay != "Full Day")
                                    {
                                        // Calculate Late In, if Actual InTime is greater that Shift Start Time
                                        if (dtmFirstInDateTime > dtmShftStartTimePlusGrace)
                                        {
                                            tsLateIn = dtmFirstInDateTime.Subtract(dtmShift_StartTime);
                                            dLateInMins = double.Parse(tsLateIn.TotalMinutes.ToString());
                                            strLateInTime = GetTotalHours(tsLateIn);
                                        }
                                    }
                                    else
                                    {
                                        strLateInTime = "00:00";
                                        dLateInMins = 0;
                                    }
                                }
                                else
                                {
                                    strLateInTime = "00:00";
                                    dLateInMins = 0;
                                }
                                // CALCULATE EARLY EXIT
                                string strShiftEndTime = string.Empty;
                                // If there is permission during the Shift End Time, then Set End Time as
                                // Permission From Time and Calculate Early Out. Else check for Second half Leave.
                                // Early Out should not be calculated during Permission Hours or Second half Leave.
                                // If Second Half Leave
                                if (dtLeave.Rows.Count > 0)
                                {
                                    // Check for Second half Leave. If so then set the Shift End time as Lunch Start Time
                                    if (strLeaveDay == "Second Session")
                                    {
                                        dblTotalDays = 0.5;
                                        strShiftEndTime = dtShift.Rows[0]["Shift_FirstHalf_EndTime"].ToString();
                                    }
                                }
                                //Added below line and adding temp weekday functionality as like from nonflexible.
                                DataTable dtTemporaryWeekDay = new DataTable();
                                string strClosingTime = string.Empty;
                                string strClosingDateTime = string.Empty;
                                try
                                {
                                    string strSQLTemporaryWeekDay = string.Empty;
                                    if (blnIsPMAM)
                                    {
                                        strSQLTemporaryWeekDay = "SELECT T.ClosingTime,T.ShiftId FROM TA_Tbl_TemWeekday T ";
                                        strSQLTemporaryWeekDay = strSQLTemporaryWeekDay + " inner join Ta_Tbl_Temporary_WeeklyOff_Levels TL on T.TempWeekday_Id = TL.TempWeekday_Id WHERE (T.TempWeekday_FromDate between '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "' and '" + dtmShiftEndTime.ToString("yyyy-MM-dd") + "')";
                                        strSQLTemporaryWeekDay = strSQLTemporaryWeekDay + " AND T.IsDeleted = 0 AND TL.LevelId=" + levelId + " AND '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "' Between  T.TempWeekday_FromDate And T.TempWeekday_ToDate ";
                                    }
                                    else if (Is24Hrs)
                                    {
                                        strSQLTemporaryWeekDay = "SELECT T.ClosingTime,T.ShiftId FROM TA_Tbl_TemWeekday T ";
                                        strSQLTemporaryWeekDay = strSQLTemporaryWeekDay + " inner join Ta_Tbl_Temporary_WeeklyOff_Levels TL on T.TempWeekday_Id = TL.TempWeekday_Id WHERE (T.TempWeekday_FromDate = '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "')";
                                        strSQLTemporaryWeekDay = strSQLTemporaryWeekDay + " AND T.IsDeleted = 0 AND TL.LevelId=" + levelId + "";
                                    }
                                    else
                                    {
                                        strSQLTemporaryWeekDay = "SELECT T.ClosingTime,T.ShiftId FROM TA_Tbl_TemWeekday T inner join Ta_Tbl_Temporary_WeeklyOff_Levels TL on T.TempWeekday_Id = TL.TempWeekday_Id WHERE (T.TempWeekday_FromDate <= '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "' and T.TempWeekday_ToDate >= '" + dtmActualShiftStartTime.ToString("yyyy-MM-dd") + "') AND T.IsDeleted = 0 AND TL.LevelId=" + levelId + " ";
                                    }
                                    dtTemporaryWeekDay = objDatafunction.ExeQuery(strSQLTemporaryWeekDay, "TA_Tbl_TemWeekday");
                                    if (dtTemporaryWeekDay.Rows.Count > 0)
                                    {
                                        for (int intTempWeeklyOff = 0; intTempWeeklyOff < dtTemporaryWeekDay.Rows.Count; intTempWeeklyOff++)
                                        {
                                            string strShiftId = Convert.ToString(dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ShiftId"]);
                                            string[] arrShiftId = strShiftId.Split(',');
                                            bool isShiftIdMatch = false;
                                            //for getting whether the shiftid is match to the temp week day shiftid
                                            for (int intShiftIdLen = 0; intShiftIdLen < arrShiftId.Length; intShiftIdLen++)
                                            {
                                                // This indicates first half end time in am means thats next day for night shift
                                                DateTime dttFirstHalfEnd = DateTime.Parse(strDate + " " + strFirstHalfEnd);
                                                //int intTempWeeklyOff = 0;
                                                if (dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"] != DBNull.Value && dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"].ToString() != string.Empty)
                                                {
                                                    if (Convert.ToString(arrShiftId[intShiftIdLen]) == Convert.ToString(intShiftId))
                                                    {
                                                        isShiftIdMatch = true;
                                                        break;
                                                    }
                                                }
                                            }
                                            if (isShiftIdMatch == true)
                                            {
                                                // This indicates first half end time in am means thats next day for night shift
                                                DateTime dttFirstHalfEnd = DateTime.Parse(strDate + " " + strFirstHalfEnd);
                                                if (dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"] != DBNull.Value && dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"].ToString() != string.Empty)
                                                {
                                                    strClosingTime = DateTime.Parse(dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"].ToString()).ToShortTimeString();
                                                    if (blnIsPMAM && strClosingTime.Contains("AM"))
                                                    {
                                                        strClosingDateTime = strDate + " " + strClosingTime;
                                                        strClosingDateTime = DateTime.Parse(strClosingDateTime).AddDays(1).ToString();
                                                        strDate = DateTime.Parse(strDate).AddDays(1).ToString("yyyy-MM-dd");
                                                    }
                                                    else
                                                    {
                                                        strClosingDateTime = strDate + " " + strClosingTime;
                                                    }
                                                    if (dtmActualShiftStartTime <= DateTime.Parse(strClosingDateTime) && dtmShiftEndTime >= DateTime.Parse(strClosingDateTime))
                                                    {
                                                    }
                                                    else
                                                    {
                                                        strClosingTime = string.Empty;
                                                    }
                                                    if (strFirstHalfEnd.Contains("AM") == true)
                                                    {
                                                        dttFirstHalfEnd = dttFirstHalfEnd.AddDays(1);
                                                    }
                                                }
                                                if ((DateTime.Parse(dtTemporaryWeekDay.Rows[intTempWeeklyOff]["ClosingTime"].ToString()) <= DateTime.Parse(strFirstHalfEnd)) || DateTime.Parse(strClosingDateTime) <= dttFirstHalfEnd)
                                                {
                                                    strANAttendanceCode = "Present";
                                                }
                                            }
                                        }
                                    }
                                }
                                catch (Exception ex)
                                {
                                    WriteErrorToEventLog("DataProcess", "function : NonFlexibleHoursCalculation(TemporaryWeekDay); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.Message);
                                }
                                if (strShiftEndTime == string.Empty)
                                {
                                    if (strClosingTime != string.Empty)
                                    {
                                        strShiftEndTime = strClosingTime;
                                        if (DateTime.Parse(strClosingDateTime) <= DateTime.Parse(strDate + " " + strFirstHalfEnd))
                                        {
                                            DateTime dttFirstHalfWorkingHoursLocal = Convert.ToDateTime(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                            DateTime dttFirstHalfEndLocal = Convert.ToDateTime(strFirstHalfEnd);
                                            DateTime dttFirstHalfShiftEndLocal = Convert.ToDateTime(strShiftEndTime);
                                            TimeSpan tsVariation = (dttFirstHalfEndLocal.Subtract(dttFirstHalfShiftEndLocal));
                                            DateTime dttShiftVariation = Convert.ToDateTime(tsVariation.ToString());
                                            TimeSpan tsWorkHours = dttFirstHalfWorkingHoursLocal.Subtract(dttShiftVariation);
                                            dtmWorkHrs = Convert.ToDateTime(tsWorkHours.ToString());
                                            strWorkHrs = GetTotalHours(tsWorkHours);
                                            isTempWeekday = true;
                                        }
                                        else
                                        {
                                            DateTime dttShift_EndTimeLocal = Convert.ToDateTime(strShift_EndTime);
                                            DateTime dttShiftEndTimeLocal = Convert.ToDateTime(strShiftEndTime);
                                            TimeSpan tsVariation = dttShift_EndTimeLocal.Subtract(dttShiftEndTimeLocal);
                                            DateTime dttShiftVariation = Convert.ToDateTime(tsVariation.ToString());
                                            TimeSpan tsWorkHours = dtmWorkHrs.Subtract(dttShiftVariation);
                                            strWorkHrs = GetTotalHours(tsWorkHours);
                                            isTempWeekday = true;
                                            dtmWorkHrs = dtmWorkHrs - Convert.ToDateTime(strShift_EndTime).Subtract(Convert.ToDateTime(strShiftEndTime));
                                        }
                                    }
                                    else
                                    {
                                        if (dtPermission.Rows.Count > 0)
                                        {
                                            if (dtmShiftEndTime >= dtmPermissionFromDateTime && dtmShiftEndTime <= dtmPermissionToDateTime)
                                            {
                                                strShiftEndTime = dtPermission.Rows[0]["Permission_FromTime"].ToString();
                                            }
                                            else
                                            {
                                                strShiftEndTime = ActualShfOutTime;
                                            }
                                        }
                                        else
                                        {
                                            strShiftEndTime = ActualShfOutTime;
                                        }
                                    }
                                }
                                // Calculating Early Out
                                TimeSpan tsEarlyOut = new TimeSpan();
                                TimeSpan tsShiftEndTime = new TimeSpan();
                                TimeSpan tsShift_EndTime = DateTime.Parse(strShiftEndTime).TimeOfDay;
                                DateTime dtmShftEndTimeMinusGrace = new DateTime();
                                DateTime dtmShift_EndTime = DateTime.Parse(strDate + " " + tsShift_EndTime.ToString());
                                if (dtShift.Rows[0]["Shift_GraceOutTime"] != DBNull.Value && dtShift.Rows[0]["Shift_GraceOutTime"].ToString() != string.Empty)
                                {
                                    strShftGraceOutTime = dtShift.Rows[0]["Shift_GraceOutTime"].ToString();
                                }
                                tsShiftEndTime = DateTime.Parse(dtShift.Rows[0]["Shift_EndTime"].ToString()).TimeOfDay;
                                dtmShftEndTimeMinusGrace = dtmShift_EndTime.Subtract(DateTime.Parse(strDate + " " + strShftGraceOutTime).TimeOfDay);
                                if (blnIsPMAM == true)
                                {
                                    dtmShftEndTimeMinusGrace = dtmShftEndTimeMinusGrace.AddDays(1);
                                    dtmShift_EndTime = dtmShift_EndTime.AddDays(1);
                                }
                                // If not Holiday, then Calculate Early Out
                                if (earlyOutCalc == 1)
                                {
                                    if (strIsHoliday != "Y" && strLeaveDay != "Full Day")
                                    {
                                        if (dtmLastOutDateTime < dtmShftEndTimeMinusGrace)
                                        {
                                            tsEarlyOut = dtmShift_EndTime.Subtract(dtmLastOutDateTime);
                                            dEarlyOutMins = double.Parse(tsEarlyOut.TotalMinutes.ToString());
                                            strEarlyExit = GetTotalHours(tsEarlyOut);
                                        }
                                        else
                                        {
                                            strEarlyExit = "00:00";
                                            dEarlyOutMins = 0;
                                        }
                                    }
                                    else
                                    {
                                        strEarlyExit = "00:00";
                                        dEarlyOutMins = 0;
                                    }
                                }
                                else
                                {
                                    strEarlyExit = "00:00";
                                    dEarlyOutMins = 0;
                                }
                                // Calculate Extra Hours Worked
                                //// Find Actual In Time is greater than the Shift Out Time
                                if (dtLeave.Rows.Count > 0)
                                {
                                    // Check for Second half Leave. If so then set the Shift End time as Lunch Start Time
                                    if (strLeaveDay == "Second Session")
                                    {
                                        dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                        strWorkHrs = Convert.ToString(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                    }
                                    else if (strLeaveDay == "First Session")
                                    {
                                        dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]);
                                        strWorkHrs = Convert.ToString(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]);
                                    }
                                }
                                else if (dtPermission.Rows.Count > 0)
                                {
                                    if (dtPermission.Rows[0]["No_Of_Hours"] != DBNull.Value)
                                    {
                                        if (dtPermission.Rows[0]["No_Of_Hours"].ToString() != string.Empty)
                                        {
                                            DateTime dttNoOfHours = Convert.ToDateTime(dtPermission.Rows[0]["No_Of_Hours"].ToString());
                                            TimeSpan tsWorkHours = (dtmWorkHrs.Subtract(dttNoOfHours));
                                            dtmWorkHrs = Convert.ToDateTime(tsWorkHours.ToString());
                                            strWorkHrs = GetTotalHours(tsWorkHours);
                                        }
                                        else
                                        {
                                            DateTime dttPermissionTo = Convert.ToDateTime(dtPermission.Rows[0]["Permission_ToTime"].ToString());
                                            DateTime dttPermissionFrom = Convert.ToDateTime(dtPermission.Rows[0]["Permission_FromTime"].ToString());
                                            TimeSpan tsVariation = (dttPermissionTo.Subtract(dttPermissionFrom));
                                            DateTime dttShiftVariation = Convert.ToDateTime(tsVariation.ToString());
                                            TimeSpan tsWorkHours = dtmWorkHrs.Subtract(dttShiftVariation);
                                            dtmWorkHrs = Convert.ToDateTime(tsWorkHours.ToString());
                                            strWorkHrs = GetTotalHours(tsWorkHours);
                                        }
                                    }
                                    else
                                    {
                                        DateTime dttPermissionTo = Convert.ToDateTime(dtPermission.Rows[0]["Permission_ToTime"].ToString());
                                        DateTime dttPermissionFrom = Convert.ToDateTime(dtPermission.Rows[0]["Permission_FromTime"].ToString());
                                        TimeSpan tsVariation = (dttPermissionTo.Subtract(dttPermissionFrom));
                                        DateTime dttShiftVariation = Convert.ToDateTime(tsVariation.ToString());
                                        TimeSpan tsWorkHours = dtmWorkHrs.Subtract(dttShiftVariation);
                                        dtmWorkHrs = Convert.ToDateTime(tsWorkHours.ToString());
                                        strWorkHrs = GetTotalHours(tsWorkHours);
                                    }
                                }
                                // Calculate Extra hours working for the Employee and Over Time
                                if (dtmLastOutDateTime > dtmShift_EndTime)
                                {
                                    TimeSpan tsLateExit = new TimeSpan();
                                    if (strIsHoliday != "Y")
                                    {
                                        tsLateExit = dtmLastOutDateTime.Subtract(dtmShift_EndTime);
                                        dLateExitMins = double.Parse(tsLateExit.TotalMinutes.ToString());
                                        strLateExitHours = GetTotalHours(tsLateExit);
                                    }
                                }
                                #region "Calculate Flexible Work Hours, OT hours and Attendance"
                                // Calculate Flexible Work Hours, OT hours and Attendance
                                double dblSupposedToWorkHrs = 0;
                                double dblFullDayAttendanceHrs = 0, dblHalfDayAttendanceHrs = 0;
                                double dblShiftWorkMins = 0, dblFirstHalfMins = 0, dblSecondHalfMins = 0;
                                // dblShiftWorkMins holds Defined Shift Total Minutes
                                dblShiftWorkMins = (dtmWorkHrs.TimeOfDay).TotalMinutes;
                                // Get the First Half Work Hours Minutes
                                if (strFirstHalfAttendanceHrs != string.Empty)
                                {
                                    dblFirstHalfMins = TimeSpan.Parse(strFirstHalfAttendanceHrs).TotalMinutes;
                                }
                                // Get the Second Half Work Hours Minutes
                                if (strSecondHalfAttendanceHrs != string.Empty)
                                {
                                    dblSecondHalfMins = TimeSpan.Parse(strSecondHalfAttendanceHrs).TotalMinutes;
                                }
                                // Call the CalculateSupposedToWorkHours function to get the actual hours supposed to work
                                dblSupposedToWorkHrs = CalculateSupposedToWorkHours(dtmWorkHrs.TimeOfDay, dblFirstHalfMins, dblSecondHalfMins, strLeaveDay);
                                if (strFullDayAttendanceHrs != string.Empty)
                                {
                                    dblFullDayAttendanceHrs = TimeSpan.Parse(strFullDayAttendanceHrs).TotalMinutes;
                                }
                                if (strHalfDayAttendanceHrs != string.Empty)
                                {
                                    dblHalfDayAttendanceHrs = TimeSpan.Parse(strHalfDayAttendanceHrs).TotalMinutes;
                                }
                                if (strPermissionHrs != string.Empty && strPermissionHrs != "00:00")
                                {
                                    dblPermissionMins = (DateTime.Parse(strPermissionHrs).TimeOfDay).TotalMinutes;
                                }
                                double LunchTakenedByEmployee = 0;
                                if (dblPhysicalWorkHrs < 0)
                                {
                                    dblPhysicalWorkHrs = 0;
                                }
                                // If Physical Hours is greater than or equal to the Supposed To Work Hours
                                if (dblPhysicalWorkHrs >= dblSupposedToWorkHrs)
                                {
                                    dblTotalMinsWorked = dblSupposedToWorkHrs;
                                    dOT = dblPhysicalWorkHrs - dblSupposedToWorkHrs;
                                    int intCompanyId = GetCompanyId(inEmployee_Code_Id, dtmDate.ToString("yyyy-MM-dd"));
                                    DataTable dtOTSettings = new DataTable();
                                    try
                                    {
                                        dtOTSettings = OverTimeStatus(intCompanyId);
                                        if (dtOTSettings != null)
                                        {
                                            if (dtOTSettings.Rows.Count > 0)
                                            {
                                                if (Convert.ToString(dtOTSettings.Rows[0]["AfterShiftTime"]) == "False")
                                                {
                                                    if (strIsHoliday != "Y")
                                                    {
                                                        if (dtmLastOutDateTime > dtmShift_EndTime)
                                                        {
                                                            TimeSpan tsLateExit = new TimeSpan();
                                                            tsLateExit = dtmLastOutDateTime.Subtract(dtmShift_EndTime);
                                                            double dLateExit = double.Parse(tsLateExit.TotalMinutes.ToString());
                                                            dOT = dOT - dLateExit;
                                                        }
                                                    }
                                                }
                                                if (Convert.ToString(dtOTSettings.Rows[0]["BeforeShiftTime"]) == "False")
                                                {
                                                    if (strIsHoliday != "Y")
                                                    {
                                                        if (dtmFirstInDateTime < dtmShift_StartTime)
                                                        {
                                                            TimeSpan tsEarlyEntry = new TimeSpan();
                                                            tsEarlyEntry = dtmShift_StartTime.Subtract(dtmFirstInDateTime);
                                                            double dEarlyEntryMins = double.Parse(tsEarlyEntry.TotalMinutes.ToString());
                                                            dOT = dOT - dEarlyEntryMins;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    catch (Exception ex)
                                    {
                                        WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(ShiftSettings); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                                    }
                                    // Calculate Attendance
                                    strFNAttendanceCode = "Present";
                                    strANAttendanceCode = "Present";
                                }
                                // If Physical Hours is lesser than Supposed To Work Hours
                                else
                                {
                                    string strIsFNANAbsent = "False";
                                    // Calculate Less Hours Worked
                                    dblFlexiHoursLess = dblSupposedToWorkHrs - dblPhysicalWorkHrs;
                                    strLessHours = TimeFormat(dblFlexiHoursLess);
                                    dOT = 0;
                                    if (inIsHalfDayAttendance == "True")
                                    {
                                        if (dblPhysicalWorkHrs >= dblFirstHalfMins)
                                        {
                                            // Calculate Attendance
                                            strFNAttendanceCode = "Present";
                                            strANAttendanceCode = "Absent";
                                        }
                                        else
                                        {
                                            strIsFNANAbsent = "True";
                                        }
                                    }
                                    else
                                    {
                                        strIsFNANAbsent = "True";
                                    }
                                    if (strIsFNANAbsent == "True")
                                    {
                                        // Calculate Attendance
                                        strFNAttendanceCode = "Absent";
                                        strANAttendanceCode = "Absent";
                                    }
                                }
                                // Update Attendance Codes based on Leave Application
                                // Check for Leave
                                if (dtLeave.Rows.Count > 0)
                                {
                                    // Half day calculation
                                    if (strLeaveCategory != string.Empty)
                                    {
                                        if (strLeaveCategory == "Leave")
                                        {
                                            if (strLeaveType != string.Empty)
                                            {
                                                if (strLeaveDay == "Full Day")
                                                {
                                                    //strFNAttendanceCode = strLeaveType;
                                                    //strANAttendanceCode = strFNAttendanceCode;
                                                    dblTotalDays = 1;
                                                }
                                                else if (strLeaveDay == "First Session")
                                                {
                                                    strFNAttendanceCode = strLeaveType;
                                                    dblTotalDays = 0.5;
                                                }
                                                else if (strLeaveDay == "Second Session")
                                                {
                                                    strANAttendanceCode = strLeaveType;
                                                    dblTotalDays = 0.5;
                                                }
                                                gstrAttendance = strLeaveType;
                                            }
                                        }
                                        else
                                        {
                                            gstrAttendance = strLeaveCategory;
                                            if (strLeaveDay == "Full Day")
                                            {
                                                //strFNAttendanceCode = strLeaveCategory;
                                                //strANAttendanceCode = strFNAttendanceCode;
                                                dblTotalDays = 1;
                                            }
                                            else if (strLeaveDay == "First Session")
                                            {
                                                strFNAttendanceCode = strLeaveCategory;
                                                dblTotalDays = 0.5;
                                            }
                                            else if (strLeaveDay == "Second Session")
                                            {
                                                strANAttendanceCode = strLeaveCategory;
                                                dblTotalDays = 0.5;
                                            }
                                        }
                                    }
                                }
                                // Set Work Hours as Physical Hours
                                dblTotalMinsWorked = dblPhysicalWorkHrs;
                                #endregion
                                // OT Calculation
                                // Check for Over Time Eligible
                                if ((inOT_Eligible == "True" || InCompoffEligible == "True") && ShftWorkOverTime != 0)
                                {
                                    // Normal OT for Flexible Hours
                                    double dblShftMinOTTime = 0, dblShftMaxOTTime = 0;
                                    string strNormOTFlag = "N";
                                    dblShftMinOTTime = tsShftMinOTTime.TotalMinutes;
                                    dblShftMaxOTTime = tsShftMaxOTTime.TotalMinutes;
                                    if (dblShftMinOTTime <= dOT && dOT <= dblShftMaxOTTime)
                                    {
                                        strNormOTFlag = "Y";
                                    }
                                    else if (dOT >= dblShftMaxOTTime)
                                    {
                                        dOT = dblShftMaxOTTime;
                                        strNormOTFlag = "Y";
                                    }
                                    if (strNormOTFlag == "Y")
                                    {
                                        if (ShftWorkOverTime != 0)
                                        {
                                            dOT = dOT * ShftWorkOverTime;
                                        }
                                        // Call OT Round Off
                                        if (inIsOTRoundOff == "True")
                                            dOT = OverTimeRoundOff(dOT, inShiftSettingsId, inIsOTRoundOff);
                                        strNorOT = ConvertMinutesToHoursMins(dOT);
                                    }
                                    else
                                    {
                                        dOT = 0;
                                    }
                                }
                                else
                                {
                                    dOT = 0;
                                }
                            }
                        }
                        strTotalWorkHours = ConvertMinutesToHoursMins(dblTotalMinsWorked);
                        if (intShiftId == -1)
                        {
                            strTotalWorkHours = ConvertMinutesToHoursMins(dblPhysicalWorkHrs);
                        }
                        TimeSpan TotalWrkhours_New = new TimeSpan();
                        TimeSpan DefinedWrkHrs_New = new TimeSpan();
                        TimeSpan ExtraWrkHrs = new TimeSpan();
                        double ExtraMins = 0;
                        TotalWrkhours_New = (DateTime.Parse(strTotalWorkHours).TimeOfDay);
                        if (intShiftId != -1 && strIsHoliday != "Y")
                        {
                            DefinedWrkHrs_New = dtmWorkHrs.TimeOfDay;
                            if (TotalWrkhours_New > DefinedWrkHrs_New)
                            {
                                ExtraWrkHrs = TotalWrkhours_New - DefinedWrkHrs_New;
                                strExtraHours = GetTotalHours(ExtraWrkHrs);
                                ExtraMins = ConvertHoursMinsToMinutes(strExtraHours);
                            }
                        }
                        else
                        {
                            ExtraWrkHrs = TotalWrkhours_New;
                            strExtraHours = GetTotalHours(ExtraWrkHrs);
                            ExtraMins = ConvertHoursMinsToMinutes(strExtraHours);
                        }
                        // Calculate OT
                        double dOTmins = 0;
                        dOTmins = dblShftHolyOverTime + dblShftWeekOffOverTime + dOT;
                        if (inStatus == "BL")
                        {
                            ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                        }
                        // Update the All the calculated data to the Processed Data table
                        #region UpdateFlagInProcessedData
                        string strSQLProcessUpdate = string.Empty;
                        string strSQLUpdateOverTimeStatus = string.Empty;
                        try
                        {
                            strSQLProcessUpdate = "UPDATE TA_Tbl_ProcessedData SET InTime = '" + strFirstIn + "',OutTime = '" + strLastOut + "',Shift_Id = " + intShiftId + ",HrsWork = '" + strTotalWorkHours + "',LateIn = '" + strLateInTime + "',LateInMins = " + dLateInMins + ",EarlyOut = '" + strEarlyExit + "',EarlyOutMins = " + dEarlyOutMins + ",HrsOT = '" + strHrsOT + "', NormOT = '" + strNorOT + "',Status = NULL,";
                            strSQLProcessUpdate += "OffOT = '" + strWeekOffOT + "', HolOT = '" + strHoliOT + "', Attendance = 'Present',";
                            strSQLProcessUpdate += " FNAttendanceCode='" + strFNAttendanceCode.Replace("'", "''") + "' , ANAttendanceCode='" + strANAttendanceCode + "',";
                            strSQLProcessUpdate += "BreakHrs = '00:00',";
                            strSQLProcessUpdate += "LunchHrs = '00:00',";
                            strSQLProcessUpdate += "HoursWorkInMins = '" + dblPhysicalWorkHrs + "',";
                            strSQLProcessUpdate += "BreakHrsInMins = '0',";
                            strSQLProcessUpdate += "LunchHrsInMins = '0',";
                            strSQLProcessUpdate += "YearSettingId = '" + intYearSettingId + "',";
                            strSQLProcessUpdate += " Indate='" + strFirstInDate + "' , Outdate='" + strLastOutDate + "',";
                            strSQLProcessUpdate += " Inpunch='" + strFirstInPunchType + "' , Outpunch='" + strLastOutPunchType + "',";
                            if (intShiftId > 0)
                            {
                                strSQLProcessUpdate += "Shift_StartTime = '" + DateTime.Parse(strActualShiftStartTime).ToString("hh:mm tt") + "',";
                                strSQLProcessUpdate += "Shift_EndTime = '" + DateTime.Parse(strShift_EndTime).ToString("hh:mm tt") + "',";
                                string strHours = string.Empty, strMinute = string.Empty;
                                if (strLeaveDay == "Full Day")
                                    strSQLProcessUpdate += "WorkHrs = '00:00'";
                                else if (isTempWeekday == true)
                                    strSQLProcessUpdate += "WorkHrs = '" + strWorkHrs + "'";
                                else
                                {
                                    //strSQLProcessUpdate += "WorkHrs = '" + dtmWorkHrs.ToString("hh:mm") + "'";
                                    strHours = dtmWorkHrs.Hour.ToString().Length > 1 ? dtmWorkHrs.Hour.ToString() : ("0" + dtmWorkHrs.Hour.ToString());
                                    strMinute = dtmWorkHrs.Minute.ToString().Length > 1 ? dtmWorkHrs.Minute.ToString() : ("0" + dtmWorkHrs.Minute.ToString());
                                    strSQLProcessUpdate += "WorkHrs = '" + strHours + ":" + strMinute + "'";
                                }
                            }
                            else
                            {
                                strSQLProcessUpdate += "Shift_StartTime = '" + DateTime.Parse(strActualShiftStartTime).ToString("hh:mm tt") + "',";
                                strSQLProcessUpdate += "Shift_EndTime = '" + DateTime.Parse(strShift_EndTime).ToString("hh:mm tt") + "',";
                                strSQLProcessUpdate += "WorkHrs = NULL";
                            }
                            DataTable dtOverTimeStatus = new DataTable();
                            if (dOTmins > 0 && gStrOverTimeStatus != string.Empty)
                            {
                                if (inOT_Eligible == "True" && InCompoffEligible == "True")
                                {
                                    strSQLUpdateOverTimeStatus = "select * from TA_Tbl_OverTimeStatus where Process_RecID=" + inProcess_Rec_ID;
                                    dtOverTimeStatus = objDatafunction.ExeQuery(strSQLUpdateOverTimeStatus, "TA_Tbl_OverTimeStatus");
                                    if (dtOverTimeStatus.Rows.Count > 0)
                                    {
                                        strSQLProcessUpdate += ",OvertimeStatus = (select OverTimeStatus from TA_Tbl_OverTimeStatus where Process_RecID=" + inProcess_Rec_ID + ")";
                                    }
                                    else
                                    {
                                        strSQLProcessUpdate += ",OvertimeStatus = 'Pending'";
                                    }
                                }
                                else if (inOT_Eligible == "True" || InCompoffEligible == "True")
                                {
                                    strSQLProcessUpdate += ",OvertimeStatus = '" + gStrOverTimeStatus + "'";
                                }
                            }
                            else
                            {
                                if (inOT_Eligible == "True" && InCompoffEligible == "True")
                                {
                                    strSQLUpdateOverTimeStatus = "select * from TA_Tbl_OverTimeStatus where Process_RecID=" + inProcess_Rec_ID;
                                    dtOverTimeStatus = objDatafunction.ExeQuery(strSQLUpdateOverTimeStatus, "TA_Tbl_OverTimeStatus");
                                    if (dtOverTimeStatus.Rows.Count > 0)
                                    {
                                        strSQLProcessUpdate += ",OvertimeStatus = (select OverTimeStatus from TA_Tbl_OverTimeStatus where Process_RecID=" + inProcess_Rec_ID + ")";
                                    }
                                    else
                                    {
                                        strSQLProcessUpdate += ",OvertimeStatus = 'Pending'";
                                    }
                                }
                                else if (inOT_Eligible == "True" || InCompoffEligible == "True")
                                {
                                    strSQLProcessUpdate += ",OvertimeStatus =NULL";
                                }
                            }
                            if (EarlyEntryCalc == 1)
                            {
                                strSQLProcessUpdate += ",EarlyEntry = 1";
                            }
                            else
                            {
                                strSQLProcessUpdate += ",EarlyEntry = 0";
                            }
                            if (lateExitCalc == 1)
                            {
                                strSQLProcessUpdate += ",LateExit = 1";
                            }
                            else
                            {
                                strSQLProcessUpdate += ",LateExit = 0";
                            }
                            strSQLProcessUpdate += ",HrsLess = '" + strLessHours + "',HrsExtra = '" + strExtraHours + "',ExtraMins = " + ExtraMins + ",OtMins = " + dOTmins + ",TotalDays = " + dblTotalDays + ",LeaveCode = '" + strLeaveCode.Replace("'", "''") + "',ProcessFlag = 1 ";
                            strSQLProcessUpdate += ",LateExitHours ='" + strLateExitHours + "'";
                            strSQLProcessUpdate += ",LateExitMins =" + dLateExitMins + "";
                            strSQLProcessUpdate += ",LessHoursInMins = '" + dblFlexiHoursLess + "'";
                            strSQLProcessUpdate += " WHERE Process_Rec_ID = " + inProcess_Rec_ID + "";
                            if (strSQLProcessUpdate != string.Empty)
                            {
                                OleDbParameter pgUpdateQuery = new OleDbParameter("@UpdateQuery", strSQLProcessUpdate);
                                OleDbParameter[] pParams_UpdateQuery ={ pgUpdateQuery };
                                objDatafunction.SP_Execute(pParams_UpdateQuery, "Proc_Ta_UpdateProcessedDataForService");
                            }
                        }
                        catch (Exception ex)
                        {
                            WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(UPDATE TA_Tbl_ProcessedData1); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                        }
                        #endregion
                        #endregion
                    }
                    else
                    {
                        #region FirstInOrLastOurPunchesAvailed
                        bool blnIsPMAM = false;
                        strFNAttendanceCode = "Absent";
                        strANAttendanceCode = "Absent";
                        gstrAttendance = "Absent";
                        string strActualShiftStartTime = string.Empty;
                        string strShift_EndTime = string.Empty;
                        if (intShiftId != -1 && intShiftId != 0 && strIsHoliday != "Y")
                        {
                            DateTime dtmActualShiftStartTime = new DateTime();
                            DateTime dtmShiftEndTime = new DateTime();
                            string strActShiftStartTime = strDate + " " + ActualShfInTime;
                            dtmActualShiftStartTime = DateTime.Parse(strActShiftStartTime);
                            string strShiftEndTim = strDate + " " + ActualShfOutTime;
                            dtmShiftEndTime = DateTime.Parse(strShiftEndTim);
                            strActualShiftStartTime = dtmActualShiftStartTime.ToString("hh:mm:ss tt");
                            strShift_EndTime = dtmShiftEndTime.ToString("hh:mm:ss tt");
                            if ((strActualShiftStartTime.Substring(9, 2) == "PM") && (strShift_EndTime.Substring(9, 2) == "AM"))
                            {
                                blnIsPMAM = true;
                                dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                            }
                            if (Is24Hrs)
                            {
                                dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                            }
                            if (blnInDateTime == true && blnOutDateTime == false)
                            {
                                TimeSpan tsLateIn = new TimeSpan();
                                if (strFirstIn == string.Empty)
                                {
                                    strFirstIn = inInTime;
                                }
                                #region LateEntryCalculation
                                if (lateEntryCalc == 1)
                                {
                                    tsLateIn = CalculateLateEntry(inEmployee_Code_Id, dtmDate, ActualShfInTime, strShftGraceInTime, strSecondHalfStart, tsFirstInTime, dtmFirstInDateTime, strDate);
                                    dLateInMins = double.Parse(tsLateIn.TotalMinutes.ToString());
                                    strLateInTime = GetTotalHours(tsLateIn);
                                }
                                else
                                {
                                    dLateInMins = 0;
                                    strLateInTime = "00:00";
                                }
                                #endregion
                            }
                        }
                        if (intShiftId == -1)
                        {
                            strFNAttendanceCode = "Weekly Off";
                            strANAttendanceCode = "Weekly Off";
                            gstrAttendance = "Weekly Off";
                        }
                        if (strIsHoliday == "Y")
                        {
                            strFNAttendanceCode = "Holiday";
                            strANAttendanceCode = "Holiday";
                            gstrAttendance = "Holiday";
                        }
                        // Update the ProcessFlag to 1
                        #region UpdateFlagInProcessedData
                        try
                        {
                            string strSQLProcessFlagUpdate = string.Empty;
                            strSQLProcessFlagUpdate = "UPDATE TA_Tbl_ProcessedData SET Shift_Id = " + intShiftId + "";
                            if (strFirstIn == string.Empty)
                            {
                                strSQLProcessFlagUpdate += ",InTime = NULL,LateIn='00:00',LateInMins=0";
                                strSQLProcessFlagUpdate += " ,Indate=NULL";
                                strSQLProcessFlagUpdate += " ,Inpunch=NULL";
                            }
                            else
                            {
                                strSQLProcessFlagUpdate += ",InTime = '" + strFirstIn + "',LateIn = '" + strLateInTime + "',LateInMins = " + dLateInMins + "";
                                strSQLProcessFlagUpdate += " ,Indate='" + strFirstInDate + "'";
                                strSQLProcessFlagUpdate += " ,Inpunch='" + strFirstInPunchType + "' ";
                            }
                            if (strLastOut == string.Empty)
                            {
                                strSQLProcessFlagUpdate += ",OutTime = NULL,EarlyOut='00:00',EarlyOutMins=0,HrsExtra='00:00',ExtraMins=0,OtMins=0,OvertimeStatus=NULL,NormOT='00:00',OffOT='00:00',HolOT='00:00'";
                                strSQLProcessFlagUpdate += " ,Outdate=NULL";
                                strSQLProcessFlagUpdate += " ,Outpunch=NULL";
                            }
                            else
                            {
                                strSQLProcessFlagUpdate += ",OutTime = '" + strLastOut + "'";
                                strSQLProcessFlagUpdate += " ,Outdate='" + strLastOutDate + "'";
                                strSQLProcessFlagUpdate += " ,Outpunch='" + strLastOutPunchType + "'";
                            }
                            if (strFirstIn != string.Empty || strLastOut != string.Empty)
                            {
                                if (inStatus == "BL")
                                {
                                    ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                }
                                strSQLProcessFlagUpdate += ",Status = NULL";
                            }
                            if (strFirstIn == string.Empty && strLastOut == string.Empty)
                            {
                                if (inStatus == "BL")
                                {
                                    if (HolidayId != 0)
                                    {
                                        gstrAttendance = "Holiday";
                                        strFNAttendanceCode = "Holiday";
                                        strANAttendanceCode = "Holiday";
                                        strSQLProcessFlagUpdate += ",Status = NULL";
                                        ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                    }
                                    else if (intShiftId == -1)
                                    {
                                        gstrAttendance = "Weekly Off";
                                        strFNAttendanceCode = "Weekly Off";
                                        strANAttendanceCode = "Weekly Off";
                                        strSQLProcessFlagUpdate += ",Status = NULL";
                                        ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                    }
                                    else if (dtLeave.Rows.Count > 0)
                                    {
                                        // Half day calculation
                                        if (strLeaveCategory != string.Empty)
                                        {
                                            if (strLeaveCategory == "Leave")
                                            {
                                                if (strLeaveType != string.Empty)
                                                {
                                                    if (strLeaveDay == "Full Day")
                                                    {
                                                        //strFNAttendanceCode = strLeaveType;
                                                        //strANAttendanceCode = strFNAttendanceCode;
                                                        dblTotalDays = 1;
                                                    }
                                                    else if (strLeaveDay == "First Session")
                                                    {
                                                        strFNAttendanceCode = strLeaveType;
                                                        dblTotalDays = 0.5;
                                                    }
                                                    else if (strLeaveDay == "Second Session")
                                                    {
                                                        strANAttendanceCode = strLeaveType;
                                                        dblTotalDays = 0.5;
                                                    }
                                                    gstrAttendance = strLeaveType;
                                                }
                                            }
                                            else
                                            {
                                                gstrAttendance = strLeaveCategory;
                                                if (strLeaveDay == "Full Day")
                                                {
                                                    //strFNAttendanceCode = strLeaveCategory;
                                                    //strANAttendanceCode = strFNAttendanceCode;
                                                    dblTotalDays = 1;
                                                }
                                                else if (strLeaveDay == "First Session")
                                                {
                                                    strFNAttendanceCode = strLeaveCategory;
                                                    dblTotalDays = 0.5;
                                                }
                                                else if (strLeaveDay == "Second Session")
                                                {
                                                    strANAttendanceCode = strLeaveCategory;
                                                    dblTotalDays = 0.5;
                                                }
                                            }
                                        }
                                        strSQLProcessFlagUpdate += ",LeaveCode = '" + strLeaveCode.Replace("'", "''") + "',Status = NULL";
                                        ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                    }
                                    else
                                    {
                                        strFNAttendanceCode = "Present";
                                        strANAttendanceCode = "Present";
                                    }
                                }
                            }
                            if (EarlyEntryCalc == 1)
                            {
                                strSQLProcessFlagUpdate += ",EarlyEntry = 1";
                            }
                            else
                            {
                                strSQLProcessFlagUpdate += ",EarlyEntry = 0";
                            }
                            if (lateExitCalc == 1)
                            {
                                strSQLProcessFlagUpdate += ",LateExit = 1";
                            }
                            else
                            {
                                strSQLProcessFlagUpdate += ",LateExit = 0";
                            }
                            if (earlyOutCalc == 0 && strLastOut != string.Empty)
                            {
                                strSQLProcessFlagUpdate += ",EarlyOut = '00:00',EarlyOutMins=0";
                            }
                            if (intShiftId > 0)
                            {
                                strSQLProcessFlagUpdate += ",WorkHrs = '" + dtmWorkHrs.ToString("hh:mm") + "'";
                                strSQLProcessFlagUpdate += ",Shift_StartTime = '" + DateTime.Parse(strActualShiftStartTime).ToString("hh:mm tt") + "'";
                                strSQLProcessFlagUpdate += ",Shift_EndTime = '" + DateTime.Parse(strShift_EndTime).ToString("hh:mm tt") + "'";
                            }
                            else
                            {
                                strSQLProcessFlagUpdate += ",WorkHrs = NULL";
                                strSQLProcessFlagUpdate += ",Shift_StartTime = '" + DateTime.Parse(strActualShiftStartTime).ToString("hh:mm tt") + "'";
                                strSQLProcessFlagUpdate += ",Shift_EndTime = '" + DateTime.Parse(strShift_EndTime).ToString("hh:mm tt") + "'";
                            }
                            strSQLProcessFlagUpdate += ",HrsLess ='00:00'";
                            strSQLProcessFlagUpdate += ",LateExitHours ='" + strLateExitHours + "'";
                            strSQLProcessFlagUpdate += ",LateExitMins =" + dLateExitMins + "";
                            strSQLProcessFlagUpdate += ",LessHoursInMins = '" + dblFlexiHoursLess + "'";
                            strSQLProcessFlagUpdate += ",BreakHrs = '00:00'";
                            strSQLProcessFlagUpdate += ",LunchHrs = '00:00'";
                            strSQLProcessFlagUpdate += ",HoursWorkInMins = '0'";
                            strSQLProcessFlagUpdate += ",BreakHrsInMins = '0'";
                            strSQLProcessFlagUpdate += ",LunchHrsInMins = '0'";
                            strSQLProcessFlagUpdate += ",YearSettingId = '" + intYearSettingId + "'";
                            strSQLProcessFlagUpdate += ",HrsWork = NULL,Attendance = '" + gstrAttendance.Replace("'", "''") + "',FNAttendanceCode = '" + strFNAttendanceCode.Replace("'", "''") + "',ANAttendanceCode = '" + strANAttendanceCode.Replace("'", "''") + "',TotalDays = " + dblTotalDays + ",ProcessFlag = 1 WHERE Process_Rec_ID = " + inProcess_Rec_ID + "";
                            if (strSQLProcessFlagUpdate != string.Empty)
                            {
                                OleDbParameter pgUpdateQuery = new OleDbParameter("@UpdateQuery", strSQLProcessFlagUpdate);
                                OleDbParameter[] pParams_UpdateQuery ={ pgUpdateQuery };
                                objDatafunction.SP_Execute(pParams_UpdateQuery, "Proc_Ta_UpdateProcessedDataForService");
                            }
                        }
                        catch (Exception ex)
                        {
                            WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(UPDATE TA_Tbl_ProcessedData2); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                        }
                        #endregion
                        #endregion
                    }
                }
                // If Employee Attendance is not Present
                else
                {
                    #region "Employee Attendance is not Present"
                    string strActualShiftStartTime = string.Empty;
                    string strShift_EndTime = string.Empty;
                    if (dtShift.Rows.Count > 0)
                    {
                        if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                        {
                            strActualShiftStartTime = Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                        }
                        if (dtShift.Rows[0]["Shift_EndTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]) != string.Empty)
                        {
                            strShift_EndTime = Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]);
                        }
                    }
                    dblTotalDays = 1;
                    string strStatus = string.Empty;
                    // Check for Holiday
                    if (HolidayId != 0)
                    {
                        gstrAttendance = "Holiday";
                        strANAttendanceCode = "Holiday";
                        strFNAttendanceCode = "Holiday";
                        ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                    }
                    else
                    {
                        if (intShiftId == -1)
                        {
                            gstrAttendance = "Weekly Off";
                            strANAttendanceCode = "Weekly Off";
                            strFNAttendanceCode = "Weekly Off";
                            ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                        }
                        else
                        {
                            int intcount = 0;
                            // Check Additional Week Off
                            intcount = CheckAdditionalWeekOff(dtmDate, inEmployee_Code_Id);
                            if (intcount == 1)
                            {
                                gstrAttendance = "Weekly Off";
                                strANAttendanceCode = "Weekly Off";
                                strFNAttendanceCode = "Weekly Off";
                                intShiftId = -1;
                                ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                            }
                            else
                            {
                                // Check in the TimeCheck Leave Application Table                                                                
                                if (dtLeave.Rows.Count > 0)
                                {
                                    if (strLeaveCategory != string.Empty)
                                    {
                                        if (strLeaveCategory == "Leave")
                                        {
                                            if (dtLeave.Rows[0]["LeaveType_id"] != DBNull.Value)
                                            {
                                                if (int.Parse(dtLeave.Rows[0]["LeaveType_id"].ToString()) > 0)
                                                {
                                                    // Get Leave Type by passing Leave Type Id
                                                    strLeaveType = GetLeaveType(int.Parse(dtLeave.Rows[0]["LeaveType_id"].ToString()));
                                                    if (strLeaveType != string.Empty)
                                                    {
                                                        if (strLeaveDay == "Full Day")
                                                        {
                                                            //strFNAttendanceCode = strLeaveType;
                                                            //strANAttendanceCode = strFNAttendanceCode;
                                                            dblTotalDays = 1;
                                                        }
                                                        else if (strLeaveDay == "First Session")
                                                        {
                                                            strFNAttendanceCode = strLeaveType;
                                                            dblTotalDays = 0.5;
                                                            dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]);
                                                        }
                                                        else if (strLeaveDay == "Second Session")
                                                        {
                                                            strANAttendanceCode = strLeaveType;
                                                            dblTotalDays = 0.5;
                                                            dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                                        }
                                                        gstrAttendance = strLeaveType;
                                                    }
                                                }
                                            }
                                        }
                                        else
                                        {
                                            gstrAttendance = strLeaveCategory;
                                            if (strLeaveDay == "Full Day")
                                            {
                                                //strFNAttendanceCode = strLeaveCategory;
                                                //strANAttendanceCode = strFNAttendanceCode;
                                                dblTotalDays = 1;
                                            }
                                            else if (strLeaveDay == "First Session")
                                            {
                                                strFNAttendanceCode = strLeaveCategory;
                                                dblTotalDays = 0.5;
                                                dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_SecondHalfWorkingHours"]);
                                            }
                                            else if (strLeaveDay == "Second Session")
                                            {
                                                strANAttendanceCode = strLeaveCategory;
                                                dblTotalDays = 0.5;
                                                dtmWorkHrs = Convert.ToDateTime(dtShift.Rows[0]["Shift_FirstHalfWorkingHours"]);
                                            }
                                        }
                                    }
                                    ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                }
                                else
                                {
                                    if (intShiftId > 0)
                                    {
                                        gstrAttendance = "Absent";
                                        strFNAttendanceCode = "Absent";
                                        strANAttendanceCode = "Absent";
                                        ResetBonusLeave(inEmployee_Code_Id, dtmDate);
                                    }
                                    else
                                    {
                                        gstrAttendance = string.Empty;
                                    }
                                }
                            }
                        }
                    }
                    #region UpdateFlagInProcessedData
                    try
                    {
                        string strSQLProcessUpdate = "UPDATE TA_Tbl_ProcessedData SET Shift_Id = " + intShiftId + ",TotalDays = " + dblTotalDays + ",LeaveCode = '" + strLeaveCode.Replace("'", "''") + "',ProcessFlag = 1,HrsWork = NULL,Status = NULL,";
                        if (gstrAttendance == string.Empty)
                        {
                            strSQLProcessUpdate += "Attendance = NULL,";
                        }
                        else
                        {
                            strSQLProcessUpdate += "Attendance = '" + gstrAttendance.Replace("'", "''") + "',";
                            strSQLProcessUpdate += " FNAttendanceCode='" + strFNAttendanceCode.Replace("'", "''") + "' , ANAttendanceCode='" + strANAttendanceCode + "',";
                        }
                        if (strFirstInDateTime == string.Empty)
                        {
                            strSQLProcessUpdate += "InTime = '00:00',LateIn='00:00',LateInMins=0,";
                            strSQLProcessUpdate += " Inpunch=NULL,";
                            strSQLProcessUpdate += "Indate=NULL,";
                        }
                        if (strLastOutDateTime == string.Empty)
                        {
                            strSQLProcessUpdate += "OutTime = '00:00',EarlyOut='00:00',EarlyOutMins=0,HrsExtra='00:00',ExtraMins=0,OtMins=0,OvertimeStatus=NULL,NormOT='00:00',OffOT='00:00',HolOT='00:00',";
                            strSQLProcessUpdate += "Outdate=NULL,";
                            strSQLProcessUpdate += "Outpunch=NULL,";
                        }
                        if (intShiftId > 0)
                        {
                            string strHours = string.Empty, strMinute = string.Empty;
                            if (strLeaveDay == "Full Day")
                                strSQLProcessUpdate += "WorkHrs = '00:00'";
                            else if (isTempWeekday == true)
                                strSQLProcessUpdate += "WorkHrs = '" + strWorkHrs + "'";
                            else
                            {
                                strHours = dtmWorkHrs.Hour.ToString().Length > 1 ? dtmWorkHrs.Hour.ToString() : ("0" + dtmWorkHrs.Hour.ToString());
                                strMinute = dtmWorkHrs.Minute.ToString().Length > 1 ? dtmWorkHrs.Minute.ToString() : ("0" + dtmWorkHrs.Minute.ToString());
                                strSQLProcessUpdate += "WorkHrs = '" + strHours + ":" + strMinute + "'";
                                //strSQLProcessUpdate += "WorkHrs = '" + dtmWorkHrs.ToString("hh:mm") + "'";
                            }
                            strSQLProcessUpdate += ",Shift_StartTime = '" + DateTime.Parse(strActualShiftStartTime).ToString("hh:mm tt") + "'";
                            strSQLProcessUpdate += ",Shift_EndTime = '" + DateTime.Parse(strShift_EndTime).ToString("hh:mm tt") + "'";
                        }
                        else
                        {
                            strSQLProcessUpdate += "WorkHrs = NULL";
                            strSQLProcessUpdate += ",Shift_StartTime = Null";
                            strSQLProcessUpdate += ",Shift_EndTime = Null";
                        }
                        if (EarlyEntryCalc == 1)
                        {
                            strSQLProcessUpdate += ",EarlyEntry = 1";
                        }
                        else
                        {
                            strSQLProcessUpdate += ",EarlyEntry = 0";
                        }
                        if (lateExitCalc == 1)
                        {
                            strSQLProcessUpdate += ",LateExit = 1";
                        }
                        else
                        {
                            strSQLProcessUpdate += ",LateExit = 0";
                        }
                        strSQLProcessUpdate += ",HrsLess = '00:00'";
                        strSQLProcessUpdate += ",BreakHrs = '00:00'";
                        strSQLProcessUpdate += ",LunchHrs = '00:00'";
                        strSQLProcessUpdate += ",HoursWorkInMins = '0'";
                        strSQLProcessUpdate += ",BreakHrsInMins = '0'";
                        strSQLProcessUpdate += ",LunchHrsInMins = '0'";
                        strSQLProcessUpdate += ",YearSettingId = '" + intYearSettingId + "'";
                        strSQLProcessUpdate += " WHERE Process_Rec_ID = " + inProcess_Rec_ID + "";
                        if (strSQLProcessUpdate != string.Empty)
                        {
                            OleDbParameter pgUpdateQuery = new OleDbParameter("@UpdateQuery", strSQLProcessUpdate);
                            OleDbParameter[] pParams_UpdateQuery ={ pgUpdateQuery };
                            objDatafunction.SP_Execute(pParams_UpdateQuery, "Proc_Ta_UpdateProcessedDataForService");
                        }
                    }
                    catch (Exception ex)
                    {
                        WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(UPDATE TA_Tbl_ProcessedData3); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
                    }
                    #endregion
                    #endregion
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : FlexibleHoursCalculation(); ProcessRecID : " + inProcess_Rec_ID + "; EmployeeId : " + inEmployee_Id + "; Date : " + inDate + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region GetTotalHours
        /// <summary>
        /// Get Total Hours
        /// </summary>
        /// <param name="tsDayHoursMins"></param>
        /// <returns></returns>
        public string GetTotalHours(TimeSpan tsDayHoursMins)
        {
            char splitChar = '.';
            string[] strSplitHours;
            string strHoursMinutes = string.Empty;
            strSplitHours = Convert.ToString(tsDayHoursMins).Split(splitChar);
            int intTotalHours = 0;
            if (strSplitHours.Length > 1)
            {
                intTotalHours = Convert.ToInt32(strSplitHours[0]);
                intTotalHours = intTotalHours * 24;
            }
            intTotalHours = intTotalHours + tsDayHoursMins.Hours;
            strHoursMinutes = intTotalHours.ToString("00") + ":" + tsDayHoursMins.Minutes.ToString("00");
            return strHoursMinutes;
        }
        #endregion
        #region GetWeeklyOffShiftId
        public int GetWeeklyOffShiftId(int inEmployeeId, string inClk_Date, string inEmployee_Code_Id)
        {
            DataTable dtShift = new DataTable();
            string strShiftStartDateTime = string.Empty, strShiftEndDateTime = string.Empty;
            string strSQLShiftStartTime = string.Empty;
            int intShiftId = 0;
            intShiftId = GetShiftId(inEmployeeId, DateTime.Parse(inClk_Date), inEmployee_Code_Id);
            if (intShiftId == -1)
            {
                intShiftId = GetWeeklyOffShiftId(inEmployeeId, DateTime.Parse(inClk_Date).AddDays(-1).ToString("yyyy-MM-dd"), inEmployee_Code_Id);
            }
            return (intShiftId);
        }
        #endregion
        #region GetWeeklyOffBreakMins
        public double GetWeeklyOffBreakMins(int inEmployeeId, string inClk_Date, string inEmployee_Code_Id)
        {
            // Get the Total Break Hours
            double dblTotalBreakMins = 0;
            try
            {
                int intShiftId = 0;
                bool Is24Hrs = false;
                DataTable dtShift = new DataTable();
                string ActualShfInTime = string.Empty, ActualShfOutTime = string.Empty;
                string strFirstBreakStartTime = "00:00", strFirstBreakEndTime = "00:00", strSecondBreakStartTime = "00:00", strSecondBreakEndTime = "00:00", strThirdBreakStartTime = "00:00", strThirdBreakEndTime = "00:00";
                intShiftId = GetWeeklyOffShiftId(inEmployeeId, inClk_Date, inEmployee_Code_Id);
                dtShift = GettingShiftDetailsUsingShiftId(intShiftId);
                if (dtShift.Rows.Count > 0)
                {
                    if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                    {
                        ActualShfInTime = Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                    }
                    if (dtShift.Rows[0]["Shift_EndTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]) != string.Empty)
                    {
                        ActualShfOutTime = Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]);
                    }
                    if (dtShift.Rows[0]["Shift_BreakStartTime1"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime1"]) != string.Empty)
                    {
                        strFirstBreakStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime1"]);
                    }
                    if (dtShift.Rows[0]["Shift_BreakEndTime1"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime1"]) != string.Empty)
                    {
                        strFirstBreakEndTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime1"]);
                    }
                    if (dtShift.Rows[0]["Shift_BreakStartTime2"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime2"]) != string.Empty)
                    {
                        strSecondBreakStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime2"]);
                    }
                    if (dtShift.Rows[0]["Shift_BreakEndTime2"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime2"]) != string.Empty)
                    {
                        strSecondBreakEndTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime2"]);
                    }
                    if (dtShift.Rows[0]["Shift_BreakStartTime3"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime3"]) != string.Empty)
                    {
                        strThirdBreakStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime3"]);
                    }
                    if (dtShift.Rows[0]["Shift_BreakEndTime3"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime3"]) != string.Empty)
                    {
                        strThirdBreakEndTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime3"]);
                    }
                    if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && dtShift.Rows[0]["24HrsShift"].ToString() != string.Empty)
                    {
                        Is24Hrs = Convert.ToBoolean(dtShift.Rows[0]["24HrsShift"]);
                    }
                }
                bool blnIsPMAM = false;
                DateTime dtmActualShiftStartTime = new DateTime();
                DateTime dtmShiftEndTime = new DateTime();
                string strActShiftStartTime = inClk_Date + " " + ActualShfInTime;
                dtmActualShiftStartTime = DateTime.Parse(strActShiftStartTime);
                string strShiftEndTim = inClk_Date + " " + ActualShfOutTime;
                dtmShiftEndTime = DateTime.Parse(strShiftEndTim);
                string strActualShiftStartTime = dtmActualShiftStartTime.ToString("hh:mm:ss tt");
                string strShift_EndTime = dtmShiftEndTime.ToString("hh:mm:ss tt");
                if ((strActualShiftStartTime.Substring(9, 2) == "PM") && (strShift_EndTime.Substring(9, 2) == "AM"))
                {
                    blnIsPMAM = true;
                    dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                }
                if (Is24Hrs)
                {
                    dtmShiftEndTime = dtmShiftEndTime.AddDays(1);
                }
                dblTotalBreakMins = CalculateTotalBreakHours(inClk_Date, blnIsPMAM, strFirstBreakStartTime, strFirstBreakEndTime, strSecondBreakStartTime, strSecondBreakEndTime, strThirdBreakStartTime, strThirdBreakEndTime);
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : GetWeeklyOffBreakMins; EmployeeId : " + inEmployeeId + "; Date : " + inClk_Date + "; Error : " + ex.ToString());
            }
            return (dblTotalBreakMins);
        }
        #endregion
        #region CalculateTotalBreakHours
        // Function to calculate Total Break Hours
        private double CalculateTotalBreakHours(string inDate, bool inIsPMAM, string inFirstBreakStartTime, string inFirstBreakEndTime, string inSecondBreakStartTime, string inSecondBreakEndTime, string inThirdBreakStartTime, string inThirdBreakEndTime)
        {
            Double dblTotalBreakMins = 0;
            try
            {
                TimeSpan tsFirstBreakHrs = new TimeSpan();
                TimeSpan tsSecondBreakHrs = new TimeSpan();
                TimeSpan tsThirdBreakHrs = new TimeSpan();
                if (inFirstBreakStartTime != "00:00" && inFirstBreakEndTime != "00:00")
                {
                    DateTime dtmFirstBreakStartTime = new DateTime();
                    DateTime dtmFirstBreakEndTime = new DateTime();
                    dtmFirstBreakStartTime = DateTime.Parse(inDate + " " + inFirstBreakStartTime);
                    dtmFirstBreakEndTime = DateTime.Parse(inDate + " " + inFirstBreakEndTime);
                    if (inIsPMAM == true)
                    {
                        if (inFirstBreakStartTime.Substring(6, 2) == "AM")
                        {
                            dtmFirstBreakStartTime.AddDays(1);
                        }
                        if (inFirstBreakEndTime.Substring(6, 2) == "AM")
                        {
                            dtmFirstBreakEndTime.AddDays(1);
                        }
                    }
                    tsFirstBreakHrs = dtmFirstBreakEndTime.Subtract(dtmFirstBreakStartTime);
                    dblTotalBreakMins = dblTotalBreakMins + tsFirstBreakHrs.TotalMinutes;
                }
                if (inSecondBreakStartTime != "00:00" && inSecondBreakEndTime != "00:00")
                {
                    DateTime dtmSecondBreakStartTime = new DateTime();
                    DateTime dtmSecondBreakEndTime = new DateTime();
                    dtmSecondBreakStartTime = DateTime.Parse(inDate + " " + inSecondBreakStartTime);
                    dtmSecondBreakEndTime = DateTime.Parse(inDate + " " + inSecondBreakEndTime);
                    if (inIsPMAM == true)
                    {
                        if (inSecondBreakStartTime.Substring(6, 2) == "AM")
                        {
                            dtmSecondBreakStartTime.AddDays(1);
                        }
                        if (inSecondBreakEndTime.Substring(6, 2) == "AM")
                        {
                            dtmSecondBreakEndTime.AddDays(1);
                        }
                    }
                    tsSecondBreakHrs = dtmSecondBreakEndTime.Subtract(dtmSecondBreakStartTime);
                    dblTotalBreakMins = dblTotalBreakMins + tsSecondBreakHrs.TotalMinutes;
                }
                if (inThirdBreakStartTime != "00:00" && inThirdBreakEndTime != "00:00")
                {
                    DateTime dtmThirdBreakStartTime = new DateTime();
                    DateTime dtmThirdBreakEndTime = new DateTime();
                    dtmThirdBreakStartTime = DateTime.Parse(inDate + " " + inThirdBreakStartTime);
                    dtmThirdBreakEndTime = DateTime.Parse(inDate + " " + inThirdBreakEndTime);
                    if (inIsPMAM == true)
                    {
                        if (inThirdBreakStartTime.Substring(6, 2) == "AM")
                        {
                            dtmThirdBreakStartTime.AddDays(1);
                        }
                        if (inThirdBreakEndTime.Substring(6, 2) == "AM")
                        {
                            dtmThirdBreakEndTime.AddDays(1);
                        }
                    }
                    tsThirdBreakHrs = dtmThirdBreakEndTime.Subtract(dtmThirdBreakStartTime);
                    dblTotalBreakMins = dblTotalBreakMins + tsThirdBreakHrs.TotalMinutes;
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : CalculateTotalBreakHours; Date : " + inDate + "; Error : " + ex.ToString());
            }
            return (dblTotalBreakMins);
        }
        #endregion
        #region OverTimeRoundOff
        private double OverTimeRoundOff(double inOvertimeMins, Int64 inShiftSettingId, string inIsOTRoundOff)
        {
            DataTable dtOverTimeRoundOff = new DataTable();
            string strSQLOverTimeRoundOff = string.Empty;
            try
            {
                OleDbParameter OverTimeRoundOff_inShiftSettingId = new OleDbParameter("@inShiftSettingId", inShiftSettingId);
                OleDbParameter OverTimeRoundOff_inOvertimeMins = new OleDbParameter("@inOvertimeMins", inOvertimeMins);
                OleDbParameter OverTimeRoundOff_inIsOTRoundOff = new OleDbParameter("@inIsOTRoundOff", inIsOTRoundOff);
                OleDbParameter[] OverTimeRoundOff_prmters ={ OverTimeRoundOff_inShiftSettingId, OverTimeRoundOff_inOvertimeMins, OverTimeRoundOff_inIsOTRoundOff };
                dtOverTimeRoundOff = objDatafunction.SelectDatas(OverTimeRoundOff_prmters, "Proc_Ta_GettingOTRoundOffValuesForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Proc.Name:Proc_Ta_GettingOTRoundOffValuesForService(" + inShiftSettingId + "," + inOvertimeMins + "," + inIsOTRoundOff + "); Error : " + ex.ToString());
            }
            return (Convert.ToDouble(dtOverTimeRoundOff.Rows[0]["RoundedOff"]));
        }
        #endregion
        #region AllowFlexibleHours
        // Function added by Kumuthini on May 18 2009
        // Function to check whether the flexible hours is applicable for an employee
        public bool AllowFlexibleHours(int inFlexibleFlag, string IsEmployeewiseFlexiHours)
        {
            // If Flexible Hours set to whole Organization
            if (inFlexibleFlag == 1)
            {
                return (true);
            }
            // If Flexible Hours set to Individual Employee
            else if (inFlexibleFlag == 2)
            {
                if (IsEmployeewiseFlexiHours == "True")
                {
                    return (true);
                }
                if (IsEmployeewiseFlexiHours == "False")
                {
                    return (false);
                }
            }
            else
            {
                return (false);
            }
            return (false);
        }
        #endregion
        #region CalculatePhysicalWorkHours
        // Function added by Kumuthini on May 19 2009
        // Function to calculate Actual Physical Worked Hours for an employee if flexible
        public double CalculatePhysicalWorkHours(string inSwipeCardNo, string Date)
        {
            DataTable dtClockDetails = new DataTable();
            string strTotalWorkHours = string.Empty;
            string strSQLTotHrsWorked = string.Empty;
            double dTotalMinsWorked = 0;
            try
            {
                // Calculating Employee's Acutal Physical Hours worked from the Clock Details Table
                OleDbParameter CalculatePhysicalWorkHours_inSwipeCardNo = new OleDbParameter("@inSwipeCardNo", inSwipeCardNo);
                OleDbParameter CalculatePhysicalWorkHours_Date = new OleDbParameter("@Date", Date);
                OleDbParameter[] CalculatePhysicalWorkHours_prmters ={ CalculatePhysicalWorkHours_inSwipeCardNo, CalculatePhysicalWorkHours_Date };
                dtClockDetails = objDatafunction.SelectDatas(CalculatePhysicalWorkHours_prmters, "Proc_TA_CalculatePhysicalWorkHoursForService");
                if (dtClockDetails.Rows.Count > 0)
                {
                    dTotalMinsWorked = Convert.ToDouble(dtClockDetails.Rows[0][0]);
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : CalculatePhysicalWorkHours; SwipeCardNo : " + inSwipeCardNo + "; Date : " + Date + "; Error : " + ex.Message);
            }
            // strTotalWorkHours holds Employee's Acutal Physical Hours worked
            double dOnDutyHours = CalculateOnDutyWorkHours(inSwipeCardNo, Date);
            strTotalWorkHours = ConvertMinutesToHoursMins(dTotalMinsWorked + dOnDutyHours);
            return (dTotalMinsWorked + dOnDutyHours);
        }
        #endregion
        #region CalculateOnDutyWorkHours
        // Function added by Kumuthini on May 19 2009
        // Function to calculate Actual Physical Worked Hours for an employee if flexible
        public double CalculateOnDutyWorkHours(string inSwipeCardNo, string Date)
        {
            DataTable dtClockDetails = new DataTable();
            string strTotalWorkHours = string.Empty;
            string strSQLTotHrsWorked = string.Empty;
            double dTotalMinsWorked = 0;
            try
            {
                // Calculating Employee's Acutal Physical Hours worked from the Clock Details Table
                strSQLTotHrsWorked = "SELECT Clk_InDate,Clk_InTime,Clk_OutDate,Clk_OutTime,Clk_InPunchType, clk_outpunchtype FROM TA_Tbl_ClockDetails WHERE Clk_EmpId = '" + inSwipeCardNo + "' AND Clk_Date = '" + Date + "' AND IsVoid = 0 order by clk_id";
                dtClockDetails = objDatafunction.ExeQuery(strSQLTotHrsWorked, "TA_Tbl_ClockDetails");
                if (dtClockDetails.Rows.Count > 0)
                {
                    for (int k = 0; k < dtClockDetails.Rows.Count; k++)
                    {
                        if ((dtClockDetails.Rows[k]["Clk_InDate"] != DBNull.Value) && (dtClockDetails.Rows[k]["Clk_InTime"] != DBNull.Value))
                        {
                            if ((dtClockDetails.Rows[k]["Clk_InDate"].ToString() != string.Empty) && (dtClockDetails.Rows[k]["Clk_InTime"].ToString() != string.Empty))
                            {
                                if ((dtClockDetails.Rows[k]["Clk_InPunchType"].ToString() != string.Empty) && (dtClockDetails.Rows[k]["Clk_InPunchType"].ToString() == "Out Duty"))
                                {
                                    if (k != 0)
                                    {
                                        if ((dtClockDetails.Rows[k - 1]["Clk_OutDate"] != DBNull.Value) && (dtClockDetails.Rows[k - 1]["Clk_OutTime"] != DBNull.Value) && (dtClockDetails.Rows[k - 1]["Clk_OutPunchType"].ToString() == "In Duty"))
                                        {
                                            if ((dtClockDetails.Rows[k - 1]["Clk_OutDate"].ToString() != string.Empty) && (dtClockDetails.Rows[k - 1]["Clk_OutTime"].ToString() != string.Empty))
                                            {
                                                string strInDateTime = DateTime.Parse(dtClockDetails.Rows[k]["Clk_InDate"].ToString()).ToString("yyyy-MM-dd") + " " + DateTime.Parse(dtClockDetails.Rows[k]["Clk_InTime"].ToString()).ToShortTimeString();
                                                string strOutDateTime = DateTime.Parse(dtClockDetails.Rows[k - 1]["Clk_OutDate"].ToString()).ToString("yyyy-MM-dd") + " " + DateTime.Parse(dtClockDetails.Rows[k - 1]["Clk_OutTime"].ToString()).ToShortTimeString();
                                                DateTime dtmInDateTime = DateTime.Parse(strInDateTime);
                                                DateTime dtmOutDateTime = DateTime.Parse(strOutDateTime);
                                                dTotalMinsWorked += double.Parse(dtmInDateTime.Subtract(dtmOutDateTime).TotalMinutes.ToString());
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : CalculateOnDutyWorkHours; SwipeCardNo : " + inSwipeCardNo + "; Date : " + Date + "; Error : " + ex.Message);
            }
            return (dTotalMinsWorked);
        }
        #endregion
        #region CalculateSupposedToWorkHours
        // Function added by Kumuthini on May 19 2009
        // Function to calculate Supposed To Work Hours for an employee if flexible
        public double CalculateSupposedToWorkHours(TimeSpan ShiftWorkHrs, double inFirstHalfMins, double inSecondHalfMins, string LeaveDay)
        {
            double dblSupposedToWorkMins = 0;
            dblSupposedToWorkMins = ShiftWorkHrs.TotalMinutes;
            if (LeaveDay == "First Session")
            {
                dblSupposedToWorkMins = inSecondHalfMins;
            }
            else if (LeaveDay == "Second Session")
            {
                dblSupposedToWorkMins = inFirstHalfMins;
            }
            else if (LeaveDay == "Full Day")
            {
                dblSupposedToWorkMins = 0;
            }
            else
            {
                // Nothing
            }
            return (dblSupposedToWorkMins);
        }
        #endregion
        #region CalculateLateEntry
        public TimeSpan CalculateLateEntry(string inEmployeeCodeId, DateTime dtmDate, string inActualShfInTime, string inShftGraceInTime, string inSecondHalfStartTime, TimeSpan tsFirstInTime, DateTime dtmFirstInDateTime, string strDate)
        {
            TimeSpan tsLateIn = new TimeSpan();
            try
            {
                strLeaveDay = string.Empty;
                string strLateInTime = string.Empty;
                #region Get Permission
                // Check for Permission
                DataTable dtPermission = new DataTable();
                DataTable dtShiftCheck = new DataTable();
                try
                {
                    dtPermission = CheckPermissionAppliedorNot(inEmployeeCodeId, dtmDate);
                    DateTime dtmPermissionFromDateTime = new DateTime();
                    DateTime dtmPermissionToDateTime = new DateTime();
                    if (dtPermission.Rows.Count > 0)
                    {
                        dtmPermissionFromDateTime = DateTime.Parse(dtPermission.Rows[0]["Permission_FromTime"].ToString());
                        dtmPermissionToDateTime = DateTime.Parse(dtPermission.Rows[0]["Permission_ToTime"].ToString());
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "function : CalculateLateEntry(Permission) ; EmployeeCodeId : " + inEmployeeCodeId + "; Date : " + dtmDate + "; Error : " + ex.ToString());
                }
                # endregion
                # region Get Leave
                // Check for Leave
                DataTable dtLeave = new DataTable();
                try
                {
                    dtLeave = CheckLeaveAppliedorNot(inEmployeeCodeId, dtmDate);
                    if (dtLeave.Rows.Count > 0)
                    {
                        strLeaveDay = CheckLeave(dtmDate, dtLeave.Rows[0]["Leave_FromDate"].ToString(), dtLeave.Rows[0]["Leave_ToDate"].ToString(), dtLeave.Rows[0]["Leave_SessionFrom"].ToString(), dtLeave.Rows[0]["Leave_SessionTo"].ToString());
                    }
                }
                catch (Exception ex)
                {
                    WriteErrorToEventLog("DataProcess", "function : CalculateLateEntry(Leave) ; EmployeeCodeId : " + inEmployeeCodeId + "; Date : " + dtmDate + "; Error : " + ex.ToString());
                }
                # endregion
                # region Calculating Late Entry
                // CALCULATE LATE INTIME
                string strShiftStartTime = string.Empty;
                // If there is permission during the Shift Start Time, then Set Start Time as
                // Permission To Time and Calculate Late. Else check if there is First half Leave
                // Late should not be calculated during Permission Hours or First half Leave.
                // Check for First Session Leave
                if (strLeaveDay == "First Session")
                {                    // Set Second Half Start Time as Shift Start Time  
                    strShiftStartTime = inSecondHalfStartTime;
                }
                if (strShiftStartTime == string.Empty)
                {
                    // Check whether there is Permission during the Shift Start Time
                    if (dtPermission.Rows.Count > 0)
                    {
                        DateTime dtmShiftStartDateTime = new DateTime();
                        string strShiftStartDateTime = dtmDate.ToString("yyyy-MM-dd") + " " + inActualShfInTime;
                        dtmShiftStartDateTime = DateTime.Parse(strShiftStartDateTime);
                        if (dtmShiftStartDateTime >= dtmPermissionFromDateTime && dtmShiftStartDateTime <= dtmPermissionToDateTime)
                        {
                            strShiftStartTime = DateTime.Parse(dtPermission.Rows[0]["Permission_ToTime"].ToString()).ToShortTimeString();
                        }
                        else
                        {
                            strShiftStartTime = inActualShfInTime;
                        }
                    }
                    else
                    {
                        strShiftStartTime = inActualShfInTime;
                    }
                }
                // Calculate Late In Time
                TimeSpan tsActualShiftStartTime = DateTime.Parse(strShiftStartTime).TimeOfDay;
                TimeSpan tsShftStartTimePlusGrace = new TimeSpan();
                DateTime dtmShftStartTimePlusGrace = new DateTime();
                DateTime dtmShift_StartTime = new DateTime();
                // Add Grace In with Shift Start Time
                tsShftStartTimePlusGrace = tsActualShiftStartTime.Add(DateTime.Parse(inShftGraceInTime).TimeOfDay);
                dtmShift_StartTime = DateTime.Parse(strDate + " " + tsActualShiftStartTime.ToString());
                dtmShftStartTimePlusGrace = DateTime.Parse(strDate + " " + tsShftStartTimePlusGrace.ToString());
                tsFirstInTime = DateTime.Parse(tsFirstInTime.ToString().Substring(0, 5)).TimeOfDay;
                // Calculate Late In, if Actual InTime is greater that Shift Start Time
                if (dtmFirstInDateTime > dtmShftStartTimePlusGrace)
                {
                    tsLateIn = dtmFirstInDateTime.Subtract(dtmShift_StartTime);
                    strLateInTime = GetTotalHours(tsLateIn);
                }
                if (strLateInTime == string.Empty)
                {
                    strLateInTime = "00:00";
                }
                # endregion
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : CalculateLateEntry ; EmployeeCodeId : " + inEmployeeCodeId + "; Date : " + dtmDate + "; Error : " + ex.ToString());
            }
            return (tsLateIn);
        }
        #endregion
        #region ResetBonusLeave
        public void ResetBonusLeave(string Employee_Code_Id, DateTime dtmDate)
        {
            string strSQLProcessedDataBLUpdate = string.Empty;
            try
            {
                OleDbParameter BLeave_Employee_Code_Id = new OleDbParameter("@Employee_Code_Id", Employee_Code_Id);
                OleDbParameter BLeave_dtmDate = new OleDbParameter("@dtmDate", dtmDate);
                OleDbParameter[] pmters_BLeave ={ BLeave_Employee_Code_Id, BLeave_dtmDate };
                objDatafunction.SP_Execute(pmters_BLeave, "Proc_Ta_ResetBonusLeaveForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : ResetBonusLeave ; EmployeeCodeId : " + Employee_Code_Id + "; Date : " + dtmDate + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region GetLevelId
        public string GetLevelId(string inClk_EmpId, string inClk_Date)
        {
            // Get the Company Id for a particular Employee
            try
            {
                DataTable dtCompany = new DataTable();
                OleDbParameter GetLevelId_inClk_EmpId = new OleDbParameter("@inClk_EmpId", inClk_EmpId);
                OleDbParameter GetLevelId_inClk_Date = new OleDbParameter("@inClk_Date", inClk_Date);
                OleDbParameter[] GetLevelId_prmters ={ GetLevelId_inClk_EmpId, GetLevelId_inClk_Date };
                dtCompany = objDatafunction.SelectDatas(GetLevelId_prmters, "Proc_Ta_GetLevelIdForService");
                if (dtCompany.Rows.Count != 0)
                {
                    gstrCompanyId = Convert.ToString(dtCompany.Rows[0][0]);
                }
                else
                {
                    gstrCompanyId = "0";
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : GetLevelId(Proc.Name : Proc_Ta_GetLevelIdForService(" + inClk_EmpId + "," + inClk_Date + "); Error : " + ex.ToString());
            }
            return gstrCompanyId;
        }
        #endregion
        #region GetCompanyId(NotUse)
        public int GetCompanyId(string inClk_EmpId, string inClk_Date)
        {
            int intCompanyId = 0;
            intCompanyId = Convert.ToInt32(GetLevelId(inClk_EmpId, inClk_Date));
            return (intCompanyId);
        }
        #endregion
        #region GetCompanyId(NotUse)
        public int GetCompanyId(int LevelId)
        {
            try
            {
                DataTable dtLevel = new DataTable();
                OleDbParameter pgCompany_id = new OleDbParameter("@LevelId", LevelId);
                OleDbParameter[] pCompanyParams ={ pgCompany_id };
                dtLevel = objDatafunction.SelectDatas(pCompanyParams, "Proc_Ta_GetCompanyIdForService");
                if (dtLevel.Rows.Count > 0)
                {
                    gintCompanyId = int.Parse(Convert.ToString(dtLevel.Rows[0]["Id"]));
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : GetCompanyId ; LevelId : " + LevelId + " ; Error : " + ex.ToString());
            }
            return (gintCompanyId);
        }
        #endregion
        #region CheckLeave
        // check whether the leave for Full Day or First Session or Second Session for particular Employee and Date
        public string CheckLeave(DateTime dtmDate, string inLeaveFromDate, string inLeaveToDate, string inLeaveFromSession, string inLeaveToSession)
        {
            DateTime dtmLeaveFromDate = DateTime.Parse(inLeaveFromDate);
            DateTime dtmLeaveToDate = DateTime.Parse(inLeaveToDate);
            string strLeaveFromSession = inLeaveFromSession;
            string strLeaveToSession = inLeaveToSession;
            if ((dtmLeaveFromDate.ToString("yyyy-MM-dd") == dtmDate.ToString("yyyy-MM-dd")) && (dtmLeaveToDate.ToString("yyyy-MM-dd") == dtmDate.ToString("yyyy-MM-dd")))
            {
                if (strLeaveDay == string.Empty)
                {
                    if (strLeaveFromSession == "First half" && strLeaveToSession == "Second half")
                    {
                        strLeaveDay = "Full Day";
                    }
                    else if (strLeaveFromSession == "First half" && strLeaveToSession == "First half")
                    {
                        strLeaveDay = "First Session";
                    }
                    else if (strLeaveFromSession == "Second half" && strLeaveToSession == "Second half")
                    {
                        strLeaveDay = "Second Session";
                    }
                }
                else
                {
                    if ((strLeaveFromSession == "First half" && strLeaveToSession == "First half") || (strLeaveFromSession == "Second half" && strLeaveToSession == "Second half"))
                    {
                        strLeaveDay = "Full Day";
                    }
                }
            }
            else if ((dtmLeaveFromDate.ToString("yyyy-MM-dd") == dtmDate.ToString("yyyy-MM-dd")) && (dtmLeaveToDate.ToString("yyyy-MM-dd") != dtmDate.ToString("yyyy-MM-dd")))
            {
                if (strLeaveFromSession == "First half")
                {
                    strLeaveDay = "Full Day";
                }
                else if (strLeaveFromSession == "Second half")
                {
                    strLeaveDay = "Second Session";
                }
                else
                {
                    // Nothing
                }
            }
            else if ((dtmLeaveFromDate.ToString("yyyy-MM-dd") != dtmDate.ToString("yyyy-MM-dd")) && (dtmLeaveToDate.ToString("yyyy-MM-dd") == dtmDate.ToString("yyyy-MM-dd")))
            {
                if (strLeaveToSession == "First half")
                {
                    strLeaveDay = "First Session";
                }
                else if (strLeaveToSession == "Second half")
                {
                    strLeaveDay = "Full Day";
                }
                else
                {
                    // Nothing
                }
            }
            else if ((DateTime.Parse(dtmLeaveFromDate.ToString("yyyy-MM-dd")) < dtmDate) && (DateTime.Parse(dtmLeaveToDate.ToString("yyyy-MM-dd")) > dtmDate))
            {
                strLeaveDay = "Full Day";
            }
            else
            {
                // Nothing
            }
            return (strLeaveDay);
        }
        #endregion
        #region GetLeaveCategory
        // Get Leave Category by Type
        public string GetLeaveCategory(string inType)
        {
            string strLeaveCategory = string.Empty;
            if (inType == "Leave")
            {
                strLeaveCategory = "Leave";
            }
            else if (inType == "Restricted Holiday")
            {
                strLeaveCategory = "RH";
            }
            else if (inType == "Comp Off")
            {
                strLeaveCategory = "Comp Off";
            }
            else if (inType == "ESI")
            {
                strLeaveCategory = "ESI";
            }
            else if (inType == "LOP")
            {
                strLeaveCategory = "LOP";
            }
            return (strLeaveCategory);
        }
        #endregion
        #region GetLeaveType
        // Get Leave Type by passing Leave Type Id
        public string GetLeaveType(Int64 inLeaveTypeId)
        {
            string strLeaveType = string.Empty;
            try
            {
                DataTable dtLeaveType = new DataTable();
                OleDbParameter pgLeaveType_id = new OleDbParameter("@inLeaveTypeId", inLeaveTypeId);
                OleDbParameter[] pLeaveTypeParams ={ pgLeaveType_id };
                dtLeaveType = objDatafunction.SelectDatas(pLeaveTypeParams, "Proc_Ta_GetLeaveTypeForservice");
                if (dtLeaveType.Rows.Count > 0)
                {
                    if (dtLeaveType.Rows[0]["LeaveType"] != DBNull.Value && Convert.ToString(dtLeaveType.Rows[0]["LeaveType"]) != string.Empty)
                    {
                        strLeaveType = Convert.ToString(dtLeaveType.Rows[0]["LeaveType"]);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Proc.Name:Proc_Ta_GetLeaveTypeForservice(" + inLeaveTypeId + "); Error : " + ex.ToString());
            }
            return (strLeaveType);
        }
        #endregion
        #region GetYearSettingId
        public int GetYearSettingId(DateTime dtmDate)
        {
            int intYearSettingId = 0;
            try
            {
                DataTable dtYearSetting = new DataTable();
                OleDbParameter pgYrsetting_dtmDate = new OleDbParameter("@dtmDate", dtmDate);
                OleDbParameter[] pYrsettingInParams ={ pgYrsetting_dtmDate };
                dtYearSetting = objDatafunction.SelectDatas(pYrsettingInParams, "Proc_Ta_GetYearSettingIdForService");
                if (dtYearSetting.Rows.Count > 0)
                {
                    if (dtYearSetting.Rows[0]["YearSettings_Id"] != DBNull.Value && Convert.ToString(dtYearSetting.Rows[0]["YearSettings_Id"]) != string.Empty)
                    {
                        intYearSettingId = int.Parse(Convert.ToString(dtYearSetting.Rows[0]["YearSettings_Id"]));
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : GetYearSettingId ; Date : " + dtmDate + "; Error : " + ex.ToString());
            }
            return (intYearSettingId);
        }
        #endregion
        #region GetFirstIn
        // Function to get First In Time for the particular Swipe Card No and Date
        public string GetFirstIn(string inSwipeCardNo, string inDate)
        {
            DataTable dtFirstIn = new DataTable();
            string strFirstInDateTime = string.Empty;
            try
            {
                OleDbParameter pgFirstInEmployee_Code_Id = new OleDbParameter("@inSwipeCardNo", inSwipeCardNo);
                OleDbParameter pgFirstIndtmDate = new OleDbParameter("@inDate", inDate);
                OleDbParameter[] pFirstInParams ={ pgFirstInEmployee_Code_Id, pgFirstIndtmDate };
                dtFirstIn = objDatafunction.SelectDatas(pFirstInParams, "Proc_Ta_GetFirstInDetailsForService");
                if (dtFirstIn.Rows.Count > 0)
                {
                    if (dtFirstIn.Rows[0]["FirstIn"] != DBNull.Value && Convert.ToString(dtFirstIn.Rows[0]["FirstIn"]) != string.Empty)
                    {
                        strFirstInDateTime = Convert.ToString(dtFirstIn.Rows[0]["FirstIn"]);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : GetFirstIn(Proc.Name:Proc_Ta_GetFirstInDetailsForService(" + inSwipeCardNo + "," + inDate + "); Error : " + ex.ToString());
            }
            return (strFirstInDateTime);
        }
        #endregion
        #region GetLastOut
        // Function to get Last Out Time for the particular Swipe Card No and Date
        public string GetLastOut(string inSwipeCardNo, string inDate)
        {
            DataTable dtLastOut = new DataTable();
            string strLastOutDateTime = string.Empty;
            string strSQLLastOut = string.Empty;
            try
            {
                OleDbParameter pgLastOutinSwipeCardNo = new OleDbParameter("@Employeecode", inSwipeCardNo);
                OleDbParameter pgLastOutinDate = new OleDbParameter("@Date", inDate);
                OleDbParameter[] pLastOutParams ={ pgLastOutinSwipeCardNo, pgLastOutinDate };
                dtLastOut = objDatafunction.SelectDatas(pLastOutParams, "Proc_Ta_GetLastOutDetailsForService");
                if (dtLastOut.Rows.Count > 0)
                {
                    if (dtLastOut.Rows[0]["LastOut"] != DBNull.Value && Convert.ToString(dtLastOut.Rows[0]["LastOut"]) != string.Empty)
                    {
                        strLastOutDateTime = Convert.ToString(dtLastOut.Rows[0]["LastOut"]);
                    }
                }
                return (strLastOutDateTime);
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : GetLastOut; SwipeCardNo : " + inSwipeCardNo + "; Date : " + inDate + "; Error : " + ex.ToString());
                throw ex;
            }
        }
        #endregion
        #region FillTempProcessTable
        // Function to fill the Temporary Table with Dates from Month Closure End Date to Current Date
        public void FillTempProcessTable()
        {
            try
            {
                OleDbParameter pgCompanyId = new OleDbParameter("@CompanyId", gintCompanyId);
                OleDbParameter pgDefaultMonthClosureDate = new OleDbParameter("@DefaultMonthClosureDate", gstrDefaultMonthClosureDate);
                OleDbParameter[] pParams ={ pgCompanyId, pgDefaultMonthClosureDate };
                objDatafunction.SP_Execute(pParams, "Proc_Ta_GetMonthClosureEndDateForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : FillTempProcessTable(Proc.Name:Proc_Ta_GetMonthClosureEndDateForService(" + gintCompanyId + "," + gstrDefaultMonthClosureDate + ")) ; Error : " + ex.ToString());
            }
        }
        #endregion
        #region FillMissedOutEmployees
        public void FillMissedOutEmployees()
        {
            //Delete the Temporary Table values from "Ta_Tbl_DataProcessCompanyLevelTemp" table
            try
            {
                objDatafunction.SP_Execute_NoParam("Proc_Ta_Delete_CompanyDetailsForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : FillMissedOutEmployees() ; Error : " + ex.ToString());
            }
            //Fill Child Levels in the Temporary table for comparing employees based on the Company
            OleDbParameter pgintCompanyId = new OleDbParameter("@ParentID", gintCompanyId);
            OleDbParameter[] pParams ={ pgintCompanyId };
            try
            {
                objDatafunction.SP_Execute(pParams, "Proc_Ta_GetChildrenLevels");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : FillMissedOutEmployees(Proc.Name: Proc_Ta_GetChildrenLevels(" + gintCompanyId + ")) ; Error : " + ex.ToString());
            }
            try
            {
                objDatafunction.SP_Execute_NoParam("PROC_TA_INSERT_PROCESSDATA_SERVICE");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Function : FillMissedOutEmployees(Proc.Name:PROC_TA_INSERT_PROCESSDATA_SERVICE) ; Error : " + ex.ToString());
            }
        }
        #endregion
        #region GetShiftId
        // Function to get Shift ID for appropriate Employee and Date
        public int GetShiftId(int inEmployeeId, DateTime dtmDate, string inEmployee_Code_Id)
        {
            int intShiftId = 0, intCompanyId = 0;
            try
            {
                intCompanyId = Convert.ToInt32(GetLevelId(inEmployee_Code_Id, dtmDate.ToString()));
                OleDbParameter pmintEmployeeId = new OleDbParameter("@EMPLOYEEAUTOID", inEmployeeId);
                //OleDbParameter pmintYear = new OleDbParameter("@year", dtmDate.Year);
                //OleDbParameter pmintmonth = new OleDbParameter("@month", dtmDate.Month);
                OleDbParameter pmintDate = new OleDbParameter("@DATE", dtmDate);
                OleDbParameter pmintCompanyId = new OleDbParameter("@COMPANYID", intCompanyId);
                OleDbParameter[] pParams ={ pmintEmployeeId, pmintDate, pmintCompanyId };
                intShiftId = objDatafunction.SP_ExecuteScalar(pParams, "Proc_TA_SelectShiftIdForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Proc.Name:Proc_TA_SelectShiftIdForService(" + inEmployeeId + "," + dtmDate + "); Error : " + ex.ToString());
            }
            return (intShiftId);
        }
        #endregion
        #region TimeFormat
        /// <summary>
        /// The TimeFormat() Function is used to convert the Total Minutes into the Time Format
        /// </summary>
        /// <param name="TotMins">Total Minutes</param>
        /// <returns>Time Format</returns>
        /// 
        public string TimeFormat(double TotMins)
        {
            string strHrsMins = string.Empty;
            double dHrs = Math.Floor(TotMins / 60);
            double dMins = TotMins % 60;
            int iHrs = Convert.ToInt32(dHrs);
            int iMins = Convert.ToInt32(dMins);
            if (Convert.ToInt32(dMins) >= 60)
            {
                iMins = Convert.ToInt32(dMins) % 60;
                iHrs += Convert.ToInt32(dMins) / 60;
            }
            strHrsMins = iHrs.ToString("00") + ":" + iMins.ToString("00");
            return (strHrsMins);
        }
        #endregion
        #region ConvertHoursMinsToMinutes
        // Function to Convert hh:mm format to Total Minutes
        public int ConvertHoursMinsToMinutes(string inHoursMins)
        {
            int intTotalMinutes = 0, intHours = 0, intMinutes = 0;
            string[] HoursMins = inHoursMins.Split(':');
            intHours = Int16.Parse(HoursMins[0]);
            intMinutes = Int16.Parse(HoursMins[1]);
            intTotalMinutes = (intHours * 60) + intMinutes;
            return (intTotalMinutes);
        }
        #endregion
        #region ConvertMinutesToHoursMins
        // Function to Convert Total Minutes to hh:mm format
        public string ConvertMinutesToHoursMins(double inTotalMinutes)
        {
            string strHoursMins = "00:00";
            double dTotHrs = Math.Floor(inTotalMinutes / 60);
            double dTotMins = inTotalMinutes % 60;
            int iTotHrs = Convert.ToInt32(dTotHrs);
            int iTotMins = Convert.ToInt32(dTotMins);
            if (Convert.ToInt32(dTotMins) >= 60)
            {
                iTotMins = Convert.ToInt32(dTotMins) % 60;
                iTotHrs += Convert.ToInt32(dTotMins) / 60;
            }
            strHoursMins = iTotHrs.ToString("00") + ":" + iTotMins.ToString("00");
            return (strHoursMins);
        }
        #endregion
        #region CheckAdditionalWeekOff
        // Function to check Additional Weekly Off
        public int CheckAdditionalWeekOff(DateTime dtmDate, string SwipeCardNo)
        {
            DateTime startOfMonth;
            string strStartOfMonth;
            int DaysToAdd, NthWeek = 0, TargetDayOfWeek = 0;
            string flag = "NE";
            try
            {
                OleDbParameter pchkadd_Employeecode = new OleDbParameter("@SwipeCardNo", SwipeCardNo);
                OleDbParameter pchkadd_dtmDate = new OleDbParameter("@dtmDate", dtmDate);
                OleDbParameter[] pchkadd_Params ={ pchkadd_Employeecode, pchkadd_dtmDate };
                DataTable dtAdditionalWeekOff = new DataTable();
                dtAdditionalWeekOff = objDatafunction.SelectDatas(pchkadd_Params, "Proc_Ta_CheckAdditionalWeekOffForService");
                for (int i = 0; i < dtAdditionalWeekOff.Rows.Count; i++)
                {
                    if (dtAdditionalWeekOff.Rows[i]["Addl_WeekOff_Day"] != DBNull.Value && Convert.ToString(dtAdditionalWeekOff.Rows[i]["Addl_WeekOff_Day"]) != string.Empty)
                    {
                        TargetDayOfWeek = GetWeekDay(Convert.ToString(dtAdditionalWeekOff.Rows[i]["Addl_WeekOff_Day"]));
                    }
                    if (dtAdditionalWeekOff.Rows[i]["Addl_WeekOff_Week"] != DBNull.Value && Convert.ToString(dtAdditionalWeekOff.Rows[i]["Addl_WeekOff_Week"]) != string.Empty)
                    {
                        string strTargetDayOfWeek = Convert.ToString(dtAdditionalWeekOff.Rows[i]["Addl_WeekOff_Week"]);
                        if (strTargetDayOfWeek == "First Week")
                        {
                            NthWeek = 1;
                        }
                        else if (strTargetDayOfWeek == "Second Week")
                        {
                            NthWeek = 2;
                        }
                        else if (strTargetDayOfWeek == "Third Week")
                        {
                            NthWeek = 3;
                        }
                        else if (strTargetDayOfWeek == "Fourth Week")
                        {
                            NthWeek = 4;
                        }
                        else if (strTargetDayOfWeek == "Fifth Week")
                        {
                            NthWeek = 5;
                        }
                    }
                    if (NthWeek != 0 && TargetDayOfWeek != 0)
                    {
                        strStartOfMonth = dtmDate.Month + "/01/" + dtmDate.Year;
                        startOfMonth = DateTime.Parse(strStartOfMonth);
                        string WeekDayName = startOfMonth.DayOfWeek.ToString();
                        int WeekDay = GetWeekDay(WeekDayName);
                        DaysToAdd = (7 - (WeekDay + (7 - TargetDayOfWeek)) % 7) % 7;
                        DateTime dtmResult = startOfMonth.AddDays(DaysToAdd + ((NthWeek - 1) * 7));
                        if (dtmResult == dtmDate)
                        {
                            flag = "E";
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : CheckAdditionalWeekOff ; SwipeCardNo : " + SwipeCardNo + "; Date : " + dtmDate + "; Error : " + ex.ToString());
            }
            if (flag == "E")
            {
                return (1);
            }
            else
            {
                return (0);
            }
        }
        #endregion
        #region GetWeekDay
        public int GetWeekDay(string WeekDayName)
        {
            int intWeekDay = 0;
            try
            {
                switch (WeekDayName)
                {
                    case "Sunday":
                        intWeekDay = 1;
                        break;
                    case "Monday":
                        intWeekDay = 2;
                        break;
                    case "Tuesday":
                        intWeekDay = 3;
                        break;
                    case "Wednesday":
                        intWeekDay = 4;
                        break;
                    case "Thursday":
                        intWeekDay = 5;
                        break;
                    case "Friday":
                        intWeekDay = 6;
                        break;
                    case "Saturday":
                        intWeekDay = 7;
                        break;
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "GetWeekDay()" + "\r\n" + ex.Message);
            }
            return (intWeekDay);
        }
        #endregion
        #region GettingShiftDetailsUsingShiftId
        public DataTable GettingShiftDetailsUsingShiftId(int intShiftId)
        {
            DataTable dtShift = new DataTable();
            try
            {
                OleDbParameter ParamShiftId = new OleDbParameter("@intShiftId", intShiftId);
                OleDbParameter[] pParamshift ={ ParamShiftId };
                dtShift = objDatafunction.SelectDatas(pParamshift, "Proc_TA_ShiftDetailsByIdForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Proc.Name:Proc_TA_ShiftDetailsByIdForService(" + intShiftId + ")" + "\r\n" + ex.Message.ToString());
            }
            return dtShift;
        }
        #endregion
        #region GettingLeaveDetails
        public DataTable CheckLeaveAppliedorNot(string inEmployeeCodeId, DateTime dtmDate)
        {
            DataTable dtLeave = new DataTable();
            try
            {
                OleDbParameter pgLeaveEmployee_Code_Id = new OleDbParameter("@inEmployee_Code_Id", inEmployeeCodeId);
                OleDbParameter pgleavedtmDate = new OleDbParameter("@dtmDate", dtmDate);
                OleDbParameter[] pleaveParams ={ pgLeaveEmployee_Code_Id, pgleavedtmDate };
                dtLeave = objDatafunction.SelectDatas(pleaveParams, "Proc_Ta_SelectLeaveDetailsForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Proc.Name:Proc_Ta_SelectLeaveDetailsForService(" + inEmployeeCodeId + "," + dtmDate + ")" + "\r\n" + ex.Message);
            }
            return dtLeave;
        }
        #endregion
        #region GettingPermissionDetails
        public DataTable CheckPermissionAppliedorNot(string inEmployeeCodeId, DateTime dtmDate)
        {
            DataTable dtPermission = new DataTable();
            try
            {
                OleDbParameter pgPermissionEmployee_Code_Id = new OleDbParameter("@inEmployee_Code_Id", inEmployeeCodeId);
                OleDbParameter pgPermissiondtmDate = new OleDbParameter("@dtmDate", dtmDate);
                OleDbParameter[] pPermissionParams ={ pgPermissionEmployee_Code_Id, pgPermissiondtmDate };
                dtPermission = objDatafunction.SelectDatas(pPermissionParams, "Proc_Ta_GettingPermissionDetailsForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "Proc.Name:Proc_Ta_GettingPermissionDetailsForService(" + inEmployeeCodeId + "," + dtmDate + ")" + "\r\n" + ex.Message);
            }
            return dtPermission;
        }
        #endregion
        #region CheckHoliday
        public int CheckHoliday(string Date, int inEmployee_Id)
        {
            int HolidayId = 0;
            try
            {
                OleDbParameter FromDate = new OleDbParameter("@FromDate", Date);
                OleDbParameter ToDate = new OleDbParameter("@ToDate", Date);
                OleDbParameter HolidayType = new OleDbParameter("@HolidayType", "G");
                OleDbParameter EmployeeAutoId = new OleDbParameter("@EmployeeAutoId", inEmployee_Id);
                OleDbParameter[] pParams ={ FromDate, ToDate, HolidayType, EmployeeAutoId };
                HolidayId = objDatafunction.SP_ExecuteWithReturn(pParams, "Proc_TA_CheckHolidayBasedOnLevel");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "CheckHoliday()" + "\r\n" + ex.Message);
            }
            return HolidayId;
        }
        #endregion
        #region CheckFlexi
        public DataTable OverTimeStatus(int intCompanyId)
        {
            DataTable dtOTSettings = new DataTable();
            try
            {
                OleDbParameter pgCompanyId = new OleDbParameter("@CompanyId", intCompanyId);
                OleDbParameter[] pParams ={ pgCompanyId };
                dtOTSettings = objDatafunction.SelectDatas(pParams, "Proc_Ta_GetBasicShiftSettingDetailsForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "OverTimeStatus()" + "\r\n" + ex.Message);
            }
            return dtOTSettings;
        }
        #endregion
        #region GetLastOutPunchType
        public string GetLastOutPunchType(string inSwipeCardNo, string inDate)
        {
            try
            {
                DataTable dtLastOutMaxid = new DataTable();
                DataTable dtLastOutPunchType = new DataTable();
                string strLastOutDatePunchType = string.Empty;
                string strSQLMaxid = string.Empty;
                string strSQLLastOutPunchType = string.Empty;
                int intMaxid = 0;
                strSQLMaxid = "SELECT MAX(Clk_Id) AS LastOut FROM TA_Tbl_ClockDetails WHERE Clk_EmpId = '" + inSwipeCardNo + "' AND Clk_Date = '" + inDate + "' AND Clk_OutDate IS NOT NULL AND IsVoid = 0";
                dtLastOutMaxid = objDatafunction.ExeQuery(strSQLMaxid, "TA_Tbl_ClockDetails");
                if (dtLastOutMaxid.Rows.Count > 0)
                {
                    if (dtLastOutMaxid.Rows[0]["LastOut"] != DBNull.Value && dtLastOutMaxid.Rows[0]["LastOut"].ToString() != string.Empty)
                    {
                        intMaxid = Convert.ToInt32(dtLastOutMaxid.Rows[0]["LastOut"]);
                        if (intMaxid > 0)
                        {
                            strLastOutDatePunchType = "SELECT Clk_OutPunchType AS LastOut FROM TA_Tbl_ClockDetails WHERE Clk_Id = " + intMaxid;
                            dtLastOutPunchType = objDatafunction.ExeQuery(strLastOutDatePunchType, "TA_Tbl_ClockDetails");
                            if (dtLastOutPunchType.Rows.Count > 0)
                            {
                                if (dtLastOutPunchType.Rows[0]["LastOut"] != DBNull.Value && dtLastOutPunchType.Rows[0]["LastOut"].ToString() != string.Empty)
                                {
                                    strLastOutDatePunchType = Convert.ToString(dtLastOutPunchType.Rows[0]["LastOut"]);
                                }
                            }
                        }
                    }
                }
                return (strLastOutDatePunchType);
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : GetLastOutPunchType; SwipeCardNo : " + inSwipeCardNo + "; Date : " + inDate + "; Error : " + ex.Message);
                throw ex;
            }
        }
        #endregion
        #region GetFirstInPunchType
        public string GetFirstInPunchType(string inSwipeCardNo, string inDate)
        {
            string strSQLFirstInPunch = string.Empty;
            string strFirstInDatePunch = string.Empty;
            try
            {
                DataTable dtFirstInPunch = new DataTable();
                OleDbParameter pgFirstInEmployee_Code_Id = new OleDbParameter("@inSwipeCardNo", inSwipeCardNo);
                OleDbParameter pgFirstIndtmDate = new OleDbParameter("@inDate", inDate);
                OleDbParameter[] pFirstInParams = { pgFirstInEmployee_Code_Id, pgFirstIndtmDate };
                dtFirstInPunch = objDatafunction.SelectDatas(pFirstInParams, "Proc_Ta_GetFirstInPunchTypeForService");
                if (dtFirstInPunch.Rows.Count > 0)
                {
                    if (dtFirstInPunch.Rows[0]["FirstIn"] != DBNull.Value && Convert.ToString(dtFirstInPunch.Rows[0]["FirstIn"]) != string.Empty)
                    {
                        strFirstInDatePunch = Convert.ToString(dtFirstInPunch.Rows[0]["FirstIn"]);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : GetFirstInPunchType; SwipeCardNo : " + inSwipeCardNo + "; Date : " + inDate + "; Error : " + ex.Message);
            }
            return (strFirstInDatePunch);
        }
        #endregion
        public void UpdateBLLeave()
        {
            try
            {
                objDatafunction.SP_Execute_NoParam("Proc_Ta_UpdateBonusLeavesForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("DataProcess", "function : Proc_Ta_UpdateBonusLeavesForService();Error : " + ex.Message);
            }
        }
    }
}